(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var RoutePolicy = Package.routepolicy.RoutePolicy;
var WebApp = Package.webapp.WebApp;
var main = Package.webapp.main;
var WebAppInternals = Package.webapp.WebAppInternals;
var _ = Package.underscore._;
var ServiceConfiguration = Package['service-configuration'].ServiceConfiguration;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Accounts = Package['accounts-base'].Accounts;
var Random = Package.random.Random;
var ECMAScript = Package.ecmascript.ECMAScript;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var middleware, _saml, SAML, profile;

var require = meteorInstall({"node_modules":{"meteor":{"accounts-saml":{"saml_server.js":function(require){

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                  //
// packages/accounts-saml/saml_server.js                                                                            //
//                                                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                    //
if (!Accounts.saml) {                                                                                               // 1
  Accounts.saml = {};                                                                                               // 2
}                                                                                                                   //
                                                                                                                    //
var Url = Npm.require("url");                                                                                       // 5
var Fiber = Npm.require("fibers");                                                                                  // 6
var connect = Npm.require("connect");                                                                               // 7
                                                                                                                    //
RoutePolicy.declare("/_saml/", "network");                                                                          // 9
                                                                                                                    //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                            // 11
                                                                                                                    //
Accounts.registerLoginHandler(function (loginRequest) {                                                             // 13
  if (!loginRequest.saml || !loginRequest.credentialToken) {                                                        // 14
    return undefined;                                                                                               // 15
  }                                                                                                                 //
                                                                                                                    //
  if (!Accounts.identityServices.saml.isEnabled()) {                                                                // 18
    throw new Meteor.Error(403, "SAML service is disabled.");                                                       // 19
  }                                                                                                                 //
                                                                                                                    //
  var loginResult = Accounts.saml.retrieveCredential(loginRequest.credentialToken);                                 // 22
  if (!loginResult) {                                                                                               // 23
    throw new Meteor.Error(500, "SAML login did not complete.");                                                    // 24
  } else if (loginResult.profile && loginResult.profile.email) {                                                    //
    var user = _.pick(loginResult.profile, "displayName", "email");                                                 // 26
    user.id = loginResult.profile.nameID;                                                                           // 27
    return Accounts.updateOrCreateUserFromExternalService("saml", user, {});                                        // 28
  } else {                                                                                                          //
    throw new Meteor.Error(500, "SAML profile did not contain an email address");                                   // 30
  }                                                                                                                 //
});                                                                                                                 //
                                                                                                                    //
// TODO(soon): This may need to be a Mongo collection in order to work when the frontend is                         //
//   replicated (but currently Sandstorm for Work is not replicated).                                               //
Accounts.saml._loginResultForCredentialToken = {};                                                                  // 36
                                                                                                                    //
Accounts.saml.hasCredential = function (credentialToken) {                                                          // 38
  return _.has(Accounts.saml._loginResultForCredentialToken, credentialToken);                                      // 39
};                                                                                                                  //
                                                                                                                    //
Accounts.saml.retrieveCredential = function (credentialToken) {                                                     // 42
  var result = Accounts.saml._loginResultForCredentialToken[credentialToken];                                       // 43
  delete Accounts.saml._loginResultForCredentialToken[credentialToken];                                             // 44
  return result;                                                                                                    // 45
};                                                                                                                  //
                                                                                                                    //
// Listen to incoming OAuth http requests                                                                           //
WebApp.connectHandlers.use(connect.bodyParser()).use(function (req, res, next) {                                    // 49
  // Need to create a Fiber since we're using synchronous http calls and nothing                                    //
  // else is wrapping this in a fiber automatically                                                                 //
  Fiber(function () {                                                                                               // 52
    middleware(req, res, next);                                                                                     // 53
  }).run();                                                                                                         //
});                                                                                                                 //
                                                                                                                    //
middleware = function middleware(req, res, next) {                                                                  // 57
  // Make sure to catch any exceptions because otherwise we'd crash                                                 //
  // the runner                                                                                                     //
  try {                                                                                                             // 60
    if (!Accounts.identityServices.saml.isEnabled()) {                                                              // 61
      next();                                                                                                       // 62
      return;                                                                                                       // 63
    }                                                                                                               //
                                                                                                                    //
    var samlObject = samlUrlToObject(req.url);                                                                      // 66
    if (!samlObject || !samlObject.serviceName) {                                                                   // 67
      next();                                                                                                       // 68
      return;                                                                                                       // 69
    }                                                                                                               //
                                                                                                                    //
    if (!samlObject.actionName) throw new Error("Missing SAML action");                                             // 72
                                                                                                                    //
    var entityId = SandstormDb.prototype.getSamlEntityId();                                                         // 75
    var service = {                                                                                                 // 76
      "provider": "default",                                                                                        // 77
      "entryPoint": SandstormDb.prototype.getSamlEntryPoint(),                                                      // 78
      // TODO(someday): find a better way to inject the DB                                                          //
      "issuer": entityId || HOSTNAME,                                                                               // 80
      "cert": SandstormDb.prototype.getSamlPublicCert()                                                             // 81
    };                                                                                                              //
                                                                                                                    //
    // Skip everything if there's no service set by the saml middleware                                             //
    if (!service || samlObject.serviceName !== service.provider) throw new Error("Unexpected SAML service " + samlObject.serviceName);
                                                                                                                    //
    if (samlObject.actionName === "authorize") {                                                                    // 88
      service.callbackUrl = Meteor.absoluteUrl("_saml/validate/" + service.provider);                               // 89
      service.id = samlObject.credentialToken;                                                                      // 90
      _saml = new SAML(service);                                                                                    // 91
      _saml.getAuthorizeUrl(req, function (err, url) {                                                              // 92
        if (err) throw new Error("Unable to generate authorize url");                                               // 93
        res.writeHead(302, { "Location": url });                                                                    // 95
        res.end();                                                                                                  // 96
      });                                                                                                           //
    } else if (samlObject.actionName === "validate") {                                                              //
      _saml = new SAML(service);                                                                                    // 99
      _saml.validateResponse(req.body.SAMLResponse, function (err, profile, loggedOut) {                            // 100
        if (err) {                                                                                                  // 101
          console.error("Error validating SAML response", err.toString());                                          // 102
          throw new Error("Unable to validate response url");                                                       // 103
        }                                                                                                           //
                                                                                                                    //
        // Do NOT use samlObject.credentialToken; it isn't signed!                                                  //
        var credentialToken = profile.inResponseToId || profile.InResponseTo;                                       // 100
        if (!credentialToken) {                                                                                     // 108
          throw new Error("SAML response missing InResponseTo attribute. Sandstorm does not support " + "IdP-initiated authentication; authentication requests must start " + "from the user choosing SAML login in the Sandstorm UI.");
        }                                                                                                           //
                                                                                                                    //
        Accounts.saml._loginResultForCredentialToken[credentialToken] = {                                           // 115
          profile: profile                                                                                          // 116
        };                                                                                                          //
                                                                                                                    //
        closePopup(res);                                                                                            // 119
      });                                                                                                           //
    } else {                                                                                                        //
      throw new Error("Unexpected SAML action " + samlObject.actionName);                                           // 122
    }                                                                                                               //
  } catch (err) {                                                                                                   //
    closePopup(res, err);                                                                                           // 125
  }                                                                                                                 //
};                                                                                                                  //
                                                                                                                    //
var samlUrlToObject = function samlUrlToObject(url) {                                                               // 129
  // req.url will be "/_saml/<action>/<service name>/<credentialToken>"                                             //
  if (!url) return null;                                                                                            // 131
                                                                                                                    //
  var splitPath = url.split("/");                                                                                   // 134
                                                                                                                    //
  // Any non-saml request will continue down the default                                                            //
  // middlewares.                                                                                                   //
  if (splitPath[1] !== "_saml") return null;                                                                        // 129
                                                                                                                    //
  return {                                                                                                          // 141
    actionName: splitPath[2],                                                                                       // 142
    serviceName: splitPath[3],                                                                                      // 143
    credentialToken: splitPath[4]                                                                                   // 144
  };                                                                                                                //
};                                                                                                                  //
                                                                                                                    //
var closePopup = function closePopup(res, err) {                                                                    // 148
  res.writeHead(200, { "Content-Type": "text/html" });                                                              // 149
  var content = "<html><head><script>window.close()</script></head></html>";                                        // 150
  if (err) content = "<html><body><h2>Sorry, an error occured</h2><div>" + err + '</div><a onclick="window.close();">Close Window</a></body></html>';
  res.end(content, "utf-8");                                                                                        // 154
};                                                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"saml_utils.js":function(require){

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                  //
// packages/accounts-saml/saml_utils.js                                                                             //
//                                                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                    //
var zlib = Npm.require("zlib");                                                                                     // 1
var xml2js = Npm.require("xml2js");                                                                                 // 2
var xmlCrypto = Npm.require("xml-crypto");                                                                          // 3
var crypto = Npm.require("crypto");                                                                                 // 4
var xmldom = Npm.require("xmldom");                                                                                 // 5
var querystring = Npm.require("querystring");                                                                       // 6
                                                                                                                    //
SAML = function SAML(options) {                                                                                     // 8
  this.options = this.initialize(options);                                                                          // 9
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.initialize = function (options) {                                                                    // 12
  if (!options) {                                                                                                   // 13
    options = {};                                                                                                   // 14
  }                                                                                                                 //
                                                                                                                    //
  if (!options.protocol) {                                                                                          // 17
    options.protocol = "https://";                                                                                  // 18
  }                                                                                                                 //
                                                                                                                    //
  if (!options.path) {                                                                                              // 21
    options.path = "/saml/consume";                                                                                 // 22
  }                                                                                                                 //
                                                                                                                    //
  if (!options.issuer) {                                                                                            // 25
    options.issuer = "onelogin_saml";                                                                               // 26
  }                                                                                                                 //
                                                                                                                    //
  if (options.identifierFormat === undefined) {                                                                     // 29
    options.identifierFormat = "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent";                              // 30
  }                                                                                                                 //
                                                                                                                    //
  return options;                                                                                                   // 33
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.generateUniqueID = function () {                                                                     // 36
  var chars = "abcdef0123456789";                                                                                   // 37
  var uniqueID = "";                                                                                                // 38
  for (var i = 0; i < 20; i++) {                                                                                    // 39
    uniqueID += chars.substr(Math.floor(Math.random() * 15), 1);                                                    // 40
  }                                                                                                                 //
                                                                                                                    //
  return uniqueID;                                                                                                  // 43
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.generateInstant = function () {                                                                      // 46
  var date = new Date();                                                                                            // 47
  return date.getUTCFullYear() + "-" + ("0" + (date.getUTCMonth() + 1)).slice(-2) + "-" + ("0" + date.getUTCDate()).slice(-2) + "T" + ("0" + date.getUTCHours()).slice(-2) + ":" + ("0" + date.getUTCMinutes()).slice(-2) + ":" + ("0" + date.getUTCSeconds()).slice(-2) + "Z";
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.signRequest = function (xml) {                                                                       // 51
  var signer = crypto.createSign("RSA-SHA1");                                                                       // 52
  signer.update(xml);                                                                                               // 53
  return signer.sign(this.options.privateCert, "base64");                                                           // 54
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.generateAuthorizeRequest = function (req) {                                                          // 57
  var id = "_" + this.generateUniqueID();                                                                           // 58
  var instant = this.generateInstant();                                                                             // 59
                                                                                                                    //
  var callbackUrl = void 0;                                                                                         // 61
  // Post-auth destination                                                                                          //
  if (this.options.callbackUrl) {                                                                                   // 57
    callbackUrl = this.options.callbackUrl;                                                                         // 64
  } else {                                                                                                          //
    callbackUrl = this.options.protocol + req.headers.host + this.options.path;                                     // 66
  }                                                                                                                 //
                                                                                                                    //
  if (this.options.id) id = this.options.id;                                                                        // 69
                                                                                                                    //
  var request = "<samlp:AuthnRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" ProtocolBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST\" AssertionConsumerServiceURL=\"" + callbackUrl + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>\n";
                                                                                                                    //
  if (this.options.identifierFormat) {                                                                              // 78
    request += "<samlp:NameIDPolicy xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Format=\"" + this.options.identifierFormat + "\" AllowCreate=\"true\"></samlp:NameIDPolicy>\n";
  }                                                                                                                 //
                                                                                                                    //
  request += "<samlp:RequestedAuthnContext xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Comparison=\"exact\">" + "<saml:AuthnContextClassRef xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" + "</saml:AuthnContextClassRef>" + "</samlp:RequestedAuthnContext>\n" + "</samlp:AuthnRequest>";
                                                                                                                    //
  return request;                                                                                                   // 91
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.generateLogoutRequest = function (req) {                                                             // 94
  var id = "_" + this.generateUniqueID();                                                                           // 95
  var instant = this.generateInstant();                                                                             // 96
                                                                                                                    //
  //samlp:LogoutRequest xmlns:samlp="urn:oasis:names:tc:SAML:2.0:protocol" xmlns:saml="urn:oasis:names:tc:SAML:2.0:assertion"
  // ID="_135ad2fd-b275-4428-b5d6-3ac3361c3a7f" Version="2.0" Destination="https://idphost/adfs/ls/"                //
  //IssueInstant="2008-06-03T12:59:57Z"><saml:Issuer>myhost</saml:Issuer><NameID Format="urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress"
  //NameQualifier="https://idphost/adfs/ls/">myemail@mydomain.com</NameID<samlp:SessionIndex>_0628125f-7f95-42cc-ad8e-fde86ae90bbe
  //</samlp:SessionIndex></samlp:LogoutRequest>                                                                     //
                                                                                                                    //
  var request = "<samlp:LogoutRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" " + "xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>" + "<saml:NameID Format=\"" + req.user.nameIDFormat + "\">" + req.user.nameID + "</saml:NameID>" + "</samlp:LogoutRequest>";
  return request;                                                                                                   // 110
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.requestToUrl = function (request, operation, callback) {                                             // 113
  var _this = this;                                                                                                 // 114
  zlib.deflateRaw(request, function (err, buffer) {                                                                 // 115
    if (err) {                                                                                                      // 116
      return callback(err);                                                                                         // 117
    }                                                                                                               //
                                                                                                                    //
    var base64 = buffer.toString("base64");                                                                         // 120
    var target = _this.options.entryPoint;                                                                          // 121
                                                                                                                    //
    if (operation === "logout") {                                                                                   // 123
      if (_this.options.logoutUrl) {                                                                                // 124
        target = _this.options.logoutUrl;                                                                           // 125
      }                                                                                                             //
    }                                                                                                               //
                                                                                                                    //
    if (target.indexOf("?") > 0) target += "&";else target += "?";                                                  // 129
                                                                                                                    //
    var samlRequest = {                                                                                             // 134
      SAMLRequest: base64                                                                                           // 135
    };                                                                                                              //
                                                                                                                    //
    if (_this.options.privateCert) {                                                                                // 138
      samlRequest.SigAlg = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";                                            // 139
      samlRequest.Signature = _this.signRequest(querystring.stringify(samlRequest));                                // 140
    }                                                                                                               //
                                                                                                                    //
    target += querystring.stringify(samlRequest);                                                                   // 143
                                                                                                                    //
    callback(null, target);                                                                                         // 145
  });                                                                                                               //
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.getAuthorizeUrl = function (req, callback) {                                                         // 149
  var request = this.generateAuthorizeRequest(req);                                                                 // 150
                                                                                                                    //
  this.requestToUrl(request, "authorize", callback);                                                                // 152
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.getLogoutUrl = function (req, callback) {                                                            // 155
  var request = this.generateLogoutRequest(req);                                                                    // 156
                                                                                                                    //
  this.requestToUrl(request, "logout", callback);                                                                   // 158
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.certToPEM = function (cert) {                                                                        // 161
  cert = cert.match(/.{1,64}/g).join("\n");                                                                         // 162
  cert = "-----BEGIN CERTIFICATE-----\n" + cert;                                                                    // 163
  cert = cert + "\n-----END CERTIFICATE-----\n";                                                                    // 164
  return cert;                                                                                                      // 165
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.validateSignature = function (xml, cert) {                                                           // 168
  var _this = this;                                                                                                 // 169
  var doc = new xmldom.DOMParser().parseFromString(xml);                                                            // 170
  var signature = xmlCrypto.xpath(doc, "//*[local-name(.)='Signature' and namespace-uri(.)='http://www.w3.org/2000/09/xmldsig#']")[0];
  var sig = new xmlCrypto.SignedXml();                                                                              // 172
  sig.keyInfoProvider = {                                                                                           // 173
    getKeyInfo: function () {                                                                                       // 174
      function getKeyInfo(key) {                                                                                    // 174
        return "<X509Data></X509Data>";                                                                             // 175
      }                                                                                                             //
                                                                                                                    //
      return getKeyInfo;                                                                                            //
    }(),                                                                                                            //
                                                                                                                    //
    getKey: function () {                                                                                           // 178
      function getKey(keyInfo) {                                                                                    // 178
        return _this.certToPEM(cert);                                                                               // 179
      }                                                                                                             //
                                                                                                                    //
      return getKey;                                                                                                //
    }()                                                                                                             //
  };                                                                                                                //
  sig.loadSignature(signature.toString());                                                                          // 182
  return sig.checkSignature(xml);                                                                                   // 183
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.getElement = function (parentElement, elementName) {                                                 // 186
  if (parentElement["saml:" + elementName]) {                                                                       // 187
    return parentElement["saml:" + elementName];                                                                    // 188
  } else if (parentElement["samlp:" + elementName]) {                                                               //
    return parentElement["samlp:" + elementName];                                                                   // 190
  } else if (parentElement["saml2p:" + elementName]) {                                                              //
    return parentElement["saml2p:" + elementName];                                                                  // 192
  } else if (parentElement["saml2:" + elementName]) {                                                               //
    return parentElement["saml2:" + elementName];                                                                   // 194
  }                                                                                                                 //
                                                                                                                    //
  return parentElement[elementName];                                                                                // 197
};                                                                                                                  //
                                                                                                                    //
SAML.prototype.validateResponse = function (samlResponse, callback) {                                               // 200
  var _this = this;                                                                                                 // 201
  var xml = new Buffer(samlResponse, "base64").toString("ascii");                                                   // 202
  var parser = new xml2js.Parser({ explicitRoot: true });                                                           // 203
  parser.parseString(xml, function (err, doc) {                                                                     // 204
    // Verify signature                                                                                             //
    if (_this.options.cert && !_this.validateSignature(xml, _this.options.cert)) {                                  // 206
      return callback(new Error("Invalid signature"), null, false);                                                 // 207
    }                                                                                                               //
                                                                                                                    //
    var response = _this.getElement(doc, "Response");                                                               // 210
    if (response) {                                                                                                 // 211
      var assertion = _this.getElement(response, "Assertion");                                                      // 212
      if (!assertion) {                                                                                             // 213
        return callback(new Error("Missing SAML assertion"), null, false);                                          // 214
      }                                                                                                             //
                                                                                                                    //
      profile = {};                                                                                                 // 217
                                                                                                                    //
      if (response.$ && response.$.InResponseTo) {                                                                  // 219
        profile.inResponseToId = response.$.InResponseTo;                                                           // 220
      }                                                                                                             //
                                                                                                                    //
      if (response.$ && response.$.Destination) {                                                                   // 223
        if (!response.$.Destination.startsWith(process.env.ROOT_URL)) {                                             // 224
          return callback(new Error("SAML Response received with invalid Destination: " + response.$.Destination));
        }                                                                                                           //
      }                                                                                                             //
                                                                                                                    //
      var issuer = _this.getElement(assertion[0], "Issuer");                                                        // 230
      if (issuer) {                                                                                                 // 231
        profile.issuer = issuer[0];                                                                                 // 232
      }                                                                                                             //
                                                                                                                    //
      var subject = _this.getElement(assertion[0], "Subject");                                                      // 235
      if (subject) {                                                                                                // 236
        var nameID = _this.getElement(subject[0], "NameID");                                                        // 237
        if (nameID) {                                                                                               // 238
          profile.nameID = nameID[0]._;                                                                             // 239
                                                                                                                    //
          if (nameID[0].$.Format) {                                                                                 // 241
            profile.nameIDFormat = nameID[0].$.Format;                                                              // 242
            if (profile.nameIDFormat.toLowerCase().indexOf("transient") !== -1) {                                   // 243
              return callback(new Error("SAML returned a transient NameID. Sandstorm requires a persistent NameID. " + "Please check your IdP config."));
            }                                                                                                       //
          }                                                                                                         //
        }                                                                                                           //
                                                                                                                    //
        var subjectConfirmation = _this.getElement(subject[0], "SubjectConfirmation");                              // 251
        if (subjectConfirmation) {                                                                                  // 252
          var subjectConfirmationData = _this.getElement(subjectConfirmation[0], "SubjectConfirmationData")[0];     // 253
          if (subjectConfirmationData) {                                                                            // 255
            var recipient = subjectConfirmationData.$.Recipient;                                                    // 256
            if (recipient && !recipient.startsWith(process.env.ROOT_URL)) {                                         // 257
              return callback(new Error("SAML sent to wrong recipient"));                                           // 258
            }                                                                                                       //
                                                                                                                    //
            var nowMs = Date.now();                                                                                 // 261
            var notBefore = subjectConfirmationData.$.NotBefore;                                                    // 262
            if (notBefore && nowMs < Date.parse(notBefore)) {                                                       // 263
              return callback(new Error("SAML assertion was signed for the future."));                              // 264
            }                                                                                                       //
                                                                                                                    //
            var notOnOrAfter = subjectConfirmationData.$.NotOnOrAfter;                                              // 267
            if (notOnOrAfter && nowMs >= Date.parse(notOnOrAfter)) {                                                // 268
              return callback(new Error("SAML assertion was signed for the past."));                                // 269
            }                                                                                                       //
          }                                                                                                         //
        }                                                                                                           //
      }                                                                                                             //
                                                                                                                    //
      var conditions = _this.getElement(assertion[0], "Conditions")[0];                                             // 275
      if (conditions) {                                                                                             // 276
        for (var key in meteorBabelHelpers.sanitizeForInObject(conditions)) {                                       // 277
          if (conditions.hasOwnProperty(key)) {                                                                     // 278
            var value = conditions[key];                                                                            // 279
            if (key === "$") {                                                                                      // 280
              var _nowMs = Date.now();                                                                              // 281
              var _notBefore = value.NotBefore;                                                                     // 282
              if (_notBefore && _nowMs < Date.parse(_notBefore)) {                                                  // 283
                return callback(new Error("SAML condition NotBefore is in the future."));                           // 284
              }                                                                                                     //
                                                                                                                    //
              var _notOnOrAfter = value.NotOnOrAfter;                                                               // 287
              if (_notOnOrAfter && _nowMs >= Date.parse(_notOnOrAfter)) {                                           // 288
                return callback(new Error("SAML condition notOnOrAfter is in the past."));                          // 289
              }                                                                                                     //
            } else if (key.endsWith(":AudienceRestriction") || key.endsWith(":OneTimeUse") || key.endsWith(":ProxyRestriction")) {
              continue;                                                                                             // 294
              // Do nothing.                                                                                        //
              // We already check both Destination and SubjectConfirmation.Recipient, so                            //
              // the Audience constraint isn't as important, and is tricky to handle                                //
              // correctly.                                                                                         //
              // OneTimeUse is actually very tricky to get right, and requires a cache of                           //
              // previously seen assertions (or at least their hashes). In Sandstorm's case,                        //
              // we would probably need to stuff it in Mongo to make it robust across multiple                      //
              // front-ends. It is a very rarely used constraint anyways.                                           //
              // ProxyRestriction constraints only govern the future use of the assertion by the                    //
              // SP. We don't fall under this constraint so it's meaningless to us. As per the                      //
              // spec, it is always considered valid.                                                               //
            } else {                                                                                                // 293
                return callback(new Error("Unrecognized SAML constraint: " + key));                                 // 307
              }                                                                                                     //
          }                                                                                                         //
        }                                                                                                           //
      }                                                                                                             //
                                                                                                                    //
      var attributeStatement = _this.getElement(assertion[0], "AttributeStatement");                                // 313
      if (attributeStatement) {                                                                                     // 314
        var attributes = _this.getElement(attributeStatement[0], "Attribute");                                      // 315
                                                                                                                    //
        if (attributes) {                                                                                           // 317
          attributes.forEach(function (attribute) {                                                                 // 318
            var value = _this.getElement(attribute, "AttributeValue");                                              // 319
            if (typeof value[0] === "string") {                                                                     // 320
              profile[attribute.$.Name] = value[0];                                                                 // 321
            } else {                                                                                                //
              profile[attribute.$.Name] = value[0]._;                                                               // 323
            }                                                                                                       //
          });                                                                                                       //
        }                                                                                                           //
                                                                                                                    //
        if (!profile.mail && profile["urn:oid:0.9.2342.19200300.100.1.3"]) {                                        // 328
          // See http://www.incommonfederation.org/attributesummary.html for definition of attribute OIDs           //
          profile.mail = profile["urn:oid:0.9.2342.19200300.100.1.3"];                                              // 330
        }                                                                                                           //
                                                                                                                    //
        if (!profile.email && profile.mail) {                                                                       // 333
          profile.email = profile.mail;                                                                             // 334
        }                                                                                                           //
      }                                                                                                             //
                                                                                                                    //
      if (!profile.email && profile.nameID && profile.nameIDFormat && profile.nameIDFormat.indexOf("emailAddress") >= 0) {
        profile.email = profile.nameID;                                                                             // 339
      }                                                                                                             //
                                                                                                                    //
      callback(null, profile, false);                                                                               // 342
    } else {                                                                                                        //
      var logoutResponse = _this.getElement(doc, "LogoutResponse");                                                 // 344
                                                                                                                    //
      if (logoutResponse) {                                                                                         // 346
        callback(null, null, true);                                                                                 // 347
      } else {                                                                                                      //
        return callback(new Error("Unknown SAML response message"), null, false);                                   // 349
      }                                                                                                             //
    }                                                                                                               //
  });                                                                                                               //
};                                                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/accounts-saml/saml_server.js");
require("./node_modules/meteor/accounts-saml/saml_utils.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['accounts-saml'] = {};

})();

//# sourceMappingURL=accounts-saml.js.map
