var require = meteorInstall({"server":{"lib":{"constants.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/lib/constants.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// A collection of some global variables used in multiple places.                                                      //
SANDSTORM_ALTHOME = Meteor.settings && Meteor.settings.home;                                                           // 18
SANDSTORM_LOGDIR = (SANDSTORM_ALTHOME || "") + "/var/log";                                                             // 19
SANDSTORM_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandstorm";                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"admin":{"admin-alert-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-alert-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _meteor = require("meteor/meteor");                                                                                // 1
                                                                                                                       //
var _check = require("meteor/check");                                                                                  // 2
                                                                                                                       //
var _auth = require("/imports/server/auth.js");                                                                        // 3
                                                                                                                       //
var maintenanceMessageShape = {                                                                                        // 5
  text: String,                                                                                                        // 6
  time: _check.Match.OneOf(Date, undefined, null),                                                                     // 7
  url: _check.Match.Optional(String)                                                                                   // 8
};                                                                                                                     //
                                                                                                                       //
_meteor.Meteor.methods({                                                                                               // 11
  setMaintenanceMessage: function () {                                                                                 // 12
    function setMaintenanceMessage(params) {                                                                           //
      (0, _auth.checkAuth)(undefined);                                                                                 // 13
      (0, _check.check)(params, maintenanceMessageShape);                                                              // 14
      var db = this.connection.sandstormDb;                                                                            // 15
      // TODO(soon): make this a single write to a single settings object                                              //
      db.collections.settings.upsert({ _id: "adminAlertTime" }, { value: params.time });                               // 12
      db.collections.settings.upsert({ _id: "adminAlertUrl" }, { value: params.url });                                 // 18
      db.collections.settings.upsert({ _id: "adminAlert" }, { value: params.text });                                   // 19
    }                                                                                                                  //
                                                                                                                       //
    return setMaintenanceMessage;                                                                                      //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-user-invite.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-user-invite.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.publish("allInviteTokens", function () {                                                                        // 1
  var db = this.connection.sandstormDb;                                                                                // 2
  if (!db.isAdminById(this.userId)) {                                                                                  // 3
    throw new Meteor.Error(403, "User must be admin to list invite tokens.");                                          // 4
  }                                                                                                                    //
                                                                                                                       //
  return db.collections.signupKeys.find({});                                                                           // 7
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"network-capabilities-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/network-capabilities-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _meteor = require("meteor/meteor");                                                                                // 1
                                                                                                                       //
var _check = require("meteor/check");                                                                                  // 2
                                                                                                                       //
var _auth = require("/imports/server/auth.js");                                                                        // 3
                                                                                                                       //
_meteor.Meteor.publish("adminGrains", function (grainIds) {                                                            // 5
  // If the caller is an admin, publishes the Grains referred to by the provided list of grain IDs.                    //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 8
  (0, _check.check)(grainIds, [String]);                                                                               // 9
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 11
  return db.collections.grains.find({                                                                                  // 12
    _id: {                                                                                                             // 13
      $in: grainIds                                                                                                    // 14
    }                                                                                                                  //
  }, {                                                                                                                 //
    fields: {                                                                                                          // 17
      identityId: 1,                                                                                                   // 18
      title: 1,                                                                                                        // 19
      packageId: 1                                                                                                     // 20
    }                                                                                                                  //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("adminPackages", function (packageIds) {                                                        // 25
  // If the caller is an admin, publishes the Packages referred to by the provided list of package                     //
  // IDs.  Otherwise, does nothing.                                                                                    //
  if (!isAdminById(this.userId)) return [];                                                                            // 28
  (0, _check.check)(packageIds, [String]);                                                                             // 29
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 31
  return db.collections.packages.find({                                                                                // 32
    _id: {                                                                                                             // 33
      $in: packageIds                                                                                                  // 34
    }                                                                                                                  //
  }, {                                                                                                                 //
    fields: {                                                                                                          // 37
      manifest: 1                                                                                                      // 38
    }                                                                                                                  //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("adminIdentities", function (identityIds) {                                                     // 43
  // If the caller is an admin, publishes the identity Users listed by ID in identityIds.                              //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 46
  (0, _check.check)(identityIds, [String]);                                                                            // 47
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 49
  return db.collections.users.find({                                                                                   // 50
    _id: {                                                                                                             // 51
      $in: identityIds                                                                                                 // 52
    }                                                                                                                  //
  });                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"personalization-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/personalization-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _meteor = require("meteor/meteor");                                                                                // 1
                                                                                                                       //
var _check = require("meteor/check");                                                                                  // 2
                                                                                                                       //
var _auth = require("/imports/server/auth.js");                                                                        // 3
                                                                                                                       //
var personalizationMessageShape = {                                                                                    // 5
  serverTitle: String,                                                                                                 // 6
  splashUrl: String,                                                                                                   // 7
  signupDialog: String,                                                                                                // 8
  termsOfServiceUrl: String,                                                                                           // 9
  privacyPolicyUrl: String                                                                                             // 10
};                                                                                                                     //
                                                                                                                       //
_meteor.Meteor.methods({                                                                                               // 13
  setPersonalizationSettings: function () {                                                                            // 14
    function setPersonalizationSettings(params) {                                                                      //
      (0, _auth.checkAuth)(undefined);                                                                                 // 15
      (0, _check.check)(params, personalizationMessageShape);                                                          // 16
      var db = this.connection.sandstormDb;                                                                            // 17
      // TODO(soon): make this a single write to a single settings object                                              //
      db.collections.settings.upsert({ _id: "serverTitle" }, { value: params.serverTitle });                           // 14
      db.collections.settings.upsert({ _id: "splashUrl" }, { value: params.splashUrl });                               // 20
      db.collections.settings.upsert({ _id: "signupDialog" }, { value: params.signupDialog });                         // 21
      db.collections.settings.upsert({ _id: "termsUrl" }, { value: params.termsOfServiceUrl });                        // 22
      db.collections.settings.upsert({ _id: "privacyUrl" }, { value: params.privacyPolicyUrl });                       // 23
    }                                                                                                                  //
                                                                                                                       //
    return setPersonalizationSettings;                                                                                 //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"system-status-server.js":["meteor/meteor","meteor/iron:router","meteor/random","crypto","fs",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/system-status-server.js                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _meteor = require("meteor/meteor");                                                                                // 1
                                                                                                                       //
var _ironRouter = require("meteor/iron:router");                                                                       // 2
                                                                                                                       //
var _random = require("meteor/random");                                                                                // 3
                                                                                                                       //
var _crypto = require("crypto");                                                                                       // 4
                                                                                                                       //
var _crypto2 = _interopRequireDefault(_crypto);                                                                        //
                                                                                                                       //
var _fs = require("fs");                                                                                               // 5
                                                                                                                       //
var _fs2 = _interopRequireDefault(_fs);                                                                                //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
var hashSessionId = function hashSessionId(sessionId) {                                                                // 7
  return _crypto2["default"].createHash("sha256").update(sessionId).digest("base64");                                  // 8
};                                                                                                                     //
                                                                                                                       //
// An in-memory map of random id -> timestamp, used to authorize requests to download the system                       //
// log.                                                                                                                //
var SYSTEM_LOG_DOWNLOAD_TOKENS = {};                                                                                   // 13
var SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION = 60000; // 60 seconds                                                 // 14
                                                                                                                       //
_meteor.Meteor.methods({                                                                                               // 16
  adminGetServerLogDownloadToken: function () {                                                                        // 17
    function adminGetServerLogDownloadToken() {                                                                        //
      var db = this.connection.sandstormDb;                                                                            // 18
      if (!db.isAdminById(this.userId)) {                                                                              // 19
        throw new _meteor.Meteor.Error(403, "User must be admin to download system log.");                             // 20
      }                                                                                                                //
                                                                                                                       //
      var token = _random.Random.id(22);                                                                               // 23
      SYSTEM_LOG_DOWNLOAD_TOKENS[token] = Date.now();                                                                  // 24
      setTimeout(function () {                                                                                         // 25
        if (SYSTEM_LOG_DOWNLOAD_TOKENS[token]) {                                                                       // 26
          delete SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                                    // 27
        }                                                                                                              //
      }, SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION * 2);                                                             //
      return token;                                                                                                    // 30
    }                                                                                                                  //
                                                                                                                       //
    return adminGetServerLogDownloadToken;                                                                             //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
_ironRouter.Router.map(function () {                                                                                   // 34
  this.route("adminDownloadServerLog", {                                                                               // 35
    where: "server",                                                                                                   // 36
    path: "/admin/status/server-log/:tokenId",                                                                         // 37
    action: function () {                                                                                              // 38
      function action() {                                                                                              //
        var token = this.params.tokenId;                                                                               // 39
        var response = this.response;                                                                                  // 40
        var issueDate = SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                             // 41
        delete SYSTEM_LOG_DOWNLOAD_TOKENS[token]; // Clear the token from the in-memory map.                           // 42
        if (issueDate === undefined || issueDate + SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION < Date.now()) {         // 38
          // Require download to start within 60 seconds of the adminGetServerLogDownloadToken                         //
          // method being called.                                                                                      //
          response.writeHead(404, { "Content-Type": "text/plain" });                                                   // 47
          return response.end("Invalid server log download token.");                                                   // 48
        }                                                                                                              //
                                                                                                                       //
        var logFilePath = SANDSTORM_LOGDIR + "/sandstorm.log";                                                         // 51
        var fd = _fs2["default"].openSync(logFilePath, "r");                                                           // 52
        var stats = _fs2["default"].fstatSync(fd);                                                                     // 53
        var initialSize = stats.size;                                                                                  // 54
        var readStream = _fs2["default"].createReadStream(undefined, {                                                 // 55
          fd: fd,                                                                                                      // 56
          start: 0,                                                                                                    // 57
          end: initialSize                                                                                             // 58
        });                                                                                                            //
                                                                                                                       //
        response.writeHead(200, {                                                                                      // 61
          "Content-Length": initialSize,                                                                               // 62
          "Content-Type": "text/plain",                                                                                // 63
          "content-Disposition": "attachment;filename=\"sandstorm.log\""                                               // 64
        });                                                                                                            //
        readStream.pipe(response);                                                                                     // 66
      }                                                                                                                //
                                                                                                                       //
      return action;                                                                                                   //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("systemStatus", function () {                                                                   // 71
  // A pseudocollection containing the number of active grain sessions and unique                                      //
  // userIds associated with these sessions                                                                            //
  var db = this.connection.sandstormDb;                                                                                // 74
  if (!db.isAdminById(this.userId)) {                                                                                  // 75
    throw new _meteor.Meteor.Error(403, "User must be admin to view system status.");                                  // 76
  }                                                                                                                    //
                                                                                                                       //
  var _this = this;                                                                                                    // 79
  var userIdToSessionHashes = {}; // Maps userId => list of (sha256(sessionId))                                        // 80
  var grainIdToSessionHashes = {}; // Maps grainId => list of (sha256(sessionId))                                      // 71
                                                                                                                       //
  var userIdCount = 0;                                                                                                 // 71
  var grainIdCount = 0;                                                                                                // 84
                                                                                                                       //
  this.added("systemStatus", "globalStatus", {                                                                         // 86
    activeUsers: userIdCount,                                                                                          // 87
    activeGrains: grainIdCount                                                                                         // 88
  });                                                                                                                  //
                                                                                                                       //
  var query = db.collections.sessions.find();                                                                          // 91
  var handle = query.observe({                                                                                         // 92
    added: function () {                                                                                               // 93
      function added(session) {                                                                                        //
        var hashedSessionId = hashSessionId(session._id);                                                              // 94
        var changed = {};                                                                                              // 95
                                                                                                                       //
        // Update userId cache.                                                                                        //
        if (session.userId) {                                                                                          // 93
          if (userIdToSessionHashes[session.userId] === undefined) {                                                   // 99
            userIdToSessionHashes[session.userId] = [];                                                                // 100
            userIdCount = userIdCount + 1;                                                                             // 101
            changed.activeUsers = userIdCount;                                                                         // 102
          }                                                                                                            //
                                                                                                                       //
          userIdToSessionHashes[session.userId] = _.union(userIdToSessionHashes[session.userId], [hashedSessionId]);   // 105
        }                                                                                                              //
                                                                                                                       //
        // Update grainId cache.                                                                                       //
        if (grainIdToSessionHashes[session.grainId] === undefined) {                                                   // 93
          grainIdToSessionHashes[session.grainId] = [];                                                                // 111
          grainIdCount = grainIdCount + 1;                                                                             // 112
          changed.activeGrains = grainIdCount;                                                                         // 113
        }                                                                                                              //
                                                                                                                       //
        grainIdToSessionHashes[session.grainId] = _.union(grainIdToSessionHashes[session.grainId], [hashedSessionId]);
                                                                                                                       //
        if (!_.isEmpty(changed)) {                                                                                     // 119
          _this.changed("systemStatus", "globalStatus", changed);                                                      // 120
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
    removed: function () {                                                                                             // 124
      function removed(session) {                                                                                      //
        var hashedSessionId = hashSessionId(session._id);                                                              // 125
        var changed = {};                                                                                              // 126
                                                                                                                       //
        if (session.userId) {                                                                                          // 128
          userIdToSessionHashes[session.userId] = _.without(userIdToSessionHashes[session.userId], hashedSessionId);   // 129
                                                                                                                       //
          if (userIdToSessionHashes[session.userId].length === 0) {                                                    // 132
            delete userIdToSessionHashes[session.userId];                                                              // 133
            userIdCount = userIdCount - 1;                                                                             // 134
            changed.activeUsers = userIdCount;                                                                         // 135
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        grainIdToSessionHashes[session.grainId] = _.without(grainIdToSessionHashes[session.grainId], hashedSessionId);
                                                                                                                       //
        if (grainIdToSessionHashes[session.grainId].length === 0) {                                                    // 142
          delete grainIdToSessionHashes[session.grainId];                                                              // 143
          grainIdCount = grainIdCount - 1;                                                                             // 144
          changed.activeGrains = grainIdCount;                                                                         // 145
        }                                                                                                              //
                                                                                                                       //
        if (!_.isEmpty(changed)) {                                                                                     // 148
          _this.changed("systemStatus", "globalStatus", changed);                                                      // 149
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  this.onStop(function () {                                                                                            // 154
    handle.stop();                                                                                                     // 155
  });                                                                                                                  //
  this.ready();                                                                                                        // 157
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("adminDemoUsers", function () {                                                                 // 160
  // Publishes expiry information about demo accounts to admins, so demo users can be counted                          //
  // clientside and reactively updated.                                                                                //
  var db = this.connection.sandstormDb;                                                                                // 163
  if (!db.isAdminById(this.userId)) {                                                                                  // 164
    throw new _meteor.Meteor.Error(403, "User must be admin to view system status.");                                  // 165
  }                                                                                                                    //
                                                                                                                       //
  return db.collections.users.find({                                                                                   // 168
    expires: {                                                                                                         // 169
      $gt: new Date()                                                                                                  // 170
    },                                                                                                                 //
    loginIdentities: {                                                                                                 // 172
      $exists: true                                                                                                    // 173
    }                                                                                                                  //
  }, {                                                                                                                 //
    expires: 1,                                                                                                        // 176
    loginIdentities: 1                                                                                                 // 177
  });                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"drivers":{"external-ui-view.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/external-ui-view.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Promise = Npm.require("es6-promise").Promise;                                                                      // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var Url = Npm.require("url");                                                                                          // 20
var Http = Npm.require("http");                                                                                        // 21
var Https = Npm.require("https");                                                                                      // 22
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 23
                                                                                                                       //
WrappedUiView = function () {                                                                                          // 25
  function WrappedUiView(token, proxy) {                                                                               // 26
    (0, _classCallCheck3["default"])(this, WrappedUiView);                                                             //
                                                                                                                       //
    // TODO(someday): handle the fact that these proxies will be garbage collected every 2 minutes,                    //
    // even if it's in use.                                                                                            //
    this.token = token;                                                                                                // 29
    this.proxy = proxy;                                                                                                // 30
  }                                                                                                                    //
                                                                                                                       //
  WrappedUiView.prototype.newSession = function () {                                                                   // 25
    function newSession(userInfo, context, sessionType, sessionParams, retryCount) {                                   //
      if (sessionType !== ApiSession.typeId) {                                                                         // 34
        throw new Error("SessionType must be ApiSession.");                                                            // 35
      }                                                                                                                //
                                                                                                                       //
      retryCount = retryCount || 0;                                                                                    // 38
      var _this = this;                                                                                                // 39
                                                                                                                       //
      return this.proxy.keepAlive().then(function () {                                                                 // 41
        // ignore the passed userInfo and instead use the one associated with this                                     //
        // token TODO(someday): Merge / intersect the two userInfo objects                                             //
        // (especially permissions) rather than only taking the token's user info.                                     //
        // This will allow the caller to request only a subset of the permissions                                      //
        // granted by the token, which is useful to protect against bugs.                                              //
        var session = _this.proxy.uiView.newSession(_this.proxy.userInfo, context, sessionType, sessionParams).session;
        return { session: session };                                                                                   // 49
      })["catch"](function (error) {                                                                                   //
        return _this.proxy.maybeRetryAfterError(error, retryCount).then(function () {                                  // 51
          return _this.newSession(userInfo, context, sessionType, sessionParams, retryCount + 1);                      // 52
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return newSession;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return WrappedUiView;                                                                                                //
}();                                                                                                                   //
                                                                                                                       //
getWrappedUiViewForToken = function getWrappedUiViewForToken(token) {                                                  // 58
  var proxyPromise = getProxyForApiToken(token);                                                                       // 59
                                                                                                                       //
  return proxyPromise.then(function (proxy) {                                                                          // 61
    return { view: new WrappedUiView(token, proxy) };                                                                  // 62
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
ExternalUiView = function () {                                                                                         // 66
  function ExternalUiView(url, grainId, token) {                                                                       // 67
    (0, _classCallCheck3["default"])(this, ExternalUiView);                                                            //
                                                                                                                       //
    this.url = url;                                                                                                    // 68
    this.grainId = grainId;                                                                                            // 69
    this.token = token;                                                                                                // 70
  }                                                                                                                    //
                                                                                                                       //
  ExternalUiView.prototype.newSession = function () {                                                                  // 66
    function newSession(userInfo, context, sessionType, sessionParams) {                                               //
      if (sessionType !== ApiSession.typeId) {                                                                         // 74
        throw new Error("SessionType must be ApiSession.");                                                            // 75
      }                                                                                                                //
                                                                                                                       //
      var options = {};                                                                                                // 78
                                                                                                                       //
      if (this.token) {                                                                                                // 80
        options.headers = {                                                                                            // 81
          authorization: "Bearer " + this.token                                                                        // 82
        };                                                                                                             //
      }                                                                                                                //
                                                                                                                       //
      return { session: new Capnp.Capability(new ExternalWebSession(this.url, this.grainId, options), ApiSession) };   // 86
    }                                                                                                                  //
                                                                                                                       //
    return newSession;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return ExternalUiView;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
var responseCodes = {                                                                                                  // 90
  200: { type: "content", code: "ok" },                                                                                // 91
  201: { type: "content", code: "created" },                                                                           // 92
  202: { type: "content", code: "accepted" },                                                                          // 93
  204: { type: "noContent", shouldResetForm: false },                                                                  // 94
  205: { type: "noContent", shouldResetForm: true },                                                                   // 95
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 206: {type: 'noContent'},                                                                                         //
  // 300: {type: 'redirect'},                                                                                          //
  301: { type: "redirect", switchToGet: true, isPermanent: true },                                                     // 100
  302: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 101
  303: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 102
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 304: {type: 'redirect'},                                                                                          //
  // 305: {type: 'redirect'},                                                                                          //
  307: { type: "redirect", switchToGet: false, isPermanent: false },                                                   // 107
  308: { type: "redirect", switchToGet: false, isPermanent: true },                                                    // 108
  400: { type: "clientError", clientErrorCode: "badRequest", descriptionHtml: "Bad Request" },                         // 109
  403: { type: "clientError", clientErrorCode: "forbidden", descriptionHtml: "Forbidden" },                            // 110
  404: { type: "clientError", clientErrorCode: "notFound", descriptionHtml: "Not Found" },                             // 111
  405: { type: "clientError", clientErrorCode: "methodNotAllowed", descriptionHtml: "Method Not Allowed" },            // 112
  406: { type: "clientError", clientErrorCode: "notAcceptable", descriptionHtml: "Not Acceptable" },                   // 113
  409: { type: "clientError", clientErrorCode: "conflict", descriptionHtml: "Conflict" },                              // 114
  410: { type: "clientError", clientErrorCode: "gone", descriptionHtml: "Gone" },                                      // 115
  413: { type: "clientError", clientErrorCode: "requestEntityTooLarge", descriptionHtml: "Request Entity Too Large" },
  414: { type: "clientError", clientErrorCode: "requestUriTooLong", descriptionHtml: "Request-URI Too Long" },         // 117
  415: { type: "clientError", clientErrorCode: "unsupportedMediaType", descriptionHtml: "Unsupported Media Type" },    // 118
  418: { type: "clientError", clientErrorCode: "imATeapot", descriptionHtml: "I'm a teapot" },                         // 119
  500: { type: "serverError" },                                                                                        // 120
  501: { type: "serverError" },                                                                                        // 121
  502: { type: "serverError" },                                                                                        // 122
  503: { type: "serverError" },                                                                                        // 123
  504: { type: "serverError" },                                                                                        // 124
  505: { type: "serverError" }                                                                                         // 125
};                                                                                                                     //
                                                                                                                       //
ExternalWebSession = function () {                                                                                     // 128
  function ExternalWebSession(url, grainId, options) {                                                                 // 129
    (0, _classCallCheck3["default"])(this, ExternalWebSession);                                                        //
                                                                                                                       //
    var parsedUrl = Url.parse(url);                                                                                    // 130
    this.host = parsedUrl.hostname;                                                                                    // 131
    this.port = parsedUrl.port;                                                                                        // 132
    this.protocol = parsedUrl.protocol;                                                                                // 133
    this.grainId = grainId;                                                                                            // 134
    this.options = options || {};                                                                                      // 135
  }                                                                                                                    //
                                                                                                                       //
  ExternalWebSession.prototype.get = function () {                                                                     // 128
    function get(path, context) {                                                                                      //
      return this._requestHelper("GET", path, context);                                                                // 139
    }                                                                                                                  //
                                                                                                                       //
    return get;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ExternalWebSession.prototype.post = function () {                                                                    // 128
    function post(path, content, context) {                                                                            //
      return this._requestHelper("POST", path, context, content.content, content.mimeType);                            // 143
    }                                                                                                                  //
                                                                                                                       //
    return post;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  ExternalWebSession.prototype.put = function () {                                                                     // 128
    function put(path, content, context) {                                                                             //
      return this._requestHelper("PUT", path, context, content.content, content.mimeType);                             // 147
    }                                                                                                                  //
                                                                                                                       //
    return put;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ExternalWebSession.prototype["delete"] = function () {                                                               // 128
    function _delete(path, context) {                                                                                  //
      return this._requestHelper("DELETE", path, context);                                                             // 151
    }                                                                                                                  //
                                                                                                                       //
    return _delete;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  // TODO(someday): implement streaming and websockets for ExternalWebSession                                          //
  //postStreaming(path, mimeType, context) {                                                                           //
  //}                                                                                                                  //
                                                                                                                       //
  //putStreaming(path, mimeType, context) {                                                                            //
  //}                                                                                                                  //
                                                                                                                       //
  //openWebSocket(path, context, protocol, clientStream) {                                                             //
  //}                                                                                                                  //
                                                                                                                       //
  ExternalWebSession.prototype._requestHelper = function () {                                                          // 128
    function _requestHelper(method, path, context, content, contentType) {                                             //
      var _this = this;                                                                                                // 165
      var session = _this;                                                                                             // 166
      return new Promise(function (resolve, reject) {                                                                  // 167
        var options = _.clone(session.options);                                                                        // 168
        options.headers = options.headers || {};                                                                       // 169
        options.path = path;                                                                                           // 170
        options.method = method;                                                                                       // 171
        if (contentType) {                                                                                             // 172
          options.headers["content-type"] = contentType;                                                               // 173
        }                                                                                                              //
                                                                                                                       //
        // set accept header                                                                                           //
        if ("accept" in context) {                                                                                     // 167
          options.headers.accept = context.accept.map(function (acceptedType) {                                        // 178
            return acceptedType.mimeType + "; " + acceptedType.qValue;                                                 // 179
          }).join(", ");                                                                                               //
        } else if (!("accept" in options.headers)) {                                                                   //
          options.headers.accept = "*/*";                                                                              // 182
        }                                                                                                              //
                                                                                                                       //
        // set cookies                                                                                                 //
        if (context.cookies && context.cookies.length > 0) {                                                           // 167
          options.headers.cookies = options.headers.cookies || "";                                                     // 187
          context.cookies.forEach(function (keyVal) {                                                                  // 188
            options.headers.cookies += keyVal.key + "=" + keyVal.val + ",";                                            // 189
          });                                                                                                          //
          options.headers.cookies = options.headers.cookies.slice(0, -1);                                              // 191
        }                                                                                                              //
                                                                                                                       //
        options.host = session.host;                                                                                   // 194
        options.port = session.port;                                                                                   // 195
                                                                                                                       //
        var requestMethod = Http.request;                                                                              // 197
        if (session.protocol === "https:") {                                                                           // 198
          requestMethod = Https.request;                                                                               // 199
        }                                                                                                              //
                                                                                                                       //
        req = requestMethod(options, function (resp) {                                                                 // 202
          var buffers = [];                                                                                            // 203
          var statusInfo = responseCodes[resp.statusCode];                                                             // 204
                                                                                                                       //
          var rpcResponse = {};                                                                                        // 206
                                                                                                                       //
          switch (statusInfo.type) {                                                                                   // 208
            case "content":                                                                                            // 209
              resp.on("data", function (buf) {                                                                         // 210
                buffers.push(buf);                                                                                     // 211
              });                                                                                                      //
                                                                                                                       //
              resp.on("end", function () {                                                                             // 214
                var content = {};                                                                                      // 215
                rpcResponse.content = content;                                                                         // 216
                                                                                                                       //
                content.statusCode = statusInfo.code;                                                                  // 218
                if ("content-encoding" in resp.headers) content.encoding = resp.headers["content-encoding"];           // 219
                if ("content-language" in resp.headers) content.language = resp.headers["content-language"];           // 220
                if ("content-type" in resp.headers) content.language = resp.headers["content-type"];                   // 221
                if ("content-disposition" in resp.headers) {                                                           // 222
                  var disposition = resp.headers["content-disposition"];                                               // 223
                  var parts = disposition.split(";");                                                                  // 224
                  if (parts[0].toLowerCase().trim() === "attachment") {                                                // 225
                    parts.forEach(function (part) {                                                                    // 226
                      var splitPart = part.split("=");                                                                 // 227
                      if (splitPart[0].toLowerCase().trim() === "filename") {                                          // 228
                        content.disposition = { download: splitPart[1].trim() };                                       // 229
                      }                                                                                                //
                    });                                                                                                //
                  }                                                                                                    //
                }                                                                                                      //
                                                                                                                       //
                content.body = {};                                                                                     // 235
                content.body.bytes = Buffer.concat(buffers);                                                           // 236
                                                                                                                       //
                resolve(rpcResponse);                                                                                  // 238
              });                                                                                                      //
              break;                                                                                                   // 240
            case "noContent":                                                                                          // 208
              var noContent = {};                                                                                      // 242
              rpcResponse.noContent = noContent;                                                                       // 243
              noContent.setShouldResetForm = statusInfo.shouldResetForm;                                               // 244
              resolve(rpcResponse);                                                                                    // 245
              break;                                                                                                   // 246
            case "redirect":                                                                                           // 208
              var redirect = {};                                                                                       // 248
              rpcResponse.redirect = redirect;                                                                         // 249
              redirect.isPermanent = statusInfo.isPermanent;                                                           // 250
              redirect.switchToGet = statusInfo.switchToGet;                                                           // 251
              if ("location" in resp.headers) redirect.location = resp.headers.location;                               // 252
              resolve(rpcResponse);                                                                                    // 253
              break;                                                                                                   // 254
            case "clientError":                                                                                        // 208
              var clientError = {};                                                                                    // 256
              rpcResponse.clientError = clientError;                                                                   // 257
              clientError.statusCode = statusInfo.clientErrorCode;                                                     // 258
              clientError.descriptionHtml = statusInfo.descriptionHtml;                                                // 259
              resolve(rpcResponse);                                                                                    // 260
              break;                                                                                                   // 261
            case "serverError":                                                                                        // 208
              var serverError = {};                                                                                    // 263
              rpcResponse.serverError = serverError;                                                                   // 264
              clientError.descriptionHtml = statusInfo.descriptionHtml;                                                // 265
              resolve(rpcResponse);                                                                                    // 266
              break;                                                                                                   // 267
            default:                                                                                                   // 208
              // ???                                                                                                   //
              err = new Error("Invalid status code " + resp.statusCode + " received in response.");                    // 269
              reject(err);                                                                                             // 270
              break;                                                                                                   // 271
          }                                                                                                            // 208
        });                                                                                                            //
                                                                                                                       //
        req.on("error", function (e) {                                                                                 // 275
          reject(e);                                                                                                   // 276
        });                                                                                                            //
                                                                                                                       //
        req.setTimeout(15000, function () {                                                                            // 279
          req.abort();                                                                                                 // 280
          err = new Error("Request timed out.");                                                                       // 281
          err.kjType = "overloaded";                                                                                   // 282
          reject(err);                                                                                                 // 283
        });                                                                                                            //
                                                                                                                       //
        if (content) {                                                                                                 // 286
          req.end(content);                                                                                            // 287
        } else {                                                                                                       //
          req.end();                                                                                                   // 289
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return _requestHelper;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  return ExternalWebSession;                                                                                           //
}();                                                                                                                   //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"ip.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/ip.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Net = Npm.require("net");                                                                                          // 18
var Dgram = Npm.require("dgram");                                                                                      // 19
var Promise = Npm.require("es6-promise").Promise;                                                                      // 20
var Capnp = Npm.require("capnp");                                                                                      // 21
                                                                                                                       //
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 23
                                                                                                                       //
ByteStreamConnection = function () {                                                                                   // 25
  function ByteStreamConnection(connection) {                                                                          // 26
    (0, _classCallCheck3["default"])(this, ByteStreamConnection);                                                      //
                                                                                                                       //
    this.connection = connection;                                                                                      // 27
  }                                                                                                                    //
                                                                                                                       //
  ByteStreamConnection.prototype.done = function () {                                                                  // 25
    function done() {                                                                                                  //
      this.connection.end();                                                                                           // 31
    }                                                                                                                  //
                                                                                                                       //
    return done;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  ByteStreamConnection.prototype.write = function () {                                                                 // 25
    function write(data) {                                                                                             //
      this.connection.write(data);                                                                                     // 35
    }                                                                                                                  //
                                                                                                                       //
    return write;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  // expectSize not implemented                                                                                        //
  // expectSize(size) { }                                                                                              //
                                                                                                                       //
                                                                                                                       //
  return ByteStreamConnection;                                                                                         //
}();                                                                                                                   //
                                                                                                                       //
IpInterfaceImpl = function () {                                                                                        // 42
  function IpInterfaceImpl(persistentMethods) {                                                                        // 43
    (0, _classCallCheck3["default"])(this, IpInterfaceImpl);                                                           //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 44
  }                                                                                                                    //
                                                                                                                       //
  IpInterfaceImpl.prototype.listenTcp = function () {                                                                  // 42
    function listenTcp(portNum, port) {                                                                                //
      return new Promise(function (resolve, reject) {                                                                  // 48
        var resolved = false;                                                                                          // 49
        var server = Net.createServer(function (connection) {                                                          // 50
          var wrappedConnection = new ByteStreamConnection(connection);                                                // 51
          var upstream = port.connect(wrappedConnection).upstream;                                                     // 52
                                                                                                                       //
          connection.on("data", function (data) {                                                                      // 54
            upstream.write(data);                                                                                      // 55
          });                                                                                                          //
                                                                                                                       //
          connection.on("close", function (hadError) {                                                                 // 58
            upstream.done();                                                                                           // 59
          });                                                                                                          //
                                                                                                                       //
          connection.on("error", function (err) {                                                                      // 62
            if (resolved) {                                                                                            // 63
              connection.write = errorWrite;                                                                           // 64
            } else {                                                                                                   //
              // upstream hasn't been resolved yet, so it's safe to reject                                             //
              reject(err);                                                                                             // 67
            }                                                                                                          //
          });                                                                                                          //
        });                                                                                                            //
                                                                                                                       //
        server.listen(portNum, function () {                                                                           // 72
          resolved = true;                                                                                             // 73
          resolve({ handle: server }); // server has a close method which is all we want from a handle                 // 74
        });                                                                                                            // 72
                                                                                                                       //
        server.on("error", function (err) {                                                                            // 77
          if (!resolved) {                                                                                             // 78
            reject(err);                                                                                               // 79
          }                                                                                                            //
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return listenTcp;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  IpInterfaceImpl.prototype.listenUdp = function () {                                                                  // 42
    function listenUdp(portNum, port) {                                                                                //
      return new Promise(function (resolve, reject) {                                                                  // 86
        var portMap = {};                                                                                              // 87
        var resolved = false;                                                                                          // 88
        var server = Dgram.createSocket("udp4"); // TODO(someday): handle ipv6 sockets too                             // 89
        server.bind(portNum);                                                                                          // 86
                                                                                                                       //
        server.on("listening", function () {                                                                           // 92
          // Although UDP is connectionless, we don't resolve until here so that we can handle bind                    //
          // errors such as invalid host                                                                               //
          resolved = true;                                                                                             // 95
          resolve({ handle: server }); // server has a close method which is all we want from a handle                 // 96
        });                                                                                                            // 92
                                                                                                                       //
        server.on("error", function (err) {                                                                            // 99
          // TODO(someday): do something about errors after the promise is resolved                                    //
          if (!resolved) {                                                                                             // 101
            reject(err);                                                                                               // 102
          } else {                                                                                                     //
            console.error("error in listenUdp: " + err);                                                               // 104
          }                                                                                                            //
        });                                                                                                            //
                                                                                                                       //
        var returnMap = {};                                                                                            // 108
        server.on("message", function (msg, rinfo) {                                                                   // 109
          var address = rinfo.address + "]:" + rinfo.port;                                                             // 110
          var returnPort = returnMap[address];                                                                         // 111
                                                                                                                       //
          if (!returnPort) {                                                                                           // 113
            returnMap[address] = returnPort = new BoundUdpPortImpl(server, rinfo.address, rinfo.port);                 // 114
          }                                                                                                            //
                                                                                                                       //
          port.send(msg, returnPort);                                                                                  // 117
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return listenUdp;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  return IpInterfaceImpl;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
makeIpInterface = function makeIpInterface(persistentMethods) {                                                        // 123
  return new Capnp.Capability(new IpInterfaceImpl(persistentMethods), IpRpc.PersistentIpInterface);                    // 124
};                                                                                                                     //
                                                                                                                       //
BoundUdpPortImpl = function () {                                                                                       // 127
  function BoundUdpPortImpl(server, address, port) {                                                                   // 128
    (0, _classCallCheck3["default"])(this, BoundUdpPortImpl);                                                          //
                                                                                                                       //
    this.server = server;                                                                                              // 129
    this.address = address;                                                                                            // 130
    this.port = port;                                                                                                  // 131
  }                                                                                                                    //
                                                                                                                       //
  BoundUdpPortImpl.prototype.send = function () {                                                                      // 127
    function send(message, returnPort) {                                                                               //
      // TODO(someday): this whole class is a hack to deal with the fact that we can't compare                         //
      // capabilities or build a map with them. What we should be doing is mapping all ports to                        //
      // their raw physical address/port, and using that here                                                          //
      this.server.send(message, 0, message.length, this.port, this.address);                                           // 138
    }                                                                                                                  //
                                                                                                                       //
    return send;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return BoundUdpPortImpl;                                                                                             //
}();                                                                                                                   //
                                                                                                                       //
var bits16 = Bignum(1).shiftLeft(16).sub(1);                                                                           // 142
var bits32 = Bignum(1).shiftLeft(32).sub(1);                                                                           // 143
                                                                                                                       //
var intToIpv4 = function intToIpv4(num) {                                                                              // 145
  var part1 = num & 255;                                                                                               // 146
  var part2 = num >> 8 & 255;                                                                                          // 147
  var part3 = num >> 16 & 255;                                                                                         // 148
  var part4 = num >> 24 & 255;                                                                                         // 149
                                                                                                                       //
  return part4 + "." + part3 + "." + part2 + "." + part1;                                                              // 151
};                                                                                                                     //
                                                                                                                       //
var addressToString = function addressToString(address) {                                                              // 154
  var ipv6num = Bignum(address.upper64).shiftLeft(64).add(Bignum(address.lower64));                                    // 155
                                                                                                                       //
  if (ipv6num.shiftRight(32).eq(bits16)) {                                                                             // 157
    // this is an ipv4 address, we should return it as such                                                            //
    var ipv4num = ipv6num.and(bits32).toNumber();                                                                      // 159
    return intToIpv4(ipv4num);                                                                                         // 160
  }                                                                                                                    //
                                                                                                                       //
  var hex = ipv6num.toString(16);                                                                                      // 163
  var numColons = 0;                                                                                                   // 164
  var out = "";                                                                                                        // 165
                                                                                                                       //
  for (var i = 0; i < hex.length; ++i) {                                                                               // 167
    // start with lower bits of address and build the output in reverse                                                //
    // this ensures that we can place a colon every 4 characters                                                       //
    out += hex[hex.length - 1 - i];                                                                                    // 170
    if ((i + 1) % 4 === 0) {                                                                                           // 171
      out += ":";                                                                                                      // 172
      ++numColons;                                                                                                     // 173
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Double colon represents all bits being 0                                                                          //
  if (numColons < 7) {                                                                                                 // 154
    out += "::";                                                                                                       // 179
  }                                                                                                                    //
                                                                                                                       //
  return out.split("").reverse().join("");                                                                             // 182
};                                                                                                                     //
                                                                                                                       //
var addressType = function addressType(address) {                                                                      // 185
  var type = "udp4";                                                                                                   // 186
                                                                                                                       //
  // Check if it's an ipv6 address                                                                                     //
  // TODO(someday): make this less hacky and change address to explicitly pass this information                        //
  if (address.indexOf(":") != -1) {                                                                                    // 185
    type = "udp6";                                                                                                     // 191
  }                                                                                                                    //
                                                                                                                       //
  return type;                                                                                                         // 194
};                                                                                                                     //
                                                                                                                       //
IpNetworkImpl = function () {                                                                                          // 197
  function IpNetworkImpl(persistentMethods) {                                                                          // 198
    (0, _classCallCheck3["default"])(this, IpNetworkImpl);                                                             //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 199
  }                                                                                                                    //
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHost = function () {                                                                // 197
    function getRemoteHost(address) {                                                                                  //
      return { host: new IpRemoteHostImpl(address) };                                                                  // 203
    }                                                                                                                  //
                                                                                                                       //
    return getRemoteHost;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHostByName = function () {                                                          // 197
    function getRemoteHostByName(address) {                                                                            //
      return { host: new IpRemoteHostImpl(address) };                                                                  // 207
    }                                                                                                                  //
                                                                                                                       //
    return getRemoteHostByName;                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  return IpNetworkImpl;                                                                                                //
}();                                                                                                                   //
                                                                                                                       //
makeIpNetwork = function makeIpNetwork(persistentMethods) {                                                            // 211
  return new Capnp.Capability(new IpNetworkImpl(persistentMethods), IpRpc.PersistentIpNetwork);                        // 212
};                                                                                                                     //
                                                                                                                       //
IpRemoteHostImpl = function () {                                                                                       // 215
  function IpRemoteHostImpl(address) {                                                                                 // 216
    (0, _classCallCheck3["default"])(this, IpRemoteHostImpl);                                                          //
                                                                                                                       //
    if (address.upper64 || address.upper64 === 0) {                                                                    // 217
      // address is an ip.capnp:IpAddress, we need to convert it                                                       //
      this.address = addressToString(address);                                                                         // 219
    } else {                                                                                                           //
      this.address = address;                                                                                          // 221
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  IpRemoteHostImpl.prototype.getTcpPort = function () {                                                                // 215
    function getTcpPort(portNum) {                                                                                     //
      return { port: new TcpPortImpl(this.address, portNum) };                                                         // 226
    }                                                                                                                  //
                                                                                                                       //
    return getTcpPort;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  IpRemoteHostImpl.prototype.getUdpPort = function () {                                                                // 215
    function getUdpPort(portNum) {                                                                                     //
      return { port: new UdpPortImpl(this.address, portNum) };                                                         // 230
    }                                                                                                                  //
                                                                                                                       //
    return getUdpPort;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return IpRemoteHostImpl;                                                                                             //
}();                                                                                                                   //
                                                                                                                       //
TcpPortImpl = function () {                                                                                            // 234
  function TcpPortImpl(address, portNum) {                                                                             // 235
    (0, _classCallCheck3["default"])(this, TcpPortImpl);                                                               //
                                                                                                                       //
    this.address = address;                                                                                            // 236
    this.port = portNum;                                                                                               // 237
  }                                                                                                                    //
                                                                                                                       //
  TcpPortImpl.prototype.connect = function () {                                                                        // 234
    function connect(downstream) {                                                                                     //
      var _this = this;                                                                                                // 241
      var resolved = false;                                                                                            // 242
      return new Promise(function (resolve, reject) {                                                                  // 243
        var client = Net.connect({ host: _this.address, port: _this.port }, function () {                              // 244
          resolved = true;                                                                                             // 245
          resolve({ upstream: new ByteStreamConnection(client) });                                                     // 246
        });                                                                                                            //
                                                                                                                       //
        client.on("data", function (data) {                                                                            // 249
          downstream.write(data);                                                                                      // 250
        });                                                                                                            //
                                                                                                                       //
        client.on("close", function (hadError) {                                                                       // 253
          downstream.done();                                                                                           // 254
        });                                                                                                            //
                                                                                                                       //
        client.on("error", function (err) {                                                                            // 257
          if (resolved) {                                                                                              // 258
            client.write = errorWrite;                                                                                 // 259
          } else {                                                                                                     //
            // upstream hasn't been resolved yet, so it's safe to reject                                               //
            reject(err);                                                                                               // 262
          }                                                                                                            //
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return connect;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  return TcpPortImpl;                                                                                                  //
}();                                                                                                                   //
                                                                                                                       //
var errorWrite = function errorWrite(data) {                                                                           // 269
  throw new Error("error occurred in connection");                                                                     // 270
};                                                                                                                     //
                                                                                                                       //
UdpPortImpl = function () {                                                                                            // 273
  function UdpPortImpl(address, portNum) {                                                                             // 274
    (0, _classCallCheck3["default"])(this, UdpPortImpl);                                                               //
                                                                                                                       //
    this.address = address;                                                                                            // 275
    this.port = portNum;                                                                                               // 276
                                                                                                                       //
    var type = addressType(address);                                                                                   // 278
    this.socket = Dgram.createSocket(type);                                                                            // 279
                                                                                                                       //
    // TODO(someday): close socket after a certain time of inactivity?                                                 //
    // This may be pointless since grains are killed frequently when not in use anyways                                //
                                                                                                                       //
    // Temporary hack. We only expect clients to pass in a single return port, so we'll store it                       //
    // and only send replies here.                                                                                     //
    // This will be changed to be correct when equality comparisons are added to capabilities.                         //
    this.returnPort = null;                                                                                            // 274
                                                                                                                       //
    var _this = this;                                                                                                  // 289
    this.socket.on("message", function (msg, rinfo) {                                                                  // 290
      if (_this.returnPort) {                                                                                          // 291
        _this.returnPort.send(msg, _this);                                                                             // 292
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  UdpPortImpl.prototype.send = function () {                                                                           // 273
    function send(message, returnPort) {                                                                               //
      this.returnPort = returnPort;                                                                                    // 298
      this.socket.send(message, 0, message.length, this.port, this.address);                                           // 299
                                                                                                                       //
      // TODO(someday): use callback to catch errors and do something with them                                        //
    }                                                                                                                  // 297
                                                                                                                       //
    return send;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return UdpPortImpl;                                                                                                  //
}();                                                                                                                   //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"mail.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/mail.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Promise = Npm.require("es6-promise").Promise;                                                                      // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 22
var EmailImpl = Capnp.importSystem("sandstorm/email-impl.capnp");                                                      // 23
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 24
var SupervisorCapnp = Capnp.importSystem("sandstorm/supervisor.capnp");                                                // 25
var Supervisor = SupervisorCapnp.Supervisor;                                                                           // 26
var SystemPersistent = SupervisorCapnp.SystemPersistent;                                                               // 27
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 28
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 30
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 32
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 33
                                                                                                                       //
var RECIPIENT_LIMIT = 20;                                                                                              // 35
                                                                                                                       //
var CLIENT_TIMEOUT = 15000; // 15s                                                                                     // 37
                                                                                                                       //
// Every day, reset all per-user sent counts to zero.                                                                  //
// TODO(cleanup): Consider a more granular approach. For example, each user could have a timer                         //
//   after which their count will reset. We'd only check the timer when that user is trying to                         //
//   send a new message. This avoids a global query.                                                                   //
if (!Meteor.settings.replicaNumber) {                                                                                  // 43
  // only first replica                                                                                                //
  SandstormDb.periodicCleanup(86400000, function () {                                                                  // 44
    Meteor.users.update({ dailySentMailCount: { $exists: true } }, { $unset: { dailySentMailCount: "" } }, { multi: true });
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 51
  var server = simplesmtp.createSimpleServer({ SMTPBanner: "Sandstorm Mail Server" }, function (req) {                 // 52
    var mailparser = new MailParser();                                                                                 // 53
    req.pipe(mailparser);                                                                                              // 54
                                                                                                                       //
    mailparser.on("end", function (mail) {                                                                             // 56
      // Wrap in outer promise for easier error handling.                                                              //
      Promise.resolve().then(function () {                                                                             // 58
        // Extract the 'from' address.                                                                                 //
        var from = void 0;                                                                                             // 60
        if (mail.from && mail.from.length > 0) {                                                                       // 61
          // It's theoretically possible for the message to have multiple 'from' headers, but this                     //
          // never really happens in legitimate practice so we'll just take the first one.                             //
          from = mail.from[0];                                                                                         // 64
        } else {                                                                                                       //
          // The mail body is missing a 'From:' header. We'll use req.from instead. Note that                          //
          // req.from is actually the bounce address, which is sometimes *not* the original sender                     //
          // but rather some intermediate agent (e.g. a mailing list daemon). See:                                     //
          //   http://en.wikipedia.org/wiki/Bounce_address                                                             //
          // TODO(someday): Is this really right, or should we report a blank address instead?                         //
          from = { address: req.from, name: false };                                                                   // 71
        }                                                                                                              //
                                                                                                                       //
        var attachments = [];                                                                                          // 74
        if (mail.attachments) {                                                                                        // 75
          attachments = mail.attachments.map(function (attachment) {                                                   // 76
            var disposition = attachment.contentDisposition || "attachment";                                           // 77
            disposition += ';\n\tfilename="' + (attachment.fileName || attachment.generatedFileName) + '"';            // 78
            return {                                                                                                   // 79
              contentType: attachment.contentType,                                                                     // 80
              contentDisposition: disposition,                                                                         // 81
              contentId: attachment.contentId,                                                                         // 82
              content: attachment.content                                                                              // 83
            };                                                                                                         //
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        if (mail.replyTo && mail.replyTo.length > 1) {                                                                 // 88
          console.error("More than one reply-to address address was received in an email.");                           // 89
        }                                                                                                              //
                                                                                                                       //
        var mailMessage = {                                                                                            // 92
          // Note that converting the date to nanoseconds actually goes outside the range of                           //
          // integers that Javascript can represent precisely. But this is OK because dates aren't                     //
          // precise anyway.                                                                                           //
          date: (mail.date || new Date()).getTime() * 1000000,                                                         // 96
          from: from,                                                                                                  // 97
          to: mail.to,                                                                                                 // 98
          cc: mail.cc || [],                                                                                           // 99
          bcc: mail.bcc || [],                                                                                         // 100
          replyTo: mail.replyTo && mail.replyTo[0] || {},                                                              // 101
          messageId: mail.headers["message-id"] || Meteor.uuid() + "@" + HOSTNAME,                                     // 102
          references: mail.references || [],                                                                           // 103
          inReplyTo: mail.inReplyTo || [],                                                                             // 104
          subject: mail.subject || "",                                                                                 // 105
          text: mail.text || null,                                                                                     // 106
          html: mail.html || null,                                                                                     // 107
          attachments: attachments                                                                                     // 108
        };                                                                                                             //
                                                                                                                       //
        // Get list of grain IDs.                                                                                      //
        var grainPublicIds = _.uniq(req.to.map(function (deliverTo) {                                                  // 58
          // simplesmtp already validates that the address contains an @.                                              //
          // To simplify things, we ignore the hostname part of the address and assume that the                        //
          // message would not have been sent here if it weren't intended for our host. Usually                        //
          // there will be an nginx frontend verifying hostnames anyway. Grain public IDs are                          //
          // globally unique anyway, so an e-mail meant for another server presumably won't match                      //
          // any ID at this one anyway.                                                                                //
          return deliverTo.slice(0, deliverTo.indexOf("@"));                                                           // 119
        }));                                                                                                           //
                                                                                                                       //
        // Deliver to each grain in parallel.                                                                          //
        return Promise.all(grainPublicIds.map(function (publicId) {                                                    // 58
          // Wrap in a function so that we can call it recursively to retry.                                           //
          var tryDeliver = function tryDeliver(retryCount) {                                                           // 125
            var grainId = void 0;                                                                                      // 126
            return inMeteor(function () {                                                                              // 127
              var grain = Grains.findOne({ publicId: publicId }, { fields: {} });                                      // 128
              if (grain) {                                                                                             // 129
                grainId = grain._id;                                                                                   // 130
                return globalBackend.continueGrain(grainId, retryCount > 0);                                           // 131
              } else {                                                                                                 //
                // TODO(someday): We really ought to rig things up so that the 'RCPT TO' SMTP command                  //
                //   fails in this case, but simplesmtp doesn't appear to support that.                                //
                throw new Error("No such grain: " + publicId);                                                         // 135
              }                                                                                                        //
            }).then(function (grainInfo) {                                                                             //
              var supervisor = grainInfo.supervisor;                                                                   // 138
              var uiView = supervisor.getMainView().view;                                                              // 139
                                                                                                                       //
              // Create an arbitrary struct to use as the session params. E-mail sessions actually                     //
              // require no params, but node-capnp won't let us pass null and we don't have an                         //
              // EmptyStruct type available, so we just use EmailAddress, but any struct type would                    //
              // work.                                                                                                 //
              // TODO(cleanup): Fix node-capnp to accept null.                                                         //
              var emptyParams = Capnp.serialize(EmailRpc.EmailAddress, {});                                            // 137
                                                                                                                       //
              // Create a new session of type HackEmailSession. This is a short-term hack until                        //
              // persistent capabilities and the Powerbox are implemented. We need to pass along a                     //
              // HackSessionContext because old versions of sandstorm-http-bridge always use                           //
              // the context of the most recent session; if an old RoundCube grain has a                               //
              // WebSession open, receives an email, and then tries to send an email, the request                      //
              // will go out on the SessionContext associated with the HackEmailSession that                           //
              // delivered the email.                                                                                  //
              var session = uiView.newSession({}, makeHackSessionContext(grainId), "0xc3b5ced7344b04a6", emptyParams).session.castAs(EmailSendPort);
              return session.send(mailMessage);                                                                        // 159
            })["catch"](function (err) {                                                                               //
              if (SandstormBackend.shouldRestartGrain(err, retryCount)) {                                              // 161
                return tryDeliver(retryCount + 1);                                                                     // 162
              } else {                                                                                                 //
                throw err;                                                                                             // 164
              }                                                                                                        //
            });                                                                                                        //
          };                                                                                                           //
                                                                                                                       //
          return tryDeliver(0);                                                                                        // 169
        }));                                                                                                           //
      }).then(function () {                                                                                            //
        req.accept();                                                                                                  // 172
      }, function (err) {                                                                                              //
        console.error("E-mail delivery failure:", err.stack);                                                          // 174
        req.reject(err.message);                                                                                       // 175
      });                                                                                                              //
    });                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  if (global.SANDSTORM_SMTP_LISTEN_HANDLE) {                                                                           // 180
    server.listen(global.SANDSTORM_SMTP_LISTEN_HANDLE);                                                                // 181
  } else {                                                                                                             //
    // We must be running `run-dev.sh`.                                                                                //
    var BIND_IP = process.env.BIND_IP || "127.0.0.1";                                                                  // 184
    var SMTP_LISTEN_PORT = Meteor.settings["public"].smtpListenPort || 30025;                                          // 185
    server.listen(SMTP_LISTEN_PORT, BIND_IP);                                                                          // 186
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
function formatAddress(field) {                                                                                        // 190
  if (!field) {                                                                                                        // 191
    return null;                                                                                                       // 192
  }                                                                                                                    //
                                                                                                                       //
  if (Array.isArray(field)) {                                                                                          // 195
    return field.map(formatAddress);                                                                                   // 196
  }                                                                                                                    //
                                                                                                                       //
  if (field.name) {                                                                                                    // 199
    return field.name + " <" + field.address + ">";                                                                    // 200
  }                                                                                                                    //
                                                                                                                       //
  return field.address;                                                                                                // 203
}                                                                                                                      //
                                                                                                                       //
hackSendEmail = function hackSendEmail(session, email) {                                                               // 206
  return inMeteor(function () {                                                                                        // 207
    var recipientCount = 0;                                                                                            // 208
    recipientCount += email.to ? email.to.length : 0;                                                                  // 209
    recipientCount += email.cc ? email.cc.length : 0;                                                                  // 210
    recipientCount += email.bcc ? email.bcc.length : 0;                                                                // 211
    if (recipientCount > RECIPIENT_LIMIT) {                                                                            // 212
      throw new Error("Sorry, Sandstorm currently only allows you to send an e-mail to " + RECIPIENT_LIMIT + " recipients at a time, for spam control. Consider setting up a mailing list. " + "Please feel free to contact us if this is a problem for you.");
    }                                                                                                                  //
                                                                                                                       //
    var grainAddress = session._getAddress();                                                                          // 219
    var userAddress = session._getUserAddress();                                                                       // 220
                                                                                                                       //
    // Overwrite the 'from' address with the grain's address.                                                          //
    if (!email.from) {                                                                                                 // 207
      email.from = {                                                                                                   // 224
        address: grainAddress                                                                                          // 225
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    if (email.from.address !== grainAddress && email.from.address !== userAddress.address) {                           // 229
      throw new Error("FROM header in outgoing emails need to equal either " + grainAddress + " or " + userAddress.address + ". Yours was: " + email.from.address);
    }                                                                                                                  //
                                                                                                                       //
    var mc = new MailComposer();                                                                                       // 235
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 237
      from: formatAddress(email.from),                                                                                 // 238
      to: formatAddress(email.to),                                                                                     // 239
      cc: formatAddress(email.cc),                                                                                     // 240
      bcc: formatAddress(email.bcc),                                                                                   // 241
      replyTo: formatAddress(email.replyTo),                                                                           // 242
      subject: email.subject,                                                                                          // 243
      text: email.text,                                                                                                // 244
      html: email.html                                                                                                 // 245
    });                                                                                                                //
                                                                                                                       //
    var envelope = mc.getEnvelope();                                                                                   // 248
    envelope.from = grainAddress;                                                                                      // 249
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 251
      envelope: envelope                                                                                               // 252
    });                                                                                                                //
                                                                                                                       //
    var headers = {};                                                                                                  // 255
    if (email.messageId) {                                                                                             // 256
      mc.addHeader("message-id", email.messageId);                                                                     // 257
    }                                                                                                                  //
                                                                                                                       //
    if (email.references) {                                                                                            // 260
      mc.addHeader("references", email.references);                                                                    // 261
    }                                                                                                                  //
                                                                                                                       //
    if (email.inReplyTo) {                                                                                             // 264
      mc.addHeader("in-reply-to", email.inReplyTo);                                                                    // 265
    }                                                                                                                  //
                                                                                                                       //
    if (email.date) {                                                                                                  // 268
      var date = new Date(email.date / 1000000);                                                                       // 269
      if (!isNaN(date.getTime())) {                                                                                    // 270
        // Check to make sure date is valid                                                                            //
        mc.addHeader("date", date.toUTCString());                                                                      // 271
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    if (email.attachments) {                                                                                           // 275
      email.attachments.forEach(function (attachment) {                                                                // 276
        mc.addAttachment({                                                                                             // 277
          cid: attachment.contentId,                                                                                   // 278
          contentType: attachment.contentType,                                                                         // 279
          contentDisposition: attachment.contentDisposition,                                                           // 280
          contents: attachment.content                                                                                 // 281
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    var grain = Grains.findOne(session.grainId);                                                                       // 286
    if (!grain) throw new Error("Grain does not exist.");                                                              // 287
    globalDb.incrementDailySentMailCount(grain.userId);                                                                // 288
                                                                                                                       //
    SandstormEmail.rawSend(mc);                                                                                        // 290
  }.bind(_this))["catch"](function (err) {                                                                             //
    console.error("Error sending e-mail:", err.stack);                                                                 // 292
    throw err;                                                                                                         // 293
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
var EmailVerifierImpl = function () {                                                                                  //
  function EmailVerifierImpl(persistentMethods, id, params) {                                                          // 298
    (0, _classCallCheck3["default"])(this, EmailVerifierImpl);                                                         //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 299
    this._id = id;                                                                                                     // 300
    this._services = params.services;                                                                                  // 301
  }                                                                                                                    //
                                                                                                                       //
  EmailVerifierImpl.prototype.getId = function () {                                                                    // 297
    function getId() {                                                                                                 //
      return { id: new Buffer(this._id, "base64") };                                                                   // 305
    }                                                                                                                  //
                                                                                                                       //
    return getId;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  EmailVerifierImpl.prototype.verifyEmail = function () {                                                              // 297
    function verifyEmail(tabId, verification) {                                                                        //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      // For now, we save() the verification and then dig through ApiTokens to find where it leads.                    //
      // TODO(cleanup): In theory we should be using something like CapabilityServerSet, but it is                     //
      //   not available in Javascript yet and even if it were, it wouldn't work in the case where                     //
      //   there are multiple front-end replicas, since the verification could be on a different                       //
      //   replica.                                                                                                    //
      return verification.castAs(SystemPersistent).save({ frontend: null }).then(function (saveResult) {               // 314
        return inMeteor(function () {                                                                                  // 315
          var tokenId = hashSturdyRef(saveResult.sturdyRef);                                                           // 316
          var tokenInfo = ApiTokens.findOne(tokenId);                                                                  // 317
                                                                                                                       //
          // Delete the token now since it's not needed.                                                               //
          ApiTokens.remove(tokenId);                                                                                   // 315
                                                                                                                       //
          for (;;) {                                                                                                   // 322
            if (!tokenInfo) throw new Error("missing token?");                                                         // 323
            if (!tokenInfo.parentToken) break;                                                                         // 324
            tokenInfo = ApiTokens.findOne(tokenInfo.parentToken);                                                      // 325
          }                                                                                                            //
                                                                                                                       //
          if (!tokenInfo.frontendRef || !tokenInfo.frontendRef.verifiedEmail) {                                        // 328
            throw new Error("not a VerifiedEmail capability");                                                         // 329
          }                                                                                                            //
                                                                                                                       //
          var verification = tokenInfo.frontendRef.verifiedEmail;                                                      // 332
          if (verification.tabId !== tabId.toString("hex")) {                                                          // 333
            throw new Error("VerifiedEmail is from a different tab");                                                  // 334
          }                                                                                                            //
                                                                                                                       //
          if (_this2._services) {                                                                                      // 337
            // Since this verifier is restricted to specific services, only indicate a match if the                    //
            // VerifiedEmail was for the correct verifier ID. (If our _services is null, then we                       //
            // match all services, and therefore all VerifiedEmails.)                                                  //
            if (verification.verifierId !== _this2._id) {                                                              // 341
              throw new Error("VerifierEmail is for a different EmailVerifier.");                                      // 342
            }                                                                                                          //
          }                                                                                                            //
                                                                                                                       //
          return verification.address;                                                                                 // 346
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return verifyEmail;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  return EmailVerifierImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 350
                                                                                                                       //
var VerifiedEmailImpl = function () {                                                                                  //
  function VerifiedEmailImpl(persistentMethods, id) {                                                                  // 353
    (0, _classCallCheck3["default"])(this, VerifiedEmailImpl);                                                         //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 354
  }                                                                                                                    //
                                                                                                                       //
  return VerifiedEmailImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
makeEmailVerifier = function makeEmailVerifier(persistentMethods, id, params) {                                        // 358
  return new Capnp.Capability(new EmailVerifierImpl(persistentMethods, id, params), EmailImpl.PersistentEmailVerifier);
};                                                                                                                     //
                                                                                                                       //
makeVerifiedEmail = function makeVerifiedEmail(persistentMethods) {                                                    // 363
  return new Capnp.Capability(new VerifiedEmailImpl(persistentMethods), EmailImpl.PersistentVerifiedEmail);            // 364
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"admin-server.js":["babel-runtime/helpers/objectWithoutProperties","meteor/meteor","fs","crypto","/imports/server/auth.js",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");                              //
                                                                                                                       //
var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);                                     //
                                                                                                                       //
var _meteor = require("meteor/meteor");                                                                                // 17
                                                                                                                       //
var _fs = require("fs");                                                                                               // 18
                                                                                                                       //
var _fs2 = _interopRequireDefault(_fs);                                                                                //
                                                                                                                       //
var _crypto = require("crypto");                                                                                       // 19
                                                                                                                       //
var _crypto2 = _interopRequireDefault(_crypto);                                                                        //
                                                                                                                       //
var _auth = require("/imports/server/auth.js");                                                                        // 20
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var publicAdminSettings = ["google", "github", "ldap", "saml", "emailToken", "splashUrl", "signupDialog", "adminAlert", "adminAlertTime", "adminAlertUrl", "termsUrl", "privacyUrl", "appMarketUrl", "appIndexUrl", "appUpdatesEnabled", "serverTitle", "returnAddress", "ldapNameField", "organizationMembership", "organizationSettings"];
                                                                                                                       //
var FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS = ["customer", "expires", "features", "isElasticBilling", "isTrial", "issued", "userLimit"];
                                                                                                                       //
var PUBLIC_FEATURE_KEY_FIELDS = ["expires", "features"];                                                               // 34
                                                                                                                       //
var smtpConfigShape = {                                                                                                // 38
  hostname: String,                                                                                                    // 39
  port: Number,                                                                                                        // 40
  auth: {                                                                                                              // 41
    user: String,                                                                                                      // 42
    pass: String                                                                                                       // 43
  },                                                                                                                   //
  returnAddress: String                                                                                                // 45
};                                                                                                                     //
                                                                                                                       //
_meteor.Meteor.methods({                                                                                               // 48
  setAccountSetting: function () {                                                                                     // 49
    function setAccountSetting(token, serviceName, value) {                                                            // 49
      (0, _auth.checkAuth)(token);                                                                                     // 50
      check(serviceName, String);                                                                                      // 51
      check(value, Boolean);                                                                                           // 52
                                                                                                                       //
      // TODO(someday): currently this relies on the fact that an account is tied to a single                          //
      // identity, and thus has only that entry in "services". This will need to be looked at when                     //
      // multiple login methods/identities are allowed for a single account.                                           //
      if (!value && !(0, _auth.tokenIsValid)(token) && !(0, _auth.tokenIsSetupSession)(token) && serviceName in _meteor.Meteor.user().services) {
        throw new _meteor.Meteor.Error(403, "You can not disable the login service that your account uses.");          // 58
      }                                                                                                                //
                                                                                                                       //
      // Only check configurations for OAuth services.                                                                 //
      var oauthServices = ["google", "github"];                                                                        // 49
      if (value && oauthServices.indexOf(serviceName) != -1) {                                                         // 64
        var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                              // 65
        var config = ServiceConfiguration.configurations.findOne({ service: serviceName });                            // 66
        if (!config) {                                                                                                 // 67
          throw new _meteor.Meteor.Error(403, "You must configure the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
        }                                                                                                              //
                                                                                                                       //
        if (!config.clientId || !config.secret) {                                                                      // 72
          throw new _meteor.Meteor.Error(403, "You must provide a non-empty clientId and secret for the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      Settings.upsert({ _id: serviceName }, { $set: { value: value } });                                               // 78
      if (value) {                                                                                                     // 79
        Settings.update({ _id: serviceName }, { $unset: { automaticallyReset: 1 } });                                  // 80
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return setAccountSetting;                                                                                          //
  }(),                                                                                                                 //
                                                                                                                       //
  setSmtpConfig: function () {                                                                                         // 84
    function setSmtpConfig(token, config) {                                                                            // 84
      (0, _auth.checkAuth)(token);                                                                                     // 85
      check(config, smtpConfigShape);                                                                                  // 86
                                                                                                                       //
      Settings.upsert({ _id: "smtpConfig" }, { $set: { value: config } });                                             // 88
    }                                                                                                                  //
                                                                                                                       //
    return setSmtpConfig;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  setSetting: function () {                                                                                            // 91
    function setSetting(token, name, value) {                                                                          // 91
      (0, _auth.checkAuth)(token);                                                                                     // 92
      check(name, String);                                                                                             // 93
      check(value, Match.OneOf(null, String, Date, Boolean));                                                          // 94
                                                                                                                       //
      Settings.upsert({ _id: name }, { $set: { value: value } });                                                      // 96
    }                                                                                                                  //
                                                                                                                       //
    return setSetting;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  submitFeatureKey: function () {                                                                                      // 99
    function submitFeatureKey(token, textBlock) {                                                                      // 99
      (0, _auth.checkAuth)(token);                                                                                     // 100
      check(textBlock, Match.OneOf(null, String));                                                                     // 101
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 103
                                                                                                                       //
      if (!textBlock) {                                                                                                // 105
        // Delete the feature key.                                                                                     //
        db.collections.featureKey.remove("currentFeatureKey");                                                         // 107
        return;                                                                                                        // 108
      }                                                                                                                //
                                                                                                                       //
      // textBlock is a base64'd string, possibly with newlines and comment lines starting with "-"                    //
      var featureKeyBase64 = _.chain(textBlock.split("\n")).filter(function (line) {                                   // 99
        return line.length > 0 && line[0] !== "-";                                                                     //
      }).value().join("");                                                                                             //
                                                                                                                       //
      var buf = new Buffer(featureKeyBase64, "base64");                                                                // 117
      if (buf.length < 64) {                                                                                           // 118
        throw new _meteor.Meteor.Error(401, "Invalid feature key");                                                    // 119
      }                                                                                                                //
                                                                                                                       //
      // loadSignedFeatureKey is provided in feature-key.js                                                            //
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 99
      if (!featureKey) {                                                                                               // 124
        throw new _meteor.Meteor.Error(401, "Invalid feature key");                                                    // 125
      }                                                                                                                //
                                                                                                                       //
      // Persist the feature key in the database.                                                                      //
      db.collections.featureKey.upsert("currentFeatureKey", {                                                          // 99
        _id: "currentFeatureKey",                                                                                      // 132
        value: buf                                                                                                     // 133
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return submitFeatureKey;                                                                                           //
  }(),                                                                                                                 //
                                                                                                                       //
  saveOrganizationSettings: function () {                                                                              // 138
    function saveOrganizationSettings(token, params) {                                                                 //
      (0, _auth.checkAuth)(token);                                                                                     // 139
      check(params, {                                                                                                  // 140
        membership: {                                                                                                  // 141
          emailToken: {                                                                                                // 142
            enabled: Boolean,                                                                                          // 143
            domain: String                                                                                             // 144
          },                                                                                                           //
          google: {                                                                                                    // 146
            enabled: Boolean,                                                                                          // 147
            domain: String                                                                                             // 148
          },                                                                                                           //
          ldap: {                                                                                                      // 150
            enabled: Boolean                                                                                           // 151
          },                                                                                                           //
          saml: {                                                                                                      // 153
            enabled: Boolean                                                                                           // 154
          }                                                                                                            //
        },                                                                                                             //
        settings: {                                                                                                    // 157
          disallowGuests: Boolean,                                                                                     // 158
          shareContacts: Boolean                                                                                       // 159
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationMembership" }, { value: params.membership });
      this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationSettings" }, { value: params.settings });
    }                                                                                                                  //
                                                                                                                       //
    return saveOrganizationSettings;                                                                                   //
  }(),                                                                                                                 //
                                                                                                                       //
                                                                                                                       //
  adminConfigureLoginService: function () {                                                                            // 167
    function adminConfigureLoginService(token, options) {                                                              // 167
      (0, _auth.checkAuth)(token);                                                                                     // 168
      check(options, Match.ObjectIncluding({ service: String }));                                                      // 169
                                                                                                                       //
      var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                // 171
                                                                                                                       //
      ServiceConfiguration.configurations.upsert({ service: options.service }, options);                               // 173
    }                                                                                                                  //
                                                                                                                       //
    return adminConfigureLoginService;                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  clearResumeTokensForService: function () {                                                                           // 176
    function clearResumeTokensForService(token, serviceName) {                                                         // 176
      (0, _auth.checkAuth)(token);                                                                                     // 177
      check(serviceName, String);                                                                                      // 178
                                                                                                                       //
      var query = {};                                                                                                  // 180
      query["services." + serviceName] = { $exists: true };                                                            // 181
      _meteor.Meteor.users.find(query).forEach(function (identity) {                                                   // 182
        if (identity.services.resume && identity.services.resume.loginTokens && identity.services.resume.loginTokens.length > 0) {
          _meteor.Meteor.users.update({ _id: identity._id }, { $set: { "services.resume.loginTokens": [] } });         // 185
        }                                                                                                              //
                                                                                                                       //
        _meteor.Meteor.users.update({ "loginIdentities.id": identity._id }, { $set: { "services.resume.loginTokens": [] } });
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return clearResumeTokensForService;                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  adminUpdateUser: function () {                                                                                       // 193
    function adminUpdateUser(token, userInfo) {                                                                        // 193
      (0, _auth.checkAuth)(token);                                                                                     // 194
      check(userInfo, {                                                                                                // 195
        userId: String,                                                                                                // 196
        signupKey: Boolean,                                                                                            // 197
        isAdmin: Boolean                                                                                               // 198
      });                                                                                                              //
                                                                                                                       //
      var userId = userInfo.userId;                                                                                    // 201
      if (userId === _meteor.Meteor.userId() && !userInfo.isAdmin) {                                                   // 202
        throw new _meteor.Meteor.Error(403, "User cannot remove admin permissions from itself.");                      // 203
      }                                                                                                                //
                                                                                                                       //
      _meteor.Meteor.users.update({ _id: userId }, { $set: _.omit(userInfo, ["_id", "userId"]) });                     // 206
    }                                                                                                                  //
                                                                                                                       //
    return adminUpdateUser;                                                                                            //
  }(),                                                                                                                 //
                                                                                                                       //
  testSend: function () {                                                                                              // 209
    function testSend(token, smtpConfig, to) {                                                                         // 209
      (0, _auth.checkAuth)(token);                                                                                     // 210
      check(smtpConfig, smtpConfigShape);                                                                              // 211
      check(to, String);                                                                                               // 212
      var returnAddress = smtpConfig.returnAddress;                                                                    //
      var restConfig = (0, _objectWithoutProperties3["default"])(smtpConfig, ["returnAddress"]);                       //
                                                                                                                       //
                                                                                                                       //
      SandstormEmail.send({                                                                                            // 215
        to: to,                                                                                                        // 216
        from: globalDb.getServerTitle() + " <" + returnAddress + ">",                                                  // 217
        subject: "Testing your Sandstorm's SMTP setting",                                                              // 218
        text: "Success! Your outgoing SMTP is working.",                                                               // 219
        smtpConfig: restConfig                                                                                         // 220
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return testSend;                                                                                                   //
  }(),                                                                                                                 //
                                                                                                                       //
  createSignupKey: function () {                                                                                       // 224
    function createSignupKey(token, note, quota) {                                                                     // 224
      (0, _auth.checkAuth)(token);                                                                                     // 225
      check(note, String);                                                                                             // 226
      check(quota, Match.OneOf(undefined, null, Number));                                                              // 227
                                                                                                                       //
      var key = Random.id();                                                                                           // 229
      var content = { _id: key, used: false, note: note };                                                             // 230
      if (typeof quota === "number") content.quota = quota;                                                            // 231
      SignupKeys.insert(content);                                                                                      // 232
      return key;                                                                                                      // 233
    }                                                                                                                  //
                                                                                                                       //
    return createSignupKey;                                                                                            //
  }(),                                                                                                                 //
                                                                                                                       //
  sendInvites: function () {                                                                                           // 236
    function sendInvites(token, origin, from, list, subject, message, quota) {                                         // 236
      (0, _auth.checkAuth)(token);                                                                                     // 237
      check([origin, from, list, subject, message], [String]);                                                         // 238
      check(quota, Match.OneOf(undefined, null, Number));                                                              // 239
                                                                                                                       //
      if (!from.trim()) {                                                                                              // 241
        throw new _meteor.Meteor.Error(403, "Must enter 'from' address.");                                             // 242
      }                                                                                                                //
                                                                                                                       //
      if (!list.trim()) {                                                                                              // 245
        throw new _meteor.Meteor.Error(403, "Must enter 'to' addresses.");                                             // 246
      }                                                                                                                //
                                                                                                                       //
      this.unblock();                                                                                                  // 249
                                                                                                                       //
      list = list.split("\n");                                                                                         // 251
      for (var i in meteorBabelHelpers.sanitizeForInObject(list)) {                                                    // 252
        var email = list[i].trim();                                                                                    // 253
                                                                                                                       //
        if (email) {                                                                                                   // 255
          var key = Random.id();                                                                                       // 256
                                                                                                                       //
          var content = {                                                                                              // 258
            _id: key,                                                                                                  // 259
            used: false,                                                                                               // 260
            note: "E-mail invite to " + email,                                                                         // 261
            email: email,                                                                                              // 262
            definitelySent: false                                                                                      // 263
          };                                                                                                           //
          if (typeof quota === "number") content.quota = quota;                                                        // 265
          SignupKeys.insert(content);                                                                                  // 266
          SandstormEmail.send({                                                                                        // 267
            to: email,                                                                                                 // 268
            from: from,                                                                                                // 269
            envelopeFrom: globalDb.getReturnAddress(),                                                                 // 270
            subject: subject,                                                                                          // 271
            text: message.replace(/\$KEY/g, origin + "/signup/" + key)                                                 // 272
          });                                                                                                          //
          SignupKeys.update(key, { $set: { definitelySent: true } });                                                  // 274
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return { sent: true };                                                                                           // 278
    }                                                                                                                  //
                                                                                                                       //
    return sendInvites;                                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  offerIpNetwork: function () {                                                                                        // 281
    function offerIpNetwork(token) {                                                                                   // 281
      (0, _auth.checkAuth)(token);                                                                                     // 282
      if (!isAdmin()) {                                                                                                // 283
        throw new _meteor.Meteor.Error(403, "Offering IpNetwork is only allowed for logged in users " + "(a token is not sufficient). Please sign in with an admin account");
      }                                                                                                                //
                                                                                                                       //
      var requirements = [{ userIsAdmin: _meteor.Meteor.userId() }];                                                   // 288
      var sturdyRef = waitPromise(saveFrontendRef({ ipNetwork: true }, { webkey: null }, requirements)).sturdyRef;     // 291
      return ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef;                             // 294
    }                                                                                                                  //
                                                                                                                       //
    return offerIpNetwork;                                                                                             //
  }(),                                                                                                                 //
                                                                                                                       //
  offerIpInterface: function () {                                                                                      // 297
    function offerIpInterface(token) {                                                                                 // 297
      (0, _auth.checkAuth)(token);                                                                                     // 298
      if (!isAdmin()) {                                                                                                // 299
        throw new _meteor.Meteor.Error(403, "Offering IpInterface is only allowed for logged in users " + "(a token is not sufficient). Please sign in with an admin account");
      }                                                                                                                //
                                                                                                                       //
      var requirements = [{ userIsAdmin: _meteor.Meteor.userId() }];                                                   // 304
      var sturdyRef = waitPromise(saveFrontendRef({ ipInterface: true }, { webkey: null }, requirements)).sturdyRef;   // 307
      return ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef;                             // 310
    }                                                                                                                  //
                                                                                                                       //
    return offerIpInterface;                                                                                           //
  }(),                                                                                                                 //
                                                                                                                       //
  adminToggleDisableCap: function () {                                                                                 // 313
    function adminToggleDisableCap(token, capId, value) {                                                              // 313
      (0, _auth.checkAuth)(token);                                                                                     // 314
      check(capId, String);                                                                                            // 315
      check(value, Boolean);                                                                                           // 316
                                                                                                                       //
      if (value) {                                                                                                     // 318
        ApiTokens.update({ _id: capId }, { $set: { revoked: true } });                                                 // 319
      } else {                                                                                                         //
        ApiTokens.update({ _id: capId }, { $set: { revoked: false } });                                                // 321
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return adminToggleDisableCap;                                                                                      //
  }(),                                                                                                                 //
                                                                                                                       //
  updateQuotas: function () {                                                                                          // 325
    function updateQuotas(token, list, quota) {                                                                        // 325
      (0, _auth.checkAuth)(token);                                                                                     // 326
      check(list, String);                                                                                             // 327
      check(quota, Match.OneOf(undefined, null, Number));                                                              // 328
                                                                                                                       //
      if (!list.trim()) {                                                                                              // 330
        throw new _meteor.Meteor.Error(400, "Must enter addresses.");                                                  // 331
      }                                                                                                                //
                                                                                                                       //
      var items = list.split("\n");                                                                                    // 334
      var invalid = [];                                                                                                // 335
      for (var i in meteorBabelHelpers.sanitizeForInObject(items)) {                                                   // 336
        var modifier = typeof quota === "number" ? { $set: { quota: quota } } : { $unset: { quota: "" } };             // 337
        var n = SignupKeys.update({ email: items[i] }, modifier, { multi: true });                                     // 339
        n += _meteor.Meteor.users.update({ signupEmail: items[i] }, modifier, { multi: true });                        // 340
                                                                                                                       //
        if (n < 1) invalid.push(items[i]);                                                                             // 342
      }                                                                                                                //
                                                                                                                       //
      if (invalid.length > 0) {                                                                                        // 345
        throw new _meteor.Meteor.Error(404, "These addresses did not map to any user nor invite: " + invalid.join(", "));
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return updateQuotas;                                                                                               //
  }(),                                                                                                                 //
                                                                                                                       //
  dismissAdminStatsNotifications: function () {                                                                        // 351
    function dismissAdminStatsNotifications(token) {                                                                   // 351
      (0, _auth.checkAuth)(token);                                                                                     // 352
      globalDb.collections.notifications.remove({ "admin.type": "reportStats" });                                      // 353
    }                                                                                                                  //
                                                                                                                       //
    return dismissAdminStatsNotifications;                                                                             //
  }(),                                                                                                                 //
                                                                                                                       //
  signUpAsAdmin: function () {                                                                                         // 356
    function signUpAsAdmin(token) {                                                                                    // 356
      check(token, String);                                                                                            // 357
      (0, _auth.checkAuth)(token);                                                                                     // 358
      if (!this.userId) {                                                                                              // 359
        throw new _meteor.Meteor.Error(403, "Must be logged in to sign up as admin.");                                 // 360
      }                                                                                                                //
                                                                                                                       //
      if (!_meteor.Meteor.user().loginIdentities) {                                                                    // 363
        throw new _meteor.Meteor.Error(403, "Must be logged into an account to sign up as admin.");                    // 364
      }                                                                                                                //
                                                                                                                       //
      _meteor.Meteor.users.update({ _id: this.userId }, { $set: { isAdmin: true, signupKey: "admin" } });              // 367
      (0, _auth.clearAdminToken)(token);                                                                               // 368
    }                                                                                                                  //
                                                                                                                       //
    return signUpAsAdmin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  redeemSetupToken: function () {                                                                                      // 371
    function redeemSetupToken(token) {                                                                                 //
      // Redeem an admin token into a setup session.                                                                   //
      check(token, String);                                                                                            // 373
      if ((0, _auth.tokenIsValid)(token)) {                                                                            // 374
        var sessId = Random.secret();                                                                                  // 375
        var creationDate = new Date();                                                                                 // 376
        var hashedSessionId = _crypto2["default"].createHash("sha256").update(sessId).digest("base64");                // 377
        this.connection.sandstormDb.collections.setupSession.upsert({                                                  // 378
          _id: "current-session"                                                                                       // 379
        }, {                                                                                                           //
          creationDate: creationDate,                                                                                  // 381
          hashedSessionId: hashedSessionId                                                                             // 382
        });                                                                                                            //
        // Then, invalidate the token, so one one else can use it.                                                     //
        (0, _auth.clearAdminToken)(token);                                                                             // 374
        return sessId;                                                                                                 // 386
      } else {                                                                                                         //
        throw new _meteor.Meteor.Error(401, "Invalid setup token");                                                    // 388
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return redeemSetupToken;                                                                                           //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
var authorizedAsAdmin = function authorizedAsAdmin(token, userId) {                                                    // 393
  return Match.test(token, Match.OneOf(undefined, null, String)) && (userId && isAdminById(userId) || (0, _auth.tokenIsValid)(token) || (0, _auth.tokenIsSetupSession)(token));
};                                                                                                                     //
                                                                                                                       //
_meteor.Meteor.publish("admin", function (token) {                                                                     // 398
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 399
  return Settings.find();                                                                                              // 400
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("adminServiceConfiguration", function (token) {                                                 // 403
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 404
  return Package["service-configuration"].ServiceConfiguration.configurations.find();                                  // 405
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("publicAdminSettings", function () {                                                            // 408
  return Settings.find({ _id: { $in: publicAdminSettings } });                                                         // 409
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("adminToken", function (token) {                                                                // 412
  check(token, String);                                                                                                // 413
  this.added("adminToken", "adminToken", { tokenIsValid: (0, _auth.tokenIsValid)(token) || (0, _auth.tokenIsSetupSession)(token) });
  this.ready();                                                                                                        // 415
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("allUsers", function (token) {                                                                  // 418
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 419
  return _meteor.Meteor.users.find();                                                                                  // 420
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("adminUserDetails", function (userId) {                                                         // 423
  var _this2 = this;                                                                                                   //
                                                                                                                       //
  if (!authorizedAsAdmin(undefined, this.userId)) return [];                                                           // 424
                                                                                                                       //
  // Reactive publish of any identities owned by the account with id userId,                                           //
  // as well as that user object itself.                                                                               //
  var identitySubs = {};                                                                                               // 423
  var accountId = userId;                                                                                              // 429
                                                                                                                       //
  var unrefIdentity = function unrefIdentity(identityId) {                                                             // 431
    if (!identitySubs[identityId]) {                                                                                   // 432
      // should never happen, but if somehow you attempt to unref an identity that we don't have a                     //
      // subscription to, then don't crash                                                                             //
      console.error("attempted to unref untracked identity id:", identityId);                                          // 435
      return;                                                                                                          // 436
    }                                                                                                                  //
                                                                                                                       //
    var observeHandle = identitySubs[identityId];                                                                      // 439
    delete identitySubs[identityId];                                                                                   // 440
    observeHandle.stop();                                                                                              // 441
    _this2.removed("users", identityId);                                                                               // 442
  };                                                                                                                   //
                                                                                                                       //
  var refIdentity = function refIdentity(identityId) {                                                                 // 445
    if (identitySubs[identityId]) {                                                                                    // 446
      // should never happen, but if somehow an account wound up with a duplicate identity ID,                         //
      // avoid leaking a subscription                                                                                  //
      console.error("duplicate identity id:", identityId);                                                             // 449
      return;                                                                                                          // 450
    }                                                                                                                  //
                                                                                                                       //
    var cursor = _meteor.Meteor.users.find({ _id: identityId });                                                       // 453
    var observeHandle = cursor.observe({                                                                               // 454
      added: function () {                                                                                             // 455
        function added(doc) {                                                                                          // 455
          _this2.added("users", doc._id, doc);                                                                         // 456
        }                                                                                                              //
                                                                                                                       //
        return added;                                                                                                  //
      }(),                                                                                                             //
                                                                                                                       //
      changed: function () {                                                                                           // 459
        function changed(newDoc, oldDoc) {                                                                             // 459
          _this2.changed("users", newDoc._id, newDoc);                                                                 // 460
        }                                                                                                              //
                                                                                                                       //
        return changed;                                                                                                //
      }(),                                                                                                             //
                                                                                                                       //
      removed: function () {                                                                                           // 463
        function removed(oldDoc) {                                                                                     // 463
          _this2.removed("users", oldDoc._id);                                                                         // 464
        }                                                                                                              //
                                                                                                                       //
        return removed;                                                                                                //
      }()                                                                                                              //
    });                                                                                                                //
                                                                                                                       //
    identitySubs[identityId] = observeHandle;                                                                          // 468
  };                                                                                                                   //
                                                                                                                       //
  var accountCursor = _meteor.Meteor.users.find({ _id: accountId });                                                   // 471
  var accountSubHandle = accountCursor.observe({                                                                       // 472
    added: function () {                                                                                               // 473
      function added(newDoc) {                                                                                         // 473
        var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                    // 474
        newIdentities.forEach(function (identityId) {                                                                  // 475
          refIdentity(identityId);                                                                                     // 476
        });                                                                                                            //
                                                                                                                       //
        _this2.added("users", newDoc._id, newDoc);                                                                     // 479
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
                                                                                                                       //
    changed: function () {                                                                                             // 482
      function changed(newDoc, oldDoc) {                                                                               // 482
        var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                    // 483
        var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                    // 484
                                                                                                                       //
        // Those in newDoc - oldDoc, ref.                                                                              //
        var identitiesAdded = _.difference(newIdentities, oldIdentities);                                              // 482
        identitiesAdded.forEach(function (identityId) {                                                                // 488
          refIdentity(identityId);                                                                                     // 489
        });                                                                                                            //
                                                                                                                       //
        // Those in oldDoc - newDoc, unref.                                                                            //
        var identitiesRemoved = _.difference(oldIdentities, newIdentities);                                            // 482
        identitiesRemoved.forEach(function (identityId) {                                                              // 494
          unrefIdentity(identityId);                                                                                   // 495
        });                                                                                                            //
                                                                                                                       //
        _this2.changed("users", newDoc._id, newDoc);                                                                   // 498
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }(),                                                                                                               //
                                                                                                                       //
    removed: function () {                                                                                             // 501
      function removed(oldDoc) {                                                                                       // 501
        _this2.removed("users", oldDoc._id);                                                                           // 502
        var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                    // 503
        oldIdentities.forEach(function (identityId) {                                                                  // 504
          unrefIdentity(identityId);                                                                                   // 505
        });                                                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  this.onStop(function () {                                                                                            // 510
    accountSubHandle.stop();                                                                                           // 511
    // Also stop all the identity subscriptions.                                                                       //
    var subs = _.values(identitySubs);                                                                                 // 510
    subs.forEach(function (sub) {                                                                                      // 514
      sub.stop();                                                                                                      // 515
    });                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  // Meteor's cursor.observe() will synchronously call all of the added() callbacks from the initial                   //
  // query, so by the time we get here we can report readiness.                                                        //
  this.ready();                                                                                                        // 423
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("activityStats", function (token) {                                                             // 524
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 525
  return ActivityStats.find();                                                                                         // 526
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("statsTokens", function (token) {                                                               // 529
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 530
  return StatsTokens.find();                                                                                           // 531
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("allPackages", function (token) {                                                               // 534
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 535
  return Packages.find({ manifest: { $exists: true } }, { fields: { appId: 1, "manifest.appVersion": 1,                // 536
      "manifest.actions": 1, "manifest.appTitle": 1 } });                                                              // 538
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("realTimeStats", function (token) {                                                             // 541
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 542
                                                                                                                       //
  // Last five minutes.                                                                                                //
  this.added("realTimeStats", "now", computeStats(new Date(Date.now() - 5 * 60 * 1000)));                              // 541
                                                                                                                       //
  // Since last sample.                                                                                                //
  var lastSample = ActivityStats.findOne({}, { sort: { timestamp: -1 } });                                             // 541
  var lastSampleTime = lastSample ? lastSample.timestamp : new Date(0);                                                // 549
  this.added("realTimeStats", "today", computeStats(lastSampleTime));                                                  // 550
                                                                                                                       //
  // TODO(someday): Update every few minutes?                                                                          //
                                                                                                                       //
  this.ready();                                                                                                        // 541
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("adminLog", function (token) {                                                                  // 557
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 558
                                                                                                                       //
  var logfile = SANDSTORM_LOGDIR + "/sandstorm.log";                                                                   // 560
                                                                                                                       //
  var fd = _fs2["default"].openSync(logfile, "r");                                                                     // 562
  var startSize = _fs2["default"].fstatSync(fd).size;                                                                  // 563
                                                                                                                       //
  // Start tailing at EOF - 8k.                                                                                        //
  var offset = Math.max(0, startSize - 8192);                                                                          // 557
                                                                                                                       //
  var _this = this;                                                                                                    // 568
  function doTail() {                                                                                                  // 569
    for (;;) {                                                                                                         // 570
      var buf = new Buffer(Math.max(1024, startSize - offset));                                                        // 571
      var n = _fs2["default"].readSync(fd, buf, 0, buf.length, offset);                                                // 572
      if (n <= 0) break;                                                                                               // 573
      _this.added("adminLog", offset, { text: buf.toString("utf8", 0, n) });                                           // 574
      offset += n;                                                                                                     // 575
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Watch the file for changes.                                                                                       //
  var watcher = _fs2["default"].watch(logfile, { persistent: false }, _meteor.Meteor.bindEnvironment(doTail));         // 557
                                                                                                                       //
  // When the subscription stops, stop watching the file.                                                              //
  this.onStop(function () {                                                                                            // 557
    watcher.close();                                                                                                   // 584
    _fs2["default"].closeSync(fd);                                                                                     // 585
  });                                                                                                                  //
                                                                                                                       //
  // Read initial 8k tail data immediately.                                                                            //
  doTail();                                                                                                            // 557
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 557
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("adminApiTokens", function (token) {                                                            // 595
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 596
  return ApiTokens.find({                                                                                              // 597
    $or: [{ "frontendRef.ipNetwork": { $exists: true } }, { "frontendRef.ipInterface": { $exists: true } }]            // 598
  }, {                                                                                                                 //
    fields: {                                                                                                          // 603
      frontendRef: 1,                                                                                                  // 604
      created: 1,                                                                                                      // 605
      requirements: 1,                                                                                                 // 606
      revoked: 1,                                                                                                      // 607
      owner: 1                                                                                                         // 608
    }                                                                                                                  //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("featureKey", function (forAdmin, token) {                                                      // 613
  var _this3 = this;                                                                                                   //
                                                                                                                       //
  if (forAdmin && !authorizedAsAdmin(token, this.userId)) return [];                                                   // 614
                                                                                                                       //
  var fields = forAdmin ? FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS : PUBLIC_FEATURE_KEY_FIELDS;                          // 616
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 619
  var featureKeyQuery = db.collections.featureKey.find({ _id: "currentFeatureKey" });                                  // 620
  var observeHandle = featureKeyQuery.observe({                                                                        // 621
    added: function () {                                                                                               // 622
      function added(doc) {                                                                                            // 622
        // Load and verify the signed feature key.                                                                     //
        var buf = new Buffer(doc.value);                                                                               // 624
        var featureKey = loadSignedFeatureKey(buf);                                                                    // 625
                                                                                                                       //
        if (featureKey) {                                                                                              // 627
          var _ref;                                                                                                    //
                                                                                                                       //
          // If the signature is valid, publish the feature key information.                                           //
          var filteredFeatureKey = (_ref = _).pick.apply(_ref, [featureKey].concat(fields));                           // 629
          _this3.added("featureKey", doc._id, filteredFeatureKey);                                                     // 630
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
                                                                                                                       //
    changed: function () {                                                                                             // 634
      function changed(newDoc, oldDoc) {                                                                               // 634
        // Load and reverify the new signed feature key.                                                               //
        var buf = new Buffer(newDoc.value);                                                                            // 636
        var featureKey = loadSignedFeatureKey(buf);                                                                    // 637
                                                                                                                       //
        if (featureKey) {                                                                                              // 639
          var _ref2;                                                                                                   //
                                                                                                                       //
          // If the signature is valid, call this.changed() with the interesting fields.                               //
          var filteredFeatureKey = (_ref2 = _).pick.apply(_ref2, [featureKey].concat(fields));                         // 641
          _this3.changed("featureKey", newDoc._id, filteredFeatureKey);                                                // 642
        } else {                                                                                                       //
          // Otherwise, call this.removed(), since the new feature key is invalid.                                     //
          _this3.removed("featureKey", oldDoc._id);                                                                    // 645
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }(),                                                                                                               //
                                                                                                                       //
    removed: function () {                                                                                             // 649
      function removed(oldDoc) {                                                                                       // 649
        _this3.removed("featureKey", oldDoc._id);                                                                      // 650
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  this.onStop(function () {                                                                                            // 654
    observeHandle.stop();                                                                                              // 655
  });                                                                                                                  //
                                                                                                                       //
  this.ready();                                                                                                        // 658
});                                                                                                                    //
                                                                                                                       //
_meteor.Meteor.publish("hasAdmin", function (token) {                                                                  // 661
  var _this4 = this;                                                                                                   //
                                                                                                                       //
  // Like hasUsers, but for admins, and with token auth required.                                                      //
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 663
                                                                                                                       //
  // Query if there are any admin users.                                                                               //
  var cursor = _meteor.Meteor.users.find({ isAdmin: true });                                                           // 661
  if (cursor.count() > 0) {                                                                                            // 667
    this.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                            // 668
  } else {                                                                                                             //
    (function () {                                                                                                     //
      var handle = cursor.observeChanges({                                                                             // 670
        added: function () {                                                                                           // 671
          function added(id) {                                                                                         // 671
            _this4.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                  // 672
            handle.stop();                                                                                             // 673
            handle = null;                                                                                             // 674
          }                                                                                                            //
                                                                                                                       //
          return added;                                                                                                //
        }()                                                                                                            //
      });                                                                                                              //
      _this4.onStop(function () {                                                                                      // 677
        if (handle) handle.stop();                                                                                     // 678
      });                                                                                                              //
    })();                                                                                                              //
  }                                                                                                                    //
                                                                                                                       //
  this.ready();                                                                                                        // 682
});                                                                                                                    //
                                                                                                                       //
function observeOauthService(name) {                                                                                   // 685
  Settings.find({ _id: name, value: true }).observe({                                                                  // 686
    added: function () {                                                                                               // 687
      function added() {                                                                                               // 687
        // Tell the oauth library it should accept login attempts from this service.                                   //
        Accounts.oauth.registerService(name);                                                                          // 689
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
                                                                                                                       //
    removed: function () {                                                                                             // 692
      function removed() {                                                                                             // 692
        // Tell the oauth library it should deny login attempts from this service.                                     //
        Accounts.oauth.unregisterService(name);                                                                        // 694
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
observeOauthService("github");                                                                                         // 699
observeOauthService("google");                                                                                         // 700
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backup.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/backup.js                                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var ChildProcess = Npm.require("child_process");                                                                       // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Promise = Npm.require("es6-promise").Promise;                                                                      // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
                                                                                                                       //
var GrainInfo = Capnp.importSystem("sandstorm/grain.capnp").GrainInfo;                                                 // 22
                                                                                                                       //
var TOKEN_CLEANUP_MINUTES = 15;                                                                                        // 24
var TOKEN_CLEANUP_TIMER = TOKEN_CLEANUP_MINUTES * 60 * 1000;                                                           // 25
                                                                                                                       //
function cleanupToken(tokenId) {                                                                                       // 27
  check(tokenId, String);                                                                                              // 28
  waitPromise(globalBackend.cap().deleteBackup(tokenId));                                                              // 29
  FileTokens.remove({ _id: tokenId });                                                                                 // 30
}                                                                                                                      //
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 33
  // Cleanup tokens every TOKEN_CLEANUP_MINUTES                                                                        //
  SandstormDb.periodicCleanup(TOKEN_CLEANUP_TIMER, function () {                                                       // 35
    var queryDate = new Date(Date.now() - TOKEN_CLEANUP_TIMER);                                                        // 36
                                                                                                                       //
    FileTokens.find({ timestamp: { $lt: queryDate } }).forEach(function (token) {                                      // 38
      cleanupToken(token._id);                                                                                         // 39
    });                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Meteor.methods({                                                                                                       // 44
  backupGrain: function () {                                                                                           // 45
    function backupGrain(grainId) {                                                                                    //
      check(grainId, String);                                                                                          // 46
      var grain = Grains.findOne(grainId);                                                                             // 47
      if (!grain || !this.userId || grain.userId !== this.userId) {                                                    // 48
        throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                            // 49
      }                                                                                                                //
                                                                                                                       //
      this.unblock();                                                                                                  // 52
                                                                                                                       //
      var token = {                                                                                                    // 54
        _id: Random.id(),                                                                                              // 55
        timestamp: new Date(),                                                                                         // 56
        name: grain.title                                                                                              // 57
      };                                                                                                               //
                                                                                                                       //
      // TODO(soon): does the grain need to be offline?                                                                //
                                                                                                                       //
      var grainInfo = _.pick(grain, "appId", "appVersion", "title");                                                   // 45
                                                                                                                       //
      FileTokens.insert(token);                                                                                        // 64
      waitPromise(globalBackend.cap().backupGrain(token._id, this.userId, grainId, grainInfo));                        // 65
                                                                                                                       //
      return token._id;                                                                                                // 67
    }                                                                                                                  //
                                                                                                                       //
    return backupGrain;                                                                                                //
  }(),                                                                                                                 //
  restoreGrain: function () {                                                                                          // 70
    function restoreGrain(tokenId, identityId) {                                                                       //
      check(tokenId, String);                                                                                          // 71
      check(identityId, String);                                                                                       // 72
      var token = FileTokens.findOne(tokenId);                                                                         // 73
      if (!token || !isSignedUpOrDemo()) {                                                                             // 74
        throw new Meteor.Error(403, "Unauthorized", "Token was not found, or user cannot create grains");              // 75
      }                                                                                                                //
                                                                                                                       //
      if (isUserOverQuota(Meteor.user())) {                                                                            // 79
        throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");         // 80
      }                                                                                                                //
                                                                                                                       //
      this.unblock();                                                                                                  // 84
                                                                                                                       //
      var grainId = Random.id(22);                                                                                     // 86
                                                                                                                       //
      try {                                                                                                            // 88
        var grainInfo = waitPromise(globalBackend.cap().restoreGrain(tokenId, this.userId, grainId)["catch"](function (err) {
          console.error("Unzip failure:", err.message);                                                                // 91
          throw new Meteor.Error(500, "Invalid backup file.");                                                         // 92
        })).info;                                                                                                      //
        if (!grainInfo.appId) {                                                                                        // 94
          globalBackend.deleteGrain(grainId, this.userId);                                                             // 95
          throw new Meteor.Error(500, "Metadata object for uploaded grain has no AppId");                              // 96
        }                                                                                                              //
                                                                                                                       //
        var action = UserActions.findOne({ appId: grainInfo.appId, userId: this.userId });                             // 99
                                                                                                                       //
        // Create variables we'll use for later Mongo query.                                                           //
        var packageId = void 0;                                                                                        // 88
        var appVersion = void 0;                                                                                       // 103
                                                                                                                       //
        // DevPackages are system-wide, so we do not check the user ID.                                                //
        var devPackage = DevPackages.findOne({ appId: grainInfo.appId });                                              // 88
        if (devPackage) {                                                                                              // 107
          // If the dev app package exists, it should override the user action.                                        //
          packageId = devPackage.packageId;                                                                            // 109
          appVersion = devPackage.manifest.appVersion;                                                                 // 110
        } else if (action) {                                                                                           //
          // The app is installed, so we can continue restoring this                                                   //
          // grain.                                                                                                    //
          packageId = action.packageId;                                                                                // 114
          appVersion = action.appVersion;                                                                              // 115
        } else {                                                                                                       //
          // If the package isn't installed at all, bail out.                                                          //
          globalBackend.deleteGrain(grainId, this.userId);                                                             // 118
          throw new Meteor.Error(500, "App id for uploaded grain not installed", "App Id: " + grainInfo.appId);        // 119
        }                                                                                                              //
                                                                                                                       //
        if (appVersion < grainInfo.appVersion) {                                                                       // 124
          globalBackend.deleteGrain(grainId, this.userId);                                                             // 125
          throw new Meteor.Error(500, "App version for uploaded grain is newer than any " + "installed version. You need to upgrade your app first", "New version: " + grainInfo.appVersion + ", Old version: " + appVersion);
        }                                                                                                              //
                                                                                                                       //
        Grains.insert({                                                                                                // 133
          _id: grainId,                                                                                                // 134
          packageId: packageId,                                                                                        // 135
          appId: grainInfo.appId,                                                                                      // 136
          appVersion: appVersion,                                                                                      // 137
          userId: this.userId,                                                                                         // 138
          identityId: identityId,                                                                                      // 139
          title: grainInfo.title,                                                                                      // 140
          "private": true                                                                                              // 141
        });                                                                                                            //
      } finally {                                                                                                      //
        cleanupToken(tokenId);                                                                                         // 144
      }                                                                                                                //
                                                                                                                       //
      return grainId;                                                                                                  // 147
    }                                                                                                                  //
                                                                                                                       //
    return restoreGrain;                                                                                               //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Router.map(function () {                                                                                               // 151
  this.route("downloadBackup", {                                                                                       // 152
    where: "server",                                                                                                   // 153
    path: "/downloadBackup/:tokenId",                                                                                  // 154
    action: function () {                                                                                              // 155
      function action() {                                                                                              //
        var token = FileTokens.findOne(this.params.tokenId);                                                           // 156
        var response = this.response;                                                                                  // 157
        if (!token) {                                                                                                  // 158
          response.writeHead(404, { "Content-Type": "text/plain" });                                                   // 159
          return response.end("File does not exist");                                                                  // 160
        }                                                                                                              //
                                                                                                                       //
        var started = false;                                                                                           // 163
        var filename = (token.name.replace(/["\n]/g, "") || "backup") + ".zip";                                        // 164
        var sawEnd = false;                                                                                            // 165
                                                                                                                       //
        var stream = {                                                                                                 // 167
          expectSize: function () {                                                                                    // 168
            function expectSize(size) {                                                                                //
              if (!started) {                                                                                          // 169
                started = true;                                                                                        // 170
                response.writeHead(200, {                                                                              // 171
                  "Content-Length": size,                                                                              // 172
                  "Content-Type": "application/zip",                                                                   // 173
                  "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                    // 174
                });                                                                                                    //
              }                                                                                                        //
            }                                                                                                          //
                                                                                                                       //
            return expectSize;                                                                                         //
          }(),                                                                                                         //
          write: function () {                                                                                         // 179
            function write(data) {                                                                                     //
              if (!started) {                                                                                          // 180
                started = true;                                                                                        // 181
                response.writeHead(200, {                                                                              // 182
                  "Content-Type": "application/zip",                                                                   // 183
                  "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                    // 184
                });                                                                                                    //
              }                                                                                                        //
                                                                                                                       //
              response.write(data);                                                                                    // 188
            }                                                                                                          //
                                                                                                                       //
            return write;                                                                                              //
          }(),                                                                                                         //
          done: function () {                                                                                          // 191
            function done(data) {                                                                                      //
              if (!started) {                                                                                          // 192
                started = true;                                                                                        // 193
                response.writeHead(200, {                                                                              // 194
                  "Content-Length": 0,                                                                                 // 195
                  "Content-Type": "application/zip",                                                                   // 196
                  "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                    // 197
                });                                                                                                    //
              }                                                                                                        //
                                                                                                                       //
              sawEnd = true;                                                                                           // 201
              response.end();                                                                                          // 202
            }                                                                                                          //
                                                                                                                       //
            return done;                                                                                               //
          }()                                                                                                          //
        };                                                                                                             //
                                                                                                                       //
        waitPromise(globalBackend.cap().downloadBackup(this.params.tokenId, stream));                                  // 206
                                                                                                                       //
        if (!sawEnd) {                                                                                                 // 208
          console.error("backend failed to call done() when downloading backup");                                      // 209
          if (!started) {                                                                                              // 210
            throw new Meteor.Error(500, "backend failed to produce data");                                             // 211
          }                                                                                                            //
                                                                                                                       //
          response.end();                                                                                              // 214
        }                                                                                                              //
                                                                                                                       //
        cleanupToken(this.params.tokenId);                                                                             // 217
      }                                                                                                                //
                                                                                                                       //
      return action;                                                                                                   //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  this.route("uploadBackup", {                                                                                         // 221
    where: "server",                                                                                                   // 222
    path: "/uploadBackup",                                                                                             // 223
    action: function () {                                                                                              // 224
      function action() {                                                                                              //
        var _this = this;                                                                                              //
                                                                                                                       //
        if (this.request.method === "POST") {                                                                          // 225
          (function () {                                                                                               //
            var request = _this.request;                                                                               // 226
            try {                                                                                                      // 227
              (function () {                                                                                           //
                var token = {                                                                                          // 228
                  _id: Random.id(),                                                                                    // 229
                  timestamp: new Date()                                                                                // 230
                };                                                                                                     //
                var stream = globalBackend.cap().uploadBackup(token._id).stream;                                       // 232
                                                                                                                       //
                FileTokens.insert(token);                                                                              // 234
                                                                                                                       //
                waitPromise(new Promise(function (resolve, reject) {                                                   // 236
                  request.on("data", function (data) {                                                                 // 237
                    stream.write(data);                                                                                // 238
                  });                                                                                                  //
                  request.on("end", function () {                                                                      // 240
                    resolve(stream.done());                                                                            // 241
                  });                                                                                                  //
                  request.on("error", function (err) {                                                                 // 243
                    stream.close();                                                                                    // 244
                  });                                                                                                  //
                }));                                                                                                   //
                                                                                                                       //
                _this.response.writeHead(200, {                                                                        // 248
                  "Content-Length": token._id.length,                                                                  // 249
                  "Content-Type": "text/plain"                                                                         // 250
                });                                                                                                    //
                _this.response.write(token._id);                                                                       // 252
                _this.response.end();                                                                                  // 253
              })();                                                                                                    //
            } catch (error) {                                                                                          //
              console.error(error.stack);                                                                              // 255
              _this.response.writeHead(500, {                                                                          // 256
                "Content-Type": "text/plain"                                                                           // 257
              });                                                                                                      //
              _this.response.write(error.stack);                                                                       // 259
              _this.response.end();                                                                                    // 260
            }                                                                                                          //
          })();                                                                                                        //
        } else {                                                                                                       //
          this.response.writeHead(405, {                                                                               // 263
            "Content-Type": "text/plain"                                                                               // 264
          });                                                                                                          //
          this.response.write("You can only POST here.");                                                              // 266
          this.response.end();                                                                                         // 267
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return action;                                                                                                   //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"core.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/core.js                                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Capnp = Npm.require("capnp");                                                                                      // 18
                                                                                                                       //
var PersistentHandle = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentHandle;                              // 20
var SandstormCore = Capnp.importSystem("sandstorm/supervisor.capnp").SandstormCore;                                    // 21
var SandstormCoreFactory = Capnp.importSystem("sandstorm/backend.capnp").SandstormCoreFactory;                         // 22
var PersistentOngoingNotification = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentOngoingNotification;    // 23
var PersistentUiView = Capnp.importSystem("sandstorm/persistentuiview.capnp").PersistentUiView;                        // 24
                                                                                                                       //
var SandstormCoreImpl = function () {                                                                                  //
  function SandstormCoreImpl(grainId) {                                                                                // 27
    (0, _classCallCheck3["default"])(this, SandstormCoreImpl);                                                         //
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 28
  }                                                                                                                    //
                                                                                                                       //
  SandstormCoreImpl.prototype.restore = function () {                                                                  // 26
    function restore(sturdyRef, requiredPermissions) {                                                                 //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      var _this = this;                                                                                                // 32
      return inMeteor(function () {                                                                                    // 33
        var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                // 34
        var token = ApiTokens.findOne({                                                                                // 35
          _id: hashedSturdyRef,                                                                                        // 36
          "owner.grain.grainId": _this2.grainId                                                                        // 37
        });                                                                                                            //
                                                                                                                       //
        if (!token) {                                                                                                  // 40
          throw new Error("no such token");                                                                            // 41
        }                                                                                                              //
                                                                                                                       //
        // Honor `requiredPermissions`.                                                                                //
        var requirements = [];                                                                                         // 33
        if (requiredPermissions && token.owner.grain.introducerIdentity) {                                             // 46
          requirements.push({                                                                                          // 47
            permissionsHeld: {                                                                                         // 48
              permissions: requiredPermissions,                                                                        // 49
              identityId: token.owner.grain.introducerIdentity,                                                        // 50
              grainId: _this.grainId                                                                                   // 51
            }                                                                                                          //
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        return restoreInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this.grainId }) }, requirements, hashedSturdyRef);
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return restore;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.drop = function () {                                                                     // 26
    function drop(sturdyRef) {                                                                                         //
      var _this = this;                                                                                                // 63
      return inMeteor(function () {                                                                                    // 64
        return dropInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this.grainId }) });                  // 65
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return drop;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.makeToken = function () {                                                                // 26
    function makeToken(ref, owner, requirements) {                                                                     //
      var _this = this;                                                                                                // 70
      return inMeteor(function () {                                                                                    // 71
        var sturdyRef = new Buffer(generateSturdyRef());                                                               // 72
        var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                // 73
        ApiTokens.insert({                                                                                             // 74
          _id: hashedSturdyRef,                                                                                        // 75
          grainId: _this.grainId,                                                                                      // 76
          objectId: ref,                                                                                               // 77
          owner: owner,                                                                                                // 78
          created: new Date(),                                                                                         // 79
          requirements: requirements                                                                                   // 80
        });                                                                                                            //
                                                                                                                       //
        return {                                                                                                       // 83
          token: sturdyRef                                                                                             // 84
        };                                                                                                             //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return makeToken;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.makeChildToken = function () {                                                           // 26
    function makeChildToken(parent, owner, requirements) {                                                             //
      var _this = this;                                                                                                // 90
      return inMeteor(function () {                                                                                    // 91
        return {                                                                                                       // 92
          token: new Buffer(makeChildTokenInternal(parent, owner, requirements))                                       // 93
        };                                                                                                             //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return makeChildToken;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.getOwnerNotificationTarget = function () {                                               // 26
    function getOwnerNotificationTarget() {                                                                            //
      var grainId = this.grainId;                                                                                      // 99
      return {                                                                                                         // 100
        owner: {                                                                                                       // 101
          addOngoing: function () {                                                                                    // 102
            function addOngoing(displayInfo, notification) {                                                           // 102
              return inMeteor(function () {                                                                            // 103
                var grain = Grains.findOne({ _id: grainId });                                                          // 104
                if (!grain) {                                                                                          // 105
                  throw new Error("Grain not found.");                                                                 // 106
                }                                                                                                      //
                                                                                                                       //
                var castedNotification = notification.castAs(PersistentOngoingNotification);                           // 109
                var wakelockToken = waitPromise(castedNotification.save()).sturdyRef;                                  // 110
                                                                                                                       //
                // We have to close both the casted cap and the original. Perhaps this should be fixed in              //
                // node-capnp?                                                                                         //
                castedNotification.close();                                                                            // 103
                notification.close();                                                                                  // 115
                var notificationId = Notifications.insert({                                                            // 116
                  ongoing: wakelockToken,                                                                              // 117
                  grainId: grainId,                                                                                    // 118
                  userId: grain.userId,                                                                                // 119
                  text: displayInfo.caption,                                                                           // 120
                  timestamp: new Date(),                                                                               // 121
                  isUnread: true                                                                                       // 122
                });                                                                                                    //
                                                                                                                       //
                var persistentMethods = {                                                                              // 125
                  save: function () {                                                                                  // 126
                    function save(params) {                                                                            //
                      return saveFrontendRef({ notificationHandle: notificationId }, params.sealFor);                  // 127
                    }                                                                                                  //
                                                                                                                       //
                    return save;                                                                                       //
                  }()                                                                                                  //
                };                                                                                                     //
                                                                                                                       //
                return { handle: makeNotificationHandle(notificationId, false, persistentMethods) };                   // 131
              });                                                                                                      //
            }                                                                                                          //
                                                                                                                       //
            return addOngoing;                                                                                         //
          }()                                                                                                          //
        }                                                                                                              //
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    return getOwnerNotificationTarget;                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return SandstormCoreImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var makeSandstormCore = function makeSandstormCore(grainId) {                                                          // 139
  return new Capnp.Capability(new SandstormCoreImpl(grainId), SandstormCore);                                          // 140
};                                                                                                                     //
                                                                                                                       //
var NotificationHandle = function () {                                                                                 //
  function NotificationHandle(notificationId, saved, persistentMethods) {                                              // 144
    (0, _classCallCheck3["default"])(this, NotificationHandle);                                                        //
                                                                                                                       //
    this.notificationId = notificationId;                                                                              // 145
    this.saved = saved;                                                                                                // 146
    _.extend(this, persistentMethods);                                                                                 // 147
  }                                                                                                                    //
                                                                                                                       //
  NotificationHandle.prototype.close = function () {                                                                   // 143
    function close() {                                                                                                 //
      var _this = this;                                                                                                // 151
      return inMeteor(function () {                                                                                    // 152
        if (!_this.saved) {                                                                                            // 153
          _dismissNotification(_this.notificationId);                                                                  // 154
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  return NotificationHandle;                                                                                           //
}();                                                                                                                   //
                                                                                                                       //
var PersistentUiViewImpl = function () {                                                                               //
  function PersistentUiViewImpl(persistentMethods) {                                                                   // 161
    (0, _classCallCheck3["default"])(this, PersistentUiViewImpl);                                                      //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 162
  }                                                                                                                    //
                                                                                                                       //
  return PersistentUiViewImpl;                                                                                         //
}()                                                                                                                    //
                                                                                                                       //
// All other UiView methods are currently unimplemented, which, while not strictly correct,                            //
// results in the same overall behavior, since users can't call restore() on a PersistentUiView,                       //
// and grains can't call methods on UiViews because they lack the "is human" pseudopermission.                         //
;                                                                                                                      //
                                                                                                                       //
var makePersistentUiView = function makePersistentUiView(persistentMethods) {                                          // 170
  return new Capnp.Capability(new PersistentUiViewImpl(persistentMethods), PersistentUiView);                          // 171
};                                                                                                                     //
                                                                                                                       //
function makeNotificationHandle(notificationId, saved, persistentMethods) {                                            // 174
  return new Capnp.Capability(new NotificationHandle(notificationId, saved, persistentMethods), PersistentHandle);     // 175
}                                                                                                                      //
                                                                                                                       //
function dropWakelock(grainId, wakeLockNotificationId) {                                                               // 179
  waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                                  // 180
    return supervisor.drop({ wakeLockNotification: wakeLockNotificationId });                                          // 181
  }));                                                                                                                 //
}                                                                                                                      //
                                                                                                                       //
function _dismissNotification(notificationId, callCancel) {                                                            // 185
  var notification = Notifications.findOne({ _id: notificationId });                                                   // 186
  if (notification) {                                                                                                  // 187
    Notifications.remove({ _id: notificationId });                                                                     // 188
    if (notification.ongoing) {                                                                                        // 189
      // For some reason, Mongo returns an object that looks buffer-like, but isn't a buffer.                          //
      // Only way to fix seems to be to copy it.                                                                       //
      var id = new Buffer(notification.ongoing);                                                                       // 192
                                                                                                                       //
      if (!callCancel) {                                                                                               // 194
        dropInternal(id, { frontend: null });                                                                          // 195
      } else {                                                                                                         //
        var notificationCap = restoreInternal(id, { frontend: null }, []).cap;                                         // 197
        var castedNotification = notificationCap.castAs(PersistentOngoingNotification);                                // 198
        dropInternal(id, { frontend: null });                                                                          // 199
        try {                                                                                                          // 200
          waitPromise(castedNotification.cancel());                                                                    // 201
          castedNotification.close();                                                                                  // 202
          notificationCap.close();                                                                                     // 203
        } catch (err) {                                                                                                //
          if (err.kjType !== "disconnected") {                                                                         // 205
            // ignore disconnected errors, since cancel may shutdown the grain before the supervisor                   //
            // responds.                                                                                               //
            throw err;                                                                                                 // 208
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
    } else if (notification.appUpdates) {                                                                              //
      _.forEach(notification.appUpdates, function (app, appId) {                                                       // 213
        deletePackage(app.packageId);                                                                                  // 214
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
hashSturdyRef = function hashSturdyRef(sturdyRef) {                                                                    // 220
  return Crypto.createHash("sha256").update(sturdyRef).digest("base64");                                               // 221
};                                                                                                                     //
                                                                                                                       //
function generateSturdyRef() {                                                                                         // 224
  return Random.secret();                                                                                              // 225
}                                                                                                                      //
                                                                                                                       //
Meteor.methods({                                                                                                       // 228
  dismissNotification: function () {                                                                                   // 229
    function dismissNotification(notificationId) {                                                                     //
      // This will remove notifications from the database and from view of the user.                                   //
      // For ongoing notifications, it will begin the process of cancelling and dropping them from                     //
      // the app.                                                                                                      //
                                                                                                                       //
      check(notificationId, String);                                                                                   // 234
                                                                                                                       //
      var notification = Notifications.findOne({ _id: notificationId });                                               // 236
      if (!notification) {                                                                                             // 237
        throw new Meteor.Error(404, "Notification id not found.");                                                     // 238
      } else if (notification.userId !== Meteor.userId()) {                                                            //
        throw new Meteor.Error(403, "Notification does not belong to current user.");                                  // 240
      } else {                                                                                                         //
        _dismissNotification(notificationId, true);                                                                    // 242
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return dismissNotification;                                                                                        //
  }(),                                                                                                                 //
  readAllNotifications: function () {                                                                                  // 246
    function readAllNotifications() {                                                                                  //
      // Marks all notifications as read for the current user.                                                         //
      if (!Meteor.userId()) {                                                                                          // 248
        throw new Meteor.Error(403, "User not logged in.");                                                            // 249
      }                                                                                                                //
                                                                                                                       //
      Notifications.update({ userId: Meteor.userId() }, { $set: { isUnread: false } }, { multi: true });               // 252
    }                                                                                                                  //
                                                                                                                       //
    return readAllNotifications;                                                                                       //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
saveFrontendRef = function saveFrontendRef(frontendRef, owner, requirements) {                                         // 256
  return inMeteor(function () {                                                                                        // 257
    var sturdyRef = new Buffer(generateSturdyRef());                                                                   // 258
    var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                    // 259
    ApiTokens.insert({                                                                                                 // 260
      _id: hashedSturdyRef,                                                                                            // 261
      frontendRef: frontendRef,                                                                                        // 262
      owner: owner,                                                                                                    // 263
      created: new Date(),                                                                                             // 264
      requirements: requirements                                                                                       // 265
    });                                                                                                                //
    return { sturdyRef: sturdyRef };                                                                                   // 267
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
checkRequirements = function (_checkRequirements) {                                                                    // 271
  function checkRequirements(_x) {                                                                                     //
    return _checkRequirements.apply(this, arguments);                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  checkRequirements.toString = function () {                                                                           //
    return _checkRequirements.toString();                                                                              //
  };                                                                                                                   //
                                                                                                                       //
  return checkRequirements;                                                                                            //
}(function (requirements) {                                                                                            //
  if (!requirements) {                                                                                                 // 272
    return true;                                                                                                       // 273
  }                                                                                                                    //
                                                                                                                       //
  for (var i in meteorBabelHelpers.sanitizeForInObject(requirements)) {                                                // 276
    var requirement = requirements[i];                                                                                 // 277
    if (requirement.tokenValid) {                                                                                      // 278
      var token = ApiTokens.findOne({ _id: requirement.tokenValid, revoked: { $ne: true } }, { fields: { requirements: 1 } });
      if (!token || !checkRequirements(token.requirements)) {                                                          // 281
        return false;                                                                                                  // 282
      }                                                                                                                //
                                                                                                                       //
      if (token.parentToken && !checkRequirements([{ tokenValid: token.parentToken }])) {                              // 285
        return false;                                                                                                  // 286
      }                                                                                                                //
    } else if (requirement.permissionsHeld) {                                                                          //
      var p = requirement.permissionsHeld;                                                                             // 289
      var viewInfo = Grains.findOne(p.grainId, { fields: { cachedViewInfo: 1 } }).cachedViewInfo;                      // 290
      var currentPermissions = SandstormPermissions.grainPermissions(globalDb, { grain: { _id: p.grainId, identityId: p.identityId } }, viewInfo || {}).permissions;
      if (!currentPermissions) {                                                                                       // 294
        return false;                                                                                                  // 295
      }                                                                                                                //
                                                                                                                       //
      for (var ii = 0; ii < p.permissions.length; ++ii) {                                                              // 298
        if (p.permissions[ii] && !currentPermissions[ii]) {                                                            // 299
          return false;                                                                                                // 300
        }                                                                                                              //
      }                                                                                                                //
    } else if (requirement.userIsAdmin) {                                                                              //
      if (!isAdminById(requirement.userIsAdmin)) {                                                                     // 304
        return false;                                                                                                  // 305
      }                                                                                                                //
    } else {                                                                                                           //
      throw new Meteor.Error(403, "Unknown requirement");                                                              // 308
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return true;                                                                                                         // 312
});                                                                                                                    //
                                                                                                                       //
restoreInternal = function (_restoreInternal) {                                                                        // 315
  function restoreInternal(_x2, _x3, _x4, _x5) {                                                                       //
    return _restoreInternal.apply(this, arguments);                                                                    //
  }                                                                                                                    //
                                                                                                                       //
  restoreInternal.toString = function () {                                                                             //
    return _restoreInternal.toString();                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  return restoreInternal;                                                                                              //
}(function (originalToken, ownerPattern, requirements, tokenId) {                                                      //
  // Restores the token `originalToken`, which is a Buffer.                                                            //
  //                                                                                                                   //
  // `ownerPattern` is a match pattern (i.e. used with check()) that the token's owner must match.                     //
  // This is used to enforce than an entity can't use tokens owned by some other entity.                               //
  //                                                                                                                   //
  // `requirements` is a list of additional MembraneRequirements to add to the returned capability,                    //
  // beyond what's already stored in ApiTokens. This is often an empty list.                                           //
  //                                                                                                                   //
  // `tokenId` is optional. If specified, it should be hashSturdyRef(originalToken); only specify                      //
  // it if you happen to have computed this already.                                                                   //
  //                                                                                                                   //
  // (When the token turns out to have a parent, this function will call itself recursively. When                      //
  // it does, `originalToken` stays the same, but `tokenId` is replaced with the parent. This is                       //
  // because the capability we ultimately restore needs to become a child of the token that is                         //
  // being restored.)                                                                                                  //
                                                                                                                       //
  tokenId = tokenId || hashSturdyRef(originalToken);                                                                   // 332
  requirements = requirements || [];                                                                                   // 333
                                                                                                                       //
  var token = ApiTokens.findOne(tokenId);                                                                              // 335
  if (!token) {                                                                                                        // 336
    throw new Meteor.Error(403, "No token found to restore");                                                          // 337
  }                                                                                                                    //
                                                                                                                       //
  if (token.revoked) {                                                                                                 // 340
    throw new Meteor.Error(403, "Token has been revoked");                                                             // 341
  }                                                                                                                    //
                                                                                                                       //
  // The ownerPattern should specify the appropriate user or grain involved, if appropriate.                           //
  check(token.owner, ownerPattern);                                                                                    // 315
                                                                                                                       //
  // Check requirements on the token.                                                                                  //
  if (!checkRequirements(token.requirements)) {                                                                        // 315
    throw new Meteor.Error(403, "Requirements not satisfied.");                                                        // 349
  }                                                                                                                    //
                                                                                                                       //
  // Check expiration.                                                                                                 //
  if (token.expires && token.expires.getTime() <= Date.now()) {                                                        // 315
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 354
  }                                                                                                                    //
                                                                                                                       //
  if (token.expiresIfUnused) {                                                                                         // 357
    if (token.expiresIfUnused.getTime() <= Date.now()) {                                                               // 358
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 359
    } else {                                                                                                           //
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(token._id, { $unset: { expiresIfUnused: "" } });                                                // 362
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // If this token has a parent, go ahead and recurse to it now.                                                       //
  if (token.parentToken) {                                                                                             // 315
    // A token which chains to some parent token.  Restore the parent token (possibly recursively),                    //
    // checking requirements on the way up.                                                                            //
    return restoreInternal(originalToken, Match.Any, requirements, token.parentToken);                                 // 370
  }                                                                                                                    //
                                                                                                                       //
  // Check the passed-in `requirements`.                                                                               //
  if (!checkRequirements(requirements)) {                                                                              // 315
    throw new Meteor.Error(403, "Requirements not satisfied.");                                                        // 375
  }                                                                                                                    //
                                                                                                                       //
  // The capability we restore must implement SystemPersistent, and we already know what the                           //
  // implementation will look like. So, construct it here.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): It would probably be a lot cleaner to have a common base class that these                          //
  //   inherit, and to pass down some common parameters to the constructor.                                            //
  var persistentMethods = {                                                                                            // 315
    save: function () {                                                                                                // 384
      function save(params) {                                                                                          //
        return inMeteor(function () {                                                                                  // 385
          var sturdyRef = new Buffer(makeChildTokenInternal(originalToken, params.sealFor, requirements, token));      // 386
          return { sturdyRef: sturdyRef };                                                                             // 388
        });                                                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return save;                                                                                                     //
    }()                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  // TODO(someday): Implement SystemPersistent.addRequirements().                                                      //
  if (token.frontendRef) {                                                                                             // 395
    // A token which represents a capability implemented by a pseudo-driver.                                           //
                                                                                                                       //
    if (token.frontendRef.notificationHandle) {                                                                        // 398
      var notificationId = token.frontendRef.notificationHandle;                                                       // 399
      return { cap: makeNotificationHandle(notificationId, true, persistentMethods) };                                 // 400
    } else if (token.frontendRef.ipNetwork) {                                                                          //
      return { cap: makeIpNetwork(persistentMethods) };                                                                // 402
    } else if (token.frontendRef.ipInterface) {                                                                        //
      return { cap: makeIpInterface(persistentMethods) };                                                              // 404
    } else if (token.frontendRef.emailVerifier) {                                                                      //
      return { cap: makeEmailVerifier(persistentMethods, tokenId, token.frontendRef.emailVerifier) };                  // 406
    } else if (token.frontendRef.verifiedEmail) {                                                                      //
      return { cap: makeVerifiedEmail(persistentMethods) };                                                            // 409
    } else {                                                                                                           //
      throw new Meteor.Error(500, "Unknown frontend token type.");                                                     // 411
    }                                                                                                                  //
  } else if (token.objectId) {                                                                                         //
    // A token which represents a specific capability exported by a grain.                                             //
                                                                                                                       //
    // Fix Mongo converting Buffers to Uint8Arrays.                                                                    //
    if (token.objectId.appRef) {                                                                                       // 417
      token.objectId.appRef = new Buffer(token.objectId.appRef);                                                       // 418
    }                                                                                                                  //
                                                                                                                       //
    // Ensure the grain is running, then restore the capability.                                                       //
    return waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                   // 413
      // Note that in this case it is the supervisor's job to implement SystemPersistent, so we                        //
      // discard persistentMethods.                                                                                    //
      return supervisor.restore(token.objectId, requirements, originalToken);                                          // 425
    }));                                                                                                               //
  } else if (token.grainId) {                                                                                          //
    // It's a UiView.                                                                                                  //
                                                                                                                       //
    // If a grain is attempting to restore a UiView, it gets a UiView which filters out all                            //
    // the method calls.  In the future, we may allow grains to restore UiViews that pass along the                    //
    // "is human" pseudopermission (say, to allow an app to proxy all requests to some grain and                       //
    // do some transformation), which will return a different capability.                                              //
    return { cap: makePersistentUiView(persistentMethods) };                                                           // 434
  } else {                                                                                                             //
    throw new Meteor.Error(500, "Unknown token type. ID: " + token._id);                                               // 436
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
function dropInternal(sturdyRef, ownerPattern) {                                                                       // 440
  // Drops `sturdyRef`, checking first that its owner matches `ownerPattern`.                                          //
                                                                                                                       //
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 443
  var token = ApiTokens.findOne({ _id: hashedSturdyRef });                                                             // 444
  if (!token) {                                                                                                        // 445
    return;                                                                                                            // 446
  }                                                                                                                    //
                                                                                                                       //
  check(token.owner, ownerPattern);                                                                                    // 449
                                                                                                                       //
  if (token.frontendRef) {                                                                                             // 451
    if (token.frontendRef.notificationHandle) {                                                                        // 452
      var notificationId = token.frontendRef.notificationHandle;                                                       // 453
      globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                              // 454
      var anyToken = ApiTokens.findOne({ "frontendRef.notificationHandle": notificationId });                          // 455
      if (!anyToken) {                                                                                                 // 456
        // No other tokens referencing this notification exist, so dismiss the notification                            //
        _dismissNotification(notificationId);                                                                          // 458
      }                                                                                                                //
    } else {                                                                                                           //
      throw new Error("Unknown frontend token type.");                                                                 // 461
    }                                                                                                                  //
  } else if (token.objectId) {                                                                                         //
    if (token.objectId.wakeLockNotification) {                                                                         // 464
      dropWakelock(token.grainId, token.objectId.wakeLockNotification);                                                // 465
    } else {                                                                                                           //
      throw new Error("Unknown objectId token type.");                                                                 // 467
    }                                                                                                                  //
  } else {                                                                                                             //
    throw new Error("Unknown token type.");                                                                            // 470
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
function makeChildTokenInternal(rawParentToken, owner, requirements, tokenInfo) {                                      // 474
  var hashedParent = hashSturdyRef(rawParentToken);                                                                    // 475
                                                                                                                       //
  // If we don't have tokenInfo (we were called from SandstormCore.makeChildToken()), look up                          //
  // the parent token now and use that.                                                                                //
  // TODO(someday): I think this makeChildToken() will lose titles because of this.                                    //
  //   Option 1: Somehow pass info through the supervisor for it to pass back through                                  //
  //       makeChildToken().                                                                                           //
  //   Option 2: Follow the chain of parentTokens here.                                                                //
  //   Option 3: Maybe the title should actually be passed in a PowerboxDescriptor which the app                       //
  //       is expected to thread through to offer(). This is analogous to how file transfers                           //
  //       work: the file name is not normally stored in the content. Our petname system for                           //
  //       grains already matches that model better -- and if we decide to get rid of said petname                     //
  //       system and instead have everyone see the author's title, then we'd presumably stop                          //
  //       storing it in the token `owner` field altogether, so this becomes moot.                                     //
  tokenInfo = tokenInfo || ApiTokens.findOne(hashedParent);                                                            // 474
  if (!tokenInfo) {                                                                                                    // 490
    throw new Error("parent token doesn't exist");                                                                     // 491
  }                                                                                                                    //
                                                                                                                       //
  if (tokenInfo.identityId) {                                                                                          // 494
    // This is a UiView capability. We need to use SandstormPermissions to create it in order                          //
    // to properly denormalize fields.                                                                                 //
                                                                                                                       //
    if (owner.user) {                                                                                                  // 498
      // Initialize the grain's title to a copy of the title set by the human user closest in the                      //
      // sharing graph. It turns out that the "root token" is actually the token representing that                     //
      // user, not the grain owner, because user-to-user sharing relationships are not parent-child                    //
      // token relationships.                                                                                          //
      var rootTitle = (((tokenInfo.owner || {}).grain || {}).saveLabel || {}).defaultText;                             // 503
      if (!owner.user.title && rootTitle) {                                                                            // 504
        owner.user.title = rootTitle;                                                                                  // 505
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: rawParentToken }, tokenInfo.grainId, tokenInfo.petname, { allAccess: null }, owner).token;
  }                                                                                                                    //
                                                                                                                       //
  if (owner.user) {                                                                                                    // 513
    throw new Error("can't save non-UiView with user as owner");                                                       // 514
  }                                                                                                                    //
                                                                                                                       //
  var sturdyRef = generateSturdyRef();                                                                                 // 517
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 518
                                                                                                                       //
  var newTokenInfo = {                                                                                                 // 520
    _id: hashedSturdyRef,                                                                                              // 521
    parentToken: hashedParent,                                                                                         // 522
    owner: owner,                                                                                                      // 523
    created: new Date(),                                                                                               // 524
    requirements: requirements                                                                                         // 525
  };                                                                                                                   //
                                                                                                                       //
  // For non-UiView capabilities, we need not denormalize grainId, identityId, etc. into the child                     //
  // token.                                                                                                            //
                                                                                                                       //
  ApiTokens.insert(newTokenInfo);                                                                                      // 474
                                                                                                                       //
  return sturdyRef;                                                                                                    // 533
};                                                                                                                     //
                                                                                                                       //
function SandstormCoreFactoryImpl() {}                                                                                 // 536
                                                                                                                       //
SandstormCoreFactoryImpl.prototype.getSandstormCore = function (grainId) {                                             // 539
  return { core: makeSandstormCore(grainId) };                                                                         // 540
};                                                                                                                     //
                                                                                                                       //
makeSandstormCoreFactory = function makeSandstormCoreFactory() {                                                       // 543
  return new Capnp.Capability(new SandstormCoreFactoryImpl(), SandstormCoreFactory);                                   // 544
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/demo-server.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var DEMO_EXPIRATION_MS = 60 * 60 * 1000;                                                                               // 17
var DEMO_GRACE_MS = 10 * 60 * 1000; // time between expiration and deletion                                            // 18
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 20
  // Enforce expiration times for demo accounts.                                                                       //
                                                                                                                       //
  if (attempt.user && attempt.user.expires) {                                                                          // 23
    (function () {                                                                                                     //
      var expireIn = attempt.user.expires.getTime() - Date.now() + DEMO_GRACE_MS;                                      // 24
      if (expireIn < 0) {                                                                                              // 25
        throw new Meteor.Error(403, "This demo account has expired.");                                                 // 26
      }                                                                                                                //
                                                                                                                       //
      if (!allowDemo) {                                                                                                // 29
        // An expiration time implies that this is a demo account, but those have been disabled.                       //
        // Perhaps the config was just changed.                                                                        //
        throw new Meteor.Error(403, "Demo accounts have been disabled.");                                              // 32
      }                                                                                                                //
                                                                                                                       //
      // Force connection close when account expires, so that the client reconnects and                                //
      // re-authenticates, which fails.                                                                                //
      var connection = attempt.connection;                                                                             // 37
      var handle = Meteor.setTimeout(function () {                                                                     // 38
        connection.close();                                                                                            // 38
      }, expireIn);                                                                                                    //
                                                                                                                       //
      connection.onClose(function () {                                                                                 // 40
        Meteor.clearTimeout(handle);                                                                                   // 40
      });                                                                                                              //
    })();                                                                                                              //
  }                                                                                                                    //
                                                                                                                       //
  return true;                                                                                                         // 43
});                                                                                                                    //
                                                                                                                       //
function cleanupExpiredUsers() {                                                                                       // 46
  // Delete expired demo accounts and all their grains.                                                                //
                                                                                                                       //
  var now = new Date(Date.now() - DEMO_GRACE_MS);                                                                      // 49
  Meteor.users.find({ expires: { $lt: now } }, { fields: { _id: 1, loginIdentities: 1, lastActive: 1, appDemoId: 1 } }).forEach(function (user) {
    Grains.find({ userId: user._id }, { fields: { _id: 1, lastUsed: 1, appId: 1 } }).forEach(function (grain) {        // 53
      console.log("delete grain: " + grain._id);                                                                       // 55
      globalDb.removeApiTokens({ grainId: grain._id });                                                                // 56
      Grains.remove(grain._id);                                                                                        // 57
      if (grain.lastUsed) {                                                                                            // 58
        DeleteStats.insert({ type: "demoGrain", lastActive: grain.lastUsed, appId: grain.appId });                     // 59
      }                                                                                                                //
                                                                                                                       //
      globalBackend.deleteGrain(grain._id, user._id);                                                                  // 62
    });                                                                                                                //
                                                                                                                       //
    console.log("delete user: " + user._id);                                                                           // 65
    // We intentionally do not do `ApiTokens.remove({accountId: user._id})`, because some such                         //
    // tokens might still play an active role in the sharing graph.                                                    //
    Contacts.remove({ ownerId: user._id });                                                                            // 52
    UserActions.remove({ userId: user._id });                                                                          // 69
    Notifications.remove({ userId: user._id });                                                                        // 70
    Meteor.users.remove(user._id);                                                                                     // 71
    waitPromise(globalBackend.cap().deleteUser(user._id));                                                             // 72
    if (user.loginIdentities && user.lastActive) {                                                                     // 73
      // When deleting a user, we can specify it as a "normal" user                                                    //
      // (type: user) or as a user who started out by using the app                                                    //
      // demo feature (type: appDemoUser).                                                                             //
      var deleteStatsType = "demoUser";                                                                                // 77
      var isAppDemoUser = !!user.appDemoId;                                                                            // 78
      if (isAppDemoUser) {                                                                                             // 79
        deleteStatsType = "appDemoUser";                                                                               // 80
      }                                                                                                                //
                                                                                                                       //
      // Intentionally record deleted users at time of deletion to avoid miscounting users that                        //
      // were demoing just before the day rolled over.                                                                 //
      DeleteStats.insert({ type: deleteStatsType, lastActive: new Date(), appId: user.appDemoId });                    // 73
    }                                                                                                                  //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
if (allowDemo) {                                                                                                       // 90
  Meteor.methods({                                                                                                     // 91
    createDemoUser: function () {                                                                                      // 92
      function createDemoUser(displayName, appDemoId) {                                                                // 92
        // This is a login method that creates a new temporary user                                                    //
        // every time it is used.                                                                                      //
        //                                                                                                             //
        // appDemoId is important for stats; see cleanupExpiredUsers().                                                //
        check(displayName, String);                                                                                    // 97
        check(appDemoId, Match.OneOf(undefined, null, String));                                                        // 98
                                                                                                                       //
        // Create the new user.                                                                                        //
        var newUser = { expires: new Date(Date.now() + DEMO_EXPIRATION_MS) };                                          // 92
        if (appDemoId) {                                                                                               // 102
          newUser.appDemoId = appDemoId;                                                                               // 103
        }                                                                                                              //
                                                                                                                       //
        var userId = Accounts.insertUserDoc({ profile: { name: displayName } }, newUser);                              // 106
                                                                                                                       //
        // Log them in on this connection.                                                                             //
        return Accounts._loginMethod(this, "createDemoUser", arguments, "demo", function () {                          // 92
          return { userId: userId };                                                                                   // 110
        });                                                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return createDemoUser;                                                                                           //
    }(),                                                                                                               //
                                                                                                                       //
    testExpireDemo: function () {                                                                                      // 113
      function testExpireDemo() {                                                                                      // 113
        if (!isDemoUser()) throw new Meteor.Error(403, "not a demo user");                                             // 114
                                                                                                                       //
        var newExpires = new Date(Date.now() + 15000);                                                                 // 116
        if (Meteor.user().expires.getTime() < newExpires.getTime()) {                                                  // 117
          throw new Meteor.Error(403, "can't exend demo");                                                             // 118
        }                                                                                                              //
                                                                                                                       //
        Meteor.users.update(this.userId, { $set: { expires: newExpires } });                                           // 121
      }                                                                                                                //
                                                                                                                       //
      return testExpireDemo;                                                                                           //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  // If demo mode is enabled, we permit the client to subscribe to                                                     //
  // information about an app by appId. If this were available in                                                      //
  // non-demo mode, then anonymous users could effectively ask the                                                     //
  // server which apps are installed.                                                                                  //
  Meteor.publish("appInfo", function (appId) {                                                                         // 90
    // This publishes info about an app, including the latest                                                          //
    // version of it. Once you log in, it also publishes your                                                          //
    // list of UserActions.                                                                                            //
    check(appId, String);                                                                                              // 133
                                                                                                                       //
    var packageCursor = Packages.find({ appId: appId }, { sort: { "manifest.appVersion": -1 } });                      // 135
                                                                                                                       //
    var pkg = packageCursor.fetch()[0];                                                                                // 139
                                                                                                                       //
    // This allows us to avoid creating duplicate UserActions.                                                         //
    if (this.userId) {                                                                                                 // 129
      return [packageCursor, UserActions.find({ userId: this.userId, appId: appId })];                                 // 143
    }                                                                                                                  //
                                                                                                                       //
    return packageCursor;                                                                                              // 149
  });                                                                                                                  //
                                                                                                                       //
  SandstormDb.periodicCleanup(DEMO_EXPIRATION_MS, cleanupExpiredUsers);                                                // 152
} else {                                                                                                               //
  // Just run once, in case the config just changed from allowing demos to prohibiting them.                           //
  Meteor.setTimeout(cleanupExpiredUsers, DEMO_EXPIRATION_MS + DEMO_GRACE_MS);                                          // 155
}                                                                                                                      //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/dev-accounts-server.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  createDevAccount: function () {                                                                                      // 20
    function createDevAccount(displayName, isAdmin, profile, unverifiedEmail) {                                        // 20
      // This is a login method that creates or logs in a dev account with the given displayName                       //
                                                                                                                       //
      check(displayName, String);                                                                                      // 23
      check(isAdmin, Match.OneOf(undefined, null, Boolean));                                                           // 24
      check(profile, Match.OneOf(undefined, null, Object));                                                            // 25
      check(unverifiedEmail, Match.OneOf(undefined, null, String));                                                    // 26
                                                                                                                       //
      if (!this.connection.sandstormDb.allowDevAccounts()) {                                                           // 28
        throw new Meteor.Error(404, "Dev accounts are not enabled on this server");                                    // 29
      }                                                                                                                //
                                                                                                                       //
      isAdmin = isAdmin || false;                                                                                      // 32
                                                                                                                       //
      profile = profile || {};                                                                                         // 34
      profile.name = profile.name || displayName;                                                                      // 35
      var hasCompletedSignup = !!unverifiedEmail && !!profile.pronoun && !!profile.handle;                             // 36
                                                                                                                       //
      var user = Meteor.users.findOne({ "services.dev.name": displayName });                                           // 38
      var userId = void 0;                                                                                             // 39
                                                                                                                       //
      if (user) {                                                                                                      // 41
        userId = user._id;                                                                                             // 42
      } else {                                                                                                         //
        userId = Accounts.insertUserDoc({                                                                              // 44
          profile: profile,                                                                                            // 45
          unverifiedEmail: unverifiedEmail                                                                             // 46
        }, {                                                                                                           //
          services: {                                                                                                  // 48
            dev: {                                                                                                     // 49
              name: displayName,                                                                                       // 50
              isAdmin: isAdmin,                                                                                        // 51
              hasCompletedSignup: hasCompletedSignup                                                                   // 52
            }                                                                                                          //
          }                                                                                                            //
        });                                                                                                            //
      }                                                                                                                //
      // Log them in on this connection.                                                                               //
      return Accounts._loginMethod(this, "createDevAccount", arguments, "dev", function () {                           // 20
        return { userId: userId };                                                                                     // 59
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return createDevAccount;                                                                                           //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"feature-key.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/feature-key.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var FeatureKey = Capnp.importSystem("sandstorm/feature-key.capnp").FeatureKey;                                         // 18
                                                                                                                       //
// We don't currently have a way of reading the raw bytes of a capnp struct in Javascript the                          //
// way we do in C++. Awkwardly, what we end up with is four 64-bit ints that have been stringified                     //
// since JS can't actually deal with 64-bit ints. We have to laboriously reconstruct the underlying                    //
// bytes using Bignum. Don't forget that everything is little-endian, as DJBeesus intended.                            //
var bits0 = Bignum(FeatureKey.signingKey.key0);                                                                        // 24
var bits1 = Bignum(FeatureKey.signingKey.key1);                                                                        // 25
var bits2 = Bignum(FeatureKey.signingKey.key2);                                                                        // 26
var bits3 = Bignum(FeatureKey.signingKey.key3);                                                                        // 27
var signingKey = bits0.add(bits1.shiftLeft(64 * 1)).add(bits2.shiftLeft(64 * 2)).add(bits3.shiftLeft(64 * 3)).toBuffer({ endian: "little", size: 32 });
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 34
                                                                                                                       //
function verifyFeatureKeySignature(buf) {                                                                              // 37
  // buf is a Buffer containing an feature key with attached signature.                                                //
  // This function returns the signed data if the signature is valid,                                                  //
  // or undefined if the signature is invalid.                                                                         //
                                                                                                                       //
  // Per crypto_sign, the first 64 bytes are the ed25519 signature                                                     //
  // and the rest of the blob is the signed data.                                                                      //
  var signature = buf.slice(0, 64);                                                                                    // 44
  var signedData = buf.slice(64);                                                                                      // 45
                                                                                                                       //
  if (!Ed25519.Verify(signedData, signature, signingKey)) {                                                            // 47
    console.error("feature key failed signature check", bits0, bits1, bits2, bits3);                                   // 48
    return undefined;                                                                                                  // 49
  } else {                                                                                                             //
    return signedData;                                                                                                 // 51
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
// Export for use in db.js and server/admin.js                                                                         //
loadSignedFeatureKey = function loadSignedFeatureKey(buf) {                                                            // 56
  // Given a Buffer containing a signed feature key, verifies and parses the feature key.                              //
  // Returns the parsed FeatureKey if it was signed by a trusted key, or                                               //
  // undefined if the signature did not pass verification.                                                             //
  var verifiedFeatureKeyBlob = verifyFeatureKeySignature(buf);                                                         // 60
  if (verifiedFeatureKeyBlob) {                                                                                        // 61
    var featureKey = Capnp.parsePacked(FeatureKey, verifiedFeatureKeyBlob);                                            // 62
    if (featureKey.isForTesting && !isTesting) {                                                                       // 63
      // This key is for testing only, but the server is not running in testing mode. Note that                        //
      // enabling testing mode forfeits up all security.                                                               //
      return undefined;                                                                                                // 66
    }                                                                                                                  //
                                                                                                                       //
    return featureKey;                                                                                                 // 69
  } else {                                                                                                             //
    return undefined;                                                                                                  // 71
  }                                                                                                                    //
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"grain-server.js":["babel-runtime/helpers/typeof",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/grain-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
var emailLinkWithInlineStyle = function emailLinkWithInlineStyle(url, text) {                                          // 19
  return "<a href='" + url + "' style='display:inline-block;text-decoration:none;" + "font-family:sans-serif;width:200px;min-height:30px;line-height:30px;" + "border-radius:4px;text-align:center;background:#762F87;color:white'>" + text + "</a>";
};                                                                                                                     //
                                                                                                                       //
Meteor.publish("grainTopBar", function (grainId) {                                                                     // 26
  check(grainId, String);                                                                                              // 27
                                                                                                                       //
  var result = [Grains.find({                                                                                          // 29
    _id: grainId,                                                                                                      // 31
    $or: [{ userId: this.userId }, { "private": { $ne: true } }]                                                       // 32
  }, {                                                                                                                 //
    fields: {                                                                                                          // 37
      title: 1,                                                                                                        // 38
      userId: 1,                                                                                                       // 39
      identityId: 1,                                                                                                   // 40
      "private": 1                                                                                                     // 41
    }                                                                                                                  //
  })];                                                                                                                 //
  if (this.userId) {                                                                                                   // 45
    var myIdentityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                 // 46
    result.push(ApiTokens.find({                                                                                       // 47
      grainId: grainId,                                                                                                // 48
      $or: [{ "owner.user.identityId": { $in: myIdentityIds } }, { identityId: { $in: myIdentityIds } }]               // 49
    }));                                                                                                               //
  }                                                                                                                    //
                                                                                                                       //
  return result;                                                                                                       // 56
});                                                                                                                    //
                                                                                                                       //
// We allow users to learn package information about a grain they own.                                                 //
// This is used for obtaining icon and app title information for grains                                                //
// you own, which is used in the sidebar. It is not a security/privacy                                                 //
// risk since it only exposes this information for grains the user owns.                                               //
Meteor.publish("packageByGrainId", function (grainId) {                                                                // 63
  check(grainId, String);                                                                                              // 64
  var publishThis = [];                                                                                                // 65
  // We need to publish the packageId so that client-side code can                                                     //
  // find the right package.                                                                                           //
  var thisGrainCursor = Grains.find({                                                                                  // 63
    _id: grainId,                                                                                                      // 69
    userId: this.userId                                                                                                // 70
  }, {                                                                                                                 //
    fields: { packageId: 1 }                                                                                           // 72
  });                                                                                                                  //
  publishThis.push(thisGrainCursor);                                                                                   // 74
                                                                                                                       //
  if (thisGrainCursor.count()) {                                                                                       // 76
    var thisGrain = thisGrainCursor.fetch()[0];                                                                        // 77
    var thisPackageCursor = Packages.find({ _id: thisGrain.packageId });                                               // 78
    publishThis.push(thisPackageCursor);                                                                               // 79
  }                                                                                                                    //
                                                                                                                       //
  return publishThis;                                                                                                  // 82
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("tokenInfo", function (token) {                                                                         // 85
  // Allows the client side to map a raw token to its entry in ApiTokens, and the additional                           //
  // metadata that it will need to display the app icon and title.  We do not care about making                        //
  // the metadata reactive.                                                                                            //
  check(token, String);                                                                                                // 89
                                                                                                                       //
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 91
  var apiToken = ApiTokens.findOne({                                                                                   // 92
    _id: hashedToken                                                                                                   // 93
  }, {                                                                                                                 //
    fields: {                                                                                                          // 95
      grainId: 1,                                                                                                      // 96
      identityId: 1,                                                                                                   // 97
      owner: 1,                                                                                                        // 98
      revoked: 1                                                                                                       // 99
    }                                                                                                                  //
  });                                                                                                                  //
  if (!apiToken) {                                                                                                     // 102
    this.added("tokenInfo", token, { invalidToken: true });                                                            // 103
  } else if (apiToken.revoked) {                                                                                       //
    this.added("tokenInfo", token, { revoked: true });                                                                 // 105
  } else {                                                                                                             //
    var grainId = apiToken.grainId;                                                                                    // 107
    var grain = Grains.findOne({                                                                                       // 108
      _id: grainId                                                                                                     // 109
    }, {                                                                                                               //
      fields: {                                                                                                        // 111
        packageId: 1,                                                                                                  // 112
        appId: 1,                                                                                                      // 113
        userId: 1                                                                                                      // 114
      }                                                                                                                //
    });                                                                                                                //
    if (!grain) {                                                                                                      // 117
      this.added("tokenInfo", token, { invalidToken: true });                                                          // 118
    } else {                                                                                                           //
      if (apiToken.owner && apiToken.owner.user) {                                                                     // 120
        var identity = globalDb.getIdentity(apiToken.owner.user.identityId);                                           // 121
        var metadata = apiToken.owner.user.denormalizedGrainMetadata;                                                  // 122
        if (identity && metadata) {                                                                                    // 123
          SandstormDb.fillInLoginId(identity);                                                                         // 124
          this.added("tokenInfo", token, {                                                                             // 125
            identityOwner: _.pick(identity, "_id", "profile", "loginId"),                                              // 126
            grainId: grainId,                                                                                          // 127
            grainMetadata: metadata                                                                                    // 128
          });                                                                                                          //
        } else {                                                                                                       //
          this.added("tokenInfo", token, { invalidToken: true });                                                      // 131
        }                                                                                                              //
      } else if (!apiToken.owner || "webkey" in apiToken.owner) {                                                      //
        if (this.userId) {                                                                                             // 134
          var user = Meteor.users.findOne({ _id: this.userId });                                                       // 135
          var identityIds = SandstormDb.getUserIdentityIds(user);                                                      // 136
          var childToken = ApiTokens.findOne({                                                                         // 137
            "owner.user.identityId": { $in: identityIds },                                                             // 138
            parentToken: apiToken._id                                                                                  // 139
          });                                                                                                          //
          if (childToken || this.userId === grain.userId || identityIds.indexOf(apiToken.identityId) >= 0) {           // 141
            this.added("tokenInfo", token, { alreadyRedeemed: true, grainId: apiToken.grainId });                      // 143
            this.ready();                                                                                              // 144
            return;                                                                                                    // 145
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        var pkg = Packages.findOne({ _id: grain.packageId }, { fields: { manifest: 1 } });                             // 149
        var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                            // 150
        var appIcon = undefined;                                                                                       // 151
        if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                             // 152
          var icons = pkg.manifest.metadata.icons;                                                                     // 153
          appIcon = icons.grain || icons.appGrid;                                                                      // 154
        }                                                                                                              //
                                                                                                                       //
        var denormalizedGrainMetadata = {                                                                              // 157
          appTitle: appTitle,                                                                                          // 158
          icon: appIcon,                                                                                               // 159
          appId: appIcon ? undefined : grain.appId                                                                     // 160
        };                                                                                                             //
        this.added("tokenInfo", token, {                                                                               // 162
          webkey: true,                                                                                                // 163
          grainId: grainId,                                                                                            // 164
          grainMetadata: denormalizedGrainMetadata                                                                     // 165
        });                                                                                                            //
      } else {                                                                                                         //
        this.added("tokenInfo", token, { invalidToken: true });                                                        // 168
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  this.ready();                                                                                                        // 173
  return;                                                                                                              // 174
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("requestingAccess", function (grainId) {                                                                // 177
  check(grainId, String);                                                                                              // 178
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 180
    throw new Meteor.Error(403, "Must be logged in to request access.");                                               // 181
  }                                                                                                                    //
                                                                                                                       //
  var grain = globalDb.getGrain(grainId);                                                                              // 184
  if (!grain) {                                                                                                        // 185
    throw new Meteor.Error(404, "Grain not found.");                                                                   // 186
  }                                                                                                                    //
                                                                                                                       //
  if (grain.userId === this.userId) {                                                                                  // 189
    this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: grain.identityId });              // 190
  }                                                                                                                    //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: this.userId }));                        // 194
  var ownerIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));                  // 195
                                                                                                                       //
  var _this = this;                                                                                                    // 198
  var query = ApiTokens.find({                                                                                         // 199
    grainId: grainId,                                                                                                  // 200
    identityId: { $in: ownerIdentityIds },                                                                             // 201
    parentToken: { $exists: false },                                                                                   // 202
    "owner.user.identityId": { $in: identityIds },                                                                     // 203
    revoked: { $ne: true }                                                                                             // 204
  });                                                                                                                  //
  var handle = query.observe({                                                                                         // 206
    added: function () {                                                                                               // 207
      function added(apiToken) {                                                                                       //
        _this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: apiToken.owner.user.identityId });
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  this.onStop(function () {                                                                                            // 213
    return handle.stop();                                                                                              //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("grainSize", function (grainId) {                                                                       // 216
  // Publish pseudo-collection containing the size of the grain opened in the given session.                           //
  check(grainId, String);                                                                                              // 218
                                                                                                                       //
  var grain = Grains.findOne(grainId);                                                                                 // 220
  if (!grain || grain.userId !== this.userId) {                                                                        // 221
    return [];                                                                                                         // 222
  }                                                                                                                    //
                                                                                                                       //
  var supervisor = globalBackend.cap().getGrain(this.userId, grainId).supervisor;                                      // 225
                                                                                                                       //
  var _this = this;                                                                                                    // 227
  var stopped = false;                                                                                                 // 228
  var promise = getGrainSize(supervisor);                                                                              // 229
                                                                                                                       //
  function getNext(oldSize) {                                                                                          // 231
    promise = getGrainSize(supervisor, oldSize);                                                                       // 232
    promise.then(function (size) {                                                                                     // 233
      if (!stopped) {                                                                                                  // 234
        if (size !== oldSize) {                                                                                        // 235
          // sometimes there are false alarms                                                                          //
          _this.changed("grainSizes", grainId, { size: size });                                                        // 236
        }                                                                                                              //
                                                                                                                       //
        getNext(size);                                                                                                 // 239
      }                                                                                                                //
    }, function (err) {                                                                                                //
                                                                                                                       //
      if (!stopped) {                                                                                                  // 243
        if (err.kjType === "disconnected") {                                                                           // 244
          _this.stop();                                                                                                // 245
        } else {                                                                                                       //
          _this.error(err);                                                                                            // 247
        }                                                                                                              //
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  promise.then(function (size) {                                                                                       // 253
    if (!stopped) {                                                                                                    // 254
      _this.added("grainSizes", grainId, { size: size });                                                              // 255
      _this.ready();                                                                                                   // 256
      getNext(size);                                                                                                   // 257
    }                                                                                                                  //
  }, function (err) {                                                                                                  //
                                                                                                                       //
    if (!stopped) {                                                                                                    // 261
      if (err.kjType === "disconnected") {                                                                             // 262
        _this.stop();                                                                                                  // 263
      } else {                                                                                                         //
        _this.error(err);                                                                                              // 265
      }                                                                                                                //
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  _this.onStop(function () {                                                                                           // 270
    stopped = true;                                                                                                    // 271
    promise.cancel();                                                                                                  // 272
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
var GRAIN_DELETION_MS = 1000 * 60 * 60 * 24 * 30; // thirty days                                                       // 276
SandstormDb.periodicCleanup(86400000, function () {                                                                    // 277
  var trashExpiration = new Date(Date.now() - GRAIN_DELETION_MS);                                                      // 278
  globalDb.removeApiTokens({ trashed: { $lt: trashExpiration } });                                                     // 279
  Grains.find({ trashed: { $lt: trashExpiration } }).forEach(function (grain) {                                        // 280
    waitPromise(globalBackend.deleteGrain(grain._id, grain.userId));                                                   // 281
    Grains.remove({ _id: grain._id });                                                                                 // 282
    globalDb.removeApiTokens({                                                                                         // 283
      grainId: grain._id,                                                                                              // 284
      $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                                // 285
    });                                                                                                                //
                                                                                                                       //
    if (grain.lastUsed) {                                                                                              // 291
      DeleteStats.insert({                                                                                             // 292
        type: "grain", // Demo grains can never never get here!                                                        // 293
        lastActive: grain.lastUsed,                                                                                    // 294
        appId: grain.appId                                                                                             // 295
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    Meteor.call("deleteUnusedPackages", grain.appId);                                                                  // 299
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Meteor.methods({                                                                                                       // 303
  moveGrainsToTrash: function () {                                                                                     // 304
    function moveGrainsToTrash(grainIds) {                                                                             // 304
      check(grainIds, [String]);                                                                                       // 305
                                                                                                                       //
      if (this.userId) {                                                                                               // 307
        Grains.update({ userId: { $eq: this.userId },                                                                  // 308
          _id: { $in: grainIds },                                                                                      // 309
          trashed: { $exists: false } }, { $set: { trashed: new Date() } }, { multi: true });                          // 310
                                                                                                                       //
        var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                               // 314
                                                                                                                       //
        ApiTokens.update({ grainId: { $in: grainIds },                                                                 // 316
          "owner.user.identityId": { $in: identityIds },                                                               // 317
          trashed: { $exists: false } }, { $set: { "trashed": new Date() } }, { multi: true });                        // 318
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return moveGrainsToTrash;                                                                                          //
  }(),                                                                                                                 //
                                                                                                                       //
  moveGrainsOutOfTrash: function () {                                                                                  // 324
    function moveGrainsOutOfTrash(grainIds) {                                                                          // 324
      check(grainIds, [String]);                                                                                       // 325
                                                                                                                       //
      if (this.userId) {                                                                                               // 327
        Grains.update({ userId: { $eq: this.userId },                                                                  // 328
          _id: { $in: grainIds },                                                                                      // 329
          trashed: { $exists: true } }, { $unset: { trashed: 1 } }, { multi: true });                                  // 330
                                                                                                                       //
        var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                               // 334
                                                                                                                       //
        ApiTokens.update({ grainId: { $in: grainIds },                                                                 // 336
          "owner.user.identityId": { $in: identityIds },                                                               // 337
          "trashed": { $exists: true } }, { $unset: { "trashed": 1 } }, { multi: true });                              // 338
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return moveGrainsOutOfTrash;                                                                                       //
  }(),                                                                                                                 //
                                                                                                                       //
  deleteGrain: function () {                                                                                           // 344
    function deleteGrain(grainId) {                                                                                    // 344
      check(grainId, String);                                                                                          // 345
                                                                                                                       //
      if (this.userId) {                                                                                               // 347
        if (!this.isSimulation) {                                                                                      // 348
          waitPromise(globalBackend.deleteGrain(grainId, this.userId));                                                // 349
        }                                                                                                              //
                                                                                                                       //
        var grain = Grains.findOne({                                                                                   // 352
          _id: grainId,                                                                                                // 353
          userId: this.userId,                                                                                         // 354
          trashed: { $exists: true }                                                                                   // 355
        });                                                                                                            //
        if (grain) {                                                                                                   // 357
          Grains.remove(grainId);                                                                                      // 358
          globalDb.removeApiTokens({                                                                                   // 359
            grainId: grainId,                                                                                          // 360
            $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                          // 361
          });                                                                                                          //
          if (grain.lastUsed) {                                                                                        // 366
            DeleteStats.insert({ type: isDemoUser() ? "demoGrain" : "grain",                                           // 367
              lastActive: grain.lastUsed, appId: grain.appId });                                                       // 368
          }                                                                                                            //
                                                                                                                       //
          if (!this.isSimulation) {                                                                                    // 371
            Meteor.call("deleteUnusedPackages", grain.appId);                                                          // 372
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return deleteGrain;                                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  forgetGrain: function () {                                                                                           // 378
    function forgetGrain(grainId, identityId) {                                                                        // 378
      check(grainId, String);                                                                                          // 379
      check(identityId, String);                                                                                       // 380
                                                                                                                       //
      if (!this.userId) {                                                                                              // 382
        throw new Meteor.Error(403, "Must be logged in to forget a grain.");                                           // 383
      }                                                                                                                //
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 386
        throw new Meteor.Error(403, "Current user does not have the identity " + identityId);                          // 387
      }                                                                                                                //
                                                                                                                       //
      globalDb.removeApiTokens({ grainId: grainId,                                                                     // 390
        "owner.user.identityId": identityId,                                                                           // 391
        "trashed": { $exists: true }                                                                                   // 392
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return forgetGrain;                                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  updateGrainPreferredIdentity: function () {                                                                          // 396
    function updateGrainPreferredIdentity(grainId, identityId) {                                                       // 396
      check(grainId, String);                                                                                          // 397
      check(identityId, String);                                                                                       // 398
      if (!this.userId) {                                                                                              // 399
        throw new Meteor.Error(403, "Must be logged in.");                                                             // 400
      }                                                                                                                //
                                                                                                                       //
      var grain = globalDb.getGrain(grainId) || {};                                                                    // 403
      if (!grain.userId === this.userId) {                                                                             // 404
        throw new Meteor.Error(403, "Grain not owned by current user.");                                               // 405
      }                                                                                                                //
                                                                                                                       //
      Grains.update({ _id: grainId }, { $set: { identityId: identityId } });                                           // 408
    }                                                                                                                  //
                                                                                                                       //
    return updateGrainPreferredIdentity;                                                                               //
  }(),                                                                                                                 //
                                                                                                                       //
  updateGrainTitle: function () {                                                                                      // 411
    function updateGrainTitle(grainId, newTitle, identityId) {                                                         // 411
      check(grainId, String);                                                                                          // 412
      check(newTitle, String);                                                                                         // 413
      check(identityId, String);                                                                                       // 414
      if (this.userId) {                                                                                               // 415
        var grain = Grains.findOne(grainId);                                                                           // 416
        if (grain) {                                                                                                   // 417
          if (grain.userId === this.userId) {                                                                          // 418
            Grains.update({ _id: grainId, userId: this.userId }, { $set: { title: newTitle } });                       // 419
                                                                                                                       //
            // Denormalize new title out to all sharing tokens.                                                        //
            ApiTokens.update({ grainId: grainId, "owner.user": { $exists: true } }, { $set: { "owner.user.upstreamTitle": newTitle } }, { multi: true });
          } else {                                                                                                     //
            if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                  // 426
              throw new Meteor.Error(403, "Current user does not have identity " + identityId);                        // 427
            }                                                                                                          //
                                                                                                                       //
            var token = ApiTokens.findOne({                                                                            // 430
              grainId: grainId,                                                                                        // 431
              objectId: { $exists: false },                                                                            // 432
              "owner.user.identityId": identityId                                                                      // 433
            }, {                                                                                                       //
              sort: { created: 1 } });                                                                                 // 435
            // The oldest token is our source of truth for the name.                                                   //
            if (token && token.owner.user.title !== newTitle) {                                                        // 437
              if (token.owner.user.upstreamTitle === newTitle) {                                                       // 438
                // User renamed grain to match upstream title. Act like they never renamed it at                       //
                // all.                                                                                                //
                ApiTokens.update({                                                                                     // 441
                  grainId: grainId,                                                                                    // 442
                  "owner.user.identityId": identityId                                                                  // 443
                }, {                                                                                                   //
                  $set: { "owner.user.title": newTitle },                                                              // 445
                  $unset: { "owner.user.upstreamTitle": 1, "owner.user.renamed": 1 }                                   // 446
                }, {                                                                                                   //
                  multi: true                                                                                          // 448
                });                                                                                                    //
              } else {                                                                                                 //
                var modification = {                                                                                   // 451
                  "owner.user.title": newTitle,                                                                        // 452
                  "owner.user.renamed": true                                                                           // 453
                };                                                                                                     //
                                                                                                                       //
                if (!token.owner.user.upstreamTitle) {                                                                 // 456
                  // If `upstreamTitle` isn't present then it is equal to the old title.                               //
                  modification["owner.user.upstreamTitle"] = token.owner.user.title;                                   // 458
                }                                                                                                      //
                                                                                                                       //
                ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: modification }, { multi: true });
              }                                                                                                        //
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return updateGrainTitle;                                                                                           //
  }(),                                                                                                                 //
                                                                                                                       //
  privatizeGrain: function () {                                                                                        // 471
    function privatizeGrain(grainId) {                                                                                 // 471
      check(grainId, String);                                                                                          // 472
      if (this.userId) {                                                                                               // 473
        Grains.update({ _id: grainId, userId: this.userId }, { $set: { "private": true } });                           // 474
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return privatizeGrain;                                                                                             //
  }(),                                                                                                                 //
                                                                                                                       //
  inviteUsersToGrain: function () {                                                                                    // 478
    function inviteUsersToGrain(origin, identityId, grainId, title, roleAssignment, contacts, message) {               // 478
      var _this2 = this;                                                                                               //
                                                                                                                       //
      if (!this.isSimulation) {                                                                                        // 480
        var _ret = function () {                                                                                       //
          check(origin, String);                                                                                       // 481
          check(identityId, String);                                                                                   // 482
          check(grainId, String);                                                                                      // 483
          check(title, String);                                                                                        // 484
          check(roleAssignment, roleAssignmentPattern);                                                                // 485
          check(contacts, [{                                                                                           // 486
            _id: String,                                                                                               // 488
            isDefault: Match.Optional(Boolean),                                                                        // 489
            profile: Match.ObjectIncluding({                                                                           // 490
              service: String,                                                                                         // 491
              name: String,                                                                                            // 492
              intrinsicName: String                                                                                    // 493
            })                                                                                                         //
          }]);                                                                                                         //
          check(message, { text: String, html: String });                                                              // 497
          if (!_this2.userId) {                                                                                        // 498
            throw new Meteor.Error(403, "Must be logged in to share by email.");                                       // 499
          }                                                                                                            //
                                                                                                                       //
          if (!globalDb.userHasIdentity(_this2.userId, identityId)) {                                                  // 502
            throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                         // 503
          }                                                                                                            //
                                                                                                                       //
          if (contacts.length === 0) {                                                                                 // 506
            throw new Meteor.Error(400, "No contacts were provided.");                                                 // 507
          }                                                                                                            //
                                                                                                                       //
          if (globalDb.isDemoUser()) {                                                                                 // 510
            throw new Meteor.Error(403, "Demo users are not allowed to share by email.");                              // 511
          }                                                                                                            //
                                                                                                                       //
          var accountId = _this2.userId;                                                                               // 514
          var outerResult = { successes: [], failures: [] };                                                           // 515
          var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                        // 516
          var replyTo = globalDb.getPrimaryEmail(accountId, identityId);                                               // 517
          contacts.forEach(function (contact) {                                                                        // 518
            if (contact.isDefault && contact.profile.service === "email") {                                            // 519
              var emailAddress = contact.profile.intrinsicName;                                                        // 520
              var result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "email invitation for " + emailAddress, roleAssignment, { webkey: { forSharing: true } });
              var url = origin + "/shared/" + result.token;                                                            // 525
              var html = message.html + "<br><br>" + emailLinkWithInlineStyle(url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: If you forward this email to other people, they will be able to access " + "the share as well. To prevent this, remove the button before forwarding.</div>";
              try {                                                                                                    // 531
                globalDb.incrementDailySentMailCount(accountId);                                                       // 532
                SandstormEmail.send({                                                                                  // 533
                  to: emailAddress,                                                                                    // 534
                  from: fromEmail,                                                                                     // 535
                  replyTo: replyTo,                                                                                    // 536
                  subject: title + " - Invitation to collaborate",                                                     // 537
                  text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + url + "\n\nNote: If you forward this email to other people, they will be able to " + "access the share as well. To prevent this, remove the link before forwarding.",
                  html: html                                                                                           // 541
                });                                                                                                    //
              } catch (e) {                                                                                            //
                outerResult.failures.push({ contact: contact, error: e.toString() });                                  // 544
              }                                                                                                        //
            } else {                                                                                                   //
              var _result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "direct invitation to " + contact.profile.intrinsicName, roleAssignment, { user: { identityId: contact._id, title: title } });
              var _url = origin + "/shared/" + _result.token;                                                          // 551
              try {                                                                                                    // 552
                var identity = Meteor.users.findOne({ _id: contact._id });                                             // 553
                var email = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                   // 554
                if (email) {                                                                                           // 556
                  var intrinsicName = contact.profile.intrinsicName;                                                   // 557
                  var loginNote = void 0;                                                                              // 558
                  if (contact.profile.service === "google") {                                                          // 559
                    loginNote = "Google account with address " + email.email;                                          // 560
                  } else if (contact.profile.service === "github") {                                                   //
                    loginNote = "Github account with username " + intrinsicName;                                       // 562
                  } else if (contact.profile.service === "email") {                                                    //
                    loginNote = "email address " + intrinsicName;                                                      // 564
                  } else if (contact.profile.service === "ldap") {                                                     //
                    loginNote = "LDAP username " + intrinsicName;                                                      // 566
                  } else if (contact.profile.service === "saml") {                                                     //
                    loginNote = "SAML ID " + intrinsicName;                                                            // 568
                  } else {                                                                                             //
                    throw new Meteor.Error(500, "Unknown service to email share link.");                               // 570
                  }                                                                                                    //
                                                                                                                       //
                  var _html = message.html + "<br><br>" + emailLinkWithInlineStyle(_url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: You will need to log in with your " + loginNote + " to access this grain.";
                  globalDb.incrementDailySentMailCount(accountId);                                                     // 578
                  SandstormEmail.send({                                                                                // 579
                    to: email.email,                                                                                   // 580
                    from: fromEmail,                                                                                   // 581
                    replyTo: replyTo,                                                                                  // 582
                    subject: title + " - Invitation to collaborate",                                                   // 583
                    text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + _url + "\n\nNote: You will need to log in with your " + loginNote + " to access this grain.",
                    html: _html                                                                                        // 587
                  });                                                                                                  //
                } else {                                                                                               //
                  outerResult.failures.push({ contact: contact, warning: "User does not have a " + "verified email, so notification of this share was not sent to them. Please " + "manually share " + _url + " with them." });
                }                                                                                                      //
              } catch (e) {                                                                                            //
                outerResult.failures.push({ contact: contact, error: e.toString(),                                     // 595
                  warning: "Share succeeded, but there was an error emailing the user. Please " + "manually share " + _url + " with them." });
              }                                                                                                        //
            }                                                                                                          //
          });                                                                                                          //
                                                                                                                       //
          return {                                                                                                     // 602
            v: outerResult                                                                                             //
          };                                                                                                           //
        }();                                                                                                           //
                                                                                                                       //
        if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret)) === "object") return _ret.v;  //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return inviteUsersToGrain;                                                                                         //
  }(),                                                                                                                 //
                                                                                                                       //
  requestAccess: function () {                                                                                         // 606
    function requestAccess(origin, grainId, identityId) {                                                              // 606
      check(origin, String);                                                                                           // 607
      check(grainId, String);                                                                                          // 608
      check(identityId, String);                                                                                       // 609
      if (!this.isSimulation) {                                                                                        // 610
        if (!this.userId) {                                                                                            // 611
          throw new Meteor.Error(403, "Must be logged in to request access.");                                         // 612
        }                                                                                                              //
                                                                                                                       //
        if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                      // 615
          throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                           // 616
        }                                                                                                              //
                                                                                                                       //
        var grain = Grains.findOne(grainId);                                                                           // 619
        if (!grain) {                                                                                                  // 620
          throw new Meteor.Error(404, "No such grain");                                                                // 621
        }                                                                                                              //
                                                                                                                       //
        var grainOwner = globalDb.getUser(grain.userId);                                                               // 624
        var email = _.findWhere(SandstormDb.getUserEmails(grainOwner), { primary: true });                             // 625
        if (!email) {                                                                                                  // 626
          throw new Meteor.Error("no email", "Grain owner has no email address.");                                     // 627
        }                                                                                                              //
                                                                                                                       //
        var emailAddress = email.email;                                                                                // 630
                                                                                                                       //
        var identity = globalDb.getIdentity(identityId);                                                               // 632
        globalDb.addContact(grainOwner._id, identityId);                                                               // 633
                                                                                                                       //
        var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                          // 635
        var replyTo = globalDb.getPrimaryEmail(Meteor.userId(), identityId);                                           // 636
                                                                                                                       //
        // TODO(soon): In the HTML version, we should display an identity card.                                        //
        var identityNote = "";                                                                                         // 610
        if (identity.profile.service === "google") {                                                                   // 640
          identityNote = " (" + identity.privateIntrinsicName + ")";                                                   // 641
        } else if (identity.profile.service === "github") {                                                            //
          identityNote = " (" + identity.profile.intrinsicName + " on GitHub)";                                        // 643
        } else if (identity.profile.service === "email") {                                                             //
          identityNote = " (" + identity.profile.intrinsicName + ")";                                                  // 645
        } else if (identity.profile.service === "ldap") {                                                              //
          identityNote = " (" + identity.profile.intrinsicName + " on LDAP)";                                          // 647
        } else if (identity.profile.service === "saml") {                                                              //
          identityNote = " (" + identity.profile.intrinsicName + " on SAML)";                                          // 649
        }                                                                                                              //
                                                                                                                       //
        var message = identity.profile.name + identityNote + " is requesting access to your grain: " + grain.title + ".";
                                                                                                                       //
        var url = origin + "/share/" + grainId + "/" + identityId;                                                     // 655
                                                                                                                       //
        var html = message + "<br><br>" + emailLinkWithInlineStyle(url, "Open Sharing Menu");                          // 657
                                                                                                                       //
        var user = Meteor.user();                                                                                      // 660
        var ACCESS_REQUEST_LIMIT = 10;                                                                                 // 661
        var resetCount = true;                                                                                         // 662
        if (user.accessRequests) {                                                                                     // 663
          if (user.accessRequests.resetOn < new Date()) {                                                              // 664
            Meteor.users.update({ _id: user._id }, { $unset: { accessRequests: 1 } });                                 // 665
          } else if (user.accessRequests.count >= ACCESS_REQUEST_LIMIT) {                                              //
            throw new Meteor.Error(403, "For spam control reasons, you are not allowed to make " + "more than " + ACCESS_REQUEST_LIMIT + " access requests per day.");
          } else {                                                                                                     //
            resetCount = false;                                                                                        // 671
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        var modifier = { $inc: { "accessRequests.count": 1 } };                                                        // 675
        if (resetCount) {                                                                                              // 676
          var tomorrow = new Date(Date.now() + 86400000);                                                              // 677
          modifier.$set = { "accessRequests.resetOn": tomorrow };                                                      // 678
        }                                                                                                              //
                                                                                                                       //
        Meteor.users.update({ _id: user._id }, modifier);                                                              // 681
                                                                                                                       //
        SandstormEmail.send({                                                                                          // 683
          to: emailAddress,                                                                                            // 684
          from: fromEmail,                                                                                             // 685
          replyTo: replyTo,                                                                                            // 686
          subject: grain.title + " - Request for access",                                                              // 687
          text: message + "\n\nFollow this link to share access:\n\n" + url,                                           // 688
          html: html                                                                                                   // 689
        });                                                                                                            //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return requestAccess;                                                                                              //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"hack-session.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/hack-session.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");                          //
                                                                                                                       //
var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);                                 //
                                                                                                                       //
var _inherits2 = require("babel-runtime/helpers/inherits");                                                            //
                                                                                                                       //
var _inherits3 = _interopRequireDefault(_inherits2);                                                                   //
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Http = Npm.require("http");                                                                                        // 18
var Https = Npm.require("https");                                                                                      // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Net = Npm.require("net");                                                                                          // 21
var Dgram = Npm.require("dgram");                                                                                      // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Capnp = Npm.require("capnp");                                                                                      // 24
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 26
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 27
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 28
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 29
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 30
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 31
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                               // 32
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 34
                                                                                                                       //
ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                            // 36
HOSTNAME = ROOT_URL.hostname;                                                                                          // 37
                                                                                                                       //
SessionContextImpl = function () {                                                                                     // 39
  function SessionContextImpl(grainId, sessionId, identityId, tabId) {                                                 // 40
    (0, _classCallCheck3["default"])(this, SessionContextImpl);                                                        //
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 41
    this.sessionId = sessionId;                                                                                        // 42
    this.identityId = identityId;                                                                                      // 43
    this.tabId = tabId;                                                                                                // 44
  }                                                                                                                    //
                                                                                                                       //
  SessionContextImpl.prototype.offer = function () {                                                                   // 39
    function offer(cap, requiredPermissions, descriptor, displayInfo) {                                                //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 48
        if (!_this2.identityId) {                                                                                      // 49
          // TODO(soon): allow non logged in users?                                                                    //
          throw new Meteor.Error(400, "Only logged in users can offer capabilities.");                                 // 51
        }                                                                                                              //
                                                                                                                       //
        var castedCap = cap.castAs(SystemPersistent);                                                                  // 54
        var apiTokenOwner = { webkey: null };                                                                          // 55
        var isUiView = descriptor && descriptor.tags && descriptor.tags.length === 1 && descriptor.tags[0] && descriptor.tags[0].id && descriptor.tags[0].id === Grain.UiView.typeId;
        if (isUiView) {                                                                                                // 59
          apiTokenOwner = {                                                                                            // 60
            user: {                                                                                                    // 61
              identityId: _this2.identityId                                                                            // 62
            }                                                                                                          //
          };                                                                                                           //
        }                                                                                                              //
                                                                                                                       //
        // TODO(soon): This will eventually use SystemPersistent.addRequirements when membranes                        //
        // are fully implemented for supervisors.                                                                      //
        // The following fields will be overwritten by PersistentUiView.save(), so no need to                          // 48
        // pass them in:                                                                                               //
        //title: "", // This will be replaced by the token's title                                                     //
        //denormalizedGrainMetadata: {}, // This will look up the package for the grain referenced.                    //
        var requirement = {                                                                                            // 73
          permissionsHeld: {                                                                                           // 74
            grainId: _this2.grainId,                                                                                   // 75
            identityId: _this2.identityId,                                                                             // 76
            permissions: requiredPermissions                                                                           // 77
          }                                                                                                            //
        };                                                                                                             //
                                                                                                                       //
        if (!checkRequirements([requirement])) {                                                                       // 81
          throw new Meteor.Error(403, "Permissions not satisfied.");                                                   // 82
        }                                                                                                              //
                                                                                                                       //
        var save = castedCap.save(apiTokenOwner);                                                                      // 85
        var sturdyRef = waitPromise(save).sturdyRef;                                                                   // 86
        ApiTokens.update({ _id: hashSturdyRef(sturdyRef) }, { $push: { requirements: requirement } });                 // 87
        var powerboxView = isUiView ? {                                                                                // 88
          offer: {                                                                                                     // 89
            uiView: {                                                                                                  // 90
              token: sturdyRef.toString(),                                                                             // 91
              tokenId: hashSturdyRef(sturdyRef.toString())                                                             // 92
            }                                                                                                          //
          }                                                                                                            //
        } : {                                                                                                          //
          offer: {                                                                                                     // 96
            url: ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef                          // 97
          }                                                                                                            //
        };                                                                                                             //
        Sessions.update({ _id: _this2.sessionId }, {                                                                   // 100
          $set: {                                                                                                      // 102
            powerboxView: powerboxView                                                                                 // 103
          }                                                                                                            //
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return offer;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  return SessionContextImpl;                                                                                           //
}();                                                                                                                   //
                                                                                                                       //
Meteor.methods({                                                                                                       // 111
  finishPowerboxRequest: function () {                                                                                 // 112
    function finishPowerboxRequest(webkeyUrl, saveLabel, identityId, grainId) {                                        //
      check(webkeyUrl, String);                                                                                        // 113
      check(saveLabel, Match.OneOf(undefined, null, String));                                                          // 114
      check(identityId, String);                                                                                       // 115
      check(grainId, String);                                                                                          // 116
                                                                                                                       //
      var userId = Meteor.userId();                                                                                    // 118
      if (!userId || !globalDb.userHasIdentity(userId, identityId)) {                                                  // 119
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 120
      }                                                                                                                //
                                                                                                                       //
      var parsedWebkey = Url.parse(webkeyUrl.trim());                                                                  // 123
      var hostId = matchWildcardHost(parsedWebkey.host);                                                               // 124
      if (!hostId || !globalDb.isApiHostId(hostId)) {                                                                  // 125
        throw new Meteor.Error(500, "Hostname does not match this server. External webkeys are not " + "supported (yet)");
      }                                                                                                                //
                                                                                                                       //
      var token = parsedWebkey.hash;                                                                                   // 130
      if (!token) {                                                                                                    // 131
        throw new Meteor.Error(400, "Invalid webkey. You must pass in the full webkey, " + "including domain name and hash fragment");
      }                                                                                                                //
                                                                                                                       //
      token = token.slice(1);                                                                                          // 136
      if (globalDb.isTokenSpecificHostId(hostId) && hostId !== globalDb.apiHostIdForToken(token)) {                    // 137
        // Note: This case is not security-sensitive. The client could easily compute the correct                      //
        //   host ID for this token. But since they've passed one that doesn't match, we assume                        //
        //   something is wrong and stop here.                                                                         //
        throw new Meteor.Error(400, "Invalid webkey: token doesn't match hostname.");                                  // 141
      }                                                                                                                //
                                                                                                                       //
      var cap = restoreInternal(new Buffer(token), Match.Optional({ webkey: Match.Optional(Match.Any) }), []).cap;     // 144
      var castedCap = cap.castAs(SystemPersistent);                                                                    // 146
      var grainOwner = {                                                                                               // 147
        grainId: grainId,                                                                                              // 148
        introducerIdentity: identityId                                                                                 // 149
      };                                                                                                               //
      if (saveLabel) {                                                                                                 // 151
        grainOwner.saveLabel = {                                                                                       // 152
          defaultText: saveLabel                                                                                       // 153
        };                                                                                                             //
      }                                                                                                                //
                                                                                                                       //
      var save = castedCap.save({ grain: grainOwner });                                                                // 157
      var sturdyRef = waitPromise(save).sturdyRef;                                                                     // 158
                                                                                                                       //
      return sturdyRef.toString();                                                                                     // 160
    }                                                                                                                  //
                                                                                                                       //
    return finishPowerboxRequest;                                                                                      //
  }(),                                                                                                                 //
  finishPowerboxOffer: function () {                                                                                   // 163
    function finishPowerboxOffer(sessionId) {                                                                          //
      check(sessionId, String);                                                                                        // 164
                                                                                                                       //
      Sessions.update({ _id: sessionId }, { $unset: { powerboxView: null } });                                         // 166
    }                                                                                                                  //
                                                                                                                       //
    return finishPowerboxOffer;                                                                                        //
  }(),                                                                                                                 //
  getViewInfoForApiToken: function () {                                                                                // 169
    function getViewInfoForApiToken(apiTokenId) {                                                                      //
      check(apiTokenId, String);                                                                                       // 170
      var token = globalDb.collections.apiTokens.findOne(apiTokenId);                                                  // 171
      if (!token) {                                                                                                    // 172
        throw new Meteor.Error(400, "No such token.");                                                                 // 173
      }                                                                                                                //
                                                                                                                       //
      var grain = globalDb.collections.grains.findOne(token.grainId);                                                  // 176
      if (!grain) {                                                                                                    // 177
        throw new Meteor.Error(500, "No grain found for token.");                                                      // 178
      }                                                                                                                //
                                                                                                                       //
      return grain.cachedViewInfo;                                                                                     // 181
    }                                                                                                                  //
                                                                                                                       //
    return getViewInfoForApiToken;                                                                                     //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
HackSessionContextImpl = function (_SessionContextImpl) {                                                              // 185
  (0, _inherits3["default"])(HackSessionContextImpl, _SessionContextImpl);                                             //
                                                                                                                       //
  function HackSessionContextImpl(grainId, sessionId, identityId, tabId) {                                             // 186
    (0, _classCallCheck3["default"])(this, HackSessionContextImpl);                                                    //
    return (0, _possibleConstructorReturn3["default"])(this, _SessionContextImpl.call(this, grainId, sessionId, identityId, tabId));
  }                                                                                                                    //
                                                                                                                       //
  HackSessionContextImpl.prototype._getPublicId = function () {                                                        // 185
    function _getPublicId() {                                                                                          //
      // Get the grain's public ID, assigning a new one if it doesn't yet have one.                                    //
      //                                                                                                               //
      // Must be called in a Meteor context.                                                                           //
                                                                                                                       //
      while (!this.publicId) {                                                                                         // 195
        // We haven't looked up the public ID yet.                                                                     //
        var grain = Grains.findOne(this.grainId, { fields: { publicId: 1 } });                                         // 197
        if (!grain) throw new Error("Grain does not exist.");                                                          // 198
                                                                                                                       //
        if (grain.publicId) {                                                                                          // 200
          this.publicId = grain.publicId;                                                                              // 201
        } else {                                                                                                       //
          // The grain doesn't have a public ID yet. Generate one.                                                     //
          var candidate = generateRandomHostname(20);                                                                  // 204
                                                                                                                       //
          if (Grains.findOne({ publicId: candidate })) {                                                               // 206
            // This should never ever happen.                                                                          //
            console.error("CRITICAL PROBLEM: Public ID collision. " + "CSPRNG is bad or has insufficient entropy.");   // 208
            continue;                                                                                                  // 210
          }                                                                                                            //
                                                                                                                       //
          // Carefully perform an update that becomes a no-op if anyone else has assigned a public ID                  //
          // simultaneously.                                                                                           //
          if (Grains.update({ _id: this.grainId, publicId: { $exists: false } }, { $set: { publicId: candidate } }) > 0) {
            // We won the race.                                                                                        //
            this.publicId = candidate;                                                                                 // 218
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return this.publicId;                                                                                            // 223
    }                                                                                                                  //
                                                                                                                       //
    return _getPublicId;                                                                                               //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype._getAddress = function () {                                                         // 185
    function _getAddress() {                                                                                           //
      // Get the grain's outgoing e-mail address.                                                                      //
      //                                                                                                               //
      // Must be called in a Meteor context.                                                                           //
                                                                                                                       //
      return this._getPublicId() + "@" + HOSTNAME;                                                                     // 231
    }                                                                                                                  //
                                                                                                                       //
    return _getAddress;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype._getUserAddress = function () {                                                     // 185
    function _getUserAddress() {                                                                                       //
      // Get the user's e-mail address.                                                                                //
      //                                                                                                               //
      // Must be called in a Meteor context.                                                                           //
                                                                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { identityId: 1 } });                                         // 239
                                                                                                                       //
      var identity = globalDb.getIdentity(grain.identityId);                                                           // 241
                                                                                                                       //
      var primaryEmail = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                      // 243
      var email = primaryEmail && primaryEmail.email || identity.unverifiedEmail;                                      // 244
                                                                                                                       //
      var result = {};                                                                                                 // 246
      if (email) {                                                                                                     // 247
        result.address = email;                                                                                        // 248
      }                                                                                                                //
                                                                                                                       //
      if (identity.profile.name) {                                                                                     // 251
        result.name = identity.profile.name;                                                                           // 252
      }                                                                                                                //
                                                                                                                       //
      return result;                                                                                                   // 255
    }                                                                                                                  //
                                                                                                                       //
    return _getUserAddress;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.send = function () {                                                                // 185
    function send(email) {                                                                                             //
      return hackSendEmail(this, email);                                                                               // 259
    }                                                                                                                  //
                                                                                                                       //
    return send;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.getPublicId = function () {                                                         // 185
    function getPublicId() {                                                                                           //
      return inMeteor(function () {                                                                                    // 263
        var result = {};                                                                                               // 264
                                                                                                                       //
        result.publicId = this._getPublicId();                                                                         // 266
        result.hostname = HOSTNAME;                                                                                    // 267
        result.autoUrl = ROOT_URL.protocol + "//" + makeWildcardHost(result.publicId);                                 // 268
                                                                                                                       //
        var grain = Grains.findOne(this.grainId, { fields: { userId: 1 } });                                           // 270
        result.isDemoUser = Meteor.users.findOne(grain.userId).expires ? true : false;                                 // 271
                                                                                                                       //
        return result;                                                                                                 // 273
      }.bind(this));                                                                                                   //
    }                                                                                                                  //
                                                                                                                       //
    return getPublicId;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.httpGet = function () {                                                             // 185
    function httpGet(url) {                                                                                            //
      var _this = this;                                                                                                // 278
      var session = _this;                                                                                             // 279
                                                                                                                       //
      return new Promise(function (resolve, reject) {                                                                  // 281
        var requestMethod = Http.request;                                                                              // 282
        if (url.indexOf("https://") === 0) {                                                                           // 283
          requestMethod = Https.request;                                                                               // 284
        } else if (url.indexOf("http://") !== 0) {                                                                     //
          err = new Error("Protocol not recognized.");                                                                 // 286
          err.nature = "precondition";                                                                                 // 287
          reject(err);                                                                                                 // 288
        }                                                                                                              //
                                                                                                                       //
        req = requestMethod(url, function (resp) {                                                                     // 291
          var buffers = [];                                                                                            // 292
          var err = void 0;                                                                                            // 293
                                                                                                                       //
          switch (Math.floor(resp.statusCode / 100)) {                                                                 // 295
            case 2:                                                                                                    // 296
              // 2xx response -- OK.                                                                                   //
              resp.on("data", function (buf) {                                                                         // 297
                buffers.push(buf);                                                                                     // 298
              });                                                                                                      //
                                                                                                                       //
              resp.on("end", function () {                                                                             // 301
                resolve({                                                                                              // 302
                  content: Buffer.concat(buffers),                                                                     // 303
                  mimeType: resp.headers["content-type"] || null                                                       // 304
                });                                                                                                    //
              });                                                                                                      //
              break;                                                                                                   // 307
            case 3:                                                                                                    // 295
              // 3xx response -- redirect.                                                                             //
              resolve(session.httpGet(resp.headers.location));                                                         // 309
              break;                                                                                                   // 310
            case 4:                                                                                                    // 295
              // 4xx response -- client error.                                                                         //
              err = new Error("Status code " + resp.statusCode + " received in response.");                            // 312
              err.nature = "precondition";                                                                             // 313
              reject(err);                                                                                             // 314
              break;                                                                                                   // 315
            case 5:                                                                                                    // 295
              // 5xx response -- internal server error.                                                                //
              err = new Error("Status code " + resp.statusCode + " received in response.");                            // 317
              err.nature = "localBug";                                                                                 // 318
              reject(err);                                                                                             // 319
              break;                                                                                                   // 320
            default:                                                                                                   // 295
              // ???                                                                                                   //
              err = new Error("Invalid status code " + resp.statusCode + " received in response.");                    // 322
              err.nature = "localBug";                                                                                 // 323
              reject(err);                                                                                             // 324
              break;                                                                                                   // 325
          }                                                                                                            // 295
        });                                                                                                            //
                                                                                                                       //
        req.on("error", function (e) {                                                                                 // 329
          e.nature = "networkFailure";                                                                                 // 330
          reject(e);                                                                                                   // 331
        });                                                                                                            //
                                                                                                                       //
        req.setTimeout(15000, function () {                                                                            // 334
          req.abort();                                                                                                 // 335
          err = new Error("Request timed out.");                                                                       // 336
          err.nature = "localBug";                                                                                     // 337
          err.durability = "overloaded";                                                                               // 338
          reject(err);                                                                                                 // 339
        });                                                                                                            //
                                                                                                                       //
        req.end();                                                                                                     // 342
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return httpGet;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.getUserAddress = function () {                                                      // 185
    function getUserAddress() {                                                                                        //
      return inMeteor(function () {                                                                                    // 347
        return this._getUserAddress();                                                                                 // 348
      }.bind(this));                                                                                                   //
    }                                                                                                                  //
                                                                                                                       //
    return getUserAddress;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteGenerateApiToken = function () {                                            // 185
    function obsoleteGenerateApiToken(petname, userInfo, expires) {                                                    //
      throw new Error("generateApiToken() has been removed. Use offer templates instead.");                            // 353
    }                                                                                                                  //
                                                                                                                       //
    return obsoleteGenerateApiToken;                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteListApiTokens = function () {                                               // 185
    function obsoleteListApiTokens() {                                                                                 //
      throw new Error("listApiTokens() has been removed. Use offer templates instead.");                               // 357
    }                                                                                                                  //
                                                                                                                       //
    return obsoleteListApiTokens;                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteRevokeApiToken = function () {                                              // 185
    function obsoleteRevokeApiToken(tokenId) {                                                                         //
      throw new Error("revokeApiToken() has been removed. Use offer templates instead.");                              // 361
    }                                                                                                                  //
                                                                                                                       //
    return obsoleteRevokeApiToken;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.getUiViewForEndpoint = function () {                                                // 185
    function getUiViewForEndpoint(url) {                                                                               //
      var parsedUrl = Url.parse(url);                                                                                  // 365
                                                                                                                       //
      if (parsedUrl.hash) {                                                                                            // 367
        // Assume that anything with a fragment is a webkey                                                            //
        if (parsedUrl.pathname) {                                                                                      // 368
          throw new Error("Webkey urls cannot contain a path.");                                                       // 369
        }                                                                                                              //
                                                                                                                       //
        var token = parsedUrl.hash.slice(1); // Get rid of # which is always the first character                       // 372
        var hostId = matchWildcardHost(parsedUrl.host);                                                                // 367
        if (hostId && globalDb.isApiHostId(hostId)) {                                                                  // 374
          // Connecting to a local capability.                                                                         //
          return getWrappedUiViewForToken(token);                                                                      // 376
        } else {                                                                                                       //
          // Connecting to a remote server with a bearer token.                                                        //
          // TODO(someday): Negotiate server-to-server Cap'n Proto connection.                                         //
          return { view: new ExternalUiView(url, this.grainId, token) };                                               // 380
        }                                                                                                              //
      } else {                                                                                                         //
        return { view: new ExternalUiView(url, this.grainId) };                                                        // 383
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return getUiViewForEndpoint;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return HackSessionContextImpl;                                                                                       //
}(SessionContextImpl);                                                                                                 //
                                                                                                                       //
makeHackSessionContext = function makeHackSessionContext(grainId, sessionId, identityId, tabId) {                      // 388
  return new Capnp.Capability(new HackSessionContextImpl(grainId, sessionId, identityId, tabId), HackSessionContext);  // 389
};                                                                                                                     //
                                                                                                                       //
var HOSTNAME_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";                                                           // 393
                                                                                                                       //
generateRandomHostname = function generateRandomHostname(length) {                                                     // 395
  // Generate a random unique name suitable for use in a hostname.                                                     //
                                                                                                                       //
  var digits = [];                                                                                                     // 398
  for (var i = 0; i < length; i++) {                                                                                   // 399
    digits[i] = Random.choice(HOSTNAME_CHARS);                                                                         // 400
  }                                                                                                                    //
                                                                                                                       //
  return digits.join("");                                                                                              // 403
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"install-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/install-server.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var localizedTextPattern = {                                                                                           // 17
  defaultText: String,                                                                                                 // 18
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 19
};                                                                                                                     //
                                                                                                                       //
var uploadTokens = {};                                                                                                 // 22
                                                                                                                       //
UserActions.allow({                                                                                                    // 24
  insert: function () {                                                                                                // 25
    function insert(userId, action) {                                                                                  // 25
      // TODO(cleanup): This check keeps breaking. Use a method instead that takes the package                         //
      //   ID as an argument.                                                                                          //
      check(action, {                                                                                                  // 28
        userId: String,                                                                                                // 29
        packageId: String,                                                                                             // 30
        appId: String,                                                                                                 // 31
        appTitle: Match.Optional(localizedTextPattern),                                                                // 32
        appMarketingVersion: Match.Optional(Object),                                                                   // 33
        appVersion: Match.Integer,                                                                                     // 34
        title: localizedTextPattern,                                                                                   // 35
        nounPhrase: Match.Optional(localizedTextPattern),                                                              // 36
        command: {                                                                                                     // 37
          executablePath: Match.Optional(String),                                                                      // 38
          deprecatedExecutablePath: Match.Optional(String),                                                            // 39
          args: Match.Optional([String]),                                                                              // 40
          argv: Match.Optional([String]),                                                                              // 41
          environ: Match.Optional([{ key: String, value: String }])                                                    // 42
        }                                                                                                              //
      });                                                                                                              //
      return userId && isSignedUpOrDemo() && action.userId === userId;                                                 // 45
    }                                                                                                                  //
                                                                                                                       //
    return insert;                                                                                                     //
  }(),                                                                                                                 //
                                                                                                                       //
  remove: function () {                                                                                                // 48
    function remove(userId, action) {                                                                                  // 48
      return userId && action.userId === userId;                                                                       // 49
    }                                                                                                                  //
                                                                                                                       //
    return remove;                                                                                                     //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
// Not all users are allowed to upload apps. We need to manually implement authorization                               //
// because Meteor.userId() is not available in server-side routes.                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 56
  cancelDownload: function (_cancelDownload) {                                                                         // 57
    function cancelDownload(_x) {                                                                                      //
      return _cancelDownload.apply(this, arguments);                                                                   //
    }                                                                                                                  //
                                                                                                                       //
    cancelDownload.toString = function () {                                                                            //
      return _cancelDownload.toString();                                                                               //
    };                                                                                                                 //
                                                                                                                       //
    return cancelDownload;                                                                                             //
  }(function (packageId) {                                                                                             //
    check(packageId, String);                                                                                          // 58
                                                                                                                       //
    // TODO(security):  Only let user cancel download if they initiated it.                                            //
    cancelDownload(packageId);                                                                                         // 57
  }),                                                                                                                  //
                                                                                                                       //
  newUploadToken: function () {                                                                                        // 64
    function newUploadToken() {                                                                                        // 64
      if (!isSignedUp()) {                                                                                             // 65
        throw new Meteor.Error(403, "Unauthorized", "Only invited users can upload apps.");                            // 66
      }                                                                                                                //
                                                                                                                       //
      if (globalDb.isUninvitedFreeUser()) {                                                                            // 69
        throw new Meteor.Error(403, "Unauthorized", "Only paid users can upload apps.");                               // 70
      }                                                                                                                //
                                                                                                                       //
      var token = Random.id(22);                                                                                       // 73
      uploadTokens[token] = setTimeout(function () {                                                                   // 74
        delete uploadTokens[token];                                                                                    // 75
      }, 20 * 60 * 1000);                                                                                              //
                                                                                                                       //
      return token;                                                                                                    // 78
    }                                                                                                                  //
                                                                                                                       //
    return newUploadToken;                                                                                             //
  }(),                                                                                                                 //
                                                                                                                       //
  upgradeGrains: function () {                                                                                         // 81
    function upgradeGrains(appId, version, packageId) {                                                                // 81
      this.connection.sandstormDb.upgradeGrains(appId, version, packageId, globalBackend);                             // 82
    }                                                                                                                  //
                                                                                                                       //
    return upgradeGrains;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  ensureInstalled: function () {                                                                                       // 85
    function ensureInstalled(packageId, url, isRetry) {                                                                // 85
      check(packageId, String);                                                                                        // 86
      check(url, Match.OneOf(String, undefined, null));                                                                // 87
      check(isRetry, Boolean);                                                                                         // 88
                                                                                                                       //
      if (!packageId.match(/^[a-zA-Z0-9]*$/)) {                                                                        // 90
        throw new Meteor.Error(400, "The package ID contains illegal characters.");                                    // 91
      }                                                                                                                //
                                                                                                                       //
      if (!this.userId) {                                                                                              // 94
        if (allowDemo && isSafeDemoAppUrl(url)) {                                                                      // 95
          // continue on                                                                                               //
        } else {                                                                                                       //
            // jscs:ignore disallowEmptyBlocks                                                                         //
            throw new Meteor.Error(403, "You must be logged in to install packages.");                                 // 98
          }                                                                                                            //
      } else if (!isSignedUp() && !isDemoUser()) {                                                                     //
        throw new Meteor.Error(403, "This Sandstorm server requires you to get an invite before installing apps.");    // 101
      } else if (isUserOverQuota(Meteor.user())) {                                                                     //
        throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");         // 104
      }                                                                                                                //
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 108
                                                                                                                       //
      if (!pkg || pkg.status !== "ready") {                                                                            // 110
        if (!this.userId || isDemoUser() || globalDb.isUninvitedFreeUser()) {                                          // 111
          if (!isSafeDemoAppUrl(url)) {                                                                                // 112
            // TODO(someday): Billing prompt on client side.                                                           //
            throw new Meteor.Error(403, "Sorry, demo and free users cannot upload custom apps; " + "they may only install apps from apps.sandstorm.io.");
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (!pkg || isRetry) {                                                                                           // 120
        globalDb.startInstall(packageId, url, isRetry);                                                                // 121
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return ensureInstalled;                                                                                            //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Router.map(function () {                                                                                               // 126
  this.route("upload", {                                                                                               // 127
    where: "server",                                                                                                   // 128
    path: "/upload/:token",                                                                                            // 129
                                                                                                                       //
    action: function () {                                                                                              // 131
      function action() {                                                                                              // 131
        if (!this.params.token || !uploadTokens[this.params.token]) {                                                  // 132
          this.response.writeHead(403, {                                                                               // 133
            "Content-Type": "text/plain"                                                                               // 134
          });                                                                                                          //
          this.response.write("Invalid upload token.");                                                                // 136
          this.response.end();                                                                                         // 137
        } else if (this.request.method === "POST") {                                                                   //
          try {                                                                                                        // 139
            var packageId = promiseToFuture(doClientUpload(this.request)).wait();                                      // 140
            this.response.writeHead(200, {                                                                             // 141
              "Content-Length": packageId.length,                                                                      // 142
              "Content-Type": "text/plain"                                                                             // 143
            });                                                                                                        //
            this.response.write(packageId);                                                                            // 145
            this.response.end();                                                                                       // 146
            clearTimeout(uploadTokens[this.params.token]);                                                             // 147
            delete uploadTokens[this.params.token];                                                                    // 148
          } catch (error) {                                                                                            //
            console.error(error.stack);                                                                                // 150
            this.response.writeHead(500, {                                                                             // 151
              "Content-Type": "text/plain"                                                                             // 152
            });                                                                                                        //
            this.response.write("Unpacking SPK failed; is it valid?");                                                 // 154
            this.response.end();                                                                                       // 155
          };                                                                                                           //
        } else {                                                                                                       //
          this.response.writeHead(405, {                                                                               // 158
            "Content-Type": "text/plain"                                                                               // 159
          });                                                                                                          //
          this.response.write("You can only POST here.");                                                              // 161
          this.response.end();                                                                                         // 162
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return action;                                                                                                   //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"installer.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/installer.js                                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Fs = Npm.require("fs");                                                                                            // 17
var Path = Npm.require("path");                                                                                        // 18
var Crypto = Npm.require("crypto");                                                                                    // 19
var ChildProcess = Npm.require("child_process");                                                                       // 20
var Http = Npm.require("http");                                                                                        // 21
var Https = Npm.require("https");                                                                                      // 22
var Url = Npm.require("url");                                                                                          // 23
var Promise = Npm.require("es6-promise").Promise;                                                                      // 24
var Capnp = Npm.require("capnp");                                                                                      // 25
                                                                                                                       //
var Manifest = Capnp.importSystem("sandstorm/package.capnp").Manifest;                                                 // 27
                                                                                                                       //
var installers = void 0; // set to {} on main replica                                                                  // 29
// To protect against race conditions, we require that each row in the Packages                                        //
// collection have at most one writer at a time, as tracked by this `installers`                                       //
// map. Each key is a package ID and each value is either an AppInstaller object                                       //
// or the string 'uninstalling', indicating that some fiber is working on                                              //
// uninstalling the package.                                                                                           //
                                                                                                                       //
var verifyIsMainReplica = function verifyIsMainReplica() {                                                             // 36
  if (Meteor.settings.replicaNumber) {                                                                                 // 37
    throw new Error("This can only be called on the main front-end replica.");                                         // 38
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 42
  deleteUnusedPackages: function () {                                                                                  // 43
    function deleteUnusedPackages(appId) {                                                                             //
      check(appId, String);                                                                                            // 44
      Packages.find({ appId: appId }).forEach(function (pkg) {                                                         // 45
        deletePackage(pkg._id);                                                                                        // 45
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return deleteUnusedPackages;                                                                                       //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
deletePackage = function deletePackage(packageId) {                                                                    // 49
  // Mark package for possible deletion;                                                                               //
  Packages.update({ _id: packageId, status: "ready" }, { $set: { shouldCleanup: true } });                             // 51
};                                                                                                                     //
                                                                                                                       //
var deletePackageInternal = function deletePackageInternal(pkg) {                                                      // 54
  verifyIsMainReplica();                                                                                               // 55
                                                                                                                       //
  var packageId = pkg._id;                                                                                             // 57
                                                                                                                       //
  if (packageId in installers) {                                                                                       // 59
    return;                                                                                                            // 60
  }                                                                                                                    //
                                                                                                                       //
  installers[packageId] = "uninstalling";                                                                              // 63
                                                                                                                       //
  try {                                                                                                                // 65
    var action = UserActions.findOne({ packageId: packageId });                                                        // 66
    var grain = Grains.findOne({ packageId: packageId });                                                              // 67
    var notificationQuery = {};                                                                                        // 68
    notificationQuery["appUpdates." + pkg.appId] = { $exists: true };                                                  // 69
    if (!grain && !action && !(pkg.isAutoUpdated && Notifications.findOne(notificationQuery))) {                       // 70
      Packages.update({                                                                                                // 71
        _id: packageId                                                                                                 // 72
      }, {                                                                                                             //
        $set: { status: "delete" },                                                                                    // 74
        $unset: { shouldCleanup: "" }                                                                                  // 75
      });                                                                                                              //
      waitPromise(globalBackend.cap().deletePackage(packageId));                                                       // 77
      Packages.remove(packageId);                                                                                      // 78
                                                                                                                       //
      // Clean up assets (icon, etc).                                                                                  //
      getAllManifestAssets(pkg.manifest).forEach(function (assetId) {                                                  // 70
        globalDb.unrefStaticAsset(assetId);                                                                            // 82
      });                                                                                                              //
    } else {                                                                                                           //
      Packages.update({ _id: packageId }, { $unset: { shouldCleanup: "" } });                                          // 85
    }                                                                                                                  //
                                                                                                                       //
    delete installers[packageId];                                                                                      // 88
  } catch (error) {                                                                                                    //
    delete installers[packageId];                                                                                      // 90
    throw error;                                                                                                       // 91
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
var startInstallInternal = function startInstallInternal(pkg) {                                                        // 95
  verifyIsMainReplica();                                                                                               // 96
                                                                                                                       //
  if (pkg._id in installers) {                                                                                         // 98
    return;                                                                                                            // 99
  }                                                                                                                    //
                                                                                                                       //
  var installer = new AppInstaller(pkg._id, pkg.url, pkg.appId, pkg.isAutoUpdated);                                    // 102
  installers[pkg._id] = installer;                                                                                     // 103
  installer.start();                                                                                                   // 104
};                                                                                                                     //
                                                                                                                       //
cancelDownload = function cancelDownload(packageId) {                                                                  // 107
  Packages.remove({ _id: packageId, status: "download" });                                                             // 108
};                                                                                                                     //
                                                                                                                       //
var cancelDownloadInternal = function cancelDownloadInternal(pkg) {                                                    // 111
  verifyIsMainReplica();                                                                                               // 112
                                                                                                                       //
  var installer = installers[pkg._id];                                                                                 // 114
                                                                                                                       //
  // Don't do anything unless a download is in progress.                                                               //
  if (installer && installer.downloadRequest) {                                                                        // 111
    // OK, effect cancellation by faking an error.                                                                     //
    installer.wrapCallback(function () {                                                                               // 119
      throw new Error("Canceled");                                                                                     // 120
    })();                                                                                                              //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 125
  installers = {};                                                                                                     // 126
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 128
    // Restart any deletions that were killed while in-progress.                                                       //
    Packages.find({ status: "delete" }).forEach(deletePackageInternal);                                                // 130
                                                                                                                       //
    // Watch for new installation requests and fulfill them.                                                           //
    Packages.find({ status: { $in: ["download", "verify", "unpack", "analyze"] } }).observe({                          // 128
      added: startInstallInternal,                                                                                     // 134
      removed: cancelDownloadInternal                                                                                  // 135
    });                                                                                                                //
                                                                                                                       //
    // Watch for new cleanup requests and fulfill them.                                                                //
    Packages.find({ status: "ready", shouldCleanup: true }).observe({                                                  // 128
      added: deletePackageInternal                                                                                     // 140
    });                                                                                                                //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
doClientUpload = function doClientUpload(stream) {                                                                     // 145
  return new Promise(function (resolve, reject) {                                                                      // 146
    var id = Random.id();                                                                                              // 147
                                                                                                                       //
    var backendStream = globalBackend.cap().installPackage().stream;                                                   // 149
    var hasher = Crypto.createHash("sha256");                                                                          // 150
                                                                                                                       //
    stream.on("data", function (chunk) {                                                                               // 152
      try {                                                                                                            // 153
        hasher.update(chunk);                                                                                          // 154
        backendStream.write(chunk);                                                                                    // 155
      } catch (err) {                                                                                                  //
        reject(err);                                                                                                   // 157
      }                                                                                                                //
    });                                                                                                                //
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 161
      try {                                                                                                            // 162
        (function () {                                                                                                 //
          backendStream.done();                                                                                        // 163
          var packageId = hasher.digest("hex").slice(0, 32);                                                           // 164
          resolve(backendStream.saveAs(packageId).then(function () {                                                   // 165
            return packageId;                                                                                          // 166
          }));                                                                                                         //
          backendStream.close();                                                                                       // 168
        })();                                                                                                          //
      } catch (err) {                                                                                                  //
        reject(err);                                                                                                   // 170
      }                                                                                                                //
    });                                                                                                                //
                                                                                                                       //
    stream.on("error", function (err) {                                                                                // 174
      // TODO(soon):  This event does't seem to fire if the user leaves the page mid-upload.                           //
      try {                                                                                                            // 176
        backendStream.close();                                                                                         // 177
        reject(err);                                                                                                   // 178
      } catch (err2) {                                                                                                 //
        reject(err2);                                                                                                  // 180
      }                                                                                                                //
    });                                                                                                                //
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
AppInstaller = function () {                                                                                           // 186
  function AppInstaller(packageId, url, appId, isAutoUpdated) {                                                        // 187
    (0, _classCallCheck3["default"])(this, AppInstaller);                                                              //
                                                                                                                       //
    verifyIsMainReplica();                                                                                             // 188
                                                                                                                       //
    this.packageId = packageId;                                                                                        // 190
    this.url = url;                                                                                                    // 191
    this.failed = false;                                                                                               // 192
    this.appId = appId;                                                                                                // 193
    this.isAutoUpdated = isAutoUpdated;                                                                                // 194
                                                                                                                       //
    // Serializes database writes.                                                                                     //
    this.writeChain = Promise.resolve();                                                                               // 187
  }                                                                                                                    //
                                                                                                                       //
  AppInstaller.prototype.updateProgress = function () {                                                                // 186
    function updateProgress(status, progress, error, manifest) {                                                       //
      // TODO(security):  On error, we should actually delete the package from the database and only                   //
      //   display the error to whomever was watching at the time.  Otherwise it's easy to confuse                     //
      //   people by 'pre-failing' packages.  (Actually, perhaps if a user tries to download an                        //
      //   already-downloading package but specifies a different URL, we really should initiate an                     //
      //   entirely separate download...  but cancel it if the first download succeeds.)                               //
                                                                                                                       //
      this.status = status;                                                                                            // 207
      this.progress = progress || -1;                                                                                  // 208
      this.error = error;                                                                                              // 209
      this.manifest = manifest || null;                                                                                // 210
                                                                                                                       //
      var _this = this;                                                                                                // 212
                                                                                                                       //
      // The callback passed to inMeteor() runs in a new fiber. We need to make sure database writes                   //
      // occur in exactly the order in which we generate them, so we use a promise chain to serialize                  //
      // them.                                                                                                         //
      this.writeChain = this.writeChain.then(function () {                                                             // 200
        return inMeteor(function () {                                                                                  // 218
          if (manifest) extractManifestAssets(manifest);                                                               // 219
                                                                                                                       //
          Packages.update(_this.packageId, {                                                                           // 221
            $set: {                                                                                                    // 222
              status: _this.status,                                                                                    // 223
              progress: _this.progress,                                                                                // 224
              error: _this.error ? _this.error.message : null,                                                         // 225
              manifest: _this.manifest,                                                                                // 226
              appId: _this.appId,                                                                                      // 227
              authorPgpKeyFingerprint: _this.authorPgpKeyFingerprint                                                   // 228
            }                                                                                                          //
          });                                                                                                          //
                                                                                                                       //
          if (_this.authorPgpKeyFingerprint) {                                                                         // 232
            globalDb.updateKeybaseProfileAsync(_this.authorPgpKeyFingerprint);                                         // 233
          }                                                                                                            //
        })["catch"](function (err) {                                                                                   //
          console.error(err.stack);                                                                                    // 236
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return updateProgress;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.wrapCallback = function () {                                                                  // 186
    function wrapCallback(method) {                                                                                    //
      // Note that the function below must not be an arrow function, since arrow functions do not have                 //
      // access to the context's arguments array.                                                                      //
      var _this = this;                                                                                                // 244
      return function () {                                                                                             // 245
        if (_this.failed) return;                                                                                      // 246
        try {                                                                                                          // 247
          return method.apply(_this, _.toArray(arguments));                                                            // 248
        } catch (err) {                                                                                                //
          _this.failed = true;                                                                                         // 250
          _this.cleanup();                                                                                             // 251
          _this.updateProgress("failed", 0, err);                                                                      // 252
          _this.writeChain = _this.writeChain.then(function () {                                                       // 253
            delete installers[_this.packageId];                                                                        // 254
          });                                                                                                          //
          console.error("Failed to install app:", err.stack);                                                          // 256
        }                                                                                                              //
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    return wrapCallback;                                                                                               //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.cleanup = function () {                                                                       // 186
    function cleanup() {                                                                                               //
      if (this.uploadStream) {                                                                                         // 262
        try {                                                                                                          // 263
          this.uploadStream.close();                                                                                   // 264
        } catch (err) {}                                                                                               //
                                                                                                                       //
        delete this.uploadStream;                                                                                      // 267
      }                                                                                                                //
                                                                                                                       //
      if (this.downloadRequest) {                                                                                      // 270
        try {                                                                                                          // 271
          this.downloadRequest.abort();                                                                                // 272
        } catch (err) {}                                                                                               //
                                                                                                                       //
        delete this.downloadRequest;                                                                                   // 275
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return cleanup;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.start = function () {                                                                         // 186
    function start() {                                                                                                 //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      return this.wrapCallback(function () {                                                                           // 280
        _this2.cleanup();                                                                                              // 281
                                                                                                                       //
        globalBackend.cap().tryGetPackage(_this2.packageId).then(_this2.wrapCallback(function (info) {                 // 283
          if (info.appId) {                                                                                            // 284
            _this2.appId = info.appId;                                                                                 // 285
            _this2.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                             // 286
            _this2.done(info.manifest);                                                                                // 287
          } else {                                                                                                     //
            _this2.doDownload();                                                                                       // 289
          }                                                                                                            //
        }), _this2.wrapCallback(function (err) {                                                                       //
          throw err;                                                                                                   // 292
        }));                                                                                                           //
      })();                                                                                                            //
    }                                                                                                                  //
                                                                                                                       //
    return start;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.doDownload = function () {                                                                    // 186
    function doDownload() {                                                                                            //
      if (!this.url) {                                                                                                 // 298
        throw new Error("Unknown package ID, and no URL was provided.");                                               // 299
      }                                                                                                                //
                                                                                                                       //
      console.log("Downloading app:", this.url);                                                                       // 302
      this.updateProgress("download");                                                                                 // 303
                                                                                                                       //
      this.uploadStream = globalBackend.cap().installPackage().stream;                                                 // 305
      return this.doDownloadTo(this.uploadStream);                                                                     // 306
    }                                                                                                                  //
                                                                                                                       //
    return doDownload;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.doDownloadTo = function () {                                                                  // 186
    function doDownloadTo(out) {                                                                                       //
      var _this3 = this;                                                                                               //
                                                                                                                       //
      var url = Url.parse(this.url);                                                                                   // 310
      var options = {                                                                                                  // 311
        hostname: url.hostname,                                                                                        // 312
        port: url.port,                                                                                                // 313
        path: url.path                                                                                                 // 314
      };                                                                                                               //
                                                                                                                       //
      var protocol = void 0;                                                                                           // 317
      if (url.protocol === "http:" || url.protocol === "https:") {                                                     // 318
        protocol = Request.defaults({                                                                                  // 319
          maxRedirects: 20,                                                                                            // 320
          // Since we will verify the download against a hash anyway, we don't need to verify the                      //
          // server's certificate. In fact, the only reason we support HTTPS at all here is because                    //
          // some servers refuse to serve over HTTP (which is, in general, a good thing). Skipping the                 //
          // certificate check here is helpful in that it means we don't have to worry about having a                  //
          // reasonable list of trusted CAs available to Sandstorm.                                                    //
          strictSSL: false                                                                                             // 326
        });                                                                                                            //
      } else {                                                                                                         //
        throw new Error("Protocol not supported: " + url.protocol);                                                    // 329
      }                                                                                                                //
                                                                                                                       //
      // TODO(security):  It could arguably be a security problem that it's possible to probe the                      //
      //   server's local network (behind any firewalls) by presenting URLs here.                                      //
      var bytesExpected = undefined;                                                                                   // 309
      var bytesReceived = 0;                                                                                           // 335
      var hasher = Crypto.createHash("sha256");                                                                        // 336
      var done = false;                                                                                                // 337
      var updateDownloadProgress = _.throttle(this.wrapCallback(function () {                                          // 338
        if (!done) {                                                                                                   // 339
          if (bytesExpected) {                                                                                         // 340
            _this3.updateProgress("download", bytesReceived / bytesExpected);                                          // 341
          } else {                                                                                                     //
            _this3.updateProgress("download", bytesReceived);                                                          // 343
          }                                                                                                            //
        }                                                                                                              //
      }), 500);                                                                                                        //
                                                                                                                       //
      var request = protocol.get(this.url);                                                                            // 348
                                                                                                                       //
      request.on("response", this.wrapCallback(function (response) {                                                   // 350
        if ("content-length" in response.headers) {                                                                    // 351
          bytesExpected = parseInt(response.headers["content-length"]);                                                // 352
        }                                                                                                              //
      }));                                                                                                             //
                                                                                                                       //
      request.on("data", this.wrapCallback(function (chunk) {                                                          // 356
        hasher.update(chunk);                                                                                          // 357
        out.write(chunk);                                                                                              // 358
        bytesReceived += chunk.length;                                                                                 // 359
        updateDownloadProgress();                                                                                      // 360
      }));                                                                                                             //
                                                                                                                       //
      request.on("end", this.wrapCallback(function () {                                                                // 363
        out.done();                                                                                                    // 364
                                                                                                                       //
        if (hasher.digest("hex").slice(0, 32) !== _this3.packageId) {                                                  // 366
          throw new Error("Package hash did not match.");                                                              // 367
        }                                                                                                              //
                                                                                                                       //
        done = true;                                                                                                   // 370
        delete _this3.downloadRequest;                                                                                 // 371
                                                                                                                       //
        _this3.updateProgress("unpack");                                                                               // 373
        out.saveAs(_this3.packageId).then(_this3.wrapCallback(function (info) {                                        // 374
          _this3.appId = info.appId;                                                                                   // 375
          _this3.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                               // 376
          _this3.done(info.manifest);                                                                                  // 377
        }), _this3.wrapCallback(function (err) {                                                                       //
          throw err;                                                                                                   // 379
        }));                                                                                                           //
      }));                                                                                                             //
                                                                                                                       //
      request.on("error", this.wrapCallback(function (err) {                                                           // 383
        throw err;                                                                                                     // 383
      }));                                                                                                             //
                                                                                                                       //
      this.downloadRequest = request;                                                                                  // 385
    }                                                                                                                  //
                                                                                                                       //
    return doDownloadTo;                                                                                               //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.done = function () {                                                                          // 186
    function done(manifest) {                                                                                          //
      console.log("App ready:", this.packageId);                                                                       // 389
      this.updateProgress("ready", 1, undefined, manifest);                                                            // 390
      var _this = this;                                                                                                // 391
      _this.writeChain = _this.writeChain.then(function () {                                                           // 392
        return inMeteor(function () {                                                                                  // 393
          if (_this.isAutoUpdated) {                                                                                   // 394
            globalDb.sendAppUpdateNotifications(_this.appId, _this.packageId, manifest.appTitle && manifest.appTitle.defaultText, manifest.appVersion, manifest.appMarketingVersion && manifest.appMarketingVersion.defaultText);
          }                                                                                                            //
        });                                                                                                            //
      }).then(function () {                                                                                            //
        delete installers[_this.packageId];                                                                            // 401
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return done;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return AppInstaller;                                                                                                 //
}();                                                                                                                   //
                                                                                                                       //
extractManifestAssets = function extractManifestAssets(manifest) {                                                     // 406
  var metadata = manifest.metadata;                                                                                    // 407
  if (!metadata) return;                                                                                               // 408
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 410
  if (icons) {                                                                                                         // 411
    var handleIcon = function handleIcon(icon) {                                                                       // 412
      if (icon.svg) {                                                                                                  // 413
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/svg+xml" }, icon.svg);                               // 414
        icon.format = "svg";                                                                                           // 415
        delete icon.svg;                                                                                               // 416
        return true;                                                                                                   // 417
      } else if (icon.png) {                                                                                           //
        // Use the 1x version for 'normal' DPI, unless 1x isn't provided, in which case use 2x.                        //
        var normalDpi = icon.png.dpi1x || icon.png.dpi2x;                                                              // 420
        if (!normalDpi) return false;                                                                                  // 421
        icon.format = "png";                                                                                           // 422
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/png" }, normalDpi);                                  // 423
                                                                                                                       //
        if (icon.png.dpi1x && icon.png.dpi2x) {                                                                        // 425
          // Icon specifies both resolutions, so also record a 2x DPI option.                                          //
          icon.assetId2xDpi = globalDb.addStaticAsset({ mimeType: "image/png" }, icon.png.dpi2x);                      // 427
        }                                                                                                              //
                                                                                                                       //
        delete icon.png;                                                                                               // 430
        return true;                                                                                                   // 431
      } else {                                                                                                         //
        // Unknown icon. Filter it.                                                                                    //
        return false;                                                                                                  // 434
      }                                                                                                                //
    };                                                                                                                 //
                                                                                                                       //
    if (icons.appGrid && !handleIcon(icons.appGrid)) delete icons.appGrid;                                             // 438
    if (icons.grain && !handleIcon(icons.grain)) delete icons.grain;                                                   // 439
                                                                                                                       //
    // We don't need the market icons.                                                                                 //
    if (icons.market) delete icons.market;                                                                             // 411
    if (icons.marketBig) delete icons.marketBig;                                                                       // 443
  }                                                                                                                    //
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 446
    if (text.defaultText) {                                                                                            // 447
      text.defaultTextAssetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, text.defaultText);                 // 448
      delete text.defaultText;                                                                                         // 449
    }                                                                                                                  //
                                                                                                                       //
    if (text.localizations) {                                                                                          // 452
      text.localizations.forEach(function (localization) {                                                             // 453
        if (localization.text) {                                                                                       // 454
          localization.assetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, localization.text);               // 455
          delete localization.text;                                                                                    // 457
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  var license = metadata.license;                                                                                      // 463
  if (license) {                                                                                                       // 464
    if (license.proprietary) license.proprietary = handleLocalizedText(license.proprietary);                           // 465
    if (license.publicDomain) license.publicDomain = handleLocalizedText(license.proprietary);                         // 466
    if (license.notices) license.notices = handleLocalizedText(license.notices);                                       // 467
  }                                                                                                                    //
                                                                                                                       //
  var author = metadata.author;                                                                                        // 470
  if (author) {                                                                                                        // 471
    // We remove the PGP signature since it was already verified down to a key ID in the back-end.                     //
    if (author.pgpSignature) delete author.pgpSignature;                                                               // 473
  }                                                                                                                    //
                                                                                                                       //
  // Don't need the keyring either.                                                                                    //
  if (metadata.pgpKeyring) delete metadata.pgpKeyring;                                                                 // 406
                                                                                                                       //
  // Perhaps used by the 'about' page?                                                                                 //
  if (metadata.description) metadata.description = handleLocalizedText(metadata.description);                          // 406
                                                                                                                       //
  // Screenshots are for app marketing; we don't use them post-install.                                                //
  if (metadata.screenshots) delete metadata.screenshots;                                                               // 406
                                                                                                                       //
  // We might allow the user to view the changelog.                                                                    //
  if (metadata.changeLog) metadata.changeLog = handleLocalizedText(metadata.changeLog);                                // 406
};                                                                                                                     //
                                                                                                                       //
getAllManifestAssets = function getAllManifestAssets(manifest) {                                                       // 489
  // Returns a list of all asset IDs in the given manifest.                                                            //
                                                                                                                       //
  var metadata = manifest.metadata;                                                                                    // 492
  if (!metadata) return [];                                                                                            // 493
                                                                                                                       //
  var result = [];                                                                                                     // 495
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 497
  if (icons) {                                                                                                         // 498
    var handleIcon = function handleIcon(icon) {                                                                       // 499
      if (icon.assetId) {                                                                                              // 500
        result.push(icon.assetId);                                                                                     // 501
      }                                                                                                                //
    };                                                                                                                 //
                                                                                                                       //
    if (icons.appGrid) handleIcon(icons.appGrid);                                                                      // 505
    if (icons.grain) handleIcon(icons.grain);                                                                          // 506
  }                                                                                                                    //
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 509
    if (text.defaultTextAssetId) {                                                                                     // 510
      result.push(defaultTextAssetId);                                                                                 // 511
    }                                                                                                                  //
                                                                                                                       //
    if (text.localizations) {                                                                                          // 514
      text.localizations.forEach(function (localization) {                                                             // 515
        if (localization.assetId) {                                                                                    // 516
          result.push(localization.assetId);                                                                           // 517
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  var license = metadata.license;                                                                                      // 523
  if (license) {                                                                                                       // 524
    if (license.proprietary) handleLocalizedText(license.proprietary);                                                 // 525
    if (license.publicDomain) handleLocalizedText(license.publicDomain);                                               // 526
    if (license.notices) handleLocalizedText(license.notices);                                                         // 527
  }                                                                                                                    //
                                                                                                                       //
  if (metadata.description) handleLocalizedText(metadata.description);                                                 // 530
  if (metadata.changeLog) handleLocalizedText(metadata.changeLog);                                                     // 531
                                                                                                                       //
  return result;                                                                                                       // 533
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"pre-meteor.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/pre-meteor.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file implements logic that we place in front of our main Meteor application,                                   //
// including routing of requests to proxies and handling of static web publishing.                                     //
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 20
var Fs = Npm.require("fs");                                                                                            // 21
var Dns = Npm.require("dns");                                                                                          // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Future = Npm.require("fibers/future");                                                                             // 24
var Http = Npm.require("http");                                                                                        // 25
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 27
var DDP_HOSTNAME = process.env.DDP_DEFAULT_CONNECTION_URL && Url.parse(process.env.DDP_DEFAULT_CONNECTION_URL).hostname;
var CACHE_TTL_SECONDS = 30; // 30 seconds.  Cache-Control expects units of seconds, not millis.                        // 30
var DNS_CACHE_TTL = CACHE_TTL_SECONDS * 1000; // DNS cache is in millis.                                               // 31
                                                                                                                       //
var staticHandlers = {};                                                                                               // 33
// Maps grain public IDs to Connect handlers.                                                                          //
// TODO(perf): Garbage-collect this map?                                                                               //
                                                                                                                       //
var dnsCache = {};                                                                                                     // 37
// Unfortunately, node's DNS library doesn't cache results, so we do our own caching.                                  //
// Unfortunately, node's DNS library also dosen't give us TTLs. So, we'll cache for                                    //
// DNS_CACHE_TTL (a relatively small value) and rely on the upstream DNS server to implement                           //
// better caching.                                                                                                     //
                                                                                                                       //
function isSandstormShell(hostname) {                                                                                  // 43
  // Is this hostname mapped to the Sandstorm shell?                                                                   //
                                                                                                                       //
  return hostname === HOSTNAME || DDP_HOSTNAME && hostname === DDP_HOSTNAME;                                           // 46
}                                                                                                                      //
                                                                                                                       //
var mime = Connect["static"].mime;                                                                                     // 49
                                                                                                                       //
function wwwHandlerForGrain(grainId) {                                                                                 // 51
  return function (request, response, cb) {                                                                            // 52
    var path = request.url;                                                                                            // 53
                                                                                                                       //
    // If a directory, open 'index.html'.                                                                              //
    if (path.slice(-1) === "/") {                                                                                      // 52
      path = path + "index.html";                                                                                      // 57
    }                                                                                                                  //
                                                                                                                       //
    // Strip leading '/'.                                                                                              //
    if (path[0] === "/") path = path.slice(1);                                                                         // 52
                                                                                                                       //
    // Strip query.                                                                                                    //
    path = path.split("?")[0];                                                                                         // 52
                                                                                                                       //
    var type = mime.lookup(path);                                                                                      // 66
    var charset = mime.charsets.lookup(type);                                                                          // 67
    if (charset) {                                                                                                     // 68
      type = type + "; charset=" + charset;                                                                            // 69
    } else if (type === "application/json") {                                                                          //
      // HACK: Apparently the MIME module does not assume UTF-8 for JSON. :(                                           //
      type = type + "; charset=utf-8";                                                                                 // 72
    }                                                                                                                  //
                                                                                                                       //
    // TODO(perf): Automatically gzip text content? Use Express's 'compress' middleware for this?                      //
    //   Note that nginx will also auto-compress things...                                                             //
                                                                                                                       //
    response.setHeader("Content-Type", type);                                                                          // 52
    response.setHeader("Cache-Control", "public, max-age=" + CACHE_TTL_SECONDS);                                       // 79
                                                                                                                       //
    if (path === "apps/index.json" || path.match(/apps\/[a-z0-9]{52}[.]json/) || path === "experimental/index.json" || path.match(/experimental\/[a-z0-9]{52}[.]json/)) {
      // TODO(cleanup): Extra special terrible hack: The app index needs to serve these JSON files                     //
      //   cross-origin. We could almost just make all web sites allow cross-origin since generally                    //
      //   web publishing is meant to publish public content. There is one case where this is                          //
      //   problematic, though: sites behind a firewall. Those sites could potentially be read                         //
      //   by outside sites if CORS is enabled on them. Some day we should make it so apps can                         //
      //   explicitly opt-in to allowing cross-origin queries but that day is not today.                               //
      response.setHeader("Access-Control-Allow-Origin", "*");                                                          // 91
    }                                                                                                                  //
                                                                                                                       //
    var stream = new ResponseStream(response, 200, "OK");                                                              // 94
                                                                                                                       //
    globalBackend.useGrain(grainId, function (supervisor) {                                                            // 96
      return supervisor.getWwwFileHack(path, stream).then(function (result) {                                          // 97
        // jscs:disable disallowQuotedKeysInObjects                                                                    //
        var status = result.status;                                                                                    // 99
        if (status === "file") {                                                                                       // 100
          if (!stream.ended) {                                                                                         // 101
            console.error("getWwwFileHack didn't write file to stream");                                               // 102
            if (!stream.started) {                                                                                     // 103
              response.writeHead(500, {                                                                                // 104
                "Content-Type": "text/plain"                                                                           // 105
              });                                                                                                      //
              response.end("Internal server error");                                                                   // 107
            } else {                                                                                                   //
              response.end();                                                                                          // 109
            }                                                                                                          //
          }                                                                                                            //
        } else if (status === "directory") {                                                                           //
          if (stream.started) {                                                                                        // 113
            console.error("getWwwFileHack wrote to stream for directory");                                             // 114
            if (!stream.ended) {                                                                                       // 115
              response.end();                                                                                          // 116
            }                                                                                                          //
          } else {                                                                                                     //
            response.writeHead(303, {                                                                                  // 119
              "Content-Type": "text/plain",                                                                            // 120
              "Location": "/" + path + "/",                                                                            // 121
              "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                  // 122
            });                                                                                                        //
            response.end("redirect: /" + path + "/");                                                                  // 124
          }                                                                                                            //
        } else if (status === "notFound") {                                                                            //
          if (stream.started) {                                                                                        // 127
            console.error("getWwwFileHack wrote to stream for notFound");                                              // 128
            if (!stream.ended) {                                                                                       // 129
              response.end();                                                                                          // 130
            }                                                                                                          //
          } else {                                                                                                     //
            response.writeHead(404, {                                                                                  // 133
              "Content-Type": "text/plain"                                                                             // 134
            });                                                                                                        //
            response.end("404 not found: /" + path);                                                                   // 136
          }                                                                                                            //
        } else {                                                                                                       //
          console.error("didn't understand result of getWwwFileHack:", status);                                        // 139
          if (!stream.started) {                                                                                       // 140
            response.writeHead(500, {                                                                                  // 141
              "Content-Type": "text/plain"                                                                             // 142
            });                                                                                                        //
            response.end("Internal server error");                                                                     // 144
          }                                                                                                            //
        }                                                                                                              //
      });                                                                                                              //
    })["catch"](function (err) {                                                                                       //
      console.error(err.stack);                                                                                        // 149
    });                                                                                                                //
  };                                                                                                                   //
}                                                                                                                      //
                                                                                                                       //
function writeErrorResponse(res, err) {                                                                                // 154
  var status = 500;                                                                                                    // 155
  if (err instanceof Meteor.Error && typeof err.error === "number" && err.error >= 400 && err.error < 600) {           // 156
    status = err.error;                                                                                                // 158
  } else if (err.httpErrorCode) {                                                                                      //
    status = err.httpErrorCode;                                                                                        // 160
  }                                                                                                                    //
                                                                                                                       //
  // Log errors that are our fault, but not errors that are the client's fault.                                        //
  if (status >= 500) console.error(err.stack);                                                                         // 154
                                                                                                                       //
  res.writeHead(status, { "Content-Type": err.htmlMessage ? "text/html" : "text/plain" });                             // 166
  res.end(err.htmlMessage || err.message);                                                                             // 167
}                                                                                                                      //
                                                                                                                       //
var PNG_MAGIC = new Buffer([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A]);                                          // 170
var JPEG_MAGIC = new Buffer([0xFF, 0xD8, 0xFF]);                                                                       // 171
                                                                                                                       //
function checkMagic(buf, magic) {                                                                                      // 173
  if (buf.length < magic.length) return false;                                                                         // 174
                                                                                                                       //
  for (var i = 0; i < magic.length; i++) {                                                                             // 176
    if (buf[i] != magic[i]) return false;                                                                              // 177
  }                                                                                                                    //
                                                                                                                       //
  return true;                                                                                                         // 180
}                                                                                                                      //
                                                                                                                       //
function serveSelfTest(req, res) {                                                                                     // 183
  try {                                                                                                                // 184
    if (req.method === "GET" && req.url === "/") {                                                                     // 185
      var content = new Buffer("Self-test OK.");                                                                       // 187
                                                                                                                       //
      // Convert the ROOT_URL to something that is a valid origin.                                                     //
      var rootUrlAsOrigin = process.env.ROOT_URL;                                                                      // 186
      if (rootUrlAsOrigin.slice(-1) === "/") {                                                                         // 191
        rootUrlAsOrigin = rootUrlAsOrigin.slice(0, -1);                                                                // 192
      }                                                                                                                //
                                                                                                                       //
      res.writeHead(200, {                                                                                             // 195
        "Content-Type": "text/plain",                                                                                  // 196
        "Content-Length": content.length,                                                                              // 197
        "Access-Control-Allow-Origin": rootUrlAsOrigin                                                                 // 198
      });                                                                                                              //
      res.end(content);                                                                                                // 200
    } else {                                                                                                           //
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 202
      res.end("Bad request to self-test subdomain.");                                                                  // 203
      return;                                                                                                          // 204
    }                                                                                                                  //
  } catch (err) {                                                                                                      //
    console.log("WARNING: An error occurred while serving self-test; proceeding anyway:", err);                        // 207
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
function serveStaticAsset(req, res) {                                                                                  // 211
  inMeteor(function () {                                                                                               // 212
    if (req.method === "GET") {                                                                                        // 213
      // jscs:disable validateQuoteMarks                                                                               //
      var assetCspHeader = "default-src 'none'; style-src 'unsafe-inline'; sandbox";                                   // 215
      if (req.headers['if-none-match'] === 'permanent') {                                                              // 216
        // Cache never invalidates since we use a new URL for every resource.                                          //
        res.writeHead(304, {                                                                                           // 218
          'Cache-Control': 'public, max-age=31536000',                                                                 // 219
          'ETag': 'permanent',                                                                                         // 220
                                                                                                                       //
          // To be safe, send these again, although it shouldn't be necessary.                                         //
          'Content-Security-Policy': assetCspHeader,                                                                   // 223
          'Access-Control-Allow-Origin': '*',                                                                          // 224
          'X-Content-Type-Options': 'nosniff'                                                                          // 225
        });                                                                                                            //
        res.end();                                                                                                     // 227
        return;                                                                                                        // 228
      }                                                                                                                //
                                                                                                                       //
      var url = Url.parse(req.url);                                                                                    // 231
      var asset = globalDb.getStaticAsset(url.pathname.slice(1));                                                      // 232
                                                                                                                       //
      if (asset) {                                                                                                     // 234
        var headers = {                                                                                                // 235
          'Content-Type': asset.mimeType,                                                                              // 236
          'Content-Length': asset.content.length,                                                                      // 237
                                                                                                                       //
          // Assets can be cached forever because each one has a unique ID.                                            //
          'Cache-Control': 'public, max-age=31536000',                                                                 // 240
                                                                                                                       //
          // Since different resources get different URLs, we can use a static etag.                                   //
          'ETag': 'permanent',                                                                                         // 243
                                                                                                                       //
          // Set strict Content-Security-Policy to prevent static assets from executing any script                     //
          // or doing basically anything when browsed to directly. The static assets host is not                       //
          // intended to serve HTML. Mostly, it serves images and javascript -- note that setting                      //
          // the CSP header on Javascript files does not prevent other hosts from voluntarily                          //
          // specifying these scripts in <script> tags.                                                                //
          'Content-Security-Policy': assetCspHeader,                                                                   // 250
                                                                                                                       //
          // Allow any host to fetch these assets. This is safe since requests to this host are                        //
          // totally side-effect-free and the asset ID acts as a capability to prevent loading                         //
          // assets you're not supposed to know about.                                                                 //
          'Access-Control-Allow-Origin': '*',                                                                          // 255
                                                                                                                       //
          // Extra protection against content type trickery.                                                           //
          'X-Content-Type-Options': 'nosniff'                                                                          // 258
        };                                                                                                             //
                                                                                                                       //
        if (asset.encoding) {                                                                                          // 261
          headers['Content-Encoding'] = asset.encoding;                                                                // 262
        }                                                                                                              //
                                                                                                                       //
        res.writeHead(200, headers);                                                                                   // 265
        res.end(asset.content);                                                                                        // 266
      } else {                                                                                                         //
        res.writeHead(404, { 'Content-Type': 'text/plain' });                                                          // 268
        res.end('not found');                                                                                          // 269
      }                                                                                                                //
    } else if (req.method === 'POST') {                                                                                //
      var _ret = function () {                                                                                         //
        res.setHeader('Access-Control-Allow-Origin', '*');                                                             // 272
                                                                                                                       //
        var url = Url.parse(req.url);                                                                                  // 274
        var purpose = globalDb.fulfillAssetUpload(url.pathname.slice(1));                                              // 275
        if (!purpose) {                                                                                                // 276
          res.writeHead(404, { 'Content-Type': 'text/plain' });                                                        // 277
          res.end('Upload token not found or expired.');                                                               // 278
          return {                                                                                                     // 279
            v: void 0                                                                                                  //
          };                                                                                                           //
        }                                                                                                              //
                                                                                                                       //
        var userId = purpose.profilePicture.userId;                                                                    // 282
        var identityId = purpose.profilePicture.identityId;                                                            // 283
        check(userId, String);                                                                                         // 284
        check(identityId, String);                                                                                     // 285
                                                                                                                       //
        var buffers = [];                                                                                              // 287
        var totalSize = 0;                                                                                             // 288
        var done = new Future();                                                                                       // 289
        req.on('data', function (buf) {                                                                                // 290
          totalSize += buf.length;                                                                                     // 291
          if (totalSize <= 64 * 1024) {                                                                                // 292
            buffers.push(buf);                                                                                         // 293
          }                                                                                                            //
        });                                                                                                            //
        req.on('end', done["return"].bind(done));                                                                      // 296
        req.on('error', done["throw"].bind(done));                                                                     // 297
        done.wait();                                                                                                   // 298
                                                                                                                       //
        if (totalSize > 64 * 1024) {                                                                                   // 300
          // TODO(soon): Resize the image ourselves.                                                                   //
          res.writeHead(400, { 'Content-Type': 'text/plain' });                                                        // 302
          res.end('Picture too large; please use an image under 64 KiB.');                                             // 303
          return {                                                                                                     // 304
            v: void 0                                                                                                  //
          };                                                                                                           //
        }                                                                                                              //
                                                                                                                       //
        var content = Buffer.concat(buffers);                                                                          // 307
        var type = void 0;                                                                                             // 308
        if (checkMagic(content, PNG_MAGIC)) {                                                                          // 309
          type = 'image/png';                                                                                          // 310
        } else if (checkMagic(content, JPEG_MAGIC)) {                                                                  //
          type = 'image/jpeg';                                                                                         // 312
        } else {                                                                                                       //
          res.writeHead(400, { 'Content-Type': 'text/plain' });                                                        // 314
          res.end('Image must be PNG or JPEG.');                                                                       // 315
          return {                                                                                                     // 316
            v: void 0                                                                                                  //
          };                                                                                                           //
        }                                                                                                              //
                                                                                                                       //
        var assetId = globalDb.addStaticAsset({ mimeType: type }, content);                                            // 319
        var old = Meteor.users.findAndModify({                                                                         // 320
          query: { '_id': identityId },                                                                                // 321
          update: { $set: { 'profile.picture': assetId } },                                                            // 322
          fields: { 'profile.picture': 1 }                                                                             // 323
        });                                                                                                            //
                                                                                                                       //
        if (old && old.profile && old.profile.picture) {                                                               // 326
          globalDb.unrefStaticAsset(old.profile.picture);                                                              // 327
        }                                                                                                              //
                                                                                                                       //
        res.writeHead(204, {});                                                                                        // 330
        res.end();                                                                                                     // 331
      }();                                                                                                             //
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret)) === "object") return _ret.v;    //
    } else if (req.method === 'OPTIONS') {                                                                             //
      var requestedHeaders = req.headers['access-control-request-headers'];                                            // 333
      if (requestedHeaders) {                                                                                          // 334
        res.setHeader('Access-Control-Allow-Headers', requestedHeaders);                                               // 335
      }                                                                                                                //
                                                                                                                       //
      res.writeHead(204, {                                                                                             // 338
        'Access-Control-Allow-Origin': '*',                                                                            // 339
        'Access-Control-Allow-Methods': 'GET, HEAD, POST, OPTIONS',                                                    // 340
        'Access-Control-Max-Age': '3600'                                                                               // 341
      });                                                                                                              //
      res.end();                                                                                                       // 343
    } else {                                                                                                           //
      res.writeHead(405, 'Method Not Allowed', {                                                                       // 345
        'Allow': 'GET, POST, OPTIONS',                                                                                 // 346
        'Content-Type': 'text/plain'                                                                                   // 347
      });                                                                                                              //
      res.end('405 Method Not Allowed: ' + req.method);                                                                // 349
    }                                                                                                                  //
  })["catch"](function (err) {                                                                                         //
    writeErrorResponse(res, err);                                                                                      // 352
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 356
                                                                                                                       //
  var meteorUpgradeListeners = WebApp.httpServer.listeners('upgrade');                                                 // 358
  WebApp.httpServer.removeAllListeners('upgrade');                                                                     // 359
                                                                                                                       //
  WebApp.httpServer.on('upgrade', function (req, socket, head) {                                                       // 361
    Promise.resolve(undefined).then(function () {                                                                      // 362
      if (!req.headers.host) {                                                                                         // 363
        throw new Meteor.Error(400, 'Missing Host header');                                                            // 364
      } else if (isSandstormShell(req.headers.host.split(':')[0])) {                                                   //
        // Go on to Meteor.                                                                                            //
        for (var ii = 0; ii < meteorUpgradeListeners.length; ++ii) {                                                   // 367
          meteorUpgradeListeners[ii](req, socket, head);                                                               // 368
        }                                                                                                              //
                                                                                                                       //
        return true;                                                                                                   // 371
      } else {                                                                                                         //
        var id = matchWildcardHost(req.headers.host);                                                                  // 373
        if (id) {                                                                                                      // 374
          return tryProxyUpgrade(id, req, socket, head);                                                               // 375
        } else {                                                                                                       //
          return false;                                                                                                // 377
        }                                                                                                              //
      }                                                                                                                //
    }).then(function (handled) {                                                                                       //
      if (!handled) socket.destroy();                                                                                  // 381
    })["catch"](function (err) {                                                                                       //
      console.error('WebSocket event handler failed:', err.stack);                                                     // 383
      socket.destroy();                                                                                                // 384
    });                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  // BlackrockPayments is only defined in the Blackrock build of Sandstorm.                                            //
  if (global.BlackrockPayments) {                                                                                      // 356
    // Have to check with global, because it could be undefined.                                                       //
    WebApp.rawConnectHandlers.use(BlackrockPayments.makeConnectHandler(globalDb));                                     // 390
  }                                                                                                                    //
                                                                                                                       //
  // This function serves responses on Sandstorm's main HTTP/HTTPS                                                     //
  // port.                                                                                                             //
  var serveMeteorOrStaticPublishing = function serveMeteorOrStaticPublishing(req, res, next) {                         // 356
    return dispatchToMeteorOrStaticPublishing(req, res, next, false);                                                  // 396
  };                                                                                                                   //
                                                                                                                       //
  // "Alternate ports" are ports other than the main HTTP or HTTPS                                                     //
  // port. For requests to the shell & grains, we redirect to the main                                                 //
  // port. For static publishing, we serve it.                                                                         //
  //                                                                                                                   //
  // They are bound to FD #5 and higher.                                                                               //
                                                                                                                       //
  function getNumberOfAlternatePorts() {                                                                               // 356
    var numPorts = process.env.PORT.split(',').length;                                                                 // 406
    var numAlternatePorts = numPorts - 1;                                                                              // 407
    return numAlternatePorts;                                                                                          // 408
  };                                                                                                                   //
                                                                                                                       //
  var canonicalizeShellOrWildcardUrl = function canonicalizeShellOrWildcardUrl(hostname, url) {                        // 411
    // Start with ROOT_URL, apply host & path from inbound URL, then                                                   //
    // redirect.                                                                                                       //
    var targetUrl = Url.parse(process.env.ROOT_URL);                                                                   // 414
                                                                                                                       //
    // Retain the protocol & port from ROOT_URL but use the inbound                                                    //
    // hostname.                                                                                                       //
    targetUrl.host = hostname + ':' + targetUrl.port;                                                                  // 411
                                                                                                                       //
    // The following allows to avoid decoding + re-encoding query                                                      //
    // string parameters, if provided.                                                                                 //
    targetUrl = Url.resolve(Url.format(targetUrl), url);                                                               // 411
    return targetUrl;                                                                                                  // 423
  };                                                                                                                   //
                                                                                                                       //
  var redirectToMeteorOrServeStaticPublishing = function redirectToMeteorOrServeStaticPublishing(req, res, next) {     // 426
    return dispatchToMeteorOrStaticPublishing(req, res, next, true);                                                   // 427
  };                                                                                                                   //
                                                                                                                       //
  for (var i = 0; i < getNumberOfAlternatePorts(); i++) {                                                              // 430
    // Call createServerForSandstorm() to skip our monkey patching.                                                    //
    var alternatePortServer = Http.createServerForSandstorm(redirectToMeteorOrServeStaticPublishing);                  // 432
    alternatePortServer.listen({ fd: i + 5 });                                                                         // 433
  }                                                                                                                    //
                                                                                                                       //
  var dispatchToMeteorOrStaticPublishing = function dispatchToMeteorOrStaticPublishing(req, res, next, redirectRatherThanServeShell) {
    if (!req.headers.host) {                                                                                           // 437
      res.writeHead(400, { 'Content-Type': 'text/plain' });                                                            // 438
      res.end('Missing Host header');                                                                                  // 439
      return;                                                                                                          // 440
    }                                                                                                                  //
                                                                                                                       //
    var hostname = req.headers.host.split(':')[0];                                                                     // 443
    if (isSandstormShell(hostname)) {                                                                                  // 444
      // Go on to Meteor, or serve a redirect.                                                                         //
      if (redirectRatherThanServeShell) {                                                                              // 446
        res.writeHead(302, { 'Location': canonicalizeShellOrWildcardUrl(hostname, req.url) });                         // 447
        res.end();                                                                                                     // 448
        return;                                                                                                        // 449
      } else {                                                                                                         //
        return next();                                                                                                 // 451
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    // This is not our main host. See if it's a member of the wildcard.                                                //
    var publicIdPromise = void 0;                                                                                      // 436
                                                                                                                       //
    var id = matchWildcardHost(req.headers.host);                                                                      // 458
    if (id) {                                                                                                          // 459
      // Match!                                                                                                        //
      if (redirectRatherThanServeShell) {                                                                              // 461
        res.writeHead(302, { 'Location': canonicalizeShellOrWildcardUrl(hostname, req.url) });                         // 462
        res.end();                                                                                                     // 463
        return;                                                                                                        // 464
      }                                                                                                                //
                                                                                                                       //
      if (id === 'static') {                                                                                           // 467
        // Static assets domain.                                                                                       //
        serveStaticAsset(req, res);                                                                                    // 469
        return;                                                                                                        // 470
      }                                                                                                                //
                                                                                                                       //
      if (id.match(/^selftest-/)) {                                                                                    // 473
        // Self test domain pattern. Starts w/ hyphen to avoid ambiguity with grain session/static                     //
        // publishing wildcard hosts.                                                                                  //
        serveSelfTest(req, res);                                                                                       // 476
        return;                                                                                                        // 477
      }                                                                                                                //
                                                                                                                       //
      // Try to route the request to a session.                                                                        //
      publicIdPromise = tryProxyRequest(id, req, res).then(function (handled) {                                        // 459
        if (handled) {                                                                                                 // 482
          return null;                                                                                                 // 483
        } else {                                                                                                       //
          return id;                                                                                                   // 485
        }                                                                                                              //
      });                                                                                                              //
    } else {                                                                                                           //
      // Not a wildcard host. Perhaps it is a custom host.                                                             //
      publicIdPromise = lookupPublicIdFromDns(hostname);                                                               // 490
    }                                                                                                                  //
                                                                                                                       //
    publicIdPromise.then(function (publicId) {                                                                         // 493
      if (publicId) {                                                                                                  // 494
        return Promise.resolve(undefined).then(function () {                                                           // 495
          var handler = staticHandlers[publicId];                                                                      // 496
          if (handler) {                                                                                               // 497
            return handler;                                                                                            // 498
          } else {                                                                                                     //
            // We don't have a handler for this publicId, so look it up in the grain DB.                               //
            return inMeteor(function () {                                                                              // 501
              var grain = Grains.findOne({ publicId: publicId }, { fields: { _id: 1 } });                              // 502
              if (!grain) {                                                                                            // 503
                throw new Meteor.Error(404, 'No such grain for public ID: ' + publicId);                               // 504
              }                                                                                                        //
                                                                                                                       //
              var grainId = grain._id;                                                                                 // 507
              return staticHandlers[publicId] = wwwHandlerForGrain(grainId);                                           // 508
            });                                                                                                        //
          }                                                                                                            //
        }).then(function (handler) {                                                                                   //
          handler(req, res, function (err) {                                                                           // 512
            if (err) {                                                                                                 // 513
              next(err);                                                                                               // 514
            } else {                                                                                                   //
              res.writeHead(404, { 'Content-Type': 'text/plain' });                                                    // 516
              res.end('404 not found: ' + req.url);                                                                    // 517
            }                                                                                                          //
          });                                                                                                          //
        });                                                                                                            //
      } else {                                                                                                         //
        return Promise.resolve(undefined);                                                                             // 522
      }                                                                                                                //
    })["catch"](function (err) {                                                                                       //
      writeErrorResponse(res, err);                                                                                    // 525
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  WebApp.rawConnectHandlers.use(serveMeteorOrStaticPublishing);                                                        // 529
});                                                                                                                    //
                                                                                                                       //
var errorTxtMapping = {};                                                                                              // 532
errorTxtMapping[Dns.NOTFOUND] = '<p>' + 'If you were trying to configure static publishing for a blog or website, powered ' + 'by a Sandstorm app hosted at this server, you either have not added DNS TXT records ' + 'correctly, or the DNS cache has not updated yet (may take a while, like 5 minutes to one ' + 'hour).</p>';
errorTxtMapping[Dns.NODATA] = errorTxtMapping[Dns.NOTFOUND];                                                           // 538
errorTxtMapping[Dns.TIMEOUT] = '<p>' + 'The DNS query has timed out, which may be a sign of poorly configured DNS on the server.</p>';
errorTxtMapping[Dns.CONNREFUSED] = '<p>' + 'The DNS server refused the connection, which means either your DNS server is down/unreachable, ' + 'or the server has misconfigured their DNS.</p>';
                                                                                                                       //
function lookupPublicIdFromDns(hostname) {                                                                             // 545
  // Given a hostname, determine its public ID.                                                                        //
  // We look for a TXT record indicating the public ID. Unfortunately, according to spec, a single                     //
  // hostname cannot have both a CNAME and a TXT record, because a TXT lookup on a CNAME'd host                        //
  // should actually be redirected to the CNAME, just like an A lookup would be. In practice lots                      //
  // of DNS software actually allows TXT records on CNAMEs, and it seems to work, but some software                    //
  // does not allow it and it's explicitly disallowed by the spec. Therefore, we instead look for                      //
  // the TXT record on a subdomain.                                                                                    //
  //                                                                                                                   //
  // I also considered having the CNAME itself point to <publicId>.<hostname>, where                                   //
  // *.<hostname> is in turn a CNAME for the Sandstorm server. This approach seemed elegant at                         //
  // first, but has a number of problems, the biggest being that it breaks the ability to place a                      //
  // CDN like CloudFlare in front of the site.                                                                         //
                                                                                                                       //
  var cache = dnsCache[hostname];                                                                                      // 559
  if (cache && Date.now() < cache.expiration) {                                                                        // 560
    return Promise.resolve(cache.value);                                                                               // 561
  }                                                                                                                    //
                                                                                                                       //
  return new Promise(function (resolve, reject) {                                                                      // 564
    Dns.resolveTxt('sandstorm-www.' + hostname, function (err, records) {                                              // 565
      if (err) {                                                                                                       // 566
        var errorMsg = errorTxtMapping[err.code] || '';                                                                // 567
        var error = new Error('Error looking up DNS TXT records for host "' + hostname + '": ' + err.message);         // 568
        error.htmlMessage = '<style type="text/css">h2, h3, p { max-width: 600px; }</style>' + '<h2>Sandstorm static publishing needs further configuration (or wrong URL)</h2>' + errorMsg + '<p>To visit this Sandstorm server\'s main interface, go to: <a href=\'' + process.env.ROOT_URL + '\'>' + process.env.ROOT_URL + '</a></p>' + '<h3>DNS details</h3>' + '<p>Error looking up DNS TXT records for host "' + hostname + '": ' + err.message + '</p>' + '<p>If you have the <tt>dig</tt> tool, you can run this command to learn more:</p>' + '<p><tt>dig TXT sandstorm-www.' + hostname + '</tt></p>' + '<h3>Changing the server URL, or troubleshooting OAuth login</h3>' + '<p>If you are the server admin and want to use this address as the main interface, ' + 'edit /opt/sandstorm/sandstorm.conf, modify the BASE_URL setting, and restart ' + 'Sandstorm.</p>' + '<p>If you got here after trying to log in via OAuth (e.g. through GitHub or Google), ' + 'the problem is probably that the OAuth callback URL was set wrong. You need to ' + 'update it through the respective login provider\'s management console. The ' + 'easiest way to do that is to run <tt>sudo sandstorm admin-token</tt>, then ' + 'reconfigure the OAuth provider.</p>';
        error.httpErrorCode = _.contains(['ENOTFOUND', 'ENODATA'], err.code) ? 404 : 500;                              // 589
        reject(error);                                                                                                 // 590
      } else if (records.length !== 1) {                                                                               //
        reject(new Error('Host "sandstorm-www.' + hostname + '" must have exactly one TXT record.'));                  // 592
      } else {                                                                                                         //
        var result = records[0];                                                                                       // 594
        dnsCache[hostname] = { value: result, expiration: Date.now() + DNS_CACHE_TTL };                                // 595
        resolve(result);                                                                                               // 596
      }                                                                                                                //
    });                                                                                                                //
  });                                                                                                                  //
}                                                                                                                      //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"proxy.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck",function(require,exports){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/proxy.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var ChildProcess = Npm.require("child_process");                                                                       // 18
var Fs = Npm.require("fs");                                                                                            // 19
var Path = Npm.require("path");                                                                                        // 20
var Future = Npm.require("fibers/future");                                                                             // 21
var Http = Npm.require("http");                                                                                        // 22
var Url = Npm.require("url");                                                                                          // 23
var Promise = Npm.require("es6-promise").Promise;                                                                      // 24
var Capnp = Npm.require("capnp");                                                                                      // 25
var Net = Npm.require("net");                                                                                          // 26
                                                                                                                       //
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 28
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 29
var WebSession = Capnp.importSystem("sandstorm/web-session.capnp").WebSession;                                         // 30
var HackSession = Capnp.importSystem("sandstorm/hack-session.capnp");                                                  // 31
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 32
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 33
                                                                                                                       //
var storeReferralProgramInfoApiTokenCreated = function storeReferralProgramInfoApiTokenCreated(db, accountId, identityId, apiTokenAccountId) {
  // From the Referral program's perspective, if Bob's Account has no referredByComplete, then we                      //
  // update Bob's Identity to say it's referredBy Alice's Account (which is apiTokenAccountId).                        //
  check(accountId, String);                                                                                            // 38
  check(identityId, String);                                                                                           // 39
  check(apiTokenAccountId, String);                                                                                    // 40
                                                                                                                       //
  // Bail out early if quota enforcement is disabled.                                                                  //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 35
    return;                                                                                                            // 44
  }                                                                                                                    //
                                                                                                                       //
  var aliceAccountId = apiTokenAccountId;                                                                              // 47
  var bobAccountId = accountId;                                                                                        // 48
  var bobIdentityId = identityId;                                                                                      // 49
                                                                                                                       //
  if (Meteor.users.find({                                                                                              // 51
    _id: bobAccountId,                                                                                                 // 52
    referredByComplete: { $exists: true }                                                                              // 53
  }).count() > 0) {                                                                                                    //
    return;                                                                                                            // 55
  }                                                                                                                    //
                                                                                                                       //
  // Only actually update Bob's Identity ID if there is no referredBy.                                                 //
  Meteor.users.update({ _id: bobIdentityId, referredBy: { $exists: false } }, { $set: { referredBy: aliceAccountId } });
};                                                                                                                     //
                                                                                                                       //
function referralProgramLogSharingTokenUse(db, bobAccountId) {                                                         // 64
  // Hooray! The sharing token is valid! Someone (let's call them Charlie) is going to get a UiView                    //
  // to this grain!  This means that the user who created this apiToken knows how to use the 'share                    //
  // access' interface. Let's call them Bob.                                                                           //
  //                                                                                                                   //
  // If Bob's Account.referredByComplete is not yet set, then look at Bob's Identities and take the                    //
  // first referredBy we find -- let's call that Alice.                                                                //
  //                                                                                                                   //
  // We copy Alice's account ID to Bob's Account.referredByComplete, and then update Alice's                           //
  // referredIdentityIds to point at Bob's Identity, and then remove the referredBy from Bob's                         //
  // Identity since it has become redundant.                                                                           //
  //                                                                                                                   //
  // Implementation note: this does mean that Alice can get referral credit for Bob by sharing a                       //
  // link with Bob, even if Bob already had an account.                                                                //
                                                                                                                       //
  // Bail out early if quota support is not enabled.                                                                   //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 80
    return;                                                                                                            // 81
  }                                                                                                                    //
                                                                                                                       //
  // Bail out if Bob has a referredByComplete.                                                                         //
  if (Meteor.users.find({ _id: bobAccountId, referredByComplete: { $exists: true } }).count() > 0) {                   // 64
    return;                                                                                                            // 86
  }                                                                                                                    //
                                                                                                                       //
  // Look for a referredBy on any of Bob's identities.                                                                 //
  var bobIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: bobAccountId }));                    // 64
  var bobIdentityWithReferredBy = Meteor.users.findOne({                                                               // 91
    _id: { $in: bobIdentityIds },                                                                                      // 92
    referredBy: { $exists: true }                                                                                      // 93
  });                                                                                                                  //
                                                                                                                       //
  if (!bobIdentityWithReferredBy) {                                                                                    // 96
    return;                                                                                                            // 97
  }                                                                                                                    //
                                                                                                                       //
  var aliceAccountId = bobIdentityWithReferredBy.referredBy;                                                           // 100
                                                                                                                       //
  // Store Bob's Account.referralCompletedBy.                                                                          //
  var now = new Date();                                                                                                // 64
  Meteor.users.update({                                                                                                // 104
    _id: bobAccountId,                                                                                                 // 105
    referredByComplete: { $exists: false }                                                                             // 106
  }, {                                                                                                                 //
    $set: {                                                                                                            // 108
      referredByComplete: bobIdentityWithReferredBy.referredBy,                                                        // 109
      referredCompleteDate: now                                                                                        // 110
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  // Update Alice's Account.referredIdentityIds.                                                                       //
  Meteor.users.update({ _id: aliceAccountId }, {                                                                       // 64
    $push: { referredIdentityIds: bobIdentityWithReferredBy._id }                                                      // 116
  });                                                                                                                  //
                                                                                                                       //
  // Remove now-redundant Bob identity referredBy.                                                                     //
  Meteor.users.update({ _id: bobIdentityWithReferredBy._id }, {                                                        // 64
    $unset: { referredBy: true }                                                                                       // 121
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
// User-agent strings that should be allowed to use http basic authentication.                                         //
// These are regex matches, so ensure they are escaped properly with double                                            //
// backslashes. For security reasons, we MUST NOT whitelist any user-agents                                            //
// that may render html and execute embedded scripts.                                                                  //
BASIC_AUTH_USER_AGENTS = ["git\\/", "GitHub-Hookshot\\/", "mirall\\/", "Mozilla\\/5\\.0 \\([^\\\\]*\\) mirall\\/", "Mozilla\\/5\\.0 \\(iOS\\) ownCloud-iOS\\/", "Mozilla\\/5\\.0 \\(Android\\) ownCloud-android\\/", "litmus\\/"];
BASIC_AUTH_USER_AGENTS_REGEX = new RegExp("^(" + BASIC_AUTH_USER_AGENTS.join("|") + ")", "");                          // 138
                                                                                                                       //
var SESSION_PROXY_TIMEOUT = 60000;                                                                                     // 140
                                                                                                                       //
var sandstormCoreFactory = makeSandstormCoreFactory();                                                                 // 142
var backendAddress = "unix:" + (SANDSTORM_ALTHOME || "") + Backend.socketPath;                                         // 143
var sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 144
var sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 145
                                                                                                                       //
// TODO(cleanup): This initilization belongs with the rest of our package initialization in                            //
//   db-deprecated.js. We can't put it there now because we need to contruct sandstormCoreFactory first.               //
globalBackend = new SandstormBackend(globalDb, sandstormBackend);                                                      // 149
Meteor.onConnection(function (connection) {                                                                            // 150
  connection.sandstormBackend = globalBackend;                                                                         // 151
});                                                                                                                    //
                                                                                                                       //
// We've observed a problem in production where occasionally the front-end stops talking to the                        //
// back-end. It happens very rarely -- like once a month -- and we've been unable to reproduce it                      //
// in testing, making it very hard to debug. The problem appears both on Sandstorm and Blackrock.                      //
// Restarting the node process (and only the node process) always fixes the problem.                                   //
//                                                                                                                     //
// Here, I've added some code that attempts to detect the problem by doing a health check                              //
// periodically and then remaking the connection if it seems broken. We'll see if this helps!                          //
var backendHealthy = true;                                                                                             // 161
var disconnectCount = 0;                                                                                               // 162
Meteor.setInterval(function () {                                                                                       // 163
  if (!backendHealthy) {                                                                                               // 164
    if (disconnectCount++ > 2) process.abort();                                                                        // 165
    console.error("error: Backend hasn't responded in 30 seconds! Reconnecting.");                                     // 166
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(true);                                        // 167
    sandstormBackendConnection.close();                                                                                // 168
    sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 169
    sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 170
    globalBackend._backendCap = sandstormBackend;                                                                      // 171
  }                                                                                                                    //
                                                                                                                       //
  var debugLog = !backendHealthy;                                                                                      // 174
  backendHealthy = false;                                                                                              // 175
  var promise = sandstormBackend.ping().then(function () {                                                             // 176
    backendHealthy = true;                                                                                             // 177
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(false);                                       // 178
  }, function (err) {                                                                                                  //
    console.error("error: Backend ping threw error!", err.stack);                                                      // 180
    // The connection will be remade on the next interval. Note that we do NOT normally observe                        //
    // exceptions being thrown for this problem; we see the connection simply stop responding.                         //
    // So we don't expect this branch to execute in any case.                                                          //
  });                                                                                                                  // 179
                                                                                                                       //
  if (debugLog) {                                                                                                      // 186
    console.log("capnp.js: outer promise:", promise);                                                                  // 187
  }                                                                                                                    //
}, 30000);                                                                                                             //
                                                                                                                       //
// =======================================================================================                             //
// Meteor context <-> Async Node.js context adapters                                                                   //
// TODO(cleanup):  Move to a different file.                                                                           //
                                                                                                                       //
var inMeteorInternal = Meteor.bindEnvironment(function (callback) {                                                    // 195
  callback();                                                                                                          // 196
});                                                                                                                    //
                                                                                                                       //
inMeteor = function inMeteor(callback) {                                                                               // 199
  // Calls the callback in a Meteor context.  Returns a Promise for its result.                                        //
  return new Promise(function (resolve, reject) {                                                                      // 201
    inMeteorInternal(function () {                                                                                     // 202
      try {                                                                                                            // 203
        resolve(callback());                                                                                           // 204
      } catch (err) {                                                                                                  //
        reject(err);                                                                                                   // 206
      }                                                                                                                //
    });                                                                                                                //
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
promiseToFuture = function promiseToFuture(promise) {                                                                  // 212
  var result = new Future();                                                                                           // 213
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                           // 214
  return result;                                                                                                       // 215
};                                                                                                                     //
                                                                                                                       //
waitPromise = function waitPromise(promise) {                                                                          // 218
  return promiseToFuture(promise).wait();                                                                              // 219
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// API for creating / starting grains from Meteor methods.                                                             //
                                                                                                                       //
var proxiesByHostId = {};                                                                                              // 225
                                                                                                                       //
Meteor.methods({                                                                                                       // 227
  newGrain: function () {                                                                                              // 228
    function newGrain(packageId, command, title, identityId) {                                                         //
      // Create and start a new grain.                                                                                 //
                                                                                                                       //
      check(packageId, String);                                                                                        // 231
      check(command, Object); // Manifest.Command from package.capnp.                                                  // 232
      check(title, String);                                                                                            // 228
      check(identityId, String);                                                                                       // 234
                                                                                                                       //
      if (!this.userId) {                                                                                              // 236
        throw new Meteor.Error(403, "Unauthorized", "Must be logged in to create grains.");                            // 237
      }                                                                                                                //
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 240
        throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                          // 241
      }                                                                                                                //
                                                                                                                       //
      if (!isSignedUpOrDemo()) {                                                                                       // 244
        throw new Meteor.Error(403, "Unauthorized", "Only invited users or demo users can create grains.");            // 245
      }                                                                                                                //
                                                                                                                       //
      if (isUserOverQuota(Meteor.user())) {                                                                            // 249
        throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");         // 250
      }                                                                                                                //
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 254
      var isDev = false;                                                                                               // 255
      if (!pkg) {                                                                                                      // 256
        // Maybe they wanted a dev package.  Check there too.                                                          //
        pkg = DevPackages.findOne(packageId);                                                                          // 258
        isDev = true;                                                                                                  // 259
      }                                                                                                                //
                                                                                                                       //
      if (!pkg) {                                                                                                      // 262
        throw new Meteor.Error(404, "Not Found", "No such package is installed.");                                     // 263
      }                                                                                                                //
                                                                                                                       //
      var appId = pkg.appId;                                                                                           // 266
      var manifest = pkg.manifest;                                                                                     // 267
      var grainId = Random.id(22); // 128 bits of entropy                                                              // 268
      Grains.insert({                                                                                                  // 228
        _id: grainId,                                                                                                  // 270
        packageId: packageId,                                                                                          // 271
        appId: appId,                                                                                                  // 272
        appVersion: manifest.appVersion,                                                                               // 273
        userId: this.userId,                                                                                           // 274
        identityId: identityId,                                                                                        // 275
        title: title,                                                                                                  // 276
        "private": true                                                                                                // 277
      });                                                                                                              //
                                                                                                                       //
      globalBackend.startGrainInternal(packageId, grainId, this.userId, command, true, isDev);                         // 280
      globalBackend.updateLastActive(grainId, this.userId, identityId);                                                // 281
      return grainId;                                                                                                  // 282
    }                                                                                                                  //
                                                                                                                       //
    return newGrain;                                                                                                   //
  }(),                                                                                                                 //
  openSession: function () {                                                                                           // 285
    function openSession(grainId, identityId, cachedSalt) {                                                            //
      // Open a new UI session on an existing grain.  Starts the grain if it is not already                            //
      // running.                                                                                                      //
                                                                                                                       //
      check(grainId, String);                                                                                          // 289
      check(identityId, Match.OneOf(undefined, null, String));                                                         // 290
      check(cachedSalt, Match.OneOf(undefined, null, String));                                                         // 291
                                                                                                                       //
      if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                           // 293
        throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                          // 294
      }                                                                                                                //
                                                                                                                       //
      var grain = Grains.findOne({ _id: grainId });                                                                    // 297
      if (!grain) {                                                                                                    // 298
        throw new Meteor.Error(404, "Grain not found", "Grain ID: " + grainId);                                        // 299
      } else if (grain.trashed) {                                                                                      //
        throw new Meteor.Error("grain-is-in-trash", "Grain is in trash", "Grain ID: " + grainId);                      // 301
      }                                                                                                                //
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 304
      check(cachedSalt, Match.OneOf(undefined, null, String));                                                         // 305
      if (!SandstormPermissions.mayOpenGrain(db, { grain: { _id: grainId, identityId: identityId } })) {               // 306
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 308
      }                                                                                                                //
                                                                                                                       //
      var opened = globalBackend.openSessionInternal(grainId, this.userId, identityId, null, null, cachedSalt);        // 311
      var result = opened.methodResult;                                                                                // 313
      var proxy = new Proxy(grainId, this.userId, result.sessionId, result.hostId, result.tabId, identityId, false, opened.supervisor);
      proxiesByHostId[result.hostId] = proxy;                                                                          // 316
      return result;                                                                                                   // 317
    }                                                                                                                  //
                                                                                                                       //
    return openSession;                                                                                                //
  }(),                                                                                                                 //
  openSessionFromApiToken: function () {                                                                               // 320
    function openSessionFromApiToken(params, identityId, cachedSalt) {                                                 //
      // Given an API token, either opens a new WebSession to the underlying grain or returns a                        //
      // path to which the client should redirect in order to open such a session.                                     //
                                                                                                                       //
      check(params, {                                                                                                  // 324
        token: String,                                                                                                 // 325
        incognito: Boolean                                                                                             // 326
      });                                                                                                              //
      check(identityId, Match.OneOf(undefined, null, String));                                                         // 328
      check(cachedSalt, Match.OneOf(undefined, null, String));                                                         // 329
                                                                                                                       //
      if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                           // 331
        throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                          // 332
      }                                                                                                                //
                                                                                                                       //
      if (!identityId && globalDb.getOrganizationDisallowGuests()) {                                                   // 335
        throw new Meteor.Error("guestDisallowed", "This Sandstorm server does not allow " + "guests or anonymous users");
      }                                                                                                                //
                                                                                                                       //
      var token = params.token;                                                                                        // 340
      var incognito = params.incognito;                                                                                // 341
      var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                    // 342
      var apiToken = ApiTokens.findOne(hashedToken);                                                                   // 343
      validateWebkey(apiToken);                                                                                        // 344
      var grain = Grains.findOne({ _id: apiToken.grainId });                                                           // 345
      if (!grain) {                                                                                                    // 346
        throw new Meteor.Error(404, "Grain not found", "Grain ID: " + apiToken.grainId);                               // 347
      }                                                                                                                //
                                                                                                                       //
      if (apiToken.accountId) {                                                                                        // 350
        referralProgramLogSharingTokenUse(globalDb, apiToken.accountId);                                               // 351
      }                                                                                                                //
                                                                                                                       //
      var title = void 0;                                                                                              // 354
      if (grain.userId === apiToken.accountId) {                                                                       // 355
        title = grain.title;                                                                                           // 356
      } else {                                                                                                         //
        var sharerToken = apiToken.identityId && ApiTokens.findOne({                                                   // 358
          grainId: apiToken.grainId,                                                                                   // 360
          "owner.user.identityId": apiToken.identityId                                                                 // 361
        }, {                                                                                                           //
          sort: {                                                                                                      // 363
            lastUsed: -1                                                                                               // 364
          }                                                                                                            //
        });                                                                                                            //
        if (sharerToken) {                                                                                             // 367
          title = sharerToken.owner.user.title;                                                                        // 368
        } else {                                                                                                       //
          title = "shared grain";                                                                                      // 370
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (this.userId && !incognito) {                                                                                 // 374
        if (identityId != apiToken.identityId && identityId != grain.identityId && !ApiTokens.findOne({ "owner.user.identityId": identityId, parentToken: hashedToken })) {
          var owner = { user: { identityId: identityId, title: title } };                                              // 377
                                                                                                                       //
          // Create a new API token for the identity redeeming this token.                                             //
          var result = SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: token }, apiToken.grainId, apiToken.petname, { allAccess: null }, owner);
          globalDb.addContact(apiToken.accountId, identityId);                                                         // 382
                                                                                                                       //
          // If the parent API token is forSharing and it has an accountId, then the logged-in user (call              //
          // them Bob) is about to access a grain owned by someone (call them Alice) and save a reference              //
          // to it as a new ApiToken. (For share-by-link, this occurs when viewing the grain. For                      //
          // share-by-identity, this happens immediately.)                                                             //
          if (result.parentApiToken) {                                                                                 // 376
            var parentApiToken = result.parentApiToken;                                                                // 389
            if (parentApiToken.forSharing && parentApiToken.accountId) {                                               // 390
              storeReferralProgramInfoApiTokenCreated(globalDb, this.userId, owner.user.identityId, parentApiToken.accountId);
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        return { redirectToGrain: apiToken.grainId };                                                                  // 397
      } else {                                                                                                         //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: apiToken })) {                                       // 399
          throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                   // 400
        }                                                                                                              //
                                                                                                                       //
        var opened = globalBackend.openSessionInternal(apiToken.grainId, null, null, title, apiToken, cachedSalt);     // 404
                                                                                                                       //
        var _result = opened.methodResult;                                                                             // 407
        var proxy = new Proxy(apiToken.grainId, grain.userId, _result.sessionId, _result.hostId, _result.tabId, identityId, false);
        proxy.apiToken = apiToken;                                                                                     // 410
        proxiesByHostId[_result.hostId] = proxy;                                                                       // 411
        return _result;                                                                                                // 412
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return openSessionFromApiToken;                                                                                    //
  }(),                                                                                                                 //
  keepSessionAlive: function () {                                                                                      // 416
    function keepSessionAlive(sessionId) {                                                                             //
      // TODO(security):  Prevent draining someone else's quota by holding open several grains shared                  //
      //   by them.                                                                                                    //
      check(sessionId, String);                                                                                        // 419
                                                                                                                       //
      var session = Sessions.findAndModify({                                                                           // 421
        query: { _id: sessionId },                                                                                     // 422
        update: { $set: { timestamp: new Date().getTime() } },                                                         // 423
        fields: { grainId: 1, identityId: 1, hostId: 1 }                                                               // 424
      });                                                                                                              //
                                                                                                                       //
      if (session) {                                                                                                   // 427
        // Session still present in database, so send keep-alive to backend.                                           //
        try {                                                                                                          // 429
          var grainId = session.grainId;                                                                               // 430
          var hostId = session.hostId;                                                                                 // 431
          var supervisor = proxiesByHostId[hostId] && proxiesByHostId[hostId].supervisor;                              // 432
          if (!supervisor) {                                                                                           // 433
            supervisor = globalBackend.continueGrain(grainId).supervisor;                                              // 434
          }                                                                                                            //
                                                                                                                       //
          waitPromise(supervisor.keepAlive());                                                                         // 437
          globalBackend.updateLastActive(grainId, this.userId, session.identityId);                                    // 438
        } catch (err) {                                                                                                //
          // Ignore disconnects, which imply that the grain shut down already. It'll start back up on                  //
          // the next request, so whatever.                                                                            //
          if (err.kjType !== "disconnected") {                                                                         // 442
            throw err;                                                                                                 // 443
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        return true;                                                                                                   // 447
      } else {                                                                                                         //
        return false;                                                                                                  // 449
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return keepSessionAlive;                                                                                           //
  }(),                                                                                                                 //
  shutdownGrain: function () {                                                                                         // 453
    function shutdownGrain(grainId) {                                                                                  //
      check(grainId, String);                                                                                          // 454
      var grain = Grains.findOne(grainId);                                                                             // 455
      if (!grain || !this.userId || grain.userId !== this.userId) {                                                    // 456
        throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                            // 457
      }                                                                                                                //
                                                                                                                       //
      waitPromise(globalBackend.shutdownGrain(grainId, grain.userId, true));                                           // 460
    }                                                                                                                  //
                                                                                                                       //
    return shutdownGrain;                                                                                              //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
var validateWebkey = function validateWebkey(apiToken, refreshedExpiration) {                                          // 464
  // Validates that `apiToken` is a valid UiView webkey, throwing an exception if it is not. If                        //
  // `refreshedExpiration` is set and if the token has an `expiresIfUnused` field, then the                            //
  // `expiresIfUnused` field is reset to `refreshedExpiration`.                                                        //
                                                                                                                       //
  if (!apiToken) {                                                                                                     // 469
    throw new Meteor.Error(403, "Invalid authorization token");                                                        // 470
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.revoked) {                                                                                              // 473
    throw new Meteor.Error(403, "Authorization token has been revoked");                                               // 474
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.owner && !("webkey" in apiToken.owner)) {                                                               // 477
    throw new Meteor.Error(403, "Unauthorized to open non-webkey token.");                                             // 478
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.expires && apiToken.expires.getTime() <= Date.now()) {                                                  // 481
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 482
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.expiresIfUnused) {                                                                                      // 485
    if (apiToken.expiresIfUnused.getTime() <= Date.now()) {                                                            // 486
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 487
    } else if (refreshedExpiration) {                                                                                  //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: refreshedExpiration } });                              // 489
    } else {                                                                                                           //
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: null } });                                             // 492
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.objectId || apiToken.frontendRef) {                                                                     // 496
    throw new Meteor.Error(403, "ApiToken refers to a non-webview Capability.");                                       // 497
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
// Used by shared/grain.js (which sounds like a broken dependency, since this code is only available                   //
// on the server)                                                                                                      //
getGrainSize = function getGrainSize(supervisor, oldSize) {                                                            // 503
  var promise = void 0;                                                                                                // 504
  if (oldSize === undefined) {                                                                                         // 505
    promise = supervisor.getGrainSize();                                                                               // 506
  } else {                                                                                                             //
    promise = supervisor.getGrainSizeWhenDifferent(oldSize);                                                           // 508
  }                                                                                                                    //
                                                                                                                       //
  var promise2 = promise.then(function (result) {                                                                      // 511
    return parseInt(result.size);                                                                                      // 511
  });                                                                                                                  //
  promise2.cancel = function () {                                                                                      // 512
    promise.cancel();                                                                                                  // 512
  };                                                                                                                   //
                                                                                                                       //
  return promise2;                                                                                                     // 514
};                                                                                                                     //
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 517
  var shutdownApp = function shutdownApp(appId) {                                                                      // 518
    Grains.find({ appId: appId }).forEach(function (grain) {                                                           // 519
      waitPromise(globalBackend.shutdownGrain(grain._id, grain.userId));                                               // 520
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  DevPackages.find().observe({                                                                                         // 524
    removed: function () {                                                                                             // 525
      function removed(devPackage) {                                                                                   //
        shutdownApp(devPackage.appId);                                                                                 // 525
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }(),                                                                                                               //
    changed: function () {                                                                                             // 527
      function changed(oldDevPackage, newDevPackage) {                                                                 //
        shutdownApp(oldDevPackage.appId);                                                                              // 528
        if (oldDevPackage.appId !== newDevPackage.appId) {                                                             // 529
          shutdownApp(newDevPackage.appId);                                                                            // 530
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }(),                                                                                                               //
    added: function () {                                                                                               // 534
      function added(devPackage) {                                                                                     //
        shutdownApp(devPackage.appId);                                                                                 // 534
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  Sessions.find().observe({                                                                                            // 537
    removed: function () {                                                                                             // 538
      function removed(session) {                                                                                      //
        var proxy = proxiesByHostId[session.hostId];                                                                   // 539
        delete proxiesByHostId[session.hostId];                                                                        // 540
        if (proxy) {                                                                                                   // 541
          proxy.close();                                                                                               // 542
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
// Kill off sessions idle for >~3 minutes.                                                                             //
var TIMEOUT_MS = 180000;                                                                                               // 549
var gcSessions = function gcSessions() {                                                                               // 550
  var now = new Date().getTime();                                                                                      // 551
  Sessions.remove({ timestamp: { $lt: now - TIMEOUT_MS } });                                                           // 552
};                                                                                                                     //
                                                                                                                       //
SandstormDb.periodicCleanup(TIMEOUT_MS, gcSessions);                                                                   // 555
                                                                                                                       //
var getProxyForHostId = function getProxyForHostId(hostId, isAlreadyOpened) {                                          // 557
  // Get the Proxy corresponding to the given grain session host, possibly (re)creating it if it                       //
  // doesn't already exist. The first request on the session host will always create a new proxy.                      //
  // Later requests may create a proxy if they go to a different front-end replica or if the                           //
  // front-end was restarted.                                                                                          //
  check(hostId, String);                                                                                               // 562
                                                                                                                       //
  return Promise.resolve(undefined).then(function () {                                                                 // 564
    var proxy = proxiesByHostId[hostId];                                                                               // 565
    if (proxy) {                                                                                                       // 566
      return proxy;                                                                                                    // 567
    } else {                                                                                                           //
      // Set table entry to null for now so that we can detect if it is concurrently deleted.                          //
      proxiesByHostId[hostId] = null;                                                                                  // 570
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 572
        var session = Sessions.findOne({ hostId: hostId });                                                            // 573
        if (!session) {                                                                                                // 574
          if (isAlreadyOpened) {                                                                                       // 575
            return new Promise(function (resolve, reject) {                                                            // 576
              var observer = void 0;                                                                                   // 577
              var task = Meteor.setTimeout(function () {                                                               // 578
                observer.stop();                                                                                       // 579
                reject(new Meteor.Error(504, "Requested session that no longer exists, and " + "timed out waiting for client to restore it. This can happen if you have " + "opened an app's content in a new window and then closed it in the " + "UI. If you see this error *inside* the Sandstorm UI, please report a " + "bug and describe the circumstances of the error."));
              }, SESSION_PROXY_TIMEOUT);                                                                               //
              observer = Sessions.find({ hostId: hostId }).observe({                                                   // 586
                added: function () {                                                                                   // 587
                  function added() {                                                                                   //
                    observer.stop();                                                                                   // 588
                    Meteor.clearTimeout(task);                                                                         // 589
                    resolve(getProxyForHostId(hostId, false));                                                         // 590
                  }                                                                                                    //
                                                                                                                       //
                  return added;                                                                                        //
                }()                                                                                                    //
              });                                                                                                      //
            });                                                                                                        //
          } else {                                                                                                     //
            // Does not appear to be a valid session host.                                                             //
            return undefined;                                                                                          // 596
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        var apiToken = void 0;                                                                                         // 600
        if (session.hashedToken) {                                                                                     // 601
          apiToken = ApiTokens.findOne({ _id: session.hashedToken });                                                  // 602
          // We don't have to fully validate the API token here because if it changed the session                      //
          // would have been deleted.                                                                                  //
          if (!apiToken) {                                                                                             // 601
            throw new Meteor.Error(410, "ApiToken has been deleted");                                                  // 606
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        var grain = Grains.findOne(session.grainId);                                                                   // 610
        if (!grain) {                                                                                                  // 611
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 613
        }                                                                                                              //
                                                                                                                       //
        // Note that we don't need to call mayOpenGrain() because the existence of a session                           //
        // implies this check was already performed.                                                                   //
                                                                                                                       //
        var proxy = new Proxy(grain._id, grain.userId, session._id, hostId, session.tabId, session.identityId, false);
        if (apiToken) proxy.apiToken = apiToken;                                                                       // 621
                                                                                                                       //
        // Only add the proxy to the table if it was not concurrently deleted (which could happen                      //
        // e.g. if the user's access was revoked).                                                                     //
        if (hostId in proxiesByHostId) {                                                                               // 572
          proxiesByHostId[hostId] = proxy;                                                                             // 626
        } else {                                                                                                       //
          throw new Meteor.Error(403, "Session was concurrently closed.");                                             // 628
        }                                                                                                              //
                                                                                                                       //
        return proxy;                                                                                                  // 631
      });                                                                                                              //
    }                                                                                                                  //
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// API tokens                                                                                                          //
                                                                                                                       //
var ApiSessionProxies = function () {                                                                                  //
  // Class that caches proxies for requests that come in through HTTP API endpoints. Such                              //
  // requests are not associated with any entry in the `Sessions` collection, so we need                               //
  // some other means of detecting unused proxies and closing them. This class works by keeping                        //
  // the proxies in two buckets. When a proxy is used, it is put in the new bucket. Periodically,                      //
  // the old bucket is emptied and the contents of new bucket are moved to the old bucket.                             //
  //                                                                                                                   //
  // Each bucket is a two-level map, keyed by hashes of the tokens and their `ApiSession.Params`                       //
  // structs.                                                                                                          //
                                                                                                                       //
  function ApiSessionProxies(intervalMillis) {                                                                         // 650
    var _this2 = this;                                                                                                 //
                                                                                                                       //
    (0, _classCallCheck3["default"])(this, ApiSessionProxies);                                                         //
                                                                                                                       //
    check(intervalMillis, Number);                                                                                     // 651
    this.newBucket = {};                                                                                               // 652
    this.oldBucket = {};                                                                                               // 653
    this.interval = Meteor.setInterval(function () {                                                                   // 654
      for (var oldHashedToken in meteorBabelHelpers.sanitizeForInObject(_this2.oldBucket)) {                           // 655
        for (var oldHashedParams in meteorBabelHelpers.sanitizeForInObject(_this2.oldBucket[oldHashedToken])) {        // 656
          var newProxy = _this2.newBucket[oldHashedToken] && _this2.newBucket[oldHashedToken][oldHashedParams];        // 657
          var oldProxy = _this2.oldBucket[oldHashedToken][oldHashedParams];                                            // 659
          if (oldProxy && !newProxy) {                                                                                 // 660
            if (Object.keys(oldProxy.websockets).length > 0) {                                                         // 661
              // A client has an open websocket. Keep the proxy around.                                                //
              _this2.put(oldHashedToken, oldHashedParams, oldProxy);                                                   // 663
            } else {                                                                                                   //
              // We can close this proxy and forget about it.                                                          //
              oldProxy.close();                                                                                        // 666
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      _this2.oldBucket = _this2.newBucket;                                                                             // 672
      _this2.newBucket = {};                                                                                           // 673
    }, intervalMillis);                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  ApiSessionProxies.prototype.get = function () {                                                                      // 640
    function get(hashedToken, hashedParams) {                                                                          //
      if (this.newBucket[hashedToken] && this.newBucket[hashedToken][hashedParams]) {                                  // 678
        return this.newBucket[hashedToken][hashedParams];                                                              // 679
      } else if (this.oldBucket[hashedToken] && this.oldBucket[hashedToken][hashedParams]) {                           //
        var proxy = this.oldBucket[hashedToken][hashedParams];                                                         // 681
        delete this.oldBucket[hashedToken][hashedParams];                                                              // 682
        this.put(hashedToken, hashedParams, proxy);                                                                    // 683
        return proxy;                                                                                                  // 684
      } else {                                                                                                         //
        return null;                                                                                                   // 686
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return get;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ApiSessionProxies.prototype.put = function () {                                                                      // 640
    function put(hashedToken, hashedParams, proxy) {                                                                   //
      if (!this.newBucket[hashedToken]) {                                                                              // 691
        this.newBucket[hashedToken] = {};                                                                              // 692
      }                                                                                                                //
                                                                                                                       //
      this.newBucket[hashedToken][hashedParams] = proxy;                                                               // 695
    }                                                                                                                  //
                                                                                                                       //
    return put;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ApiSessionProxies.prototype.removeProxiesOfToken = function () {                                                     // 640
    function removeProxiesOfToken(hashedToken) {                                                                       //
      if (hashedToken in this.oldBucket) {                                                                             // 699
        for (var hashedParams in meteorBabelHelpers.sanitizeForInObject(this.oldBucket[hashedToken])) {                // 700
          this.oldBucket[hashedToken][hashedParams].close();                                                           // 701
        }                                                                                                              //
                                                                                                                       //
        delete this.oldBucket[hashedToken];                                                                            // 704
      }                                                                                                                //
                                                                                                                       //
      if (hashedToken in this.newBucket) {                                                                             // 707
        for (var _hashedParams in meteorBabelHelpers.sanitizeForInObject(this.newBucket[hashedToken])) {               // 708
          this.newBucket[hashedToken][_hashedParams].close();                                                          // 709
        }                                                                                                              //
                                                                                                                       //
        delete this.newBucket[hashedToken];                                                                            // 712
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return removeProxiesOfToken;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return ApiSessionProxies;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var apiSessionProxies = new ApiSessionProxies(3 * 60 * 1000);                                                          // 717
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 719
  Grains.find().observe({                                                                                              // 720
    changed: function () {                                                                                             // 721
      function changed(newGrain, oldGrain) {                                                                           //
        if (oldGrain["private"] != newGrain["private"]) {                                                              // 722
          Sessions.remove({ grainId: oldGrain._id, identityId: { $ne: oldGrain.identityId } });                        // 723
          ApiTokens.find({ grainId: oldGrain._id }).forEach(function (apiToken) {                                      // 724
            apiSessionProxies.removeProxiesOfToken(apiToken._id);                                                      // 725
          });                                                                                                          //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
function getApiSessionParams(request) {                                                                                // 732
  var params = {};                                                                                                     // 733
  if ("x-sandstorm-passthrough" in request.headers) {                                                                  // 734
    var optIns = request.headers["x-sandstorm-passthrough"].split(",").map(function (s) {                              // 735
      return s.trim();                                                                                                 // 737
    });                                                                                                                //
    // The only currently supported passthrough value is 'address', but others could be useful in                      //
    // the future.                                                                                                     //
                                                                                                                       //
    if (optIns.indexOf("address") !== -1) {                                                                            // 734
      // Sadly, we can't use request.socket.remoteFamily because it's not available in the                             //
      // (rather-old) version of node that comes in the Meteor bundle we're using. Hence this                          //
      // hackery.                                                                                                      //
      var addressToPass = request.socket.remoteAddress;                                                                // 745
      if (isRfc1918OrLocal(addressToPass) && "x-real-ip" in request.headers) {                                         // 746
        // Allow overriding the socket's remote address with X-Real-IP header if the request comes                     //
        // from either localhost or an RFC1918 address. These are not useful for geolocation anyway.                   //
        addressToPass = request.headers["x-real-ip"];                                                                  // 749
      }                                                                                                                //
                                                                                                                       //
      if (Net.isIPv4(addressToPass)) {                                                                                 // 752
        // Map IPv4 addresses in IPv6.                                                                                 //
        // This conveniently comes out to a 48-bit number, which is precisely representable in a                       //
        // double (which has 53 mantissa bits). Thus we can avoid using Bignum/strings, which we                       //
        // might otherwise need to precisely represent 64-bit fields.                                                  //
        var v4Int = 0xFFFF00000000 + addressToPass.split(".").map(function (x) {                                       // 757
          return parseInt(x, 10);                                                                                      // 758
        }).reduce(function (a, b) {                                                                                    //
          return 256 * a + b;                                                                                          // 759
        });                                                                                                            //
        params.remoteAddress = {                                                                                       // 760
          lower64: v4Int,                                                                                              // 761
          upper64: 0                                                                                                   // 762
        };                                                                                                             //
      } else if (Net.isIPv6(addressToPass)) {                                                                          //
        // TODO(test): Unit test this                                                                                  //
        // Parse a valid v6 address.                                                                                   //
        // Split into groups, then insert an appropriate number of 0's if :: was used.                                 //
        var groups = addressToPass.split(":");                                                                         // 768
                                                                                                                       //
        // Strip extra empty group in the case of a leading or trailing '::'.                                          //
        if (groups[0] === "") {                                                                                        // 764
          groups.shift();                                                                                              // 772
        }                                                                                                              //
                                                                                                                       //
        if (groups[groups.length - 1] === "") {                                                                        // 775
          groups.pop();                                                                                                // 776
        }                                                                                                              //
                                                                                                                       //
        var lastGroup = groups[groups.length - 1];                                                                     // 779
        // Handle IPv4-mapped IPv6 addresses.  These end in a dotted-quad IPv4 address, which we                       //
        // should expand into two groups of 4-character hex strings, like the rest of the address.                     //
        if (Net.isIPv4(lastGroup)) {                                                                                   // 764
          groups.pop();                                                                                                // 783
          var _quad = lastGroup.split(".").map(function (x) {                                                          // 784
            return parseInt(x, 10);                                                                                    // 784
          });                                                                                                          //
          groups.push((_quad[0] * 256 + _quad[1]).toString(16));                                                       // 785
          groups.push((_quad[2] * 256 + _quad[3]).toString(16));                                                       // 786
        }                                                                                                              //
                                                                                                                       //
        var groupsToAdd = 8 - groups.length;                                                                           // 789
        var emptyGroupIndex = groups.indexOf("");                                                                      // 790
        var cleanGroups = void 0;                                                                                      // 791
        if (emptyGroupIndex !== -1) {                                                                                  // 792
          var head = groups.slice(0, emptyGroupIndex);                                                                 // 793
          // groupsToAdd + 1 because we sliced out the empty element                                                   //
          var mid = Array(groupsToAdd + 1);                                                                            // 792
          for (var i = 0; i < groupsToAdd + 1; i++) {                                                                  // 796
            mid[i] = "0";                                                                                              // 797
          }                                                                                                            //
                                                                                                                       //
          var tail = groups.slice(emptyGroupIndex + 1, groups.length);                                                 // 800
          cleanGroups = [].concat(head, mid, tail);                                                                    // 801
        } else {                                                                                                       //
          cleanGroups = groups;                                                                                        // 803
        }                                                                                                              //
                                                                                                                       //
        var ints = cleanGroups.map(function (x) {                                                                      // 806
          return parseInt(x, 16);                                                                                      // 806
        });                                                                                                            //
        // We use strings because we'd lose data from loss of precision casting the 64-bit uints                       //
        // into 53-bit-mantissa doubles.                                                                               //
        params.remoteAddress = {                                                                                       // 764
          upper64: quadToIntString(ints.slice(0, 4)),                                                                  // 810
          lower64: quadToIntString(ints.slice(4, 8))                                                                   // 811
        };                                                                                                             //
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return Capnp.serialize(ApiSession.Params, params);                                                                   // 817
}                                                                                                                      //
                                                                                                                       //
// Used by server/drivers/external-ui/view.js                                                                          //
getProxyForApiToken = function getProxyForApiToken(token, request) {                                                   // 821
  check(token, String);                                                                                                // 822
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 823
  var tabId = Crypto.createHash("sha256").update("tab:").update(hashedToken).digest("hex").slice(0, 32);               // 824
  var serializedParams = getApiSessionParams(request);                                                                 // 826
  var hashedParams = Crypto.createHash("sha256").update(serializedParams).digest("base64");                            // 827
  return Promise.resolve(undefined).then(function () {                                                                 // 828
    var proxy = apiSessionProxies.get(hashedToken, hashedParams);                                                      // 829
    if (proxy) {                                                                                                       // 830
      if (proxy.expires && proxy.expires.getTime() <= Date.now()) {                                                    // 831
        throw new Meteor.Error(403, "Authorization token expired");                                                    // 832
      }                                                                                                                //
                                                                                                                       //
      return proxy;                                                                                                    // 835
    } else {                                                                                                           //
      return inMeteor(function () {                                                                                    // 837
        var tokenInfo = ApiTokens.findOne(hashedToken);                                                                // 838
        validateWebkey(tokenInfo);                                                                                     // 839
                                                                                                                       //
        var grain = Grains.findOne(tokenInfo.grainId);                                                                 // 841
        if (!grain) {                                                                                                  // 842
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 844
        }                                                                                                              //
                                                                                                                       //
        var proxy = void 0;                                                                                            // 847
        if (tokenInfo.userInfo) {                                                                                      // 848
          throw new Error("API tokens created with arbitrary userInfo no longer supported");                           // 849
        } else {                                                                                                       //
          var identityId = null;                                                                                       // 851
          if (tokenInfo.identityId && !tokenInfo.forSharing) {                                                         // 852
            identityId = tokenInfo.identityId;                                                                         // 853
          }                                                                                                            //
                                                                                                                       //
          proxy = new Proxy(tokenInfo.grainId, grain.userId, null, null, tabId, identityId, true);                     // 856
          proxy.apiToken = tokenInfo;                                                                                  // 857
          proxy.apiSessionParams = serializedParams;                                                                   // 858
        }                                                                                                              //
                                                                                                                       //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: tokenInfo })) {                                      // 861
          // Note that only public grains may be opened without a user ID.                                             //
          throw new Meteor.Error(403, "Unauthorized.");                                                                // 863
        }                                                                                                              //
                                                                                                                       //
        if (tokenInfo.expires) {                                                                                       // 866
          proxy.expires = tokenInfo.expires;                                                                           // 867
        }                                                                                                              //
                                                                                                                       //
        apiSessionProxies.put(hashedToken, hashedParams, proxy);                                                       // 870
                                                                                                                       //
        return proxy;                                                                                                  // 872
      });                                                                                                              //
    }                                                                                                                  //
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
var apiUseBasicAuth = function apiUseBasicAuth(req, hostId) {                                                          // 878
  // If the request was to a token-specific host *and* the request has no Origin header (meaning                       //
  // it is not an XHR from a web site), then we permit the use of HTTP basic auth. The reason we                       //
  // prohibit XHRs is because we want to discourage people from using basic auth in a browser,                         //
  // because the browser will cache the credentials, which exposes the hostname to XSRF attack                         //
  // (which is mostly, but not completely, mitigated by the unguessable hostname). The reason we                       //
  // want to allow basic auth at all is because a lot of existing client apps support only basic                       //
  // auth. New clients and web-based clients should use `Authorization: bearer <token>` instead.                       //
  if (globalDb.isTokenSpecificHostId(hostId) && !req.headers.origin) {                                                 // 886
    return true;                                                                                                       // 887
  }                                                                                                                    //
                                                                                                                       //
  // Historically, all API tokens were served from the same host rather than have token-specific                       //
  // hosts. In this model, basic auth in browsers was far more dangerous since the hostname was                        //
  // not a secret -- in fact, even benign attempts to use two APIs on the same server from the same                    //
  // browser could interfere if using basic auth. Hence, basic auth was prohibited except when                         //
  // coming from certain whitelisted clients known not to be browsers, e.g. Mirall, the ownCloud                       //
  // client app.                                                                                                       //
  //                                                                                                                   //
  // Since many clients in the wild have already been configured to use the shared API host, we                        //
  // must continue to support them, so this logic remains.                                                             //
  var agent = req.headers["user-agent"];                                                                               // 878
  return agent.match(BASIC_AUTH_USER_AGENTS_REGEX);                                                                    // 900
};                                                                                                                     //
                                                                                                                       //
var apiTokenForRequest = function apiTokenForRequest(req, hostId) {                                                    // 903
  // Extract the API token from the request.                                                                           //
                                                                                                                       //
  var auth = req.headers.authorization;                                                                                // 906
  var token = void 0;                                                                                                  // 907
  if (auth && auth.slice(0, 7).toLowerCase() === "bearer ") {                                                          // 908
    token = auth.slice(7).trim();                                                                                      // 909
  } else if (auth && auth.slice(0, 6).toLowerCase() === "basic " && apiUseBasicAuth(req, hostId)) {                    //
    token = new Buffer(auth.slice(6).trim(), "base64").toString().split(":")[1];                                       // 912
  } else if (hostId !== "api" && req.url.startsWith("/.sandstorm-token/")) {                                           //
    // Disallow clients that use the old "api" hostId from using tokens in the path.                                   //
    // Allowing them would be a security problem in browsers that ignore CSP.                                          //
    var parts = req.url.slice(1).split("/"); // remove leading / and split                                             // 916
    if (parts.length < 2) {                                                                                            // 913
      token = undefined;                                                                                               // 918
    } else {                                                                                                           //
      token = parts[1];                                                                                                // 920
      req.url = "/" + parts.slice(2).join("/");                                                                        // 921
      // remove .sandstorm-api-token/$TOKEN from path                                                                  //
    }                                                                                                                  // 919
  } else {                                                                                                             //
      token = undefined;                                                                                               // 925
    }                                                                                                                  //
                                                                                                                       //
  if (token && hostId !== "api") {                                                                                     // 928
    // Verify that the token matches the specific host.                                                                //
    if (hostId !== globalDb.apiHostIdForToken(token)) {                                                                // 930
      token = undefined;                                                                                               // 931
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return token;                                                                                                        // 935
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// Routing to proxies.                                                                                                 //
//                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyUpgrade = function tryProxyUpgrade(hostId, req, socket, head) {                                                // 943
  // Attempt to handle a WebSocket upgrade by dispatching it to a grain. Returns a promise that                        //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  if (globalDb.isApiHostId(hostId)) {                                                                                  // 949
    var token = apiTokenForRequest(req, hostId);                                                                       // 950
    if (token) {                                                                                                       // 951
      return getProxyForApiToken(token, req).then(function (proxy) {                                                   // 952
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 955
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 957
        return true;                                                                                                   // 958
      });                                                                                                              //
    } else {                                                                                                           //
      return Promise.resolve(false);                                                                                   // 961
    }                                                                                                                  //
  } else {                                                                                                             //
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 964
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 965
      if (proxy) {                                                                                                     // 966
        // Cross-origin requests are not allowed on UI session hosts.                                                  //
        var origin = req.headers.origin;                                                                               // 968
        if (origin !== PROTOCOL + "//" + req.headers.host) {                                                           // 969
          throw new Meteor.Error(403, "Detected illegal cross-origin WebSocket from: " + origin);                      // 970
        }                                                                                                              //
                                                                                                                       //
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 966
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 977
        return true;                                                                                                   // 978
      } else {                                                                                                         //
        return false;                                                                                                  // 980
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyRequest = function tryProxyRequest(hostId, req, res) {                                                         // 987
  // Attempt to handle an HTTP request by dispatching it to a grain. Returns a promise that                            //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  var hostIdHash = globalDb.isApiHostId(hostId);                                                                       // 993
  if (hostIdHash) {                                                                                                    // 994
    var _ret = function () {                                                                                           //
      // This is a request for the API host.                                                                           //
                                                                                                                       //
      res.setHeader("Access-Control-Allow-Origin", "*");                                                               // 997
                                                                                                                       //
      if (req.method === "OPTIONS") {                                                                                  // 999
        // Reply to CORS preflight request.                                                                            //
                                                                                                                       //
        // All we want to do is permit APIs to be accessed from arbitrary origins. Since clients                       //
        // must send a valid Authorization header, and since cookies are not used for                                  //
        // authorization, this is perfectly safe. In a sane world, we would only need to send back                     //
        // 'Access-Control-Allow-Origin: *' and be done with it.                                                       //
        //                                                                                                             //
        // However, CORS demands that we explicitly whitelist individual methods and headers for                       //
        // use cross-origin, as if this is somehow useful for implementing any practical security                      //
        // policy (it isn't). To make matters worse, we are REQUIRED to enumerate each one                             //
        // individually. We cannot just write '*' for these lists. WTF, CORS?                                          //
        //                                                                                                             //
        // Luckily, the request tells us exactly what method and headers are being requested, so we                    //
        // only need to copy those over, rather than create an exhaustive list. But this is still                      //
        // overly complicated.                                                                                         //
                                                                                                                       //
        var accessControlHeaders = {                                                                                   // 1016
          "Access-Control-Allow-Methods": "GET, HEAD, POST, PUT, PATCH, DELETE",                                       // 1017
          "Access-Control-Max-Age": "3600"                                                                             // 1018
        };                                                                                                             //
                                                                                                                       //
        // Copy all requested headers to the allowed headers list.                                                     //
        var requestedHeaders = req.headers["access-control-request-headers"];                                          // 999
        if (requestedHeaders) {                                                                                        // 1023
          accessControlHeaders["Access-Control-Allow-Headers"] = requestedHeaders;                                     // 1024
        }                                                                                                              //
                                                                                                                       //
        // Add the requested method to the allowed methods list, if it's not there already.                            //
        var requestedMethod = req.headers["access-control-request-method"];                                            // 999
        if (requestedMethod && !_.contains(["GET", "HEAD", "POST", "PUT", "PATCH", "DELETE"], requestedMethod)) {      // 1029
          accessControlHeaders["Access-Control-Allow-Methods"] += ", " + requestedMethod;                              // 1031
        }                                                                                                              //
                                                                                                                       //
        for (header in meteorBabelHelpers.sanitizeForInObject(accessControlHeaders)) {                                 // 1034
          res.setHeader(header, accessControlHeaders[header]);                                                         // 1035
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      var errorHandler = function errorHandler(err) {                                                                  // 1039
        if (err instanceof Meteor.Error) {                                                                             // 1040
          console.log("error: " + err);                                                                                // 1041
          res.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                                      // 1042
        } else {                                                                                                       //
          res.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                               // 1044
        }                                                                                                              //
                                                                                                                       //
        res.end(err.stack);                                                                                            // 1047
      };                                                                                                               //
                                                                                                                       //
      var token = apiTokenForRequest(req, hostId);                                                                     // 1050
      if (token && req.headers["x-sandstorm-token-keepalive"]) {                                                       // 1051
        inMeteor(function () {                                                                                         // 1052
          var keepaliveDuration = parseInt(req.headers["x-sandstorm-token-keepalive"]);                                // 1053
          check(keepaliveDuration, Match.Integer);                                                                     // 1054
          var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                // 1055
          validateWebkey(ApiTokens.findOne(hashedToken), new Date(Date.now() + keepaliveDuration));                    // 1056
        }).then(function () {                                                                                          //
          res.writeHead(200, {});                                                                                      // 1058
          res.end();                                                                                                   // 1059
        }, errorHandler);                                                                                              //
      } else if (token) {                                                                                              //
        getProxyForApiToken(token, req).then(function (proxy) {                                                        // 1062
          proxy.requestHandler(req, res);                                                                              // 1063
        }, errorHandler);                                                                                              //
      } else {                                                                                                         //
        // No token. Look up static API host info.                                                                     //
        inMeteor(function () {                                                                                         // 1067
          var apiHost = globalDb.collections.apiHosts.findOne(hostIdHash);                                             // 1068
                                                                                                                       //
          if (req.method === "OPTIONS") {                                                                              // 1070
            // OPTIONS request with no authorization token.                                                            //
                                                                                                                       //
            var dav = ((apiHost || {}).options || {}).dav || [];                                                       // 1073
            if (dav.length > 0) {                                                                                      // 1074
              res.setHeader("DAV", dav.join(", "));                                                                    // 1075
              res.setHeader("Access-Control-Expose-Headers", "DAV");                                                   // 1076
            }                                                                                                          //
                                                                                                                       //
            res.writeHead(200, {});                                                                                    // 1079
            res.end();                                                                                                 // 1080
          } else {                                                                                                     //
            var resources = (apiHost || {}).resources || {};                                                           // 1082
            var path = SandstormDb.escapeMongoKey(req.url.split("?")[0]);                                              // 1083
            if (path in resources) {                                                                                   // 1084
              // Serve a static resource.                                                                              //
              var resource = resources[path];                                                                          // 1086
              console.log(path, resources, resource);                                                                  // 1087
              if (resource.language) res.setHeader("Content-Language", resource.language);                             // 1088
              if (resource.encoding) res.setHeader("Content-Encoding", resource.encoding);                             // 1089
              res.writeHead(200, {                                                                                     // 1090
                "Content-Type": resource.type                                                                          // 1091
              });                                                                                                      //
              res.end(resource.body);                                                                                  // 1093
            } else {                                                                                                   //
              if (apiUseBasicAuth(req, hostId)) {                                                                      // 1095
                res.writeHead(401, {                                                                                   // 1096
                  "Content-Type": "text/plain",                                                                        // 1097
                  "WWW-Authenticate": "Basic realm='Sandstorm API'"                                                    // 1098
                });                                                                                                    //
              } else {                                                                                                 //
                // TODO(someday): Display some sort of nifty API browser.                                              //
                res.writeHead(403, { "Content-Type": "text/plain" });                                                  // 1102
              }                                                                                                        //
                                                                                                                       //
              res.end("Missing or invalid authorization header.\n\n" + "This address serves APIs, which allow external apps (such as a phone app) to\n" + "access data on your Sandstorm server. This address is not meant to be opened\n" + "in a regular browser.");
            }                                                                                                          //
          }                                                                                                            //
        }).then(function () {}, errorHandler);                                                                         //
      }                                                                                                                //
                                                                                                                       //
      return {                                                                                                         // 1114
        v: Promise.resolve(true)                                                                                       //
      };                                                                                                               //
    }();                                                                                                               //
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret)) === "object") return _ret.v;      //
  } else {                                                                                                             //
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1116
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1117
      if (proxy) {                                                                                                     // 1118
        proxy.requestHandler(req, res);                                                                                // 1119
        return true;                                                                                                   // 1120
      } else {                                                                                                         //
        return false;                                                                                                  // 1122
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// Proxy class                                                                                                         //
//                                                                                                                     //
// Connects to a grain and exports it on a wildcard host.                                                              //
//                                                                                                                     //
                                                                                                                       //
var Proxy = function () {                                                                                              //
  function Proxy(grainId, ownerId, sessionId, hostId, tabId, identityId, isApi, supervisor) {                          // 1135
    var _this3 = this;                                                                                                 //
                                                                                                                       //
    (0, _classCallCheck3["default"])(this, Proxy);                                                                     //
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 1136
    this.ownerId = ownerId;                                                                                            // 1137
    this.identityId = identityId;                                                                                      // 1138
    this.supervisor = supervisor; // note: optional parameter; we can reconnect                                        // 1139
    this.sessionId = sessionId;                                                                                        // 1135
    this.tabId = tabId;                                                                                                // 1141
    this.isApi = isApi;                                                                                                // 1142
    this.hasLoaded = false;                                                                                            // 1143
    this.websockets = {};                                                                                              // 1144
    this.websocketCounter = 0; // Used for generating unique socket IDs.                                               // 1145
    if (sessionId) {                                                                                                   // 1135
      if (!hostId) throw new Error("sessionId must come with hostId");                                                 // 1147
      if (isApi) throw new Error("API proxy shouldn't have sessionId");                                                // 1148
      this.hostId = hostId;                                                                                            // 1149
    } else {                                                                                                           //
      if (!isApi) throw new Error("non-API proxy requires sessionId");                                                 // 1151
      if (hostId) throw new Error("API proxy sholudn't have hostId");                                                  // 1152
    }                                                                                                                  //
                                                                                                                       //
    if (this.identityId) {                                                                                             // 1155
      var identity = globalDb.getIdentity(this.identityId);                                                            // 1156
      if (!identity) {                                                                                                 // 1157
        throw new Error("identity not found: " + this.identityId);                                                     // 1158
      }                                                                                                                //
                                                                                                                       //
      this.userInfo = {                                                                                                // 1161
        displayName: { defaultText: identity.profile.name },                                                           // 1162
        preferredHandle: identity.profile.handle,                                                                      // 1163
        identityId: new Buffer(identity._id, "hex")                                                                    // 1164
      };                                                                                                               //
      if (identity.profile.pictureUrl) this.userInfo.pictureUrl = identity.profile.pictureUrl;                         // 1166
      if (identity.profile.pronoun) this.userInfo.pronouns = identity.profile.pronoun;                                 // 1167
    } else {                                                                                                           //
      this.userInfo = {                                                                                                // 1169
        displayName: { defaultText: "Anonymous User" },                                                                // 1170
        preferredHandle: "anonymous"                                                                                   // 1171
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    var _this = this;                                                                                                  // 1175
                                                                                                                       //
    this.requestHandler = function (request, response) {                                                               // 1177
      if (_this3.sessionId) {                                                                                          // 1178
        // Implement /_sandstorm-init for setting the session cookie.                                                  //
        var url = Url.parse(request.url, true);                                                                        // 1180
        if (url.pathname === "/_sandstorm-init" && url.query.sessionid === _this.sessionId) {                          // 1181
          _this.doSessionInit(request, response, url.query.path);                                                      // 1182
          return;                                                                                                      // 1183
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      Promise.resolve(undefined).then(function () {                                                                    // 1187
        var contentLength = request.headers["content-length"];                                                         // 1188
        if ((request.method === "POST" || request.method === "PUT") && (contentLength === undefined || contentLength > 1024 * 1024)) {
          // The input is either very long, or we don't know how long it is, so use streaming mode.                    //
          return _this.handleRequestStreaming(request, response, contentLength, 0);                                    // 1192
        } else {                                                                                                       //
          return readAll(request).then(function (data) {                                                               // 1194
            return _this.handleRequest(request, data, response, 0);                                                    // 1195
          });                                                                                                          //
        }                                                                                                              //
      })["catch"](function (err) {                                                                                     //
        _this.setHasLoaded();                                                                                          // 1199
                                                                                                                       //
        var body = err.stack;                                                                                          // 1201
        if (err.cppFile) {                                                                                             // 1202
          body += "\nC++ location:" + err.cppFile + ":" + (err.line || "??");                                          // 1203
        }                                                                                                              //
                                                                                                                       //
        if (err.kjType) {                                                                                              // 1206
          body += "\ntype: " + err.kjType;                                                                             // 1207
        }                                                                                                              //
                                                                                                                       //
        if (response.headersSent) {                                                                                    // 1210
          // Unfortunately, it's too late to tell the client what happened.                                            //
          console.error("HTTP request failed after response already sent:", body);                                     // 1212
          response.end();                                                                                              // 1213
        } else {                                                                                                       //
          if (err instanceof Meteor.Error) {                                                                           // 1215
            response.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                               // 1216
          } else {                                                                                                     //
            response.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                        // 1218
          }                                                                                                            //
                                                                                                                       //
          response.end(body);                                                                                          // 1221
        }                                                                                                              //
      });                                                                                                              //
    };                                                                                                                 //
                                                                                                                       //
    this.upgradeHandler = function (request, socket, head) {                                                           // 1226
      _this.handleWebSocket(request, socket, head, 0)["catch"](function (err) {                                        // 1227
        console.error("WebSocket setup failed:", err.stack);                                                           // 1228
        // TODO(cleanup):  Manually send back a 500 response?                                                          //
        socket.destroy();                                                                                              // 1227
      });                                                                                                              //
    };                                                                                                                 //
  }                                                                                                                    //
                                                                                                                       //
  Proxy.prototype.close = function () {                                                                                // 1134
    function close() {                                                                                                 //
      for (var socketIdx in meteorBabelHelpers.sanitizeForInObject(this.websockets)) {                                 // 1236
        this.websockets[socketIdx].destroy();                                                                          // 1237
      };                                                                                                               //
                                                                                                                       //
      this.websockets = {};                                                                                            // 1240
                                                                                                                       //
      if (this.session) {                                                                                              // 1242
        this.session.close();                                                                                          // 1243
        delete this.session;                                                                                           // 1244
      }                                                                                                                //
                                                                                                                       //
      if (this.uiView) {                                                                                               // 1247
        this.uiView.close();                                                                                           // 1248
        delete this.uiView;                                                                                            // 1249
      }                                                                                                                //
                                                                                                                       //
      if (this.supervisor) {                                                                                           // 1252
        this.supervisor.close();                                                                                       // 1253
        delete this.supervisor;                                                                                        // 1254
      }                                                                                                                //
                                                                                                                       //
      if (this.permissionsObserver) {                                                                                  // 1257
        this.permissionsObserver.stop();                                                                               // 1258
        delete this.permissionsObserver;                                                                               // 1259
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.getConnection = function () {                                                                        // 1134
    function getConnection() {                                                                                         //
      if (!this.supervisor) {                                                                                          // 1264
        this.supervisor = globalBackend.cap().getGrain(this.ownerId, this.grainId).supervisor;                         // 1265
        this.uiView = null;                                                                                            // 1266
      }                                                                                                                //
                                                                                                                       //
      if (!this.uiView) {                                                                                              // 1269
        this.uiView = this.supervisor.getMainView().view;                                                              // 1270
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return getConnection;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewWebSession = function () {                                                                   // 1134
    function _callNewWebSession(request, userInfo) {                                                                   //
      var params = Capnp.serialize(WebSession.Params, {                                                                // 1275
        basePath: PROTOCOL + "//" + request.headers.host,                                                              // 1276
        userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",               // 1277
        acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
          return s.trim();                                                                                             // 1281
        }) : ["en-US", "en"]                                                                                           //
      });                                                                                                              //
      return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, new Buffer(this.tabId, "hex")).session;
    }                                                                                                                  //
                                                                                                                       //
    return _callNewWebSession;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewApiSession = function () {                                                                   // 1134
    function _callNewApiSession(request, userInfo) {                                                                   //
      var _this4 = this;                                                                                               //
                                                                                                                       //
      var serializedParams = this.apiSessionParams;                                                                    // 1290
      if (!serializedParams) {                                                                                         // 1291
        throw new Meteor.Error(500, "Should have already computed apiSessionParams.");                                 // 1292
      }                                                                                                                //
                                                                                                                       //
      // TODO(someday): We are currently falling back to WebSession if we get any kind of error upon                   //
      // calling newSession with an ApiSession._id.                                                                    //
      // Eventually we'll remove this logic once we're sure apps have updated.                                         //
      return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), ApiSession.typeId, serializedParams, new Buffer(this.tabId, "hex")).then(function (session) {
        return session.session;                                                                                        // 1302
      }, function (err) {                                                                                              //
        return _this4._callNewWebSession(request, userInfo);                                                           // 1304
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return _callNewApiSession;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewSession = function () {                                                                      // 1134
    function _callNewSession(request, viewInfo) {                                                                      //
      var userInfo = _.clone(this.userInfo);                                                                           // 1309
      var _this = this;                                                                                                // 1310
      var promise = inMeteor(function () {                                                                             // 1311
        var vertex = void 0;                                                                                           // 1312
        if (_this.apiToken) {                                                                                          // 1313
          vertex = { token: _this.apiToken };                                                                          // 1314
        } else {                                                                                                       //
          // (_this.identityId might be null; this is fine)                                                            //
          vertex = { grain: { _id: _this.grainId, identityId: _this.identityId } };                                    // 1317
        }                                                                                                              //
                                                                                                                       //
        var onInvalidated = function () {                                                                              // 1320
          function onInvalidated() {                                                                                   // 1320
            Sessions.remove({ _id: _this.sessionId });                                                                 // 1321
          }                                                                                                            //
                                                                                                                       //
          return onInvalidated;                                                                                        //
        }();                                                                                                           //
                                                                                                                       //
        if (!_this.sessionId) {                                                                                        // 1324
          onInvalidated = function () {                                                                                // 1325
            function onInvalidated() {                                                                                 // 1325
              apiSessionProxies.removeProxiesOfToken(_this.apiToken._id);                                              // 1326
            }                                                                                                          //
                                                                                                                       //
            return onInvalidated;                                                                                      //
          }();                                                                                                         //
        }                                                                                                              //
                                                                                                                       //
        var permissions = SandstormPermissions.grainPermissions(globalDb, vertex, viewInfo, onInvalidated);            // 1330
        if (!permissions.permissions) {                                                                                // 1332
          throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                   // 1333
        }                                                                                                              //
                                                                                                                       //
        _this.permissionsObserver = permissions.observeHandle;                                                         // 1336
                                                                                                                       //
        Sessions.update({                                                                                              // 1338
          _id: _this.sessionId                                                                                         // 1339
        }, {                                                                                                           //
          $set: {                                                                                                      // 1341
            viewInfo: viewInfo,                                                                                        // 1342
            permissions: permissions.permissions                                                                       // 1343
          }                                                                                                            //
        });                                                                                                            //
                                                                                                                       //
        return permissions.permissions;                                                                                // 1347
      });                                                                                                              //
                                                                                                                       //
      return promise.then(function (permissions) {                                                                     // 1350
        userInfo.permissions = permissions;                                                                            // 1351
                                                                                                                       //
        var numBytes = Math.ceil(permissions.length / 8);                                                              // 1353
        var buf = new Buffer(numBytes);                                                                                // 1354
        for (var ii = 0; ii < numBytes; ++ii) {                                                                        // 1355
          buf[ii] = 0;                                                                                                 // 1356
        }                                                                                                              //
                                                                                                                       //
        for (var _ii = 0; _ii < permissions.length; ++_ii) {                                                           // 1359
          var byteNum = Math.floor(_ii / 8);                                                                           // 1360
          var bitNum = _ii % 8;                                                                                        // 1361
          if (permissions[_ii]) {                                                                                      // 1362
            buf[byteNum] = buf[byteNum] | 1 << bitNum;                                                                 // 1363
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        userInfo.deprecatedPermissionsBlob = buf;                                                                      // 1367
                                                                                                                       //
        if (_this.isApi) {                                                                                             // 1369
          return _this._callNewApiSession(request, userInfo);                                                          // 1370
        } else {                                                                                                       //
          return _this._callNewWebSession(request, userInfo);                                                          // 1372
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return _callNewSession;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.getSession = function () {                                                                           // 1134
    function getSession(request) {                                                                                     //
      var _this5 = this;                                                                                               //
                                                                                                                       //
      if (!this.session) {                                                                                             // 1378
        (function () {                                                                                                 //
          _this5.getConnection(); // make sure we're connected                                                         // 1379
          var _this = _this5;                                                                                          // 1380
          var promise = _this5.uiView.getViewInfo().then(function (viewInfo) {                                         // 1381
            return inMeteor(function () {                                                                              // 1382
              Grains.update(_this.grainId, { $set: { cachedViewInfo: viewInfo } });                                    // 1383
            }).then(function () {                                                                                      //
              return _this._callNewSession(request, viewInfo);                                                         // 1385
            });                                                                                                        //
          }, function (error) {                                                                                        //
            if (error.kjType === "failed" || error.kjType === "unimplemented") {                                       // 1388
              // Method not implemented.                                                                               //
              // TODO(apibump): Don't treat 'failed' as 'unimplemented'. Unfortunately, old apps built                 //
              //   with old versions of Cap'n Proto don't throw 'unimplemented' exceptions, so we have                 //
              //   to accept 'failed' here at least until the next API bump.                                           //
              return _this._callNewSession(request, {});                                                               // 1393
            } else {                                                                                                   //
              return Promise.reject(error);                                                                            // 1395
            }                                                                                                          //
          });                                                                                                          //
          _this5.session = new Capnp.Capability(promise, WebSession);                                                  // 1398
        })();                                                                                                          //
      }                                                                                                                //
                                                                                                                       //
      return this.session;                                                                                             // 1401
    }                                                                                                                  //
                                                                                                                       //
    return getSession;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.keepAlive = function () {                                                                            // 1134
    function keepAlive() {                                                                                             //
      this.getConnection();                                                                                            // 1405
      return this.supervisor.keepAlive();                                                                              // 1406
    }                                                                                                                  //
                                                                                                                       //
    return keepAlive;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.resetConnection = function () {                                                                      // 1134
    function resetConnection() {                                                                                       //
      if (this.session) {                                                                                              // 1410
        this.session.close();                                                                                          // 1411
        delete this.session;                                                                                           // 1412
      }                                                                                                                //
                                                                                                                       //
      if (this.uiView) {                                                                                               // 1415
        this.uiView.close();                                                                                           // 1416
        delete this.uiView;                                                                                            // 1417
      }                                                                                                                //
                                                                                                                       //
      if (this.supervisor) {                                                                                           // 1420
        this.supervisor.close();                                                                                       // 1421
        delete this.supervisor;                                                                                        // 1422
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return resetConnection;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.maybeRetryAfterError = function () {                                                                 // 1134
    function maybeRetryAfterError(error, retryCount) {                                                                 //
      // If the error may be caused by the grain dying or a network failure, try to restart it,                        //
      // returning a promise that resolves once restarted. Otherwise, just rethrow the error.                          //
      // `retryCount` should be incremented for every successful retry as part of the same request;                    //
      // we only want to retry once.                                                                                   //
      var _this = this;                                                                                                // 1431
      if (SandstormBackend.shouldRestartGrain(error, retryCount)) {                                                    // 1432
        this.resetConnection();                                                                                        // 1433
        return inMeteor(function () {                                                                                  // 1434
          _this.supervisor = globalBackend.continueGrain(_this.grainId).supervisor;                                    // 1435
        });                                                                                                            //
      } else {                                                                                                         //
        throw error;                                                                                                   // 1438
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return maybeRetryAfterError;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.doSessionInit = function () {                                                                        // 1134
    function doSessionInit(request, response, requestPath) {                                                           //
      // jscs:disable disallowQuotedKeysInObjects                                                                      //
      var path = requestPath || "/";                                                                                   // 1444
                                                                                                                       //
      // Check that the path is relative (ie. starts with a /).                                                        //
      // Also ensure that it doesn't start with 2 /, because that is interpreted as non-relative                       //
      if (path.lastIndexOf("/", 0) !== 0 || path.lastIndexOf("//", 0) === 0) {                                         // 1442
        response.writeHead(400, "Invalid path supplied", { "Content-Type": "text/plain" });                            // 1449
        response.end("Invalid path supplied.");                                                                        // 1450
        return;                                                                                                        // 1451
      }                                                                                                                //
                                                                                                                       //
      // Set the session ID.                                                                                           //
      response.setHeader("Set-Cookie", ["sandstorm-sid=", this.sessionId, "; Max-Age=31536000; HttpOnly"].join(""));   // 1442
                                                                                                                       //
      response.setHeader("Cache-Control", "no-cache, private");                                                        // 1457
                                                                                                                       //
      // Redirect to the app's root URL.                                                                               //
      // Note:  All browsers support relative locations and the next update to HTTP/1.1 will officially                //
      //   make them valid.  http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-26#page-67                     //
      response.writeHead(303, "See Other", { "Location": encodeURI(path) });                                           // 1442
      response.end();                                                                                                  // 1463
    }                                                                                                                  //
                                                                                                                       //
    return doSessionInit;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.makeContext = function () {                                                                          // 1134
    function makeContext(request, response) {                                                                          //
      // Parses the cookies from the request, checks that the session ID is present and valid, then                    //
      // returns the request context which contains the other cookies.  Throws an exception if the                     //
      // session ID is missing or invalid.                                                                             //
                                                                                                                       //
      var context = {};                                                                                                // 1471
                                                                                                                       //
      if (this.hostId) {                                                                                               // 1473
        var parseResult = parseCookies(request);                                                                       // 1474
        if (!parseResult.sessionId || parseResult.sessionId !== this.sessionId) {                                      // 1475
          throw new Meteor.Error(403, "Unauthorized");                                                                 // 1476
        }                                                                                                              //
                                                                                                                       //
        if (parseResult.cookies.length > 0) {                                                                          // 1479
          context.cookies = parseResult.cookies;                                                                       // 1480
        }                                                                                                              //
      } else {                                                                                                         //
        // jscs:disable disallowEmptyBlocks                                                                            //
        // This is an API request. Cookies are not supported.                                                          //
      }                                                                                                                //
                                                                                                                       //
      context.accept = parseAcceptHeader(request);                                                                     // 1487
                                                                                                                       //
      context.eTagPrecondition = parsePreconditionHeader(request);                                                     // 1489
                                                                                                                       //
      context.additionalHeaders = [];                                                                                  // 1491
      WebSession.Context.headerWhitelist.forEach(function (headerName) {                                               // 1492
        if (headerName.endsWith("*")) {                                                                                // 1493
          var prefix = headerName.substr(0, headerName.length - 1);                                                    // 1494
          for (var h in meteorBabelHelpers.sanitizeForInObject(request.headers)) {                                     // 1495
            if (!h.startsWith(prefix)) {                                                                               // 1496
              continue;                                                                                                // 1497
            }                                                                                                          //
                                                                                                                       //
            context.additionalHeaders.push({                                                                           // 1500
              name: h,                                                                                                 // 1501
              value: request.headers[h]                                                                                // 1502
            });                                                                                                        //
          }                                                                                                            //
        } else if (request.headers[headerName]) {                                                                      //
          context.additionalHeaders.push({                                                                             // 1506
            name: headerName,                                                                                          // 1507
            value: request.headers[headerName]                                                                         // 1508
          });                                                                                                          //
        };                                                                                                             //
      });                                                                                                              //
                                                                                                                       //
      var promise = new Promise(function (resolve, reject) {                                                           // 1513
        response.resolveResponseStream = resolve;                                                                      // 1514
        response.rejectResponseStream = reject;                                                                        // 1515
      });                                                                                                              //
                                                                                                                       //
      context.responseStream = new Capnp.Capability(promise, ByteStream);                                              // 1518
                                                                                                                       //
      return context;                                                                                                  // 1520
    }                                                                                                                  //
                                                                                                                       //
    return makeContext;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.translateResponse = function () {                                                                    // 1134
    function translateResponse(rpcResponse, response, request) {                                                       //
      if (this.hostId) {                                                                                               // 1524
        if (rpcResponse.setCookies && rpcResponse.setCookies.length > 0) {                                             // 1525
          response.setHeader("Set-Cookie", rpcResponse.setCookies.map(makeSetCookieHeader));                           // 1526
        }                                                                                                              //
                                                                                                                       //
        // TODO(security): Add a Content-Security-Policy header which:                                                 //
        // (1) Prevents the app from initiating HTTP requests to third parties.                                        //
        // (2) Prevents the app from navigating the parent frame.                                                      //
        // (3) Prevents the app from opening popups.                                                                   //
        // (4) Prohibits anyone other than the Sandstorm shell from framing the app (as a backup                       //
        //   defense vs. clickjacking, though unguessable hostnames already mostly prevent this).                      //
      } else {                                                                                                         // 1524
          // jscs:disable validateQuoteMarks                                                                           //
          // This is an API request. Cookies are not supported.                                                        //
                                                                                                                       //
          // We need to make sure caches know that different bearer tokens get totally different results.              //
          response.setHeader('Vary', 'Authorization');                                                                 // 1540
                                                                                                                       //
          // APIs can be called from any origin. Because we ignore cookies, there is no security problem.              //
          response.setHeader('Access-Control-Allow-Origin', '*');                                                      // 1535
                                                                                                                       //
          // Add a Content-Security-Policy as a backup in case someone finds a way to load this resource               //
          // in a browser context. This policy should thoroughly neuter it.                                            //
          response.setHeader('Content-Security-Policy', "default-src 'none'; sandbox");                                // 1535
        }                                                                                                              //
                                                                                                                       //
      // On first response, update the session to have hasLoaded=true                                                  //
      this.setHasLoaded();                                                                                             // 1523
                                                                                                                       //
      // TODO(security): Set X-Content-Type-Options: nosniff?                                                          //
                                                                                                                       //
      if ('content' in rpcResponse) {                                                                                  // 1523
        var _ret3 = function () {                                                                                      //
          var content = rpcResponse.content;                                                                           // 1556
          var code = successCodes[content.statusCode];                                                                 // 1557
          if (!code) {                                                                                                 // 1558
            throw new Error('Unknown status code: ', content.statusCode);                                              // 1559
          }                                                                                                            //
                                                                                                                       //
          if (content.mimeType) {                                                                                      // 1562
            response.setHeader('Content-Type', content.mimeType);                                                      // 1563
          }                                                                                                            //
                                                                                                                       //
          if (content.encoding) {                                                                                      // 1566
            response.setHeader('Content-Encoding', content.encoding);                                                  // 1567
          }                                                                                                            //
                                                                                                                       //
          if (content.language) {                                                                                      // 1570
            response.setHeader('Content-Language', content.language);                                                  // 1571
          }                                                                                                            //
                                                                                                                       //
          if (content.eTag) {                                                                                          // 1574
            response.setHeader('ETag', composeETag(content.eTag));                                                     // 1575
          }                                                                                                            //
                                                                                                                       //
          if ('disposition' in content && 'download' in content.disposition) {                                         // 1578
            response.setHeader('Content-Disposition', 'attachment; filename="' + content.disposition.download.replace(/([\\"\n])/g, "\\$1") + '"');
          }                                                                                                            //
                                                                                                                       //
          if ('stream' in content.body) {                                                                              // 1583
            if (request.method === 'HEAD') {                                                                           // 1584
              content.body.stream.close();                                                                             // 1585
              response.rejectResponseStream(new Error('HEAD request; content doesn\'t matter.'));                      // 1586
            } else {                                                                                                   //
              var _ret4 = function () {                                                                                //
                var streamHandle = content.body.stream;                                                                // 1588
                var promise = new Promise(function (resolve, reject) {                                                 // 1589
                  response.resolveResponseStream(new Capnp.Capability(new ResponseStream(response, code.id, code.title, resolve, reject), ByteStream));
                }).then(function () {                                                                                  //
                  streamHandle.close();                                                                                // 1594
                }, function (err) {                                                                                    //
                  streamHandle.close();                                                                                // 1596
                  throw err;                                                                                           // 1597
                });                                                                                                    //
                promise.streamHandle = streamHandle;                                                                   // 1599
                return {                                                                                               // 1600
                  v: {                                                                                                 //
                    v: promise                                                                                         //
                  }                                                                                                    //
                };                                                                                                     //
              }();                                                                                                     //
                                                                                                                       //
              if ((typeof _ret4 === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret4)) === "object") return _ret4.v;
            }                                                                                                          //
          } else {                                                                                                     //
            response.rejectResponseStream(new Error('Response content body was not a stream.'));                       // 1603
                                                                                                                       //
            if ('bytes' in content.body) {                                                                             // 1606
              response.setHeader('Content-Length', content.body.bytes.length);                                         // 1607
            } else {                                                                                                   //
              throw new Error('Unknown content body type.');                                                           // 1609
            }                                                                                                          //
          }                                                                                                            //
                                                                                                                       //
          response.writeHead(code.id, code.title);                                                                     // 1613
                                                                                                                       //
          if ('bytes' in content.body && request.method !== 'HEAD') {                                                  // 1615
            response.write(content.body.bytes);                                                                        // 1616
          }                                                                                                            //
                                                                                                                       //
          response.end();                                                                                              // 1619
        }();                                                                                                           //
                                                                                                                       //
        if ((typeof _ret3 === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret3)) === "object") return _ret3.v;
      } else if ('noContent' in rpcResponse) {                                                                         //
        var noContent = rpcResponse.noContent;                                                                         // 1621
        var noContentCode = noContentSuccessCodes[noContent.shouldResetForm * 1];                                      // 1622
        response.writeHead(noContentCode.id, noContentCode.title);                                                     // 1623
        response.end();                                                                                                // 1624
      } else if ('preconditionFailed' in rpcResponse) {                                                                //
        var preconditionFailed = rpcResponse.preconditionFailed;                                                       // 1626
        if (request.method === 'GET' && 'if-none-match' in request.headers) {                                          // 1627
          if (preconditionFailed.matchingETag) {                                                                       // 1628
            response.setHeader('ETag', composeETag(preconditionFailed.matchingETag));                                  // 1629
          }                                                                                                            //
                                                                                                                       //
          response.writeHead(304, 'Not Modified');                                                                     // 1632
        } else {                                                                                                       //
          response.writeHead(412, 'Precondition Failed');                                                              // 1634
        }                                                                                                              //
                                                                                                                       //
        response.end();                                                                                                // 1637
      } else if ('redirect' in rpcResponse) {                                                                          //
        var redirect = rpcResponse.redirect;                                                                           // 1639
        var redirectCode = redirectCodes[redirect.switchToGet * 2 + redirect.isPermanent];                             // 1640
        response.writeHead(redirectCode.id, redirectCode.title, {                                                      // 1641
          'Location': redirect.location                                                                                // 1642
        });                                                                                                            //
        response.end();                                                                                                // 1644
      } else if ('clientError' in rpcResponse) {                                                                       //
        var clientError = rpcResponse.clientError;                                                                     // 1646
        var errorCode = errorCodes[clientError.statusCode];                                                            // 1647
        if (!errorCode) {                                                                                              // 1648
          throw new Error('Unknown status code: ', clientError.statusCode);                                            // 1649
        }                                                                                                              //
                                                                                                                       //
        response.writeHead(errorCode.id, errorCode.title, {                                                            // 1652
          'Content-Type': 'text/html'                                                                                  // 1653
        });                                                                                                            //
                                                                                                                       //
        if (request.method !== 'HEAD') {                                                                               // 1656
          if (clientError.descriptionHtml) {                                                                           // 1657
            response.write(clientError.descriptionHtml);                                                               // 1658
          } else {                                                                                                     //
            // TODO(someday):  Better default error page.                                                              //
            response.write('<html><body><h1>' + errorCode.id + ': ' + errorCode.title + '</h1></body></html>');        // 1661
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        response.end();                                                                                                // 1666
      } else if ('serverError' in rpcResponse) {                                                                       //
        response.writeHead(500, 'Internal Server Error', {                                                             // 1668
          'Content-Type': 'text/html'                                                                                  // 1669
        });                                                                                                            //
                                                                                                                       //
        if (request.method !== 'HEAD') {                                                                               // 1672
          if (rpcResponse.serverError.descriptionHtml) {                                                               // 1673
            response.write(rpcResponse.serverError.descriptionHtml);                                                   // 1674
          } else {                                                                                                     //
            // TODO(someday):  Better default error page.                                                              //
            response.write('<html><body><h1>500: Internal Server Error</h1></body></html>');                           // 1677
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        response.end();                                                                                                // 1681
      } else {                                                                                                         //
        throw new Error('Unknown HTTP response type:\n' + JSON.stringify(rpcResponse));                                // 1683
      }                                                                                                                //
                                                                                                                       //
      return Promise.resolve(undefined);                                                                               // 1686
    }                                                                                                                  //
                                                                                                                       //
    return translateResponse;                                                                                          //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.handleRequest = function () {                                                                        // 1134
    function handleRequest(request, data, response, retryCount) {                                                      //
      var _this = this;                                                                                                // 1690
      return Promise.resolve(undefined).then(function () {                                                             // 1691
        return _this.makeContext(request, response);                                                                   // 1692
      }).then(function (context) {                                                                                     //
        // jscs:disable requireDotNotation                                                                             //
        // Send the RPC.                                                                                               //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1696
        var session = _this.getSession(request);                                                                       // 1693
                                                                                                                       //
        var requestContent = function () {                                                                             // 1699
          function requestContent() {                                                                                  // 1699
            return {                                                                                                   // 1700
              content: data,                                                                                           // 1701
              encoding: request.headers['content-encoding'],                                                           // 1702
              mimeType: request.headers['content-type']                                                                // 1703
            };                                                                                                         //
          }                                                                                                            //
                                                                                                                       //
          return requestContent;                                                                                       //
        }();                                                                                                           //
                                                                                                                       //
        var xmlContent = function () {                                                                                 // 1707
          function xmlContent() {                                                                                      // 1707
            var type = request.headers['content-type'] || 'application/xml;charset=utf-8';                             // 1708
            var match = type.match(/[^/]*\/xml(; *charset *= *([^ ;]*))?/);                                            // 1709
            if (!match) {                                                                                              // 1710
              response.writeHead(415, 'Unsupported media type.', {                                                     // 1711
                'Content-Type': 'text/plain'                                                                           // 1712
              });                                                                                                      //
              response.end('expected XML request body');                                                               // 1714
              throw new Error('expected XML request body');                                                            // 1715
            }                                                                                                          //
                                                                                                                       //
            var charset = match[2] || 'ISO-8859-1';                                                                    // 1718
                                                                                                                       //
            var encoding = request.headers['content-encoding'];                                                        // 1720
            if (encoding && encoding !== 'identity') {                                                                 // 1721
              if (encoding !== 'gzip') throw new Error('unknown Content-Encoding: ' + encoding);                       // 1722
              data = gunzipSync(data);                                                                                 // 1723
            }                                                                                                          //
                                                                                                                       //
            return data.toString(charset.toLowerCase() === 'utf-8' ? 'utf8' : 'binary');                               // 1726
          }                                                                                                            //
                                                                                                                       //
          return xmlContent;                                                                                           //
        }();                                                                                                           //
                                                                                                                       //
        var propfindDepth = function () {                                                                              // 1729
          function propfindDepth() {                                                                                   // 1729
            var depth = request.headers['depth'];                                                                      // 1730
            return depth === '0' ? 'zero' : depth === '1' ? 'one' : 'infinity';                                        // 1731
          }                                                                                                            //
                                                                                                                       //
          return propfindDepth;                                                                                        //
        }();                                                                                                           //
                                                                                                                       //
        var shallow = function () {                                                                                    // 1736
          function shallow() {                                                                                         // 1736
            return request.headers['depth'] === '0';                                                                   // 1737
          }                                                                                                            //
                                                                                                                       //
          return shallow;                                                                                              //
        }();                                                                                                           //
                                                                                                                       //
        var noOverwrite = function () {                                                                                // 1740
          function noOverwrite() {                                                                                     // 1740
            return (request.headers['overwrite'] || '').toLowerCase() === 'f';                                         // 1741
          }                                                                                                            //
                                                                                                                       //
          return noOverwrite;                                                                                          //
        }();                                                                                                           //
                                                                                                                       //
        var destination = function () {                                                                                // 1744
          function destination() {                                                                                     // 1744
            var result = request.headers['destination'];                                                               // 1745
            if (!result) throw new Error('missing destination');                                                       // 1746
            return Url.parse(result).path.slice(1); // remove leading '/'                                              // 1747
          }                                                                                                            // 1744
                                                                                                                       //
          return destination;                                                                                          //
        }();                                                                                                           //
                                                                                                                       //
        if (request.method === 'GET' || request.method === 'HEAD') {                                                   // 1750
          return session.get(path, context, request.method === 'HEAD');                                                // 1751
        } else if (request.method === 'POST') {                                                                        //
          return session.post(path, requestContent(), context);                                                        // 1753
        } else if (request.method === 'PUT') {                                                                         //
          return session.put(path, requestContent(), context);                                                         // 1755
        } else if (request.method === 'PATCH') {                                                                       //
          return session.patch(path, requestContent(), context);                                                       // 1757
        } else if (request.method === 'DELETE') {                                                                      //
          return session["delete"](path, context);                                                                     // 1759
        } else if (request.method === 'PROPFIND') {                                                                    //
          return session.propfind(path, xmlContent(), propfindDepth(), context);                                       // 1761
        } else if (request.method === 'PROPPATCH') {                                                                   //
          return session.proppatch(path, xmlContent(), context);                                                       // 1763
        } else if (request.method === 'MKCOL') {                                                                       //
          return session.mkcol(path, requestContent(), context);                                                       // 1765
        } else if (request.method === 'COPY') {                                                                        //
          return session.copy(path, destination(), noOverwrite(), shallow(), context);                                 // 1767
        } else if (request.method === 'MOVE') {                                                                        //
          return session.move(path, destination(), noOverwrite(), context);                                            // 1769
        } else if (request.method === 'LOCK') {                                                                        //
          return session.lock(path, xmlContent(), shallow(), context);                                                 // 1771
        } else if (request.method === 'UNLOCK') {                                                                      //
          return session.unlock(path, request.headers['lock-token'], context);                                         // 1773
        } else if (request.method === 'ACL') {                                                                         //
          return session.acl(path, xmlContent(), context);                                                             // 1775
        } else if (request.method === 'REPORT') {                                                                      //
          return session.report(path, requestContent(), context);                                                      // 1777
        } else if (request.method === 'OPTIONS') {                                                                     //
          return session.options(path, context).then(function (options) {                                              // 1779
            var dav = [];                                                                                              // 1780
            if (options.davClass1) dav.push('1');                                                                      // 1781
            if (options.davClass2) dav.push('2');                                                                      // 1782
            if (options.davClass3) dav.push('3');                                                                      // 1783
            if (options.davExtensions) {                                                                               // 1784
              options.davExtensions.forEach(function (token) {                                                         // 1785
                if (token.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+|<[\x21-\x7E]*>)$/)) {                                   // 1786
                  dav.push(token);                                                                                     // 1787
                }                                                                                                      //
              });                                                                                                      //
            }                                                                                                          //
                                                                                                                       //
            if (dav.length > 0) {                                                                                      // 1792
              response.setHeader("DAV", dav.join(", "));                                                               // 1793
              response.setHeader("Access-Control-Expose-Headers", "DAV");                                              // 1794
            }                                                                                                          //
                                                                                                                       //
            response.end();                                                                                            // 1797
            // Return no response; we already handled everything.                                                      //
          }, function (err) {                                                                                          // 1779
            if (err.kjType !== 'unimplemented') throw err;                                                             // 1800
            response.end();                                                                                            // 1801
            // Return no response; we already handled everything.                                                      //
          });                                                                                                          // 1799
        } else {                                                                                                       //
            throw new Error('Sandstorm only supports the following methods: GET, POST, PUT, PATCH, DELETE, HEAD, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK, ACL, REPORT, and OPTIONS.');
          }                                                                                                            //
      }).then(function (rpcResponse) {                                                                                 //
        if (rpcResponse !== undefined) {                                                                               // 1808
          // Will be undefined for OPTIONS request.                                                                    //
          return _this.translateResponse(rpcResponse, response, request);                                              // 1809
        }                                                                                                              //
      })["catch"](function (error) {                                                                                   //
        return _this.maybeRetryAfterError(error, retryCount).then(function () {                                        // 1812
          return _this.handleRequest(request, data, response, retryCount + 1);                                         // 1813
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return handleRequest;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.handleRequestStreaming = function () {                                                               // 1134
    function handleRequestStreaming(request, response, contentLength, retryCount) {                                    //
      var _this = this;                                                                                                // 1819
      var context = this.makeContext(request, response);                                                               // 1820
      var path = request.url.slice(1); // remove leading '/'                                                           // 1821
      var session = this.getSession(request);                                                                          // 1818
                                                                                                                       //
      var mimeType = request.headers['content-type'] || 'application/octet-stream';                                    // 1824
      var encoding = request.headers['content-encoding'];                                                              // 1825
                                                                                                                       //
      var requestStreamPromise = void 0;                                                                               // 1827
      if (request.method === 'POST') {                                                                                 // 1828
        requestStreamPromise = session.postStreaming(path, mimeType, context, encoding);                               // 1829
      } else if (request.method === 'PUT') {                                                                           //
        requestStreamPromise = session.putStreaming(path, mimeType, context, encoding);                                // 1831
      } else {                                                                                                         //
        throw new Error('Sandstorm only supports streaming POST and PUT requests.');                                   // 1833
      }                                                                                                                //
                                                                                                                       //
      // TODO(perf): We ought to be pipelining the body, but we can't currently, because we have to                    //
      //   handle the case where the app doesn't actually support streaming. We could pipeline while                   //
      //   also buffering the data on the side in case we need it again later, but that's kind of                      //
      //   complicated. We should fix the whole protocol to make streaming the standard.                               //
      return requestStreamPromise.then(function (requestStreamResult) {                                                // 1818
        var requestStream = requestStreamResult.stream;                                                                // 1841
                                                                                                                       //
        // Initialized when getResponse() returns, if the response is streaming.                                       //
        var downloadStreamHandle = void 0;                                                                             // 1840
                                                                                                                       //
        // Initialized if an upload-stream method throws.                                                              //
        var uploadStreamError = void 0;                                                                                // 1840
                                                                                                                       //
        // We call `getResponse()` immediately so that the app can start streaming data down even while                //
        // data is still being streamed up. This theoretically allows apps to perform bidirectional                    //
        // streaming, though probably very few actually do that.                                                       //
        //                                                                                                             //
        // Note that we need to be able to cancel `responsePromise` below, so it's important that it is                //
        // the raw Cap'n Proto promise. Hence `translateResponsePromise` is a separate variable.                       //
        var responsePromise = requestStream.getResponse();                                                             // 1840
                                                                                                                       //
        var reportUploadStreamError = function () {                                                                    // 1857
          function reportUploadStreamError(err) {                                                                      // 1857
            // Called when an upload-stream method throws.                                                             //
                                                                                                                       //
            if (!uploadStreamError) {                                                                                  // 1860
              uploadStreamError = err;                                                                                 // 1861
                                                                                                                       //
              // If we're still waiting on any response stuff, cancel it.                                              //
              responsePromise.cancel();                                                                                // 1860
              requestStream.close();                                                                                   // 1865
              if (downloadStreamHandle) {                                                                              // 1866
                downloadStreamHandle.close();                                                                          // 1867
              }                                                                                                        //
            }                                                                                                          //
          }                                                                                                            //
                                                                                                                       //
          return reportUploadStreamError;                                                                              //
        }();                                                                                                           //
                                                                                                                       //
        // If we have a Content-Length, pass it along to the app by calling `expectSize()`.                            //
        if (contentLength !== undefined) {                                                                             // 1840
          requestStream.expectSize(contentLength)["catch"](function (err) {                                            // 1874
            // expectSize() is allowed to be unimplemented.                                                            //
            if (err.kjType !== 'unimplemented') {                                                                      // 1876
              reportUploadStreamError(err);                                                                            // 1877
            }                                                                                                          //
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        // Pipe the input stream to the app.                                                                           //
        request.on('data', function (buf) {                                                                            // 1840
          // TODO(soon): Only allow a small number of write()s to be in-flight at once,                                //
          //   pausing the input stream if we hit that limit, so that we block the TCP socket all the                  //
          //   way back to the source. May want to also coalesce small writes for this purpose.                        //
          // TODO(security): The above problem may allow a DoS attack on the front-end.                                //
          if (!uploadStreamError) requestStream.write(buf)["catch"](reportUploadStreamError);                          // 1888
        });                                                                                                            //
                                                                                                                       //
        request.on('end', function () {                                                                                // 1891
          if (!uploadStreamError) requestStream.done()["catch"](reportUploadStreamError);                              // 1892
                                                                                                                       //
          // We're all done making calls to requestStream.                                                             //
          requestStream.close();                                                                                       // 1891
        });                                                                                                            //
                                                                                                                       //
        request.on('close', function () {                                                                              // 1898
          reportUploadStreamError(new Error('HTTP connection unexpectedly closed during request.'));                   // 1899
        });                                                                                                            //
                                                                                                                       //
        request.on('error', function (err) {                                                                           // 1902
          reportUploadStreamError(err);                                                                                // 1903
        });                                                                                                            //
                                                                                                                       //
        return responsePromise.then(function (rpcResponse) {                                                           // 1906
          // Stop here if the upload stream has already failed.                                                        //
          if (uploadStreamError) throw uploadStreamError;                                                              // 1908
          var promise = _this.translateResponse(rpcResponse, response, request);                                       // 1909
          downloadStreamHandle = promise.streamHandle;                                                                 // 1910
          return promise;                                                                                              // 1911
        });                                                                                                            //
      }, function (err) {                                                                                              //
        if (err.kjType === 'failed' && err.message.indexOf('not implemented') !== -1) {                                // 1914
          // Hack to work around old apps using an old version of Cap'n Proto, before the                              //
          // 'unimplemented' exception type was introduced. :(                                                         //
          // TODO(cleanup): When we transition to API version 2, we can move this into the                             //
          //   compatibility layer.                                                                                    //
          err.kjType = 'unimplemented';                                                                                // 1919
        }                                                                                                              //
                                                                                                                       //
        if (SandstormBackend.shouldRestartGrain(err, 0)) {                                                             // 1922
          // This is the kind of error that indicates we should retry. Note that we passed 0 for the                   //
          // retry count above because we were just checking if this is a retriable error (vs. possibly                //
          // a method-not-implemented error); maybeRetryAfterError() will check again with the proper                  //
          // retry count.                                                                                              //
          return _this.maybeRetryAfterError(err, retryCount).then(function () {                                        // 1927
            return _this.handleRequestStreaming(request, response, contentLength, retryCount + 1);                     // 1928
          });                                                                                                          //
        } else if (err.kjType === 'unimplemented') {                                                                   //
          // Streaming is not implemented. Fall back to non-streaming version.                                         //
          return readAll(request).then(function (data) {                                                               // 1932
            return _this.handleRequest(request, data, response, 0);                                                    // 1933
          });                                                                                                          //
        } else {                                                                                                       //
          throw err;                                                                                                   // 1936
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return handleRequestStreaming;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.handleWebSocket = function () {                                                                      // 1134
    function handleWebSocket(request, socket, head, retryCount) {                                                      //
      var _this = this;                                                                                                // 1942
                                                                                                                       //
      return Promise.resolve(undefined).then(function () {                                                             // 1944
        return _this.makeContext(request);                                                                             // 1945
      }).then(function (context) {                                                                                     //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1947
        var session = _this.getSession(request);                                                                       // 1946
                                                                                                                       //
        if (!('sec-websocket-key' in request.headers)) {                                                               // 1950
          throw new Error('Missing Sec-WebSocket-Accept header.');                                                     // 1951
        }                                                                                                              //
                                                                                                                       //
        var magic = request.headers['sec-websocket-key'] + '258EAFA5-E914-47DA-95CA-C5AB0DC85B11';                     // 1954
        var acceptKey = Crypto.createHash('sha1').update(magic).digest('base64');                                      // 1955
                                                                                                                       //
        var protocols = [];                                                                                            // 1957
        if ('sec-websocket-protocol' in request.headers) {                                                             // 1958
          protocols = request.headers['sec-websocket-protocol'].split(',').map(function (s) {                          // 1959
            return s.trim();                                                                                           // 1960
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        var receiver = new WebSocketReceiver(socket);                                                                  // 1963
                                                                                                                       //
        var promise = session.openWebSocket(path, context, protocols, receiver);                                       // 1965
                                                                                                                       //
        if (head.length > 0) {                                                                                         // 1967
          promise.serverStream.sendBytes(head);                                                                        // 1968
        }                                                                                                              //
                                                                                                                       //
        var socketIdx = _this.websocketCounter.toString();                                                             // 1971
        _this.websockets[socketIdx] = socket;                                                                          // 1972
        _this.websocketCounter += 1;                                                                                   // 1973
        pumpWebSocket(socket, promise.serverStream, function () {                                                      // 1974
          delete _this.websockets[socketIdx];                                                                          // 1974
        });                                                                                                            //
                                                                                                                       //
        return promise.then(function (response) {                                                                      // 1976
          var headers = ['HTTP/1.1 101 Switching Protocols', 'Upgrade: websocket', 'Connection: Upgrade', 'Sec-WebSocket-Accept: ' + acceptKey];
          if (response.protocol && response.protocol.length > 0) {                                                     // 1983
            headers.push('Sec-WebSocket-Protocol: ' + response.protocol.join(', '));                                   // 1984
          }                                                                                                            //
                                                                                                                       //
          headers.push('');                                                                                            // 1987
          headers.push('');                                                                                            // 1988
                                                                                                                       //
          socket.write(headers.join('\r\n'));                                                                          // 1990
          receiver.go();                                                                                               // 1991
                                                                                                                       //
          // Note:  At this point errors are out of our hands.                                                         //
        });                                                                                                            // 1976
      })["catch"](function (error) {                                                                                   //
        return _this.maybeRetryAfterError(error, retryCount).then(function () {                                        // 1996
          return _this.handleWebSocket(request, socket, head, retryCount + 1);                                         // 1997
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return handleWebSocket;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.setHasLoaded = function () {                                                                         // 1134
    function setHasLoaded() {                                                                                          //
      var _this6 = this;                                                                                               //
                                                                                                                       //
      if (!this.hasLoaded) {                                                                                           // 2003
        (function () {                                                                                                 //
          _this6.hasLoaded = true;                                                                                     // 2004
          var sessionId = _this6.sessionId;                                                                            // 2005
          inMeteor(function () {                                                                                       // 2006
            Sessions.update({ _id: sessionId }, { $set: { hasLoaded: true } });                                        // 2007
          });                                                                                                          //
        })();                                                                                                          //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return setHasLoaded;                                                                                               //
  }();                                                                                                                 //
                                                                                                                       //
  return Proxy;                                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 2013
                                                                                                                       //
var isRfc1918OrLocal = function isRfc1918OrLocal(address) {                                                            // 2015
  if (Net.isIPv4(address)) {                                                                                           // 2016
    quad = address.split('.').map(function (x) {                                                                       // 2017
      return parseInt(x, 10);                                                                                          // 2017
    });                                                                                                                //
    return quad[0] === 127 || quad[0] === 10 || quad[0] === 192 && quad[1] === 168 || quad[0] === 172 && quad[1] >= 16 && quad[1] < 32;
  } else if (Net.isIPv6(address)) {                                                                                    //
    // IPv6 specifies ::1 as localhost and fd:: as reserved for private networks                                       //
    return address === '::1' || address.lastIndexOf('fd', 0) === 0;                                                    // 2023
  } else {                                                                                                             //
    // Ignore things that are neither IPv4 nor IPv6                                                                    //
    return false;                                                                                                      // 2026
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
var quadToIntString = function quadToIntString(quad) {                                                                 // 2030
  var num = Bignum(quad[0]).shiftLeft(16).add(quad[1]).shiftLeft(16).add(quad[2]).shiftLeft(16).add(quad[3]);          // 2031
  return num.toString();                                                                                               // 2035
};                                                                                                                     //
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Session cookie management                                                                                           //
                                                                                                                       //
var parseCookies = function parseCookies(request) {                                                                    // 2041
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers['cookie'];                                                                              // 2043
                                                                                                                       //
  var result = { cookies: [] };                                                                                        // 2045
  if (header) {                                                                                                        // 2046
    var reqCookies = header.split(';');                                                                                // 2047
    for (var i in meteorBabelHelpers.sanitizeForInObject(reqCookies)) {                                                // 2048
      var reqCookie = reqCookies[i];                                                                                   // 2049
      var equalsPos = reqCookie.indexOf('=');                                                                          // 2050
      var cookie = void 0;                                                                                             // 2051
      if (equalsPos === -1) {                                                                                          // 2052
        cookie = { key: reqCookie.trim(), value: '' };                                                                 // 2053
      } else {                                                                                                         //
        cookie = { key: reqCookie.slice(0, equalsPos).trim(), value: reqCookie.slice(equalsPos + 1) };                 // 2055
      }                                                                                                                //
                                                                                                                       //
      if (cookie.key === 'sandstorm-sid') {                                                                            // 2058
        if (result.sessionId) {                                                                                        // 2059
          throw new Error('Multiple sandstorm session IDs?');                                                          // 2060
        }                                                                                                              //
                                                                                                                       //
        result.sessionId = cookie.value;                                                                               // 2063
      } else {                                                                                                         //
        result.cookies.push(cookie);                                                                                   // 2065
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return result;                                                                                                       // 2070
};                                                                                                                     //
                                                                                                                       //
var parsePreconditionHeader = function parsePreconditionHeader(request) {                                              // 2073
  if (request.headers['if-match']) {                                                                                   // 2074
    if (request.headers['if-match'].trim() === '*') {                                                                  // 2075
      return { exists: null };                                                                                         // 2076
    }                                                                                                                  //
                                                                                                                       //
    var matches = parseETagList(request.headers['if-match']);                                                          // 2079
    if (matches.length > 0) {                                                                                          // 2080
      return { matchesOneOf: matches };                                                                                // 2081
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  if (request.headers['if-none-match']) {                                                                              // 2085
    if (request.headers['if-none-match'].trim() === '*') {                                                             // 2086
      return { doesntExist: null };                                                                                    // 2087
    }                                                                                                                  //
                                                                                                                       //
    var noneMatches = parseETagList(request.headers['if-none-match']);                                                 // 2090
    if (noneMatches.length > 0) {                                                                                      // 2091
      return { matchesNoneOf: noneMatches };                                                                           // 2092
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return { none: null };                                                                                               // 2096
};                                                                                                                     //
                                                                                                                       //
var parseETagList = function parseETagList(input) {                                                                    // 2099
  // An ETag is a quoted, \-escaped string, possibly prefixed with W/ (outside the quotes) to                          //
  // indicate that it is weak. We are parsing a list of comma-delimited etags.                                         //
                                                                                                                       //
  input = input.trim();                                                                                                // 2103
  var results = [];                                                                                                    // 2104
                                                                                                                       //
  while (input.length > 0) {                                                                                           // 2106
    var match = input.match(/^\s*(W\/)?"(([^"\\]|\\.)*)"\s*($|,)/);                                                    // 2107
    if (!match) throw new Meteor.Error(400, 'invalid etag');                                                           // 2108
                                                                                                                       //
    input = input.slice(match[0].length).trim();                                                                       // 2110
    results.push({ weak: !!match[1], value: match[2].replace(/\\(.)/g, '$1') });                                       // 2111
  }                                                                                                                    //
                                                                                                                       //
  return results;                                                                                                      // 2114
};                                                                                                                     //
                                                                                                                       //
var composeETag = function composeETag(tag) {                                                                          // 2117
  var result = '"' + (tag.value || '').replace(/([\\"])/g, '\\$1') + '"';                                              // 2118
  if (tag.weak) result = 'W/' + result;                                                                                // 2119
  return result;                                                                                                       // 2120
};                                                                                                                     //
                                                                                                                       //
var parseAcceptHeader = function parseAcceptHeader(request) {                                                          // 2123
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers['accept'];                                                                              // 2125
                                                                                                                       //
  var result = [];                                                                                                     // 2127
  if (header) {                                                                                                        // 2128
    var acceptList = header.split(',');                                                                                // 2129
    for (var i in meteorBabelHelpers.sanitizeForInObject(acceptList)) {                                                // 2130
      var acceptStr = acceptList[i];                                                                                   // 2131
      var tokensList = acceptStr.split(';');                                                                           // 2132
                                                                                                                       //
      var temp = { mimeType: tokensList[0].trim() };                                                                   // 2134
                                                                                                                       //
      var tokensListRest = tokensList.slice(1);                                                                        // 2136
      for (var j in meteorBabelHelpers.sanitizeForInObject(tokensListRest)) {                                          // 2137
        var token = tokensListRest[j];                                                                                 // 2138
        var equalsPos = token.indexOf('=');                                                                            // 2139
        if (equalsPos) {                                                                                               // 2140
          var key = token.slice(0, equalsPos).trim();                                                                  // 2141
          var value = token.slice(equalsPos + 1).trim();                                                               // 2142
                                                                                                                       //
          if (key === 'q') {                                                                                           // 2144
            temp.qValue = +value;                                                                                      // 2145
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      result.push(temp);                                                                                               // 2150
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return result;                                                                                                       // 2154
};                                                                                                                     //
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Regular HTTP request handling                                                                                       //
                                                                                                                       //
var readAll = function readAll(stream) {                                                                               // 2160
  return new Promise(function (resolve, reject) {                                                                      // 2161
    var buffers = [];                                                                                                  // 2162
    stream.on('data', function (buf) {                                                                                 // 2163
      buffers.push(buf);                                                                                               // 2164
    });                                                                                                                //
                                                                                                                       //
    stream.on('end', function () {                                                                                     // 2167
      resolve(Buffer.concat(buffers));                                                                                 // 2168
    });                                                                                                                //
                                                                                                                       //
    stream.on('error', reject);                                                                                        // 2171
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
var makeSetCookieHeader = function makeSetCookieHeader(cookie) {                                                       // 2175
  var result = [cookie.name, '=', cookie.value];                                                                       // 2176
                                                                                                                       //
  if ('absolute' in cookie.expires) {                                                                                  // 2178
    result.push('; Expires=');                                                                                         // 2179
    result.push(new Date(cookie.expires.absolute * 1000).toUTCString());                                               // 2180
  } else if ('relative' in cookie.expires) {                                                                           //
    result.push('; Max-Age=' + cookie.expires.relative);                                                               // 2182
  }                                                                                                                    //
                                                                                                                       //
  if (cookie.path) {                                                                                                   // 2185
    result.push('; Path=' + cookie.path);                                                                              // 2186
  }                                                                                                                    //
                                                                                                                       //
  if (cookie.httpOnly) {                                                                                               // 2189
    result.push('; HttpOnly');                                                                                         // 2190
  }                                                                                                                    //
                                                                                                                       //
  return result.join('');                                                                                              // 2193
};                                                                                                                     //
                                                                                                                       //
// TODO(cleanup):  Auto-generate based on annotations in web-session.capnp.                                            //
var successCodes = {                                                                                                   // 2197
  ok: { id: 200, title: 'OK' },                                                                                        // 2198
  created: { id: 201, title: 'Created' },                                                                              // 2199
  accepted: { id: 202, title: 'Accepted' },                                                                            // 2200
  multiStatus: { id: 207, title: 'Multi-Status' }                                                                      // 2201
};                                                                                                                     //
var noContentSuccessCodes = [                                                                                          // 2203
// Indexed by shouldResetForm * 1                                                                                      //
{ id: 204, title: 'No Content' }, { id: 205, title: 'Reset Content' }];                                                // 2205
var redirectCodes = [                                                                                                  // 2208
// Indexed by switchToGet * 2 + isPermanent                                                                            //
{ id: 307, title: 'Temporary Redirect' }, { id: 308, title: 'Permanent Redirect' }, { id: 303, title: 'See Other' }, { id: 301, title: 'Moved Permanently' }];
var errorCodes = {                                                                                                     // 2215
  badRequest: { id: 400, title: 'Bad Request' },                                                                       // 2216
  forbidden: { id: 403, title: 'Forbidden' },                                                                          // 2217
  notFound: { id: 404, title: 'Not Found' },                                                                           // 2218
  methodNotAllowed: { id: 405, title: 'Method Not Allowed' },                                                          // 2219
  notAcceptable: { id: 406, title: 'Not Acceptable' },                                                                 // 2220
  conflict: { id: 409, title: 'Conflict' },                                                                            // 2221
  gone: { id: 410, title: 'Gone' },                                                                                    // 2222
  requestEntityTooLarge: { id: 413, title: 'Request Entity Too Large' },                                               // 2223
  requestUriTooLong: { id: 414, title: 'Request-URI Too Long' },                                                       // 2224
  unsupportedMediaType: { id: 415, title: 'Unsupported Media Type' },                                                  // 2225
  imATeapot: { id: 418, title: 'I\'m a teapot' },                                                                      // 2226
  unprocessableEntity: { id: 422, title: 'Unprocessable Entity' }                                                      // 2227
};                                                                                                                     //
                                                                                                                       //
ResponseStream = function () {                                                                                         // 2230
  // Note: This class is used in pre-meteor.js as well as in this file.                                                //
                                                                                                                       //
  function ResponseStream(response, httpCode, httpStatus, resolve, reject) {                                           // 2233
    var _this7 = this;                                                                                                 //
                                                                                                                       //
    (0, _classCallCheck3["default"])(this, ResponseStream);                                                            //
                                                                                                                       //
    // This is stupidly complicated, because:                                                                          //
    // - New versions of sandstorm-http-bridge (and other well-behaved apps) wait on write()                           //
    //   completion for flow control, so we want write() to complete only when there is space                          //
    //   available for more writes.                                                                                    //
    // - Old versions of sandstorm-http-bridge would make a zillion simultaneous calls to write()                      //
    //   with all of the data they wanted to send without waiting for previous calls to complete.                      //
    //   While in-flight, these writes can consume a lot of RAM at multiple points in the system.                      //
    // - Old versions of sandstorm-http-bridge would print any thrown error to stderr and then                         //
    //   keep going. So if canceling a download early on causes all future write()s to fail, this                      //
    //   can lead to very excessive log spam.                                                                          //
    // - If a write() fails to complete (it returns a promise that never resolves), then later                         //
    //   upon garbage collection the RPC will actually throw an exception about a PromiseFulfiller                     //
    //   never having been fulfilled. Hence, if we simply stop responding to write()s after some                       //
    //   point, we again get log spam.                                                                                 //
    // - If the connection closes during a write, Node never calls the completion callback at all.                     //
    //   We have to listen for the "close" event.                                                                      //
                                                                                                                       //
    this.response = response;                                                                                          // 2251
    this.httpCode = httpCode;                                                                                          // 2252
    this.httpStatus = httpStatus;                                                                                      // 2253
    this.resolve = resolve;                                                                                            // 2254
    this.reject = reject;                                                                                              // 2255
                                                                                                                       //
    this.started = false;                                                                                              // 2257
    this.ended = false;                                                                                                // 2258
    this.waiting = [];                                                                                                 // 2259
                                                                                                                       //
    response.on("drain", function () {                                                                                 // 2261
      _this7.waiting.forEach(function (f) {                                                                            // 2262
        return f();                                                                                                    //
      });                                                                                                              //
      _this7.waiting = [];                                                                                             // 2263
    });                                                                                                                //
                                                                                                                       //
    response.on("close", function () {                                                                                 // 2266
      _this7.aborted = true;                                                                                           // 2267
                                                                                                                       //
      // Resolve all outstanding writes. This is OK even if they didn't actually go through because                    //
      // an incomplete download is the client's problem, not the server's. The important thing is                      //
      // to cancel the stream if it is still being generated; to that end, the next new write()                        //
      // call after this point will throw.                                                                             //
      _this7.waiting.forEach(function (f) {                                                                            // 2266
        return f();                                                                                                    //
      });                                                                                                              //
      _this7.waiting = [];                                                                                             // 2274
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  ResponseStream.prototype.expectSize = function () {                                                                  // 2230
    function expectSize(size) {                                                                                        //
      if (!this.started) {                                                                                             // 2279
        this.started = true;                                                                                           // 2280
        this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": size });                           // 2281
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return expectSize;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  ResponseStream.prototype.write = function () {                                                                       // 2230
    function write(data) {                                                                                             //
      var _this8 = this;                                                                                               //
                                                                                                                       //
      if (!this.started) {                                                                                             // 2286
        this.started = true;                                                                                           // 2287
        this.response.writeHead(this.httpCode, this.httpStatus);                                                       // 2288
      }                                                                                                                //
                                                                                                                       //
      if (this.aborted) {                                                                                              // 2291
        // Connection has been aborted.                                                                                //
        if (this.alreadyThrew) {                                                                                       // 2293
          // We already threw an error from a previous write(). Do not throw more errors, because                      //
          // older versions of sandstorm-http-bridge do not stop on the first error and will print                     //
          // every error to the log, wasting space. Newer versions stop on the first failure.                          //
          return;                                                                                                      // 2297
        } else {                                                                                                       //
          this.alreadyThrew = true;                                                                                    // 2299
          throw new Error("client disconnected");                                                                      // 2300
        }                                                                                                              //
      } else {                                                                                                         //
        if (this.response.write(data)) {                                                                               // 2303
          // All written.                                                                                              //
          return;                                                                                                      // 2305
        } else {                                                                                                       //
          // Write buffer is full. Don't complete until it has more space.                                             //
          if (this.waiting.length >= 16) {                                                                             // 2308
            // Yikes, there are 16 writes in-flight already. Probably, the caller does not implement                   //
            // flow control, and is going to do *all* of its writes in parallel. Since the caller                      //
            // is ignoring returns anyway, we might as well shed load from the Cap'n Proto tables                      //
            // by closing out the earlier calls.                                                                       //
            this.waiting.shift()();                                                                                    // 2313
          }                                                                                                            //
                                                                                                                       //
          return new Promise(function (resolve, reject) {                                                              // 2316
            _this8.waiting.push(resolve);                                                                              // 2317
          });                                                                                                          //
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return write;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  ResponseStream.prototype.done = function () {                                                                        // 2230
    function done() {                                                                                                  //
      if (!this.started) {                                                                                             // 2324
        this.started = true;                                                                                           // 2325
        this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": 0 });                              // 2326
      }                                                                                                                //
                                                                                                                       //
      this.response.end();                                                                                             // 2329
      this.ended = true;                                                                                               // 2330
    }                                                                                                                  //
                                                                                                                       //
    return done;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  ResponseStream.prototype.close = function () {                                                                       // 2230
    function close() {                                                                                                 //
      if (this.ended) {                                                                                                // 2334
        if (this.resolve) this.resolve();                                                                              // 2335
      } else {                                                                                                         //
        if (this.reject) this.reject(new Error('done() was never called on outbound stream.'));                        // 2337
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  return ResponseStream;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
// TODO(cleanup): Node 0.12 has a `gunzipSync` but 0.10 (which Meteor still uses) does not.                            //
var Zlib = Npm.require('zlib');                                                                                        // 2343
var gunzipSync = Meteor.wrapAsync(Zlib.gunzip, Zlib);                                                                  // 2344
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// WebSocket handling                                                                                                  //
                                                                                                                       //
WebSocketReceiver = function () {                                                                                      // 2349
  function WebSocketReceiver(socket) {                                                                                 // 2350
    (0, _classCallCheck3["default"])(this, WebSocketReceiver);                                                         //
                                                                                                                       //
    this.socket = socket;                                                                                              // 2351
    this.queue = [];                                                                                                   // 2352
  }                                                                                                                    //
                                                                                                                       //
  WebSocketReceiver.prototype.go = function () {                                                                       // 2349
    function go() {                                                                                                    //
      for (var i in meteorBabelHelpers.sanitizeForInObject(this.queue)) {                                              // 2356
        this.socket.write(this.queue[i]);                                                                              // 2357
      }                                                                                                                //
                                                                                                                       //
      this.queue = null;                                                                                               // 2360
    }                                                                                                                  //
                                                                                                                       //
    return go;                                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  WebSocketReceiver.prototype.sendBytes = function () {                                                                // 2349
    function sendBytes(message) {                                                                                      //
      // TODO(someday):  Flow control of some sort?                                                                    //
      if (this.queue === null) {                                                                                       // 2365
        this.socket.write(message);                                                                                    // 2366
      } else {                                                                                                         //
        this.queue.push(message);                                                                                      // 2368
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return sendBytes;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  WebSocketReceiver.prototype.close = function () {                                                                    // 2349
    function close() {                                                                                                 //
      this.socket.end();                                                                                               // 2373
    }                                                                                                                  //
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  return WebSocketReceiver;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
pumpWebSocket = function pumpWebSocket(socket, rpcStream, destructor) {                                                // 2377
  socket.on('data', function (chunk) {                                                                                 // 2378
    rpcStream.sendBytes(chunk)["catch"](function (err) {                                                               // 2379
      if (err.kjType !== 'disconnected') {                                                                             // 2380
        console.error('WebSocket sendBytes failed: ' + err.stack);                                                     // 2381
      }                                                                                                                //
                                                                                                                       //
      socket.destroy();                                                                                                // 2384
    });                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  socket.on('end', function (chunk) {                                                                                  // 2388
    rpcStream.close();                                                                                                 // 2389
  });                                                                                                                  //
                                                                                                                       //
  socket.on("close", function () {                                                                                     // 2392
    destructor();                                                                                                      // 2393
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// Debug log access                                                                                                    //
                                                                                                                       //
Meteor.publish('grainLog', function (grainId) {                                                                        // 2400
  var _this9 = this;                                                                                                   //
                                                                                                                       //
  check(grainId, String);                                                                                              // 2401
  var id = 0;                                                                                                          // 2402
  var grain = Grains.findOne(grainId);                                                                                 // 2403
  if (!grain || !this.userId || grain.userId !== this.userId) {                                                        // 2404
    this.added('grainLog', id++, { text: 'Only the grain owner can view the debug log.' });                            // 2405
    this.ready();                                                                                                      // 2406
    return;                                                                                                            // 2407
  }                                                                                                                    //
                                                                                                                       //
  var connected = false;                                                                                               // 2410
  var _this = this;                                                                                                    // 2411
                                                                                                                       //
  var receiver = {                                                                                                     // 2413
    write: function () {                                                                                               // 2414
      function write(data) {                                                                                           //
        connected = true;                                                                                              // 2415
        _this.added('grainLog', id++, { text: data.toString('utf8') });                                                // 2416
      }                                                                                                                //
                                                                                                                       //
      return write;                                                                                                    //
    }(),                                                                                                               //
    close: function () {                                                                                               // 2419
      function close() {                                                                                               //
        if (connected) {                                                                                               // 2420
          _this.added('grainLog', id++, {                                                                              // 2421
            text: '*** lost connection to grain (probably because it shut down) ***'                                   // 2422
          });                                                                                                          //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return close;                                                                                                    //
    }()                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  try {                                                                                                                // 2428
    (function () {                                                                                                     //
      var handle = waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                 // 2429
        return supervisor.watchLog(8192, receiver);                                                                    // 2430
      })).handle;                                                                                                      //
      connected = true;                                                                                                // 2432
      _this9.onStop(function () {                                                                                      // 2433
        handle.close();                                                                                                // 2434
      });                                                                                                              //
    })();                                                                                                              //
  } catch (err) {                                                                                                      //
    if (!connected) {                                                                                                  // 2437
      this.added('grainLog', id++, {                                                                                   // 2438
        text: '*** couldn\'t connect to grain (' + err + ') ***'                                                       // 2439
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 2400
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"sandcats.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/sandcats.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Sandcats = {};                                                                                                         // 17
                                                                                                                       //
var querystring = Npm.require("querystring");                                                                          // 19
var https = Npm.require("https");                                                                                      // 20
var fs = Npm.require("fs");                                                                                            // 21
var dgram = Npm.require("dgram");                                                                                      // 22
var Url = Npm.require("url");                                                                                          // 23
                                                                                                                       //
var SANDCATS_HOSTNAME = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].sandcatsHostname;    // 25
var SANDCATS_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandcats";                                                     // 27
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 29
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 30
var SANDCATS_NAME = void 0; // Look at `startup` below to see where this is set                                        // 31
                                                                                                                       //
var updateSandcatsIp = function updateSandcatsIp() {                                                                   // 33
  var responseCallback = function responseCallback(res) {                                                              // 34
    if (res.statusCode === 200) {                                                                                      // 35
      console.log("Successfully updated sandcats IP");                                                                 // 36
    } else {                                                                                                           //
      console.error("Failed to update sandcats IP:", res.headers);                                                     // 38
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  var errorCallback = function errorCallback(err) {                                                                    // 42
    console.error("Couldn't send update sandcats hostname", err);                                                      // 43
  };                                                                                                                   //
                                                                                                                       //
  performSandcatsRequest("/update", SANDCATS_HOSTNAME, { rawHostname: SANDCATS_NAME }, errorCallback, responseCallback);
};                                                                                                                     //
                                                                                                                       //
var pingUdp = function pingUdp() {                                                                                     // 50
  var socket = dgram.createSocket("udp4");                                                                             // 51
  var secret = Random.secret(16);                                                                                      // 52
                                                                                                                       //
  message = new Buffer(SANDCATS_NAME + " " + secret);                                                                  // 54
  socket.on("message", function (buf) {                                                                                // 55
    if (buf.toString() === secret) {                                                                                   // 56
      updateSandcatsIp();                                                                                              // 57
    } else {                                                                                                           //
      console.error("Received unexpected response in UDP sandcats ping:", buf.toString());                             // 59
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  socket.send(message, 0, message.length, 8080, SANDCATS_HOSTNAME, function (err) {                                    // 63
    if (err) {                                                                                                         // 64
      console.error("Couldn't send UDP sandcats ping", err);                                                           // 65
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  Meteor.setTimeout(function () {                                                                                      // 69
    socket.close();                                                                                                    // 70
  }, 10 * 1000);                                                                                                       //
};                                                                                                                     //
                                                                                                                       //
var performSandcatsRequest = function performSandcatsRequest(path, hostname, postData, errorCallback, responseCallback) {
  var options = {                                                                                                      // 75
    hostname: hostname,                                                                                                // 76
    path: path,                                                                                                        // 77
    method: "POST",                                                                                                    // 78
    agent: false,                                                                                                      // 79
    key: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa"),                                                                 // 80
    cert: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa.pub"),                                                            // 81
    headers: {                                                                                                         // 82
      "X-Sand": "cats",                                                                                                // 83
      "Content-Type": "application/x-www-form-urlencoded"                                                              // 84
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  if (postData.certificateSigningRequest) {                                                                            // 88
    console.log("Submitting certificate request for host", postData.rawHostname, "where the request has length", postData.certificateSigningRequest.length);
  }                                                                                                                    //
                                                                                                                       //
  var newPostData = querystring.stringify(postData);                                                                   // 94
  if (SANDCATS_HOSTNAME === "sandcats-dev.sandstorm.io" && !process.env.NODE_TLS_REJECT_UNAUTHORIZED) {                // 95
    console.log("You are using the Sandcats dev server but have full HTTPS " + "certificate checking enabled. Probably you will get an HTTPS " + "error. Proceeding anyway.");
  }                                                                                                                    //
                                                                                                                       //
  var req = https.request(options, responseCallback);                                                                  // 102
  req.write(newPostData);                                                                                              // 103
  req.end();                                                                                                           // 104
                                                                                                                       //
  if (errorCallback) {                                                                                                 // 106
    req.on("error", errorCallback);                                                                                    // 107
  }                                                                                                                    //
                                                                                                                       //
  return req;                                                                                                          // 110
};                                                                                                                     //
                                                                                                                       //
var generateKeyAndCsr = function generateKeyAndCsr(commonName) {                                                       // 113
  // This function relies on the this.forge object created by the                                                      //
  // meteor-node-forge package.                                                                                        //
  check(commonName, String);                                                                                           // 116
                                                                                                                       //
  // Generate key pair. Using Meteor.wrapAsync because forge supports                                                  //
  // a synchronous as well as an asynchronous API, and the synchronous                                                 //
  // one blocks for a while.                                                                                           //
  var wrappedGenerateKeyPair = Meteor.wrapAsync(_this.forge.pki.rsa.generateKeyPair);                                  // 113
                                                                                                                       //
  // I could pick an `e`[xponent] value for the resulting RSA key, but                                                 //
  // I will refrain.                                                                                                   //
  var keys = wrappedGenerateKeyPair({ bits: 2048 });                                                                   // 113
                                                                                                                       //
  // Create a certificate request (CSR).                                                                               //
  var csr = _this.forge.pki.createCertificationRequest();                                                              // 113
  csr.publicKey = keys.publicKey;                                                                                      // 129
  csr.setSubject([{                                                                                                    // 130
    name: "commonName",                                                                                                // 132
    value: commonName,                                                                                                 // 133
    valueTagClass: _this.forge.asn1.Type.UTF8                                                                          // 134
  }]);                                                                                                                 //
  // We specify UTF8 to encode a UTF8String (rather than the default of PRINTABLESTRING) in the                        //
  // commonName so that GlobalSign does not report a warning, and also because that happens to                         //
  // be what openssl(1) does when asked to create a CSR.                                                               //
  csr.sign(keys.privateKey);                                                                                           // 140
  console.log("generateKeyAndCsr created new key & certificate request for", commonName);                              // 141
  return {                                                                                                             // 142
    privateKeyAsPem: _this.forge.pki.privateKeyToPem(keys.privateKey),                                                 // 143
    csrAsPem: _this.forge.pki.certificationRequestToPem(csr)                                                           // 144
  };                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
Sandcats.storeNewKeyAndCsr = function (hostname, basePath) {                                                           // 148
  // We use the current JS time (like UNIX timestamp but in                                                            //
  // milliseconds) as the key number. Note that the keyNumber is                                                       //
  // intended to be an opaque identifier; the only important thing is                                                  //
  // that it increases numerically over time. We use the current time                                                  //
  // just as a simplistic way to pick a filename that probably no one                                                  //
  // else has created yet.                                                                                             //
  var keyNumber = new Date().getTime();                                                                                // 155
  var keyFilename = basePath + "/" + keyNumber;                                                                        // 156
  var csrFilename = keyFilename + ".csr";                                                                              // 157
  var responseFilename = keyFilename + ".response-json";                                                               // 158
  var withWildcard = "*." + hostname;                                                                                  // 159
  var keyAndCsr = generateKeyAndCsr(withWildcard);                                                                     // 160
  fs.writeFileSync(keyFilename, keyAndCsr.privateKeyAsPem, { mode: 0400 });                                            // 161
  fs.writeFileSync(csrFilename, keyAndCsr.csrAsPem);                                                                   // 163
  console.log("storeNewKeyAndCsr successfully saved key and certificate request to", keyFilename, "and", csrFilename, "respectively of length", keyAndCsr.privateKeyAsPem.length, "and", keyAndCsr.csrAsPem.length);
  return {                                                                                                             // 168
    csrFilename: csrFilename,                                                                                          // 169
    keyFilename: keyFilename,                                                                                          // 170
    responseFilename: responseFilename                                                                                 // 171
  };                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
Sandcats.renewHttpsCertificateIfNeeded = function () {                                                                 // 175
  var renewHttpsCertificate = function renewHttpsCertificate() {                                                       // 176
    var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                           // 177
    var basePath = "/var/sandcats/https/" + hostname;                                                                  // 178
    var filenames = Sandcats.storeNewKeyAndCsr(hostname, basePath);                                                    // 179
                                                                                                                       //
    var errorCallback = function errorCallback(err) {                                                                  // 181
      console.error("Error while renewing HTTPS certificate (will continue to retry)", err);                           // 182
    };                                                                                                                 //
                                                                                                                       //
    var responseCallback = function responseCallback(res) {                                                            // 185
      if (res.statusCode == 200) {                                                                                     // 186
        (function () {                                                                                                 //
          // Save the response, chunk by chunk, then store it on disk                                                  //
          // for later use.                                                                                            //
          var responseBody = "";                                                                                       // 189
          res.on("data", function (chunk) {                                                                            // 190
            responseBody += chunk;                                                                                     // 191
          });                                                                                                          //
                                                                                                                       //
          res.on("end", function () {                                                                                  // 194
            // For sanity, make sure it parses as JSON, since we're                                                    //
            // going to need it to do that.                                                                            //
            try {                                                                                                      // 197
              JSON.parse(responseBody);                                                                                // 198
            } catch (e) {                                                                                              //
              console.error("JSON parse error receiving new HTTPS certificate. Discarding:", responseBody, "due to exception:", e);
              // Overwrite the responseBody with the empty JSON object                                                 //
              // and continue with the process of saving it to disk.                                                   //
              responseBody = "{}";                                                                                     // 199
            }                                                                                                          //
                                                                                                                       //
            try {                                                                                                      // 209
              fs.writeFileSync(filenames.responseFilename, responseBody, "utf-8");                                     // 210
            } catch (err) {                                                                                            //
              return console.error("Failure while saveing new HTTPS certificate to", filenames.responseFilename, "will continue to retry. Exception was:", err);
            }                                                                                                          //
                                                                                                                       //
            // Tell Sandcats that now is a good time to update its info                                                //
            // about which keys are available.                                                                         //
            if (!global.sandcats) {                                                                                    // 194
              console.error("When getting new certificate, could not find callback to request re-keying! Certs will probably become invalid soon.");
            } else {                                                                                                   //
              // Call the sandcats rekeying function.                                                                  //
              global.sandcats.rekey();                                                                                 // 224
              // That's that.                                                                                          //
              console.log("Successfully renewed HTTPS certificate into", filenames.responseFilename);                  // 222
            }                                                                                                          //
          });                                                                                                          //
        })();                                                                                                          //
      } else {                                                                                                         //
        console.log("Received HTTP error while renewing certificate (will keep retrying)", res.statusCode);            // 231
        res.on("data", function (chunk) {                                                                              // 233
          console.log("Error response contained information", chunk.toString("utf-8"));                                // 234
        });                                                                                                            //
      }                                                                                                                //
    };                                                                                                                 //
                                                                                                                       //
    var wrappedReadFile = Meteor.wrapAsync(fs.readFile);                                                               // 239
                                                                                                                       //
    performSandcatsRequest("/getcertificate", SANDCATS_HOSTNAME, {                                                     // 241
      rawHostname: SANDCATS_NAME,                                                                                      // 242
      certificateSigningRequest: wrappedReadFile(filenames.csrFilename, "utf-8")                                       // 243
    }, errorCallback, responseCallback);                                                                               //
  };                                                                                                                   //
                                                                                                                       //
  if (global.sandcats.shouldGetAnotherCertificate()) {                                                                 // 247
    console.log("renewHttpsCertificateIfNeeded: Happily choosing to renew certificate.");                              // 248
    return renewHttpsCertificate();                                                                                    // 249
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Sandcats.initializeSandcats = function () {                                                                            // 253
  var i = HOSTNAME.lastIndexOf(SANDCATS_HOSTNAME);                                                                     // 254
  if (i < 0) {                                                                                                         // 255
    console.error("SANDCATS_BASE_DOMAIN is configured but your HOSTNAME doesn't appear to contain it:", SANDCATS_HOSTNAME, HOSTNAME);
  } else {                                                                                                             //
    var oneMinute = 60 * 1000;                                                                                         // 259
    var oneHour = 60 * oneMinute;                                                                                      // 260
    var randomIntervalZeroToOneHour = Math.random() * oneHour;                                                         // 261
    // All Sandcats installs need dyndns updating.                                                                     //
    SANDCATS_NAME = HOSTNAME.slice(0, i - 1);                                                                          // 258
    Meteor.setInterval(pingUdp, oneMinute);                                                                            // 264
    // If process.env.HTTPS_PORT is set, we need to auto-refresh our HTTPS certificate.                                //
    if (process.env.HTTPS_PORT) {                                                                                      // 258
      // Always do a HTTPS certificate update check on Sandstorm start.                                                //
      Sandcats.renewHttpsCertificateIfNeeded();                                                                        // 268
                                                                                                                       //
      // After that's done, schedule it for every approx 1-2 hours in                                                  //
      // the future.                                                                                                   //
      Meteor.setInterval(Sandcats.renewHttpsCertificateIfNeeded, oneHour + randomIntervalZeroToOneHour);               // 266
    }                                                                                                                  //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
if (SANDCATS_HOSTNAME) {                                                                                               // 278
  Meteor.startup(Sandcats.initializeSandcats);                                                                         // 279
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"shell-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/shell-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Set up browser policy.                                                                                              //
//                                                                                                                     //
// Note that by default (when the browser-policy package is added), Content-Security-Policy will                       //
// already be set to same-origin-only for everything except XHR and WebSocket. Eval is disabled,                       //
// but inline script are enabled.                                                                                      //
//                                                                                                                     //
// TODO(security): Consider disallowing inline scripts. Currently this forces Meteor to do an                          //
//   extra round trip on startup to fetch server settings. That seems like something that could                        //
//   be fixed in Meteor (e.g. embed the settings as JSON text rather than script). Startup time                        //
//   is incredibly important, and Meteor's templating system (which we use to render all our                           //
//   HTML) already does a good job of protecting us from script injection, so right now I think                        //
//   we should favor avoiding the round trip.                                                                          //
//                                                                                                                     //
// TODO(someday): Detect when an app tries to navigate off-site using CSP's violation reporting                        //
//   feature. Ask the user whether they want to open the link in a new tab. This is an annoying                        //
//   prompt, but if we just open the tab directly then apps can trivially leak by opening tabs                         //
//   with encoded URLs to an evil server. Although, this attack would be very detectable to the                        //
//   user, so maybe it's not a big deal...                                                                             //
                                                                                                                       //
BrowserPolicy.framing.disallow(); // Disallow framing of the UI.                                                       // 36
BrowserPolicy.content.allowFrameOrigin(getWildcardOrigin());                                                           // 37
                                                                                                                       //
// Allow anything to be loaded from the static asset host.                                                             //
var Url = Npm.require("url");                                                                                          // 40
var staticAssetHost = Url.parse(process.env.ROOT_URL).protocol + "//" + globalDb.makeWildcardHost("static");           // 41
BrowserPolicy.content.allowImageOrigin(staticAssetHost);                                                               // 43
BrowserPolicy.content.allowScriptOrigin(staticAssetHost);                                                              // 44
BrowserPolicy.content.allowFontOrigin(staticAssetHost);                                                                // 45
BrowserPolicy.content.allowConnectOrigin(staticAssetHost);                                                             // 46
                                                                                                                       //
Meteor.publish("grainsMenu", function () {                                                                             // 48
  var _this = this;                                                                                                    //
                                                                                                                       //
  if (this.userId) {                                                                                                   // 49
    if (Meteor.settings["public"].quotaEnabled) {                                                                      // 50
      (function () {                                                                                                   //
        // Hack: Fire off an asynchronous update to the user's storage usage whenever they open the                    //
        //   front page.                                                                                               //
        // TODO(someday): Implement the ability to reactively subscribe to storage usage from the                      //
        //   back-end?                                                                                                 //
        var userId = _this.userId;                                                                                     // 55
        globalBackend.cap().getUserStorageUsage(userId).then(function (results) {                                      // 56
          inMeteor(function () {                                                                                       // 57
            Meteor.users.update(userId, { $set: { storageUsage: parseInt(results.size) } });                           // 58
          });                                                                                                          //
        })["catch"](function (err) {                                                                                   //
          if (err.kjType !== "unimplemented") {                                                                        // 61
            console.error(err.stack);                                                                                  // 62
          }                                                                                                            //
        });                                                                                                            //
      })();                                                                                                            //
    }                                                                                                                  //
                                                                                                                       //
    var identityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                   // 67
    return [UserActions.find({ userId: this.userId }), Grains.find({ userId: this.userId }), ApiTokens.find({ "owner.user.identityId": { $in: identityIds } })];
  } else {                                                                                                             //
    return [];                                                                                                         // 74
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("sessions", function (sessionId) {                                                                      // 78
  // sessionId itself should be secret enough, but they are also not meant to be shared, so as                         //
  // a backup we only publish the session to its owner. Note that `userId` can be null if the                          //
  // user is not logged in or is using incognito mode.                                                                 //
  check(sessionId, String);                                                                                            // 82
  return Sessions.find({ _id: sessionId, $or: [{ userId: this.userId }, { userId: null }] });                          // 83
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("devPackages", function () {                                                                            // 86
  return DevPackages.find();                                                                                           // 87
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("notifications", function () {                                                                          // 90
  return Notifications.find({ userId: this.userId }, { fields: { timestamp: 1, text: 1, grainId: 1, userId: 1, isUnread: 1, appUpdates: 1,
      admin: 1, referral: 1, mailingListBonus: 1 } });                                                                 // 93
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("notificationGrains", function (notificationIds) {                                                      // 96
  // Since publishes can't be reactive, we leave it to the client to subscribe to both                                 //
  // "notifications" and "notificationGrains" reactively.                                                              //
  check(notificationIds, [String]);                                                                                    // 99
  var notifications = Notifications.find({                                                                             // 100
    _id: { $in: notificationIds },                                                                                     // 101
    userId: this.userId                                                                                                // 102
  }, {                                                                                                                 //
    fields: { grainId: 1 }                                                                                             // 104
  });                                                                                                                  //
                                                                                                                       //
  var grainIds = notifications.map(function (row) {                                                                    // 107
    return row.grainId;                                                                                                // 108
  });                                                                                                                  //
                                                                                                                       //
  return Grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } });                                            // 111
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("hasUsers", function () {                                                                               // 114
  var _this2 = this;                                                                                                   //
                                                                                                                       //
  // Publish pseudo-collection which tells the client if there are any users at all.                                   //
  //                                                                                                                   //
  // TODO(cleanup):  This seems overcomplicated.  Does Meteor have a better way?                                       //
  var cursor = Meteor.users.find();                                                                                    // 118
  if (cursor.count() > 0) {                                                                                            // 119
    this.added("hasUsers", "hasUsers", { hasUsers: true });                                                            // 120
  } else {                                                                                                             //
    (function () {                                                                                                     //
      var handle = cursor.observeChanges({                                                                             // 122
        added: function () {                                                                                           // 123
          function added(id) {                                                                                         // 123
            _this2.added("hasUsers", "hasUsers", { hasUsers: true });                                                  // 124
            handle.stop();                                                                                             // 125
            handle = null;                                                                                             // 126
          }                                                                                                            //
                                                                                                                       //
          return added;                                                                                                //
        }()                                                                                                            //
      });                                                                                                              //
      _this2.onStop(function () {                                                                                      // 129
        if (handle) handle.stop();                                                                                     // 130
      });                                                                                                              //
    })();                                                                                                              //
  }                                                                                                                    //
                                                                                                                       //
  this.ready();                                                                                                        // 134
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("referralInfoPseudo", function () {                                                                     // 137
  var _this3 = this;                                                                                                   //
                                                                                                                       //
  // This publishes a pseudo-collection called referralInfo whose documents have the following                         //
  // form:                                                                                                             //
  //                                                                                                                   //
  // - id: (String) same as the User._id of an identity this user has referred                                         //
  // - name: (String) the profile.name from that identity                                                              //
  // - completed: (Boolean) if this referral is complete                                                               //
                                                                                                                       //
  //  If the user is not logged in, then we have no referralInfo.                                                      //
  if (!this.userId) {                                                                                                  // 146
    return [];                                                                                                         // 147
  }                                                                                                                    //
                                                                                                                       //
  // Implementation note:                                                                                              //
  //                                                                                                                   //
  // This pseudo-collection is populated very differently for (1) the completed: false case versus                     //
  // the (2) completed: true case.                                                                                     //
                                                                                                                       //
  // Case 1. Publish information about not-yet-complete referrals.                                                     //
  var notCompletedReferralIdentitiesCursor = Meteor.users.find({                                                       // 137
    referredBy: this.userId,                                                                                           // 157
    "profile.name": { $exists: true }                                                                                  // 158
  }, {                                                                                                                 //
    fields: {                                                                                                          // 160
      _id: 1,                                                                                                          // 161
      referredBy: 1,                                                                                                   // 162
      "profile.name": 1                                                                                                // 163
    }                                                                                                                  //
  });                                                                                                                  //
  var notCompletedReferralIdentitiesHandle = notCompletedReferralIdentitiesCursor.observeChanges({                     // 166
    // The added function gets called with the id of Bob when Alice refers Bob.                                        //
    added: function () {                                                                                               // 168
      function added(id, fields) {                                                                                     // 168
        _this3.added("referralInfo", id, { name: fields.profile.name, completed: false });                             // 169
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
    // The removed function gets called when Bob is no longer an uncompleted referral.  Note that                      //
    // this will get more complicated once we support sending completed referrals to the client.                       //
    removed: function () {                                                                                             // 173
      function removed(id) {                                                                                           // 173
        _this3.removed("referralInfo", id);                                                                            // 174
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }(),                                                                                                               //
    // The modified function gets called when Bob's profile.name changed.                                              //
    modified: function () {                                                                                            // 177
      function modified(id, fields) {                                                                                  // 177
        _this3.modified("referralInfo", id, { name: fields.profile.name, completed: false });                          // 178
      }                                                                                                                //
                                                                                                                       //
      return modified;                                                                                                 //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  // Case 2. Handle completed referrals.                                                                               //
  //                                                                                                                   //
  // - Do a query for the current list of completed identities.                                                        //
  //                                                                                                                   //
  // - Every time we see a new such identity, we create a query that watches that one identity in                      //
  //   case its profile.name changes.                                                                                  //
  //                                                                                                                   //
  // - Also watch the first query, since the list of completed identities might change.                                //
  var handleForProfileNameByIdentityId = {};                                                                           // 137
  var stopWatchingAllIdentities = function stopWatchingAllIdentities() {                                               // 191
    Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                      // 192
      stopWatchingIdentity(identityId);                                                                                // 193
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  var stopWatchingIdentity = function stopWatchingIdentity(identityId) {                                               // 197
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 198
    if (handleForProfileName) {                                                                                        // 199
      _this3.removed("referralInfo", identityId);                                                                      // 200
      handleForProfileName.stop();                                                                                     // 201
      // delete is safe because we iterate across `Object.keys()` which returns a copy.                                //
      delete handleForProfileNameByIdentityId[identityId];                                                             // 199
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  var watchIdentityAndPublishReferralSuccess = function watchIdentityAndPublishReferralSuccess(identityId) {           // 207
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 208
    if (handleForProfileName) {                                                                                        // 209
      return;                                                                                                          // 210
    }                                                                                                                  //
                                                                                                                       //
    handleForProfileName = Meteor.users.find({                                                                         // 213
      _id: identityId                                                                                                  // 214
    }, {                                                                                                               //
      fields: {                                                                                                        // 216
        "profile.name": 1                                                                                              // 217
      }                                                                                                                //
    }).observeChanges({                                                                                                //
      added: function () {                                                                                             // 220
        function added(id, fields) {                                                                                   // 220
          _this3.added("referralInfo", id, { name: fields.profile.name, completed: true });                            // 221
        }                                                                                                              //
                                                                                                                       //
        return added;                                                                                                  //
      }(),                                                                                                             //
                                                                                                                       //
      changed: function () {                                                                                           // 224
        function changed(id, fields) {                                                                                 // 224
          _this3.changed("referralInfo", id, { name: fields.profile.name, completed: true });                          // 225
        }                                                                                                              //
                                                                                                                       //
        return changed;                                                                                                //
      }(),                                                                                                             //
                                                                                                                       //
      removed: function () {                                                                                           // 228
        function removed(id) {                                                                                         // 228
          stopWatchingIdentity(id);                                                                                    // 229
        }                                                                                                              //
                                                                                                                       //
        return removed;                                                                                                //
      }()                                                                                                              //
    });                                                                                                                //
                                                                                                                       //
    handleForProfileNameByIdentityId[identityId] = handleForProfileName;                                               // 233
  };                                                                                                                   //
                                                                                                                       //
  var completedIdentityIdsHandle = Meteor.users.find({                                                                 // 236
    _id: this.userId,                                                                                                  // 237
    referredIdentityIds: { $exists: true }                                                                             // 238
  }, {                                                                                                                 //
    fields: {                                                                                                          // 240
      referredIdentityIds: true                                                                                        // 241
    }                                                                                                                  //
  }).observeChanges({                                                                                                  //
    // `added` gets called when a user gets their first completed referral.                                            //
    added: function () {                                                                                               // 245
      function added(id, fields) {                                                                                     // 245
        for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                  // 246
          // Unconditionally mark these as successful referrals and start watching.                                    //
          watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                       // 248
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
    // `changed` gets called when a user adds/removes referredIdentityIds, usually when a                              //
    // referral becomes complete.                                                                                      //
    changed: function () {                                                                                             // 254
      function changed(id, fields) {                                                                                   // 254
        // Two major tasks.                                                                                            //
        //                                                                                                             //
        // 1. Look for identityIds to unsubscribe from & send removed notices to the client.                           //
        //                                                                                                             //
        // 2. Look for identityIds to subscribe to.                                                                    //
                                                                                                                       //
        // Task 1. Unsubscribe where needed.                                                                           //
        var referredIdentityIdsAsObject = {};                                                                          // 262
        fields.referredIdentityIds.forEach(function (i) {                                                              // 263
          referredIdentityIdsAsObject[i] = true;                                                                       // 263
        });                                                                                                            //
                                                                                                                       //
        Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                  // 265
          // If the handle doesn't show up in the new list of referredIdentityIds, then remove                         //
          // info from the client & stop it on the server & make it null.                                              //
          var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                     // 268
          if (referredIdentityIdsAsObject.hasOwnProperty(identityId)) {                                                // 269
            stopWatchingIdentity(identityId);                                                                          // 270
          }                                                                                                            //
        });                                                                                                            //
                                                                                                                       //
        // Task 2. Subscribe where needed.                                                                             //
        for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                  // 254
          // The watch... function will avoid double-creating subscriptions, so this is safe.                          //
          watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                       // 277
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }(),                                                                                                               //
    // `removed` gets called when a User suddenly has no referredIdentityIds.                                          //
    removed: function () {                                                                                             // 281
      function removed() {                                                                                             // 281
        // Remove all data from client; stop all handles.                                                              //
        stopWatchingAllIdentities();                                                                                   // 283
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  // With cases 1 and 2 handled, register a cleanup function, then declare victory.                                    //
  this.onStop(function () {                                                                                            // 137
    stopWatchingAllIdentities();                                                                                       // 289
    notCompletedReferralIdentitiesHandle.stop();                                                                       // 290
    completedIdentityIdsHandle.stop();                                                                                 // 291
  });                                                                                                                  //
                                                                                                                       //
  this.ready();                                                                                                        // 294
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("backers", function () {                                                                                // 297
  var _this4 = this;                                                                                                   //
                                                                                                                       //
  var backers = Assets.getText("backers.txt");                                                                         // 298
  var anonCount = 0;                                                                                                   // 299
  var counter = 0;                                                                                                     // 300
                                                                                                                       //
  backers.split("\n").forEach(function (name) {                                                                        // 302
    name = name.trim();                                                                                                // 303
    if (name === "") {                                                                                                 // 304
      ++anonCount;                                                                                                     // 305
    } else {                                                                                                           //
      _this4.added("backers", counter++, { name: name });                                                              // 307
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  // Text file ends in \n but that shouldn't count.                                                                    //
  --anonCount;                                                                                                         // 297
                                                                                                                       //
  this.added("backers", "anonymous", { count: anonCount - 1 });                                                        // 314
                                                                                                                       //
  this.ready();                                                                                                        // 316
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"signup-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/signup-server.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file covers creation and consumption of invite keys (i.e. to invite people to become                           //
// users of the Sandstorm server).                                                                                     //
                                                                                                                       //
Meteor.publish("signupKey", function (key) {                                                                           // 20
  check(key, String);                                                                                                  // 21
  return SignupKeys.find(key);                                                                                         // 22
});                                                                                                                    //
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  useSignupKey: function () {                                                                                          // 26
    function useSignupKey(key) {                                                                                       // 26
      check(key, String);                                                                                              // 27
                                                                                                                       //
      if (!this.userId) {                                                                                              // 29
        throw new Meteor.Error(403, "Must be signed in.");                                                             // 30
      }                                                                                                                //
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 33
      if (user.signupKey) {                                                                                            // 34
        // Don't waste it.                                                                                             //
        return;                                                                                                        // 36
      }                                                                                                                //
                                                                                                                       //
      if (isDemoUser()) {                                                                                              // 39
        throw new Meteor.Error(403, "Demo users cannot accept invite keys. Please sign in as a real user.");           // 40
      }                                                                                                                //
                                                                                                                       //
      if (!user.loginIdentities) {                                                                                     // 44
        // Don't consume signup key as identity user.                                                                  //
        return;                                                                                                        // 46
      }                                                                                                                //
                                                                                                                       //
      var keyInfo = SignupKeys.findOne(key);                                                                           // 49
      if (!keyInfo || keyInfo.used) {                                                                                  // 50
        throw new Meteor.Error(403, "Invalid key or already used.");                                                   // 51
      }                                                                                                                //
                                                                                                                       //
      if (isSignedUp() && user.payments && user.payments.id) {                                                         // 54
        // This user is already signed up with a payment account. Possibly, they signed up before                      //
        // using their invite, and then went back and clicked on the invite. As a result they                          //
        // probably now have two payment accounts. Mark this invite as used but also add a special                     //
        // flag so we can find it later and cancel the dupe payment account. Record who tried to                       //
        // use it so that we can transfer credits over if needed.                                                      //
        SignupKeys.update(key, { $set: { used: true, rejectedBy: this.userId } });                                     // 60
        return;                                                                                                        // 61
      }                                                                                                                //
                                                                                                                       //
      var userFields = {                                                                                               // 64
        signupKey: key,                                                                                                // 65
        signupNote: keyInfo.note                                                                                       // 66
      };                                                                                                               //
      if (keyInfo.email) {                                                                                             // 68
        userFields.signupEmail = keyInfo.email;                                                                        // 69
      }                                                                                                                //
                                                                                                                       //
      if ("quota" in keyInfo) {                                                                                        // 72
        userFields.quota = keyInfo.quota;                                                                              // 73
      }                                                                                                                //
                                                                                                                       //
      if (keyInfo.plan) {                                                                                              // 76
        userFields.plan = keyInfo.plan;                                                                                // 77
      }                                                                                                                //
                                                                                                                       //
      if (keyInfo.payments) {                                                                                          // 80
        userFields["payments.id"] = keyInfo.payments.id;                                                               // 81
      }                                                                                                                //
                                                                                                                       //
      Meteor.users.update(this.userId, { $set: userFields });                                                          // 84
      SignupKeys.update(key, { $set: { used: true } });                                                                // 85
    }                                                                                                                  //
                                                                                                                       //
    return useSignupKey;                                                                                               //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"startup.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/startup.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file is for various startup code that doesn't fit neatly anywhere else                                         //
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 19
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 21
  var baseUrlRow = Misc.findOne({ _id: "BASE_URL" });                                                                  // 22
                                                                                                                       //
  if (!baseUrlRow) {                                                                                                   // 24
    // Fill data with current value in the case this is a first run                                                    //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 26
    Misc.insert(baseUrlRow);                                                                                           // 27
  } else if (baseUrlRow.value !== ROOT_URL) {                                                                          //
    console.log("resetting oauth");                                                                                    // 29
    Settings.find({ _id: { $in: ["google", "github"] } }).forEach(function (setting) {                                 // 30
      if (!!setting.value) {                                                                                           // 31
        Settings.update({ _id: setting._id }, { $set: { value: false,                                                  // 32
            automaticallyReset: { baseUrlChangedFrom: baseUrlRow.value } } });                                         // 34
      }                                                                                                                //
    });                                                                                                                //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 37
    Misc.update({ _id: "BASE_URL" }, { $set: { value: ROOT_URL } });                                                   // 38
  }                                                                                                                    //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"stats-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/stats-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var DAY_MS = 24 * 60 * 60 * 1000;                                                                                      // 17
                                                                                                                       //
if (Mongo.Collection.prototype.aggregate) {                                                                            // 19
  throw new Error("Looks like Meteor wrapped the Collection.aggregate() call. Make sure it " + "works then delete our own wrapper.");
}                                                                                                                      //
                                                                                                                       //
Mongo.Collection.prototype.aggregate = function () {                                                                   // 24
  // Meteor doesn't wrapp Mongo's aggregate() method.                                                                  //
  var raw = this.rawCollection();                                                                                      // 26
  return Meteor.wrapAsync(raw.aggregate, raw).apply(raw, arguments);                                                   // 27
};                                                                                                                     //
                                                                                                                       //
computeStats = function computeStats(since) {                                                                          // 30
  // We'll need this for a variety of queries.                                                                         //
  var timeConstraint = { $gt: since };                                                                                 // 32
                                                                                                                       //
  // This calculates the number of user accounts that have been used                                                   //
  // during the requested time period.                                                                                 //
  var currentlyActiveUsersCount = Meteor.users.find({                                                                  // 30
    expires: { $exists: false },                                                                                       // 37
    loginIdentities: { $exists: true },                                                                                // 38
    lastActive: timeConstraint                                                                                         // 39
  }).count();                                                                                                          //
                                                                                                                       //
  // This calculates the number of grains that have been used during                                                   //
  // the requested time period.                                                                                        //
  var activeGrainsCount = Grains.find({ lastUsed: timeConstraint }).count();                                           // 30
                                                                                                                       //
  // If Meteor.settings.allowDemoAccounts is true, DeleteStats                                                         //
  // contains records of type `user` and `appDemoUser`, indicating                                                     //
  // the number of those types of accounts that were created and                                                       //
  // then auto-expired through the demo mode's auto-account-expiry.                                                    //
  var deletedDemoUsersCount = DeleteStats.find({ type: "demoUser", lastActive: timeConstraint }).count();              // 30
  var deletedAppDemoUsersCount = DeleteStats.find({ type: "appDemoUser", lastActive: timeConstraint }).count();        // 52
                                                                                                                       //
  // Similarly, if the demo is enabled, we auto-delete grains; we store that                                           //
  // fact in DeleteStats with type: "grain".                                                                           //
  var deletedGrainsCount = DeleteStats.find({ type: "grain", lastActive: timeConstraint }).count();                    // 30
                                                                                                                       //
  var apps = Grains.aggregate([{ $match: { lastUsed: timeConstraint } }, {                                             // 60
    $group: {                                                                                                          // 63
      _id: "$appId",                                                                                                   // 64
      grains: { $sum: 1 },                                                                                             // 65
      userIds: { $addToSet: "$userId" }                                                                                // 66
    }                                                                                                                  //
  }, {                                                                                                                 //
    $project: {                                                                                                        // 70
      grains: 1,                                                                                                       // 71
      owners: { $size: "$userIds" }                                                                                    // 72
    }                                                                                                                  //
  }]);                                                                                                                 //
  apps = _.indexBy(apps, "_id");                                                                                       // 76
                                                                                                                       //
  for (var appId in meteorBabelHelpers.sanitizeForInObject(apps)) {                                                    // 78
    // We need to count ApiTokens, which don't have appId denormalized into them. We therefore                         //
    // have to fetch a list of grainIds first.                                                                         //
    // TODO(perf): If stats are getting slow, denormalize appId into ApiTokens. Note that it is                        //
    //   already denormalized for the specific case of apps that don't have icons, but the data                        //
    //   for that use case is NOT safe to use here because it's intended that we might allow an                        //
    //   app to mimic another app's icon by spoofing that app ID. In other words, the existing                         //
    //   denormalization of appId should be considered "app ID for identicon purposes only". We'll                     //
    //   need to add a new denormalization for stats purposes -- and make sure that it is not                          //
    //   revealed to the user.                                                                                         //
    var app = apps[appId];                                                                                             // 88
    delete app._id;                                                                                                    // 89
    var grains = Grains.find({                                                                                         // 90
      lastUsed: timeConstraint,                                                                                        // 91
      appId: appId                                                                                                     // 92
    }, {                                                                                                               //
      fields: { _id: 1 }                                                                                               // 94
    }).fetch();                                                                                                        //
    var grainIds = _.pluck(grains, "_id");                                                                             // 96
                                                                                                                       //
    var counts = ApiTokens.aggregate([{                                                                                // 98
      $match: {                                                                                                        // 100
        "owner.user": { $exists: true },                                                                               // 101
        lastUsed: timeConstraint,                                                                                      // 102
        grainId: { $in: grainIds }                                                                                     // 103
      }                                                                                                                //
    }, { $group: { _id: "$owner.user.identityId" } }, {                                                                //
      $group: {                                                                                                        // 108
        _id: "count",                                                                                                  // 109
        count: { $sum: 1 }                                                                                             // 110
      }                                                                                                                //
    }]);                                                                                                               //
                                                                                                                       //
    if (counts.length > 0) {                                                                                           // 115
      if (counts.length !== 1) {                                                                                       // 116
        console.error("error: sharedUsers aggregation returned multiple rows");                                        // 117
      }                                                                                                                //
                                                                                                                       //
      app.sharedUsers = counts[0].count;                                                                               // 120
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Count per-app appdemo users and deleted grains.                                                                   //
  DeleteStats.aggregate([{                                                                                             // 30
    $match: {                                                                                                          // 127
      lastActive: timeConstraint,                                                                                      // 128
      appId: { $exists: true }                                                                                         // 129
    }                                                                                                                  //
  }, {                                                                                                                 //
    $group: {                                                                                                          // 133
      _id: {                                                                                                           // 134
        appId: "$appId",                                                                                               // 135
        type: "$type"                                                                                                  // 136
      },                                                                                                               //
      count: { $sum: 1 }                                                                                               // 138
    }                                                                                                                  //
  }]).forEach(function (deletion) {                                                                                    //
    var app = apps[deletion._id.appId];                                                                                // 142
    if (!app) {                                                                                                        // 143
      app = apps[deletion.appId] = {};                                                                                 // 144
    }                                                                                                                  //
                                                                                                                       //
    if (deletion._id.type === "appDemoUser") {                                                                         // 147
      app.appDemoUsers = deletion.count;                                                                               // 148
    } else if (deletion._id.type === "grain") {                                                                        //
      app.deleted = deletion.count;                                                                                    // 150
    } else if (deletion._id.type === "demoGrain") {                                                                    //
      app.demoed = deletion.count;                                                                                     // 152
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  return {                                                                                                             // 156
    activeUsers: currentlyActiveUsersCount,                                                                            // 157
    demoUsers: deletedDemoUsersCount,                                                                                  // 158
    appDemoUsers: deletedAppDemoUsersCount,                                                                            // 159
    activeGrains: activeGrainsCount + deletedGrainsCount,                                                              // 160
    apps: apps                                                                                                         // 161
  };                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
function recordStats() {                                                                                               // 165
  var now = new Date();                                                                                                // 166
                                                                                                                       //
  var planStats = _.countBy(Meteor.users.find({ expires: { $exists: false }, "payments.id": { $exists: true } }, { fields: { plan: 1 } }).fetch(), "plan");
                                                                                                                       //
  var record = {                                                                                                       // 174
    timestamp: now,                                                                                                    // 175
    daily: computeStats(new Date(now.getTime() - DAY_MS)),                                                             // 176
    weekly: computeStats(new Date(now.getTime() - 7 * DAY_MS)),                                                        // 177
    monthly: computeStats(new Date(now.getTime() - 30 * DAY_MS)),                                                      // 178
    forever: computeStats(new Date(0)),                                                                                // 179
    plans: planStats                                                                                                   // 180
  };                                                                                                                   //
  record.computeTime = Date.now() - now;                                                                               // 182
                                                                                                                       //
  ActivityStats.insert(record);                                                                                        // 184
  var age = ActivityStats.find().count();                                                                              // 185
  if (age > 3) {                                                                                                       // 186
    var reportSetting = Settings.findOne({ _id: "reportStats" });                                                      // 187
    if (!reportSetting) {                                                                                              // 188
      // Setting not set yet, send out notifications and set it to false                                               //
      globalDb.sendAdminNotification("You can help Sandstorm by sending us some anonymous " + "usage stats. Click here for more info.", "/admin/stats");
      Settings.insert({ _id: "reportStats", value: "unset" });                                                         // 192
    } else if (reportSetting.value === true) {                                                                         //
      // The stats page which the user agreed we can send actually displays the whole history                          //
      // of the server, but we're only sending stats from the last day. Let's also throw in the                        //
      // length of said history. This is still strictly less information than what the user said                       //
      // we're allowed to send.                                                                                        //
      record.serverAge = age;                                                                                          // 198
                                                                                                                       //
      HTTP.post("https://alpha-api.sandstorm.io/data", {                                                               // 200
        data: record,                                                                                                  // 201
        headers: {                                                                                                     // 202
          Authorization: "Bearer aT-mGyNwsgwZBbZvd5FWr0Ma79O9IehI4NiEO94y_oR",                                         // 203
          "Content-Type": "application/json"                                                                           // 204
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 211
  // Wait until 10:00 UTC (2:00 PST / 5:00 EST), then start recording stats every 24 hours.                            //
  // (Only on the first replica to avoid conflicts.)                                                                   //
  Meteor.setTimeout(function () {                                                                                      // 214
    Meteor.setInterval(function () {                                                                                   // 215
      recordStats();                                                                                                   // 216
    }, DAY_MS);                                                                                                        //
                                                                                                                       //
    recordStats();                                                                                                     // 219
  }, DAY_MS - (Date.now() - 10 * 60 * 60 * 1000) % DAY_MS);                                                            //
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 222
    if (StatsTokens.find().count() === 0) {                                                                            // 223
      StatsTokens.remove({});                                                                                          // 224
      StatsTokens.insert({ _id: Random.id(22) });                                                                      // 225
    }                                                                                                                  //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
Meteor.methods({                                                                                                       // 230
  regenerateStatsToken: function () {                                                                                  // 231
    function regenerateStatsToken() {                                                                                  // 231
      if (!isAdmin()) {                                                                                                // 232
        throw new Meteor.Error(403, "Unauthorized", "User must be admin");                                             // 233
      }                                                                                                                //
                                                                                                                       //
      StatsTokens.remove({});                                                                                          // 236
      var token = StatsTokens.insert({ _id: Random.id(22) });                                                          // 237
      return token._id;                                                                                                // 238
    }                                                                                                                  //
                                                                                                                       //
    return regenerateStatsToken;                                                                                       //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Router.map(function () {                                                                                               // 242
  this.route("fetchStats", {                                                                                           // 243
    where: "server",                                                                                                   // 244
    path: "/fetchStats/:tokenId",                                                                                      // 245
    action: function () {                                                                                              // 246
      function action() {                                                                                              // 246
        var token = StatsTokens.findOne({ _id: this.params.tokenId });                                                 // 247
                                                                                                                       //
        if (!token) {                                                                                                  // 249
          this.response.writeHead(404, {                                                                               // 250
            "Content-Type": "text/plain"                                                                               // 251
          });                                                                                                          //
          this.response.write("Token not found");                                                                      // 253
          return this.response.end();                                                                                  // 254
        }                                                                                                              //
                                                                                                                       //
        try {                                                                                                          // 257
          var stats = ActivityStats.find().fetch();                                                                    // 258
          var statsString = JSON.stringify(stats);                                                                     // 259
                                                                                                                       //
          this.response.writeHead(200, {                                                                               // 261
            "Content-Type": "application/json"                                                                         // 262
          });                                                                                                          //
          this.response.write(statsString);                                                                            // 264
        } catch (error) {                                                                                              //
          console.error(error.stack);                                                                                  // 266
          this.response.writeHead(500, {                                                                               // 267
            "Content-Type": "text/plain"                                                                               // 268
          });                                                                                                          //
          this.response.write(error.stack);                                                                            // 270
        }                                                                                                              //
                                                                                                                       //
        return this.response.end();                                                                                    // 273
      }                                                                                                                //
                                                                                                                       //
      return action;                                                                                                   //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"lib":{"db-deprecated.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// lib/db-deprecated.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file imports symbols from the sandstorm-db package. New code should use SandstormDb                            //
// directly.                                                                                                           //
                                                                                                                       //
// TODO(cleanup): Over time, eliminate the use of each of these assignments by using `globalDb`                        //
//   directly. For collections, prefer to update SandstormDb to provide methods for querying the                       //
//   collection rather than use `globalDb.collections` directly. When code is moved into packages,                     //
//   the `globalDb` global should NOT go with it; the package should expect a SandstormDb to be                        //
//   passed in, thus allowing mocking the database for unit tests.                                                     //
                                                                                                                       //
globalDb = new SandstormDb();                                                                                          // 26
                                                                                                                       //
Packages = globalDb.collections.packages;                                                                              // 28
DevPackages = globalDb.collections.devPackages;                                                                        // 29
UserActions = globalDb.collections.userActions;                                                                        // 30
Grains = globalDb.collections.grains;                                                                                  // 31
Contacts = globalDb.collections.contacts;                                                                              // 32
Sessions = globalDb.collections.sessions;                                                                              // 33
SignupKeys = globalDb.collections.signupKeys;                                                                          // 34
ActivityStats = globalDb.collections.activityStats;                                                                    // 35
DeleteStats = globalDb.collections.deleteStats;                                                                        // 36
FileTokens = globalDb.collections.fileTokens;                                                                          // 37
ApiTokens = globalDb.collections.apiTokens;                                                                            // 38
Notifications = globalDb.collections.notifications;                                                                    // 39
StatsTokens = globalDb.collections.statsTokens;                                                                        // 40
Misc = globalDb.collections.misc;                                                                                      // 41
Settings = globalDb.collections.settings;                                                                              // 42
                                                                                                                       //
currentUserGrains = globalDb.currentUserGrains.bind(globalDb);                                                         // 44
isDemoUser = globalDb.isDemoUser.bind(globalDb);                                                                       // 45
isSignedUp = globalDb.isSignedUp.bind(globalDb);                                                                       // 46
isSignedUpOrDemo = globalDb.isSignedUpOrDemo.bind(globalDb);                                                           // 47
isUserOverQuota = globalDb.isUserOverQuota.bind(globalDb);                                                             // 48
isUserExcessivelyOverQuota = globalDb.isUserExcessivelyOverQuota.bind(globalDb);                                       // 49
isAdmin = globalDb.isAdmin.bind(globalDb);                                                                             // 50
isAdminById = globalDb.isAdminById.bind(globalDb);                                                                     // 51
findAdminUserForToken = globalDb.findAdminUserForToken.bind(globalDb);                                                 // 52
matchWildcardHost = globalDb.matchWildcardHost.bind(globalDb);                                                         // 53
makeWildcardHost = globalDb.makeWildcardHost.bind(globalDb);                                                           // 54
allowDevAccounts = globalDb.allowDevAccounts.bind(globalDb);                                                           // 55
roleAssignmentPattern = globalDb.roleAssignmentPattern;                                                                // 56
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 58
  getWildcardOrigin = globalDb.getWildcardOrigin.bind(globalDb);                                                       // 59
                                                                                                                       //
  Meteor.onConnection(function (connection) {                                                                          // 61
    // TODO(cleanup): This is the best way I've thought of so far to allow methods declared in                         //
    //   packages to actually use the DB, but it's pretty sad.                                                         //
    connection.sandstormDb = globalDb;                                                                                 // 64
  });                                                                                                                  //
  SandstormDb.periodicCleanup(5 * 60 * 1000, SandstormPermissions.cleanupSelfDestructing(globalDb));                   // 66
  SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                       // 67
    SandstormAutoupdateApps.updateAppIndex(globalDb);                                                                  // 68
  });                                                                                                                  //
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 71
    globalDb.migrateToLatest();                                                                                        // 71
  });                                                                                                                  //
  LDAP_DEFAULTS.url = globalDb.getLdapUrl();                                                                           // 72
  LDAP_DEFAULTS.base = globalDb.getLdapBase();                                                                         // 73
}                                                                                                                      //
                                                                                                                       //
if (Meteor.isClient) {                                                                                                 // 76
  Session.setDefault("shrink-navbar", false);                                                                          // 77
  globalGrains = new GrainViewList(globalDb);                                                                          // 78
                                                                                                                       //
  // If Meteor._localStorage disappears, we'll have to write our own localStorage wrapper, I guess.                    //
  // Using window.localStorage is dangerous because it throws an exception if cookies are disabled.                    //
  Session.set("shrink-navbar", Meteor._localStorage.getItem("shrink-navbar") === "true");                              // 76
  globalTopbar = new SandstormTopbar(globalDb, {                                                                       // 83
    get: function () {                                                                                                 // 85
      function get() {                                                                                                 //
        return Session.get("topbar-expanded");                                                                         // 86
      }                                                                                                                //
                                                                                                                       //
      return get;                                                                                                      //
    }(),                                                                                                               //
    set: function () {                                                                                                 // 89
      function set(value) {                                                                                            //
        Session.set("topbar-expanded", value);                                                                         // 90
      }                                                                                                                //
                                                                                                                       //
      return set;                                                                                                      //
    }()                                                                                                                //
  }, globalGrains, {                                                                                                   //
    get: function () {                                                                                                 // 95
      function get() {                                                                                                 //
        return Session.get("shrink-navbar");                                                                           // 96
      }                                                                                                                //
                                                                                                                       //
      return get;                                                                                                      //
    }(),                                                                                                               //
    set: function () {                                                                                                 // 99
      function set(value) {                                                                                            //
        Meteor._localStorage.setItem("shrink-navbar", value);                                                          // 100
        Session.set("shrink-navbar", value);                                                                           // 101
      }                                                                                                                //
                                                                                                                       //
      return set;                                                                                                      //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  globalAccountsUi = new AccountsUi(globalDb);                                                                         // 105
                                                                                                                       //
  Template.registerHelper("globalTopbar", function () {                                                                // 107
    return globalTopbar;                                                                                               // 107
  });                                                                                                                  //
  Template.registerHelper("globalAccountsUi", function () {                                                            // 108
    return globalAccountsUi;                                                                                           // 108
  });                                                                                                                  //
} else {                                                                                                               //
  // TODO(cleanup): Refactor accounts registration stuff so that this doesn't need to be defined                       //
  //   at all on the server.                                                                                           //
  globalAccountsUi = null;                                                                                             // 112
}                                                                                                                      //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"demo.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// lib/demo.js                                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Used in both client/demo.js and server/demo.js, as well as install.js                                               //
allowDemo = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDemoAccounts;               // 18
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"imports":{"server":{"auth.js":["meteor/meteor","meteor/check","crypto","fs",function(require,exports){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/auth.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
exports.__esModule = true;                                                                                             //
exports.tokenIsSetupSession = exports.tokenIsValid = exports.clearAdminToken = exports.checkAuth = undefined;          //
                                                                                                                       //
var _meteor = require("meteor/meteor");                                                                                // 1
                                                                                                                       //
var _check = require("meteor/check");                                                                                  // 2
                                                                                                                       //
var _crypto = require("crypto");                                                                                       // 3
                                                                                                                       //
var _crypto2 = _interopRequireDefault(_crypto);                                                                        //
                                                                                                                       //
var _fs = require("fs");                                                                                               // 4
                                                                                                                       //
var _fs2 = _interopRequireDefault(_fs);                                                                                //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// TODO(cleanup): globalDb is still an unbound global, but extracting it is Hard.                                      //
                                                                                                                       //
var ADMIN_TOKEN_EXPIRATION_TIME = 15 * 60 * 1000;                                                                      // 7
var SANDSTORM_ADMIN_TOKEN = SANDSTORM_VARDIR + "/adminToken";                                                          // 8
                                                                                                                       //
function clearAdminToken(token) {                                                                                      // 10
  if (tokenIsSetupSession(token)) {                                                                                    // 11
    var hash = _crypto2["default"].createHash("sha256").update(token).digest("base64");                                // 12
    globalDb.collections.setupSession.remove({                                                                         // 13
      _id: "current-session",                                                                                          // 14
      hashedSessionId: hash                                                                                            // 15
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  if (tokenIsValid(token)) {                                                                                           // 19
    _fs2["default"].unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                 // 20
    console.log("Admin token deleted.");                                                                               // 21
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
function tokenIsValid(token) {                                                                                         // 25
  if (token && _fs2["default"].existsSync(SANDSTORM_ADMIN_TOKEN)) {                                                    // 26
    var stats = _fs2["default"].statSync(SANDSTORM_ADMIN_TOKEN);                                                       // 27
    var expireTime = new Date(Date.now() - ADMIN_TOKEN_EXPIRATION_TIME);                                               // 28
    if (stats.mtime < expireTime) {                                                                                    // 29
      return false;                                                                                                    // 30
    } else {                                                                                                           //
      return _fs2["default"].readFileSync(SANDSTORM_ADMIN_TOKEN, { encoding: "utf8" }) === token;                      // 32
    }                                                                                                                  //
  } else {                                                                                                             //
    return false;                                                                                                      // 35
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
function tokenIsSetupSession(token) {                                                                                  // 39
  if (token) {                                                                                                         // 40
    var setupSession = globalDb.collections.setupSession.findOne({ _id: "current-session" });                          // 41
    if (setupSession) {                                                                                                // 42
      var hash = _crypto2["default"].createHash("sha256").update(token).digest("base64");                              // 43
      var now = new Date();                                                                                            // 44
      var sessionLifetime = 24 * 60 * 60 * 1000; // length of setup session validity, in milliseconds: 1 day           // 45
      if (setupSession.hashedSessionId === hash && now - setupSession.creationDate < sessionLifetime) {                // 42
        return true;                                                                                                   // 47
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return false;                                                                                                        // 52
}                                                                                                                      //
                                                                                                                       //
function checkAuth(token) {                                                                                            // 55
  (0, _check.check)(token, _check.Match.OneOf(undefined, null, String));                                               // 56
  if (!isAdmin() && !tokenIsValid(token) && !tokenIsSetupSession(token)) {                                             // 57
    throw new _meteor.Meteor.Error(403, "User must be admin or provide a valid token");                                // 58
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
exports.checkAuth = checkAuth;                                                                                         //
exports.clearAdminToken = clearAdminToken;                                                                             //
exports.tokenIsValid = tokenIsValid;                                                                                   //
exports.tokenIsSetupSession = tokenIsSetupSession;                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}},"shared":{"admin.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/admin.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
function serviceEnabled(name) {                                                                                        // 17
  var setting = Settings.findOne({ _id: name });                                                                       // 18
  return setting && !!setting.value;                                                                                   // 19
}                                                                                                                      //
                                                                                                                       //
Accounts.identityServices.github = {                                                                                   // 22
  isEnabled: function () {                                                                                             // 23
    function isEnabled() {                                                                                             // 23
      return serviceEnabled("github");                                                                                 // 24
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 27
    function getLoginId(identity) {                                                                                    // 27
      return identity.services.github.username;                                                                        // 28
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 31
    function initiateLogin(loginId) {                                                                                  // 31
      Meteor.loginWithGithub();                                                                                        // 32
      return { oneClick: true };                                                                                       // 33
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 36
    name: "oauthLoginButton",                                                                                          // 37
    priority: 1,                                                                                                       // 38
    data: {                                                                                                            // 39
      method: "loginWithGithub",                                                                                       // 40
      name: "github",                                                                                                  // 41
      displayName: "GitHub",                                                                                           // 42
      linkingNewIdentity: false                                                                                        // 43
    }                                                                                                                  //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Accounts.identityServices.google = {                                                                                   // 48
  isEnabled: function () {                                                                                             // 49
    function isEnabled() {                                                                                             // 49
      return serviceEnabled("google");                                                                                 // 50
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 53
    function getLoginId(identity) {                                                                                    // 53
      return identity.services.google.email;                                                                           // 54
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 57
    function initiateLogin(loginId) {                                                                                  // 57
      Meteor.loginWithGoogle({ loginHint: loginId });                                                                  // 58
      return { oneClick: true };                                                                                       // 59
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 62
    name: "oauthLoginButton",                                                                                          // 63
    priority: 2,                                                                                                       // 64
    data: {                                                                                                            // 65
      method: "loginWithGoogle",                                                                                       // 66
      name: "google",                                                                                                  // 67
      displayName: "Google",                                                                                           // 68
      linkingNewIdentity: false                                                                                        // 69
    }                                                                                                                  //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Accounts.identityServices.email = {                                                                                    // 74
  isEnabled: function () {                                                                                             // 75
    function isEnabled() {                                                                                             // 75
      return serviceEnabled("emailToken");                                                                             // 76
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 79
    function getLoginId(identity) {                                                                                    // 79
      return identity.services.email.email;                                                                            // 80
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 83
    function initiateLogin(loginId) {                                                                                  // 83
      return { form: true };                                                                                           // 84
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 87
    name: "emailLoginForm",                                                                                            // 88
    priority: 10                                                                                                       // 89
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Accounts.identityServices.ldap = {                                                                                     // 93
  isEnabled: function () {                                                                                             // 94
    function isEnabled() {                                                                                             // 94
      return serviceEnabled("ldap") && globalDb.isFeatureKeyValid();                                                   // 95
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 98
    function getLoginId(identity) {                                                                                    // 98
      return identity.services.ldap.username;                                                                          // 99
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 102
    function initiateLogin(loginId) {                                                                                  // 102
      return { form: true };                                                                                           // 103
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 106
    name: "ldapLoginForm",                                                                                             // 107
    priority: 21 }                                                                                                     // 108
};                                                                                                                     //
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.saml = {                                                                                     // 112
  isEnabled: function () {                                                                                             // 113
    function isEnabled() {                                                                                             // 113
      return serviceEnabled("saml") && globalDb.isFeatureKeyValid();                                                   // 114
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 117
    function getLoginId(identity) {                                                                                    // 117
      return identity.services.saml.id;                                                                                // 118
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 121
    function initiateLogin(loginId) {                                                                                  // 121
      Meteor.loginWithSaml();                                                                                          // 122
      return { oneClick: true };                                                                                       // 123
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 126
    name: "samlLoginForm",                                                                                             // 127
    priority: 20 }                                                                                                     // 128
};                                                                                                                     //
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.demo = {                                                                                     // 132
  isEnabled: function () {                                                                                             // 133
    function isEnabled() {                                                                                             // 133
      return false; // You can never authenticate as a demo user.                                                      // 134
    }                                                                                                                  // 133
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 137
    function getLoginId(identity) {                                                                                    // 137
      return identity._id;                                                                                             // 138
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 141
    function initiateLogin(loginId) {                                                                                  // 141
      return { demoCannotLogin: true };                                                                                // 142
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {}                                                                                                    // 145
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/dev-accounts.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Accounts.identityServices.dev = {                                                                                      // 17
  isEnabled: function () {                                                                                             // 18
    function isEnabled() {                                                                                             // 18
      return globalDb.allowDevAccounts();                                                                              // 19
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 22
    function getLoginId(identity) {                                                                                    // 22
      return identity.services.dev.name;                                                                               // 23
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 26
    function initiateLogin(loginId) {                                                                                  // 26
      loginDevAccount(loginId);                                                                                        // 27
      return { oneClick: true };                                                                                       // 28
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 31
    name: "devLoginForm",                                                                                              // 32
    priority: -10 }                                                                                                    // 33
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"install.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/install.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
isSafeDemoAppUrl = function () {                                                                                       // 17
    function isSafeDemoAppUrl(url) {                                                                                   // 17
        // For demo accounts, we allow using a bare hash with no URL (which will never upload a new app)               //
        // and we allow specifying a sandstorm.io URL.                                                                 //
        return !url || url.lastIndexOf("http://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://alpha-j7uny7u376jnimcsx34c.sandstorm.io/", 0) === 0 || url.lastIndexOf("https://app-index.sandstorm.io/", 0) === 0;
    }                                                                                                                  //
                                                                                                                       //
    return isSafeDemoAppUrl;                                                                                           //
}();                                                                                                                   //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"testing.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/testing.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 17
                                                                                                                       //
// jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                                 //
if (isTesting) {                                                                                                       // 21
  if (Meteor.isServer) {                                                                                               // 22
    (function () {                                                                                                     //
      var clearUser = function clearUser(id) {                                                                         //
        UserActions.remove({ userId: id });                                                                            // 24
        globalDb.removeApiTokens({ userId: id });                                                                      // 25
        Grains.find({ userId: id }).forEach(function (grain) {                                                         // 26
          globalBackend.deleteGrain(grain._id);                                                                        // 27
        });                                                                                                            //
                                                                                                                       //
        Grains.remove({ userId: id });                                                                                 // 30
        Meteor.users.remove({ _id: id });                                                                              // 31
      };                                                                                                               //
                                                                                                                       //
      Meteor.methods({                                                                                                 // 34
        createMockGithubUser: function () {                                                                            // 35
          function createMockGithubUser() {                                                                            // 35
            Meteor.users.update({ _id: "Py8fwsaryQNGBuiXb" }, { $set: { createdAt: new Date("2014-08-11T21:44:04.147Z"), isAdmin: true, lastActive: new Date("2014-08-19T09:58:39.676Z"), profile: { name: "Github User" }, services: { github: { accessToken: "sometoken", id: 1595880, username: "testuser" }, resume: { loginTokens: [{ when: new Date("2099-08-13T05:16:02.356Z"), hashedToken: "GriUSDp+uN/K4HptwSl1wsdWfHEpS8c9KjjdqwKNo0k=" }] } }, signupKey: "admin" } }, { upsert: true });
          }                                                                                                            //
                                                                                                                       //
          return createMockGithubUser;                                                                                 //
        }(),                                                                                                           //
                                                                                                                       //
        clearMockGithubUser: function () {                                                                             // 41
          function clearMockGithubUser() {                                                                             // 41
            clearUser("Py8fwsaryQNGBuiXb");                                                                            // 42
          }                                                                                                            //
                                                                                                                       //
          return clearMockGithubUser;                                                                                  //
        }(),                                                                                                           //
                                                                                                                       //
        createMockGoogleUser: function () {                                                                            // 45
          function createMockGoogleUser() {                                                                            // 45
            Meteor.users.update({ _id: "6WJcRo2gg2Ysuxsok" }, { $set: { createdAt: new Date("2014-08-21T07:52:55.581Z"), profile: { name: "Google User" }, services: { google: { accessToken: "sometoken", expiresAt: 4562182723000, id: "116893057283177439912", verified_email: true, name: "Google User", given_name: "Google", family_name: "User", picture: "https://lh3.googleusercontent.com/-XdUIqdMkCWA/AAAAAAAAAAI/AAAAAAAAAAA/4252rscbv5M/photo.jpg", locale: "en", gender: "male" }, resume: { loginTokens: [{ when: new Date("2099-08-21T07:52:55.592Z"), hashedToken: "cbJGxLGKW3f0j7Ehit77hdK58W7xuPjzZhGHgKhyddo=" }] } }, signupKey: "admin" } }, { upsert: true });
          }                                                                                                            //
                                                                                                                       //
          return createMockGoogleUser;                                                                                 //
        }(),                                                                                                           //
                                                                                                                       //
        clearMockGoogleUser: function () {                                                                             // 51
          function clearMockGoogleUser() {                                                                             // 51
            clearUser("6WJcRo2gg2Ysuxsok");                                                                            // 52
          }                                                                                                            //
                                                                                                                       //
          return clearMockGoogleUser;                                                                                  //
        }()                                                                                                            //
      });                                                                                                              //
    })();                                                                                                              //
  }                                                                                                                    //
                                                                                                                       //
  mockLoginGithub = function mockLoginGithub() {                                                                       // 57
    Meteor.call("createMockGithubUser", function (err) {                                                               // 58
      if (err) {                                                                                                       // 59
        console.log(err);                                                                                              // 60
      }                                                                                                                //
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "F0S6luPxIJV--y_GAkBKOMuWMYnnqgG3UMv9M-DIs2f");                 // 63
      window.localStorage.setItem("Meteor.loginTokenExpires", "Mon Nov 10 2099 21:16:02 GMT-0800 (PST)");              // 64
      window.localStorage.setItem("Meteor.userId", "Py8fwsaryQNGBuiXb");                                               // 65
      window.location.reload();                                                                                        // 66
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  clearMockGithubUser = function clearMockGithubUser() {                                                               // 70
    Meteor.call("clearMockGithubUser", function (err) {                                                                // 71
      if (err) {                                                                                                       // 72
        console.log(err);                                                                                              // 73
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  mockLoginGoogle = function mockLoginGoogle() {                                                                       // 78
    Meteor.call("createMockGoogleUser", function (err) {                                                               // 79
      if (err) {                                                                                                       // 80
        console.log(err);                                                                                              // 81
      }                                                                                                                //
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "P3ffUfVJtptyVX2IPUfNDZY0F3b-GIZ-WQf7w3GdL21");                 // 84
      window.localStorage.setItem("Meteor.loginTokenExpires", "Tue Nov 18 2099 23:52:55 GMT-0800 (PST)");              // 85
      window.localStorage.setItem("Meteor.userId", "6WJcRo2gg2Ysuxsok");                                               // 86
      window.location.reload();                                                                                        // 87
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  clearMockGoogleUser = function clearMockGoogleUser() {                                                               // 91
    Meteor.call("clearMockGoogleUser", function (err) {                                                                // 92
      if (err) {                                                                                                       // 93
        console.log(err);                                                                                              // 94
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
}                                                                                                                      //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}},{"extensions":[".js",".json"]});
require("./server/lib/constants.js");
require("./lib/db-deprecated.js");
require("./lib/demo.js");
require("./server/admin/admin-alert-server.js");
require("./server/admin/admin-user-invite.js");
require("./server/admin/network-capabilities-server.js");
require("./server/admin/personalization-server.js");
require("./server/admin/system-status-server.js");
require("./server/drivers/external-ui-view.js");
require("./server/drivers/ip.js");
require("./server/drivers/mail.js");
require("./server/admin-server.js");
require("./server/backup.js");
require("./server/core.js");
require("./server/demo-server.js");
require("./server/dev-accounts-server.js");
require("./server/feature-key.js");
require("./server/grain-server.js");
require("./server/hack-session.js");
require("./server/install-server.js");
require("./server/installer.js");
require("./server/pre-meteor.js");
require("./server/proxy.js");
require("./server/sandcats.js");
require("./server/shell-server.js");
require("./server/signup-server.js");
require("./server/startup.js");
require("./server/stats-server.js");
require("./shared/admin.js");
require("./shared/dev-accounts.js");
require("./shared/install.js");
require("./shared/testing.js");
//# sourceMappingURL=app.js.map
